/* color.c generated by valac 0.56.17, the Vala compiler
 * generated from color.vala, do not modify */

/*
 * Extension to Gdk.Color which has support for an alpha channel.
 *
 * Copyright (C) 2008, 2009 Mark Lee <libdesktop-agnostic@lazymalevolence.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 *
 * Author : Mark Lee <libdesktop-agnostic@lazymalevolence.com>
 */

#include "libdesktop-agnostic/desktop-agnostic.h"
#include <gdk/gdk.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>
#include <stdio.h>
#include <float.h>
#include <math.h>
#include "desktop-agnostic.h"

#define DESKTOP_AGNOSTIC_COLOR_HTML_STRING "#%02hx%02hx%02hx%02hx"
#define DESKTOP_AGNOSTIC_COLOR_HTML_SCALE ((gushort) 256)
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	DESKTOP_AGNOSTIC_COLOR_0_PROPERTY,
	DESKTOP_AGNOSTIC_COLOR_COLOR_PROPERTY,
	DESKTOP_AGNOSTIC_COLOR_RED_PROPERTY,
	DESKTOP_AGNOSTIC_COLOR_GREEN_PROPERTY,
	DESKTOP_AGNOSTIC_COLOR_BLUE_PROPERTY,
	DESKTOP_AGNOSTIC_COLOR_ALPHA_PROPERTY,
	DESKTOP_AGNOSTIC_COLOR_NUM_PROPERTIES
};
static GParamSpec* desktop_agnostic_color_properties[DESKTOP_AGNOSTIC_COLOR_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _DesktopAgnosticColorPrivate {
	GdkColor _color;
	gushort _alpha;
};

static gint DesktopAgnosticColor_private_offset;
static gpointer desktop_agnostic_color_parent_class = NULL;

static gushort desktop_agnostic_color_ushortify (DesktopAgnosticColor* self,
                                          guint value,
                                          GError** error);
static void desktop_agnostic_color_finalize (GObject * obj);
static GType desktop_agnostic_color_get_type_once (void);
static void _vala_desktop_agnostic_color_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_desktop_agnostic_color_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);

GQuark
desktop_agnostic_color_parse_error_quark (void)
{
	return g_quark_from_static_string ("desktop-agnostic-color-parse-error-quark");
}

static GType
desktop_agnostic_color_parse_error_get_type_once (void)
{
	static const GEnumValue values[] = {{DESKTOP_AGNOSTIC_COLOR_PARSE_ERROR_INVALID_INPUT, "DESKTOP_AGNOSTIC_COLOR_PARSE_ERROR_INVALID_INPUT", "invalid-input"}, {DESKTOP_AGNOSTIC_COLOR_PARSE_ERROR_INVALID_ALPHA, "DESKTOP_AGNOSTIC_COLOR_PARSE_ERROR_INVALID_ALPHA", "invalid-alpha"}, {0, NULL, NULL}};
	GType desktop_agnostic_color_parse_error_type_id;
	desktop_agnostic_color_parse_error_type_id = g_enum_register_static ("DesktopAgnosticColorParseError", values);
	return desktop_agnostic_color_parse_error_type_id;
}

GType
desktop_agnostic_color_parse_error_get_type (void)
{
	static volatile gsize desktop_agnostic_color_parse_error_type_id__once = 0;
	if (g_once_init_enter (&desktop_agnostic_color_parse_error_type_id__once)) {
		GType desktop_agnostic_color_parse_error_type_id;
		desktop_agnostic_color_parse_error_type_id = desktop_agnostic_color_parse_error_get_type_once ();
		g_once_init_leave (&desktop_agnostic_color_parse_error_type_id__once, desktop_agnostic_color_parse_error_type_id);
	}
	return desktop_agnostic_color_parse_error_type_id__once;
}

static inline gpointer
desktop_agnostic_color_get_instance_private (DesktopAgnosticColor* self)
{
	return G_STRUCT_MEMBER_P (self, DesktopAgnosticColor_private_offset);
}

static gushort
desktop_agnostic_color_ushortify (DesktopAgnosticColor* self,
                                  guint value,
                                  GError** error)
{
	gboolean _tmp0_ = FALSE;
	GError* _inner_error0_ = NULL;
	gushort result;
#line 52 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 55 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	if (value < ((guint) 0)) {
#line 55 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		_tmp0_ = TRUE;
#line 131 "color.c"
	} else {
#line 55 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		_tmp0_ = value > ((guint) G_MAXUSHORT);
#line 135 "color.c"
	}
#line 55 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	if (_tmp0_) {
#line 139 "color.c"
		GError* _tmp1_;
#line 57 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		_tmp1_ = g_error_new (DESKTOP_AGNOSTIC_COLOR_PARSE_ERROR, DESKTOP_AGNOSTIC_COLOR_PARSE_ERROR_INVALID_INPUT, "RGB values must be between 0 and %hu.", G_MAXUSHORT);
#line 57 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		_inner_error0_ = _tmp1_;
#line 57 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		if (_inner_error0_->domain == DESKTOP_AGNOSTIC_COLOR_PARSE_ERROR) {
#line 147 "color.c"
			gushort _tmp2_ = 0U;
#line 57 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
			g_propagate_error (error, _inner_error0_);
#line 57 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
			return _tmp2_;
#line 153 "color.c"
		} else {
			gushort _tmp3_ = 0U;
#line 57 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 57 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
			g_clear_error (&_inner_error0_);
#line 57 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
			return _tmp3_;
#line 162 "color.c"
		}
	}
#line 60 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	result = (gushort) value;
#line 60 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	return result;
#line 169 "color.c"
}

DesktopAgnosticColor*
desktop_agnostic_color_construct (GType object_type,
                                  GdkColor* color,
                                  gushort alpha)
{
	DesktopAgnosticColor * self = NULL;
	GdkColor _tmp0_;
#line 107 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	g_return_val_if_fail (color != NULL, NULL);
#line 107 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	self = (DesktopAgnosticColor*) g_object_new (object_type, NULL);
#line 109 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	_tmp0_ = *color;
#line 109 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	self->priv->_color = _tmp0_;
#line 110 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	self->priv->_alpha = alpha;
#line 107 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	return self;
#line 191 "color.c"
}

DesktopAgnosticColor*
desktop_agnostic_color_new (GdkColor* color,
                            gushort alpha)
{
#line 107 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	return desktop_agnostic_color_construct (DESKTOP_AGNOSTIC_TYPE_COLOR, color, alpha);
#line 200 "color.c"
}

DesktopAgnosticColor*
desktop_agnostic_color_construct_from_values (GType object_type,
                                              gushort red,
                                              gushort green,
                                              gushort blue,
                                              gushort alpha)
{
	DesktopAgnosticColor * self = NULL;
#line 112 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	self = (DesktopAgnosticColor*) g_object_new (object_type, NULL);
#line 114 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	memset (&self->priv->_color, 0, sizeof (GdkColor));
#line 115 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	self->priv->_color.red = (guint16) red;
#line 116 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	self->priv->_color.green = (guint16) green;
#line 117 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	self->priv->_color.blue = (guint16) blue;
#line 118 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	self->priv->_alpha = alpha;
#line 112 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	return self;
#line 225 "color.c"
}

DesktopAgnosticColor*
desktop_agnostic_color_new_from_values (gushort red,
                                        gushort green,
                                        gushort blue,
                                        gushort alpha)
{
#line 112 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	return desktop_agnostic_color_construct_from_values (DESKTOP_AGNOSTIC_TYPE_COLOR, red, green, blue, alpha);
#line 236 "color.c"
}

/**
     * Parses color from string.
     * @see Gdk.Color.parse
     */
static gunichar
string_get_char (const gchar* self,
                 glong index)
{
	gunichar result;
#line 1313 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0U);
#line 1314 "glib-2.0.vapi"
	result = g_utf8_get_char (((gchar*) self) + index);
#line 1314 "glib-2.0.vapi"
	return result;
#line 254 "color.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1501 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1501 "glib-2.0.vapi"
	end = _tmp0_;
#line 1502 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1502 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1503 "glib-2.0.vapi"
		result = maxlen;
#line 1503 "glib-2.0.vapi"
		return result;
#line 277 "color.c"
	} else {
		gchar* _tmp2_;
#line 1505 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1505 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1505 "glib-2.0.vapi"
		return result;
#line 286 "color.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1512 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1514 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 305 "color.c"
	} else {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 309 "color.c"
	}
#line 1514 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1516 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 315 "color.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1518 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1518 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1518 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 325 "color.c"
	}
#line 1521 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1522 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1523 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 333 "color.c"
	} else {
#line 1525 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 337 "color.c"
	}
#line 1527 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1528 "glib-2.0.vapi"
		len = string_length - offset;
#line 343 "color.c"
	}
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1531 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1531 "glib-2.0.vapi"
	result = _tmp3_;
#line 1531 "glib-2.0.vapi"
	return result;
#line 353 "color.c"
}

static const gchar*
string_offset (const gchar* self,
               glong offset)
{
	const gchar* result;
#line 1322 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1323 "glib-2.0.vapi"
	result = (const gchar*) (((gchar*) self) + offset);
#line 1323 "glib-2.0.vapi"
	return result;
#line 367 "color.c"
}

DesktopAgnosticColor*
desktop_agnostic_color_construct_from_string (GType object_type,
                                              const gchar* spec,
                                              GError** error)
{
	DesktopAgnosticColor * self = NULL;
	gchar* color_data = NULL;
	const gchar* _tmp25_;
	GdkColor _tmp26_ = {0};
	gboolean _tmp27_;
	GError* _inner_error0_ = NULL;
#line 124 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	g_return_val_if_fail (spec != NULL, NULL);
#line 124 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	self = (DesktopAgnosticColor*) g_object_new (object_type, NULL);
#line 126 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	memset (&self->priv->_color, 0, sizeof (GdkColor));
#line 127 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	self->priv->_alpha = G_MAXUSHORT;
#line 129 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	if (string_get_char (spec, (glong) 0) == ((gunichar) '#')) {
#line 391 "color.c"
		gsize cd_len = 0UL;
		gchar* color_hex = NULL;
		gchar* _tmp0_;
		const gchar* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gboolean _tmp4_ = FALSE;
		gboolean _tmp5_ = FALSE;
		gsize hex_len = 0UL;
		gsize offset = 0UL;
		gchar* rgb_hex = NULL;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		const gchar* alpha_hex = NULL;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		gint _tmp18_;
		gboolean _tmp19_;
		gushort bits = 0U;
		const gchar* _tmp22_;
		gchar* _tmp23_;
#line 131 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		cd_len = (gsize) 0;
#line 132 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		_tmp0_ = string_substring (spec, (glong) 1, (glong) -1);
#line 132 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		color_hex = _tmp0_;
#line 134 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		_tmp1_ = color_hex;
#line 134 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		_tmp2_ = strlen (_tmp1_);
#line 134 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		_tmp3_ = _tmp2_;
#line 134 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		cd_len = (gsize) _tmp3_;
#line 135 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		if ((cd_len % 4) != ((gsize) 0)) {
#line 135 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
			_tmp5_ = TRUE;
#line 438 "color.c"
		} else {
#line 135 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
			_tmp5_ = cd_len < ((gsize) 4);
#line 442 "color.c"
		}
#line 135 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		if (_tmp5_) {
#line 135 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
			_tmp4_ = TRUE;
#line 448 "color.c"
		} else {
#line 135 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
			_tmp4_ = cd_len > ((gsize) 16);
#line 452 "color.c"
		}
#line 135 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		if (_tmp4_) {
#line 456 "color.c"
			GError* _tmp6_;
#line 137 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
			_tmp6_ = g_error_new_literal (DESKTOP_AGNOSTIC_COLOR_PARSE_ERROR, DESKTOP_AGNOSTIC_COLOR_PARSE_ERROR_INVALID_INPUT, "Invalid input size.");
#line 137 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
			_inner_error0_ = _tmp6_;
#line 137 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
			if (_inner_error0_->domain == DESKTOP_AGNOSTIC_COLOR_PARSE_ERROR) {
#line 137 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
				g_propagate_error (error, _inner_error0_);
#line 137 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
				_g_free0 (color_hex);
#line 137 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
				_g_free0 (color_data);
#line 137 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
				_g_object_unref0 (self);
#line 137 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
				return NULL;
#line 474 "color.c"
			} else {
#line 137 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
				_g_free0 (color_hex);
#line 137 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
				_g_free0 (color_data);
#line 137 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 137 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
				g_clear_error (&_inner_error0_);
#line 137 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
				return NULL;
#line 486 "color.c"
			}
		}
#line 139 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		hex_len = cd_len / 4;
#line 140 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		offset = hex_len * 3;
#line 141 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		_tmp7_ = color_hex;
#line 141 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		_tmp8_ = string_substring (_tmp7_, (glong) 0, (glong) offset);
#line 141 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		rgb_hex = _tmp8_;
#line 142 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		_tmp9_ = color_hex;
#line 142 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		_tmp10_ = string_offset (_tmp9_, (glong) offset);
#line 142 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		alpha_hex = _tmp10_;
#line 143 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		_tmp11_ = alpha_hex;
#line 143 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		_tmp12_ = g_strdup_printf ("%" G_GSIZE_FORMAT, hex_len);
#line 143 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		_tmp13_ = _tmp12_;
#line 143 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		_tmp14_ = g_strconcat ("%", _tmp13_, NULL);
#line 143 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		_tmp15_ = _tmp14_;
#line 143 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		_tmp16_ = g_strconcat (_tmp15_, "hx", NULL);
#line 143 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		_tmp17_ = _tmp16_;
#line 143 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		_tmp18_ = sscanf (_tmp11_, _tmp17_, &self->priv->_alpha);
#line 143 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		_tmp19_ = _tmp18_ == 0;
#line 143 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		_g_free0 (_tmp17_);
#line 143 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		_g_free0 (_tmp15_);
#line 143 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		_g_free0 (_tmp13_);
#line 143 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		if (_tmp19_) {
#line 531 "color.c"
			const gchar* _tmp20_;
			GError* _tmp21_;
#line 145 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
			_tmp20_ = alpha_hex;
#line 145 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
			_tmp21_ = g_error_new (DESKTOP_AGNOSTIC_COLOR_PARSE_ERROR, DESKTOP_AGNOSTIC_COLOR_PARSE_ERROR_INVALID_ALPHA, "Could not parse alpha section of input: %s", _tmp20_);
#line 145 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
			_inner_error0_ = _tmp21_;
#line 145 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
			if (_inner_error0_->domain == DESKTOP_AGNOSTIC_COLOR_PARSE_ERROR) {
#line 145 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
				g_propagate_error (error, _inner_error0_);
#line 145 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
				_g_free0 (rgb_hex);
#line 145 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
				_g_free0 (color_hex);
#line 145 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
				_g_free0 (color_data);
#line 145 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
				_g_object_unref0 (self);
#line 145 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
				return NULL;
#line 554 "color.c"
			} else {
#line 145 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
				_g_free0 (rgb_hex);
#line 145 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
				_g_free0 (color_hex);
#line 145 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
				_g_free0 (color_data);
#line 145 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 145 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
				g_clear_error (&_inner_error0_);
#line 145 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
				return NULL;
#line 568 "color.c"
			}
		}
#line 148 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		bits = (gushort) cd_len;
#line 149 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		self->priv->_alpha = (gushort) (self->priv->_alpha << (16 - bits));
#line 150 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		while (TRUE) {
#line 150 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
			if (!(((gint) bits) < 16)) {
#line 150 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
				break;
#line 581 "color.c"
			}
#line 152 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
			self->priv->_alpha = self->priv->_alpha | (self->priv->_alpha >> bits);
#line 153 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
			bits *= (gushort) 2;
#line 587 "color.c"
		}
#line 155 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		_tmp22_ = rgb_hex;
#line 155 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		_tmp23_ = g_strconcat ("#", _tmp22_, NULL);
#line 155 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		_g_free0 (color_data);
#line 155 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		color_data = _tmp23_;
#line 129 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		_g_free0 (rgb_hex);
#line 129 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		_g_free0 (color_hex);
#line 601 "color.c"
	} else {
		gchar* _tmp24_;
#line 160 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		_tmp24_ = g_strdup (spec);
#line 160 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		_g_free0 (color_data);
#line 160 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		color_data = _tmp24_;
#line 610 "color.c"
	}
#line 162 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	_tmp25_ = color_data;
#line 162 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	_tmp27_ = gdk_color_parse (_tmp25_, &_tmp26_);
#line 162 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	self->priv->_color = _tmp26_;
#line 162 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	if (!_tmp27_) {
#line 620 "color.c"
		GError* _tmp28_;
#line 164 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		_tmp28_ = g_error_new (DESKTOP_AGNOSTIC_COLOR_PARSE_ERROR, DESKTOP_AGNOSTIC_COLOR_PARSE_ERROR_INVALID_INPUT, "Could not parse color string: %s", spec);
#line 164 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		_inner_error0_ = _tmp28_;
#line 164 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		if (_inner_error0_->domain == DESKTOP_AGNOSTIC_COLOR_PARSE_ERROR) {
#line 164 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
			g_propagate_error (error, _inner_error0_);
#line 164 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
			_g_free0 (color_data);
#line 164 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
			_g_object_unref0 (self);
#line 164 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
			return NULL;
#line 636 "color.c"
		} else {
#line 164 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
			_g_free0 (color_data);
#line 164 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 164 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
			g_clear_error (&_inner_error0_);
#line 164 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
			return NULL;
#line 646 "color.c"
		}
	}
#line 124 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	_g_free0 (color_data);
#line 124 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	return self;
#line 653 "color.c"
}

DesktopAgnosticColor*
desktop_agnostic_color_new_from_string (const gchar* spec,
                                        GError** error)
{
#line 124 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	return desktop_agnostic_color_construct_from_string (DESKTOP_AGNOSTIC_TYPE_COLOR, spec, error);
#line 662 "color.c"
}

gchar*
desktop_agnostic_color_to_html_color (DesktopAgnosticColor* self)
{
	guint _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
	guint _tmp3_;
	guint _tmp4_;
	guint _tmp5_;
	gchar* _tmp6_;
	gchar* result;
#line 168 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 171 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	_tmp0_ = desktop_agnostic_color_get_red (self);
#line 171 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	_tmp1_ = _tmp0_;
#line 171 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	_tmp2_ = desktop_agnostic_color_get_green (self);
#line 171 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	_tmp3_ = _tmp2_;
#line 171 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	_tmp4_ = desktop_agnostic_color_get_blue (self);
#line 171 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	_tmp5_ = _tmp4_;
#line 171 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	_tmp6_ = g_strdup_printf (DESKTOP_AGNOSTIC_COLOR_HTML_STRING, _tmp1_ / DESKTOP_AGNOSTIC_COLOR_HTML_SCALE, _tmp3_ / DESKTOP_AGNOSTIC_COLOR_HTML_SCALE, _tmp5_ / DESKTOP_AGNOSTIC_COLOR_HTML_SCALE, self->priv->_alpha / DESKTOP_AGNOSTIC_COLOR_HTML_SCALE);
#line 171 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	result = _tmp6_;
#line 171 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	return result;
#line 696 "color.c"
}

/**
     * Behaves the same as Gdk.Color.to_string (), except that it adds
     * alpha data.
     * @see Gdk.Color.to_string
     */
gchar*
desktop_agnostic_color_to_string (DesktopAgnosticColor* self)
{
	gchar* gdk_str = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 181 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 184 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	_tmp0_ = gdk_color_to_string (&self->priv->_color);
#line 184 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	gdk_str = _tmp0_;
#line 185 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	_tmp1_ = g_strdup_printf ("%s%04x", gdk_str, (guint) self->priv->_alpha);
#line 185 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	result = _tmp1_;
#line 185 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	_g_free0 (gdk_str);
#line 185 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	return result;
#line 725 "color.c"
}

/**
     * Returns the color values as doubles, where 0.0 < value <= 1.0.
     */
void
desktop_agnostic_color_get_cairo_color (DesktopAgnosticColor* self,
                                        gdouble* red,
                                        gdouble* green,
                                        gdouble* blue,
                                        gdouble* alpha)
{
	gdouble _vala_red = 0.0;
	gdouble _vala_green = 0.0;
	gdouble _vala_blue = 0.0;
	gdouble _vala_alpha = 0.0;
#line 190 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	g_return_if_fail (self != NULL);
#line 194 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	if ((&_vala_red) != NULL) {
#line 746 "color.c"
		guint _tmp0_;
		guint _tmp1_;
#line 196 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		_tmp0_ = desktop_agnostic_color_get_red (self);
#line 196 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		_tmp1_ = _tmp0_;
#line 196 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		_vala_red = desktop_agnostic_color_gdk_value_to_cairo ((gushort) _tmp1_);
#line 755 "color.c"
	}
#line 198 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	if ((&_vala_green) != NULL) {
#line 759 "color.c"
		guint _tmp2_;
		guint _tmp3_;
#line 200 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		_tmp2_ = desktop_agnostic_color_get_green (self);
#line 200 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		_tmp3_ = _tmp2_;
#line 200 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		_vala_green = desktop_agnostic_color_gdk_value_to_cairo ((gushort) _tmp3_);
#line 768 "color.c"
	}
#line 202 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	if ((&_vala_blue) != NULL) {
#line 772 "color.c"
		guint _tmp4_;
		guint _tmp5_;
#line 204 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		_tmp4_ = desktop_agnostic_color_get_blue (self);
#line 204 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		_tmp5_ = _tmp4_;
#line 204 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		_vala_blue = desktop_agnostic_color_gdk_value_to_cairo ((gushort) _tmp5_);
#line 781 "color.c"
	}
#line 206 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	if ((&_vala_alpha) != NULL) {
#line 208 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		_vala_alpha = desktop_agnostic_color_gdk_value_to_cairo (self->priv->_alpha);
#line 787 "color.c"
	}
#line 190 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	if (red) {
#line 190 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		*red = _vala_red;
#line 793 "color.c"
	}
#line 190 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	if (green) {
#line 190 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		*green = _vala_green;
#line 799 "color.c"
	}
#line 190 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	if (blue) {
#line 190 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		*blue = _vala_blue;
#line 805 "color.c"
	}
#line 190 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	if (alpha) {
#line 190 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		*alpha = _vala_alpha;
#line 811 "color.c"
	}
}

/**
     * Sets the color with values as doubles, where 0.0 < value <= 1.0.
     */
void
desktop_agnostic_color_set_cairo_color (DesktopAgnosticColor* self,
                                        gdouble red,
                                        gdouble green,
                                        gdouble blue,
                                        gdouble alpha)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
#line 214 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	g_return_if_fail (self != NULL);
#line 217 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	if (red > ((gdouble) 0.0f)) {
#line 217 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		_tmp0_ = red <= ((gdouble) 1.0f);
#line 835 "color.c"
	} else {
#line 217 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		_tmp0_ = FALSE;
#line 839 "color.c"
	}
#line 217 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	if (_tmp0_) {
#line 219 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		desktop_agnostic_color_set_red (self, (guint) desktop_agnostic_color_cairo_value_to_gdk (red));
#line 845 "color.c"
	}
#line 221 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	if (green > ((gdouble) 0.0f)) {
#line 221 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		_tmp1_ = green <= ((gdouble) 1.0f);
#line 851 "color.c"
	} else {
#line 221 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		_tmp1_ = FALSE;
#line 855 "color.c"
	}
#line 221 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	if (_tmp1_) {
#line 223 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		desktop_agnostic_color_set_green (self, (guint) desktop_agnostic_color_cairo_value_to_gdk (green));
#line 861 "color.c"
	}
#line 225 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	if (blue > ((gdouble) 0.0f)) {
#line 225 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		_tmp2_ = blue <= ((gdouble) 1.0f);
#line 867 "color.c"
	} else {
#line 225 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		_tmp2_ = FALSE;
#line 871 "color.c"
	}
#line 225 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	if (_tmp2_) {
#line 227 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		desktop_agnostic_color_set_blue (self, (guint) desktop_agnostic_color_cairo_value_to_gdk (blue));
#line 877 "color.c"
	}
#line 229 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	if (alpha > ((gdouble) 0.0f)) {
#line 229 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		_tmp3_ = alpha <= ((gdouble) 1.0f);
#line 883 "color.c"
	} else {
#line 229 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		_tmp3_ = FALSE;
#line 887 "color.c"
	}
#line 229 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	if (_tmp3_) {
#line 231 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		self->priv->_alpha = desktop_agnostic_color_cairo_value_to_gdk (alpha);
#line 893 "color.c"
	}
}

/**
     * Converts a single RGBA value for cairo to its GDK/Pango equivalent.
     */
gushort
desktop_agnostic_color_cairo_value_to_gdk (gdouble value)
{
	gushort result;
#line 240 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	result = (gushort) (lround (value * 65536) - 1);
#line 240 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	return result;
#line 908 "color.c"
}

/**
     * Converts a single RGBA value for GDK/Pango to its cairo equivalent.
     */
gdouble
desktop_agnostic_color_gdk_value_to_cairo (gushort value)
{
	gdouble result;
#line 248 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	result = (value + 1) / 65536.0;
#line 248 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	return result;
#line 922 "color.c"
}

void
desktop_agnostic_color_get_color (DesktopAgnosticColor* self,
                                  GdkColor * result)
{
	GdkColor _tmp0_;
#line 43 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	g_return_if_fail (self != NULL);
#line 45 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	_tmp0_ = self->priv->_color;
#line 45 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	*result = _tmp0_;
#line 45 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	return;
#line 938 "color.c"
}

void
desktop_agnostic_color_set_color (DesktopAgnosticColor* self,
                                  GdkColor * value)
{
	GdkColor _tmp0_;
#line 47 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	g_return_if_fail (self != NULL);
#line 49 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	_tmp0_ = *value;
#line 49 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	self->priv->_color = _tmp0_;
#line 47 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	g_object_notify_by_pspec ((GObject *) self, desktop_agnostic_color_properties[DESKTOP_AGNOSTIC_COLOR_COLOR_PROPERTY]);
#line 954 "color.c"
}

guint
desktop_agnostic_color_get_red (DesktopAgnosticColor* self)
{
	guint result;
	GdkColor _tmp0_;
#line 64 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 66 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	_tmp0_ = self->priv->_color;
#line 66 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	result = (guint) _tmp0_.red;
#line 66 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	return result;
#line 970 "color.c"
}

void
desktop_agnostic_color_set_red (DesktopAgnosticColor* self,
                                guint value)
{
	gushort _tmp0_ = 0U;
	GError* _inner_error0_ = NULL;
#line 68 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	g_return_if_fail (self != NULL);
#line 70 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	_tmp0_ = desktop_agnostic_color_ushortify (self, value, &_inner_error0_);
#line 70 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 70 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 70 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		g_clear_error (&_inner_error0_);
#line 70 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		return;
#line 991 "color.c"
	}
#line 70 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	self->priv->_color.red = (guint16) _tmp0_;
#line 68 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	g_object_notify_by_pspec ((GObject *) self, desktop_agnostic_color_properties[DESKTOP_AGNOSTIC_COLOR_RED_PROPERTY]);
#line 997 "color.c"
}

guint
desktop_agnostic_color_get_green (DesktopAgnosticColor* self)
{
	guint result;
	GdkColor _tmp0_;
#line 75 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 77 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	_tmp0_ = self->priv->_color;
#line 77 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	result = (guint) _tmp0_.green;
#line 77 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	return result;
#line 1013 "color.c"
}

void
desktop_agnostic_color_set_green (DesktopAgnosticColor* self,
                                  guint value)
{
	gushort _tmp0_ = 0U;
	GError* _inner_error0_ = NULL;
#line 79 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	g_return_if_fail (self != NULL);
#line 81 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	_tmp0_ = desktop_agnostic_color_ushortify (self, value, &_inner_error0_);
#line 81 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 81 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 81 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		g_clear_error (&_inner_error0_);
#line 81 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		return;
#line 1034 "color.c"
	}
#line 81 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	self->priv->_color.green = (guint16) _tmp0_;
#line 79 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	g_object_notify_by_pspec ((GObject *) self, desktop_agnostic_color_properties[DESKTOP_AGNOSTIC_COLOR_GREEN_PROPERTY]);
#line 1040 "color.c"
}

guint
desktop_agnostic_color_get_blue (DesktopAgnosticColor* self)
{
	guint result;
	GdkColor _tmp0_;
#line 86 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 88 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	_tmp0_ = self->priv->_color;
#line 88 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	result = (guint) _tmp0_.blue;
#line 88 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	return result;
#line 1056 "color.c"
}

void
desktop_agnostic_color_set_blue (DesktopAgnosticColor* self,
                                 guint value)
{
	gushort _tmp0_ = 0U;
	GError* _inner_error0_ = NULL;
#line 90 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	g_return_if_fail (self != NULL);
#line 92 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	_tmp0_ = desktop_agnostic_color_ushortify (self, value, &_inner_error0_);
#line 92 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 92 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 92 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		g_clear_error (&_inner_error0_);
#line 92 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		return;
#line 1077 "color.c"
	}
#line 92 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	self->priv->_color.blue = (guint16) _tmp0_;
#line 90 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	g_object_notify_by_pspec ((GObject *) self, desktop_agnostic_color_properties[DESKTOP_AGNOSTIC_COLOR_BLUE_PROPERTY]);
#line 1083 "color.c"
}

guint
desktop_agnostic_color_get_alpha (DesktopAgnosticColor* self)
{
	guint result;
#line 98 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 100 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	result = (guint) self->priv->_alpha;
#line 100 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	return result;
#line 1096 "color.c"
}

void
desktop_agnostic_color_set_alpha (DesktopAgnosticColor* self,
                                  guint value)
{
	gushort _tmp0_ = 0U;
	GError* _inner_error0_ = NULL;
#line 102 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	g_return_if_fail (self != NULL);
#line 104 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	_tmp0_ = desktop_agnostic_color_ushortify (self, value, &_inner_error0_);
#line 104 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 104 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 104 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		g_clear_error (&_inner_error0_);
#line 104 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		return;
#line 1117 "color.c"
	}
#line 104 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	self->priv->_alpha = _tmp0_;
#line 102 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	g_object_notify_by_pspec ((GObject *) self, desktop_agnostic_color_properties[DESKTOP_AGNOSTIC_COLOR_ALPHA_PROPERTY]);
#line 1123 "color.c"
}

static void
desktop_agnostic_color_class_init (DesktopAgnosticColorClass * klass,
                                   gpointer klass_data)
{
#line 36 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	desktop_agnostic_color_parent_class = g_type_class_peek_parent (klass);
#line 36 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	g_type_class_adjust_private_offset (klass, &DesktopAgnosticColor_private_offset);
#line 36 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_desktop_agnostic_color_get_property;
#line 36 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_desktop_agnostic_color_set_property;
#line 36 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	G_OBJECT_CLASS (klass)->finalize = desktop_agnostic_color_finalize;
#line 36 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DESKTOP_AGNOSTIC_COLOR_COLOR_PROPERTY, desktop_agnostic_color_properties[DESKTOP_AGNOSTIC_COLOR_COLOR_PROPERTY] = g_param_spec_boxed ("color", "color", "color", GDK_TYPE_COLOR, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 36 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DESKTOP_AGNOSTIC_COLOR_RED_PROPERTY, desktop_agnostic_color_properties[DESKTOP_AGNOSTIC_COLOR_RED_PROPERTY] = g_param_spec_uint ("red", "red", "red", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 36 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DESKTOP_AGNOSTIC_COLOR_GREEN_PROPERTY, desktop_agnostic_color_properties[DESKTOP_AGNOSTIC_COLOR_GREEN_PROPERTY] = g_param_spec_uint ("green", "green", "green", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 36 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DESKTOP_AGNOSTIC_COLOR_BLUE_PROPERTY, desktop_agnostic_color_properties[DESKTOP_AGNOSTIC_COLOR_BLUE_PROPERTY] = g_param_spec_uint ("blue", "blue", "blue", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 36 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DESKTOP_AGNOSTIC_COLOR_ALPHA_PROPERTY, desktop_agnostic_color_properties[DESKTOP_AGNOSTIC_COLOR_ALPHA_PROPERTY] = g_param_spec_uint ("alpha", "alpha", "alpha", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1150 "color.c"
}

static void
desktop_agnostic_color_instance_init (DesktopAgnosticColor * self,
                                      gpointer klass)
{
#line 36 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	self->priv = desktop_agnostic_color_get_instance_private (self);
#line 95 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	self->priv->_alpha = G_MAXUSHORT;
#line 1161 "color.c"
}

static void
desktop_agnostic_color_finalize (GObject * obj)
{
	DesktopAgnosticColor * self;
#line 36 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DESKTOP_AGNOSTIC_TYPE_COLOR, DesktopAgnosticColor);
#line 36 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	G_OBJECT_CLASS (desktop_agnostic_color_parent_class)->finalize (obj);
#line 1172 "color.c"
}

/**
   * Note: cannot use ushort in properties as Value cannot be mapped to it.
   */
static GType
desktop_agnostic_color_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DesktopAgnosticColorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) desktop_agnostic_color_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DesktopAgnosticColor), 0, (GInstanceInitFunc) desktop_agnostic_color_instance_init, NULL };
	GType desktop_agnostic_color_type_id;
	desktop_agnostic_color_type_id = g_type_register_static (G_TYPE_OBJECT, "DesktopAgnosticColor", &g_define_type_info, 0);
	DesktopAgnosticColor_private_offset = g_type_add_instance_private (desktop_agnostic_color_type_id, sizeof (DesktopAgnosticColorPrivate));
	return desktop_agnostic_color_type_id;
}

GType
desktop_agnostic_color_get_type (void)
{
	static volatile gsize desktop_agnostic_color_type_id__once = 0;
	if (g_once_init_enter (&desktop_agnostic_color_type_id__once)) {
		GType desktop_agnostic_color_type_id;
		desktop_agnostic_color_type_id = desktop_agnostic_color_get_type_once ();
		g_once_init_leave (&desktop_agnostic_color_type_id__once, desktop_agnostic_color_type_id);
	}
	return desktop_agnostic_color_type_id__once;
}

static void
_vala_desktop_agnostic_color_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	DesktopAgnosticColor * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DESKTOP_AGNOSTIC_TYPE_COLOR, DesktopAgnosticColor);
#line 36 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	switch (property_id) {
#line 36 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		case DESKTOP_AGNOSTIC_COLOR_COLOR_PROPERTY:
#line 1212 "color.c"
		{
			GdkColor boxed;
#line 36 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
			desktop_agnostic_color_get_color (self, &boxed);
#line 36 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
			g_value_set_boxed (value, &boxed);
#line 1219 "color.c"
		}
#line 36 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		break;
#line 36 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		case DESKTOP_AGNOSTIC_COLOR_RED_PROPERTY:
#line 36 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		g_value_set_uint (value, desktop_agnostic_color_get_red (self));
#line 36 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		break;
#line 36 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		case DESKTOP_AGNOSTIC_COLOR_GREEN_PROPERTY:
#line 36 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		g_value_set_uint (value, desktop_agnostic_color_get_green (self));
#line 36 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		break;
#line 36 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		case DESKTOP_AGNOSTIC_COLOR_BLUE_PROPERTY:
#line 36 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		g_value_set_uint (value, desktop_agnostic_color_get_blue (self));
#line 36 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		break;
#line 36 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		case DESKTOP_AGNOSTIC_COLOR_ALPHA_PROPERTY:
#line 36 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		g_value_set_uint (value, desktop_agnostic_color_get_alpha (self));
#line 36 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		break;
#line 1247 "color.c"
		default:
#line 36 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 36 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		break;
#line 1253 "color.c"
	}
}

static void
_vala_desktop_agnostic_color_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	DesktopAgnosticColor * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DESKTOP_AGNOSTIC_TYPE_COLOR, DesktopAgnosticColor);
#line 36 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
	switch (property_id) {
#line 36 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		case DESKTOP_AGNOSTIC_COLOR_COLOR_PROPERTY:
#line 36 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		desktop_agnostic_color_set_color (self, g_value_get_boxed (value));
#line 36 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		break;
#line 36 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		case DESKTOP_AGNOSTIC_COLOR_RED_PROPERTY:
#line 36 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		desktop_agnostic_color_set_red (self, g_value_get_uint (value));
#line 36 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		break;
#line 36 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		case DESKTOP_AGNOSTIC_COLOR_GREEN_PROPERTY:
#line 36 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		desktop_agnostic_color_set_green (self, g_value_get_uint (value));
#line 36 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		break;
#line 36 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		case DESKTOP_AGNOSTIC_COLOR_BLUE_PROPERTY:
#line 36 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		desktop_agnostic_color_set_blue (self, g_value_get_uint (value));
#line 36 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		break;
#line 36 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		case DESKTOP_AGNOSTIC_COLOR_ALPHA_PROPERTY:
#line 36 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		desktop_agnostic_color_set_alpha (self, g_value_get_uint (value));
#line 36 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		break;
#line 1297 "color.c"
		default:
#line 36 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 36 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/color.vala"
		break;
#line 1303 "color.c"
	}
}

