/* desktop-entry.c generated by valac 0.56.17, the Vala compiler
 * generated from desktop-entry.vala, do not modify */

/*
 * Desktop Agnostic Library: Desktop Entry interface.
 *
 * Copyright (C) 2009 Mark Lee <libdesktop-agnostic@lazymalevolence.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 *
 * Author : Mark Lee <libdesktop-agnostic@lazymalevolence.com>
 */

#include "desktop-agnostic-fdo.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <desktop-agnostic-vfs.h>
#include <glib-object.h>
#include <libdesktop-agnostic/desktop-agnostic.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_free0(var) ((var == NULL) ? NULL : (var = (g_free (var), NULL)))

/**
   * Generic, DesktopEntry-related errors.
   */

VALA_EXTERN GType* desktop_agnostic_fdo_module_type;
GType* desktop_agnostic_fdo_module_type = NULL;

static GType desktop_agnostic_fdo_desktop_entry_get_type_once (void);
static GType* _g_type_dup (GType* self);

/**
   * Flags used when launching an application from a desktop entry.
   */
static GType
desktop_agnostic_fdo_desktop_entry_launch_flags_get_type_once (void)
{
	static const GEnumValue values[] = {{DESKTOP_AGNOSTIC_FDO_DESKTOP_ENTRY_LAUNCH_FLAGS_ONLY_ONE, "DESKTOP_AGNOSTIC_FDO_DESKTOP_ENTRY_LAUNCH_FLAGS_ONLY_ONE", "only-one"}, {DESKTOP_AGNOSTIC_FDO_DESKTOP_ENTRY_LAUNCH_FLAGS_USE_CWD, "DESKTOP_AGNOSTIC_FDO_DESKTOP_ENTRY_LAUNCH_FLAGS_USE_CWD", "use-cwd"}, {DESKTOP_AGNOSTIC_FDO_DESKTOP_ENTRY_LAUNCH_FLAGS_DO_NOT_REAP_CHILD, "DESKTOP_AGNOSTIC_FDO_DESKTOP_ENTRY_LAUNCH_FLAGS_DO_NOT_REAP_CHILD", "do-not-reap-child"}, {0, NULL, NULL}};
	GType desktop_agnostic_fdo_desktop_entry_launch_flags_type_id;
	desktop_agnostic_fdo_desktop_entry_launch_flags_type_id = g_enum_register_static ("DesktopAgnosticFDODesktopEntryLaunchFlags", values);
	return desktop_agnostic_fdo_desktop_entry_launch_flags_type_id;
}

GType
desktop_agnostic_fdo_desktop_entry_launch_flags_get_type (void)
{
	static volatile gsize desktop_agnostic_fdo_desktop_entry_launch_flags_type_id__once = 0;
	if (g_once_init_enter (&desktop_agnostic_fdo_desktop_entry_launch_flags_type_id__once)) {
		GType desktop_agnostic_fdo_desktop_entry_launch_flags_type_id;
		desktop_agnostic_fdo_desktop_entry_launch_flags_type_id = desktop_agnostic_fdo_desktop_entry_launch_flags_get_type_once ();
		g_once_init_leave (&desktop_agnostic_fdo_desktop_entry_launch_flags_type_id__once, desktop_agnostic_fdo_desktop_entry_launch_flags_type_id);
	}
	return desktop_agnostic_fdo_desktop_entry_launch_flags_type_id__once;
}

/**
   * The kind of desktop entry.
   *
   * [[http://standards.freedesktop.org/desktop-entry-spec/latest/ar01s05.html]]
   */
static GType
desktop_agnostic_fdo_desktop_entry_type_get_type_once (void)
{
	static const GEnumValue values[] = {{DESKTOP_AGNOSTIC_FDO_DESKTOP_ENTRY_TYPE_UNKNOWN, "DESKTOP_AGNOSTIC_FDO_DESKTOP_ENTRY_TYPE_UNKNOWN", "unknown"}, {DESKTOP_AGNOSTIC_FDO_DESKTOP_ENTRY_TYPE_APPLICATION, "DESKTOP_AGNOSTIC_FDO_DESKTOP_ENTRY_TYPE_APPLICATION", "application"}, {DESKTOP_AGNOSTIC_FDO_DESKTOP_ENTRY_TYPE_LINK, "DESKTOP_AGNOSTIC_FDO_DESKTOP_ENTRY_TYPE_LINK", "link"}, {DESKTOP_AGNOSTIC_FDO_DESKTOP_ENTRY_TYPE_DIRECTORY, "DESKTOP_AGNOSTIC_FDO_DESKTOP_ENTRY_TYPE_DIRECTORY", "directory"}, {0, NULL, NULL}};
	GType desktop_agnostic_fdo_desktop_entry_type_type_id;
	desktop_agnostic_fdo_desktop_entry_type_type_id = g_enum_register_static ("DesktopAgnosticFDODesktopEntryType", values);
	return desktop_agnostic_fdo_desktop_entry_type_type_id;
}

GType
desktop_agnostic_fdo_desktop_entry_type_get_type (void)
{
	static volatile gsize desktop_agnostic_fdo_desktop_entry_type_type_id__once = 0;
	if (g_once_init_enter (&desktop_agnostic_fdo_desktop_entry_type_type_id__once)) {
		GType desktop_agnostic_fdo_desktop_entry_type_type_id;
		desktop_agnostic_fdo_desktop_entry_type_type_id = desktop_agnostic_fdo_desktop_entry_type_get_type_once ();
		g_once_init_leave (&desktop_agnostic_fdo_desktop_entry_type_type_id__once, desktop_agnostic_fdo_desktop_entry_type_type_id);
	}
	return desktop_agnostic_fdo_desktop_entry_type_type_id__once;
}

GQuark
desktop_agnostic_fdo_desktop_entry_error_quark (void)
{
	return g_quark_from_static_string ("desktop-agnostic-fdo-desktop-entry-error-quark");
}

static GType
desktop_agnostic_fdo_desktop_entry_error_get_type_once (void)
{
	static const GEnumValue values[] = {{DESKTOP_AGNOSTIC_FDO_DESKTOP_ENTRY_ERROR_INVALID_FILE, "DESKTOP_AGNOSTIC_FDO_DESKTOP_ENTRY_ERROR_INVALID_FILE", "invalid-file"}, {DESKTOP_AGNOSTIC_FDO_DESKTOP_ENTRY_ERROR_NOT_LAUNCHABLE, "DESKTOP_AGNOSTIC_FDO_DESKTOP_ENTRY_ERROR_NOT_LAUNCHABLE", "not-launchable"}, {0, NULL, NULL}};
	GType desktop_agnostic_fdo_desktop_entry_error_type_id;
	desktop_agnostic_fdo_desktop_entry_error_type_id = g_enum_register_static ("DesktopAgnosticFDODesktopEntryError", values);
	return desktop_agnostic_fdo_desktop_entry_error_type_id;
}

GType
desktop_agnostic_fdo_desktop_entry_error_get_type (void)
{
	static volatile gsize desktop_agnostic_fdo_desktop_entry_error_type_id__once = 0;
	if (g_once_init_enter (&desktop_agnostic_fdo_desktop_entry_error_type_id__once)) {
		GType desktop_agnostic_fdo_desktop_entry_error_type_id;
		desktop_agnostic_fdo_desktop_entry_error_type_id = desktop_agnostic_fdo_desktop_entry_error_get_type_once ();
		g_once_init_leave (&desktop_agnostic_fdo_desktop_entry_error_type_id__once, desktop_agnostic_fdo_desktop_entry_error_type_id);
	}
	return desktop_agnostic_fdo_desktop_entry_error_type_id__once;
}

/**
   * Converts a DesktopEntryType to its string counterpart.
   */
gchar*
desktop_agnostic_fdo_desktop_entry_type_to_string (DesktopAgnosticFDODesktopEntryType entry_type)
{
	gchar* result;
#line 65 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	switch (entry_type) {
#line 65 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
		case DESKTOP_AGNOSTIC_FDO_DESKTOP_ENTRY_TYPE_APPLICATION:
#line 144 "desktop-entry.c"
		{
			gchar* _tmp0_;
#line 68 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
			_tmp0_ = g_strdup ("Application");
#line 68 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
			result = _tmp0_;
#line 68 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
			return result;
#line 153 "desktop-entry.c"
		}
#line 65 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
		case DESKTOP_AGNOSTIC_FDO_DESKTOP_ENTRY_TYPE_LINK:
#line 157 "desktop-entry.c"
		{
			gchar* _tmp1_;
#line 70 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
			_tmp1_ = g_strdup ("Link");
#line 70 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
			result = _tmp1_;
#line 70 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
			return result;
#line 166 "desktop-entry.c"
		}
#line 65 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
		case DESKTOP_AGNOSTIC_FDO_DESKTOP_ENTRY_TYPE_DIRECTORY:
#line 170 "desktop-entry.c"
		{
			gchar* _tmp2_;
#line 72 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
			_tmp2_ = g_strdup ("Directory");
#line 72 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
			result = _tmp2_;
#line 72 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
			return result;
#line 179 "desktop-entry.c"
		}
		default:
		{
			gchar* _tmp3_;
#line 74 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
			_tmp3_ = g_strdup ("Unknown");
#line 74 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
			result = _tmp3_;
#line 74 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
			return result;
#line 190 "desktop-entry.c"
		}
	}
}

gboolean
desktop_agnostic_fdo_desktop_entry_key_exists (DesktopAgnosticFDODesktopEntry* self,
                                               const gchar* key)
{
	DesktopAgnosticFDODesktopEntryIface* _iface_;
#line 109 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 109 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	_iface_ = DESKTOP_AGNOSTIC_FDO_DESKTOP_ENTRY_GET_INTERFACE (self);
#line 109 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	if (_iface_->key_exists) {
#line 109 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
		return _iface_->key_exists (self, key);
#line 208 "desktop-entry.c"
	}
#line 109 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	return FALSE;
#line 212 "desktop-entry.c"
}

gboolean
desktop_agnostic_fdo_desktop_entry_get_boolean (DesktopAgnosticFDODesktopEntry* self,
                                                const gchar* key)
{
	DesktopAgnosticFDODesktopEntryIface* _iface_;
#line 110 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 110 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	_iface_ = DESKTOP_AGNOSTIC_FDO_DESKTOP_ENTRY_GET_INTERFACE (self);
#line 110 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	if (_iface_->get_boolean) {
#line 110 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
		return _iface_->get_boolean (self, key);
#line 228 "desktop-entry.c"
	}
#line 110 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	return FALSE;
#line 232 "desktop-entry.c"
}

void
desktop_agnostic_fdo_desktop_entry_set_boolean (DesktopAgnosticFDODesktopEntry* self,
                                                const gchar* key,
                                                gboolean value)
{
	DesktopAgnosticFDODesktopEntryIface* _iface_;
#line 111 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	g_return_if_fail (self != NULL);
#line 111 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	_iface_ = DESKTOP_AGNOSTIC_FDO_DESKTOP_ENTRY_GET_INTERFACE (self);
#line 111 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	if (_iface_->set_boolean) {
#line 111 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
		_iface_->set_boolean (self, key, value);
#line 249 "desktop-entry.c"
	}
}

gchar*
desktop_agnostic_fdo_desktop_entry_get_string (DesktopAgnosticFDODesktopEntry* self,
                                               const gchar* key)
{
	DesktopAgnosticFDODesktopEntryIface* _iface_;
#line 112 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 112 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	_iface_ = DESKTOP_AGNOSTIC_FDO_DESKTOP_ENTRY_GET_INTERFACE (self);
#line 112 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	if (_iface_->get_string) {
#line 112 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
		return _iface_->get_string (self, key);
#line 266 "desktop-entry.c"
	}
#line 112 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	return NULL;
#line 270 "desktop-entry.c"
}

void
desktop_agnostic_fdo_desktop_entry_set_string (DesktopAgnosticFDODesktopEntry* self,
                                               const gchar* key,
                                               const gchar* value)
{
	DesktopAgnosticFDODesktopEntryIface* _iface_;
#line 113 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	g_return_if_fail (self != NULL);
#line 113 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	_iface_ = DESKTOP_AGNOSTIC_FDO_DESKTOP_ENTRY_GET_INTERFACE (self);
#line 113 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	if (_iface_->set_string) {
#line 113 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
		_iface_->set_string (self, key, value);
#line 287 "desktop-entry.c"
	}
}

gchar*
desktop_agnostic_fdo_desktop_entry_get_localestring (DesktopAgnosticFDODesktopEntry* self,
                                                     const gchar* key,
                                                     const gchar* locale)
{
	DesktopAgnosticFDODesktopEntryIface* _iface_;
#line 114 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 114 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	_iface_ = DESKTOP_AGNOSTIC_FDO_DESKTOP_ENTRY_GET_INTERFACE (self);
#line 114 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	if (_iface_->get_localestring) {
#line 114 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
		return _iface_->get_localestring (self, key, locale);
#line 305 "desktop-entry.c"
	}
#line 114 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	return NULL;
#line 309 "desktop-entry.c"
}

void
desktop_agnostic_fdo_desktop_entry_set_localestring (DesktopAgnosticFDODesktopEntry* self,
                                                     const gchar* key,
                                                     const gchar* locale,
                                                     const gchar* value)
{
	DesktopAgnosticFDODesktopEntryIface* _iface_;
#line 115 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	g_return_if_fail (self != NULL);
#line 115 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	_iface_ = DESKTOP_AGNOSTIC_FDO_DESKTOP_ENTRY_GET_INTERFACE (self);
#line 115 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	if (_iface_->set_localestring) {
#line 115 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
		_iface_->set_localestring (self, key, locale, value);
#line 327 "desktop-entry.c"
	}
}

gchar**
desktop_agnostic_fdo_desktop_entry_get_string_list (DesktopAgnosticFDODesktopEntry* self,
                                                    const gchar* key)
{
	DesktopAgnosticFDODesktopEntryIface* _iface_;
#line 117 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 117 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	_iface_ = DESKTOP_AGNOSTIC_FDO_DESKTOP_ENTRY_GET_INTERFACE (self);
#line 117 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	if (_iface_->get_string_list) {
#line 117 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
		return _iface_->get_string_list (self, key);
#line 344 "desktop-entry.c"
	}
#line 117 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	return NULL;
#line 348 "desktop-entry.c"
}

void
desktop_agnostic_fdo_desktop_entry_set_string_list (DesktopAgnosticFDODesktopEntry* self,
                                                    const gchar* key,
                                                    gchar** value)
{
	DesktopAgnosticFDODesktopEntryIface* _iface_;
#line 118 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	g_return_if_fail (self != NULL);
#line 118 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	_iface_ = DESKTOP_AGNOSTIC_FDO_DESKTOP_ENTRY_GET_INTERFACE (self);
#line 118 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	if (_iface_->set_string_list) {
#line 118 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
		_iface_->set_string_list (self, key, value);
#line 365 "desktop-entry.c"
	}
}

/**
     * Whether the path specified in the "Exec" key exists. if the entry type is
     * "Application", also checks to see if it's launchable.
     */
gboolean
desktop_agnostic_fdo_desktop_entry_exists (DesktopAgnosticFDODesktopEntry* self)
{
	DesktopAgnosticFDODesktopEntryIface* _iface_;
#line 124 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 124 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	_iface_ = DESKTOP_AGNOSTIC_FDO_DESKTOP_ENTRY_GET_INTERFACE (self);
#line 124 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	if (_iface_->exists) {
#line 124 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
		return _iface_->exists (self);
#line 385 "desktop-entry.c"
	}
#line 124 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	return FALSE;
#line 389 "desktop-entry.c"
}

GPid
desktop_agnostic_fdo_desktop_entry_launch (DesktopAgnosticFDODesktopEntry* self,
                                           DesktopAgnosticFDODesktopEntryLaunchFlags flags,
                                           GSList* documents,
                                           GError** error)
{
	DesktopAgnosticFDODesktopEntryIface* _iface_;
#line 125 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 125 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	_iface_ = DESKTOP_AGNOSTIC_FDO_DESKTOP_ENTRY_GET_INTERFACE (self);
#line 125 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	if (_iface_->launch) {
#line 125 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
		return _iface_->launch (self, flags, documents, error);
#line 407 "desktop-entry.c"
	}
#line 125 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	return 0;
#line 411 "desktop-entry.c"
}

void
desktop_agnostic_fdo_desktop_entry_save (DesktopAgnosticFDODesktopEntry* self,
                                         DesktopAgnosticVFSFile* new_file,
                                         GError** error)
{
	DesktopAgnosticFDODesktopEntryIface* _iface_;
#line 126 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	g_return_if_fail (self != NULL);
#line 126 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	_iface_ = DESKTOP_AGNOSTIC_FDO_DESKTOP_ENTRY_GET_INTERFACE (self);
#line 126 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	if (_iface_->save) {
#line 126 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
		_iface_->save (self, new_file, error);
#line 428 "desktop-entry.c"
	}
}

DesktopAgnosticVFSFile*
desktop_agnostic_fdo_desktop_entry_get_file (DesktopAgnosticFDODesktopEntry* self)
{
	DesktopAgnosticFDODesktopEntryIface* _iface_;
#line 86 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 86 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	_iface_ = DESKTOP_AGNOSTIC_FDO_DESKTOP_ENTRY_GET_INTERFACE (self);
#line 86 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	if (_iface_->get_file) {
#line 86 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
		return _iface_->get_file (self);
#line 444 "desktop-entry.c"
	}
#line 86 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	return NULL;
#line 448 "desktop-entry.c"
}

void
desktop_agnostic_fdo_desktop_entry_set_file (DesktopAgnosticFDODesktopEntry* self,
                                             DesktopAgnosticVFSFile* value)
{
	DesktopAgnosticFDODesktopEntryIface* _iface_;
#line 86 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	g_return_if_fail (self != NULL);
#line 86 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	_iface_ = DESKTOP_AGNOSTIC_FDO_DESKTOP_ENTRY_GET_INTERFACE (self);
#line 86 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	if (_iface_->set_file) {
#line 86 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
		_iface_->set_file (self, value);
#line 464 "desktop-entry.c"
	}
}

GKeyFile*
desktop_agnostic_fdo_desktop_entry_get_keyfile (DesktopAgnosticFDODesktopEntry* self)
{
	DesktopAgnosticFDODesktopEntryIface* _iface_;
#line 93 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 93 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	_iface_ = DESKTOP_AGNOSTIC_FDO_DESKTOP_ENTRY_GET_INTERFACE (self);
#line 93 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	if (_iface_->get_keyfile) {
#line 93 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
		return _iface_->get_keyfile (self);
#line 480 "desktop-entry.c"
	}
#line 93 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	return NULL;
#line 484 "desktop-entry.c"
}

void
desktop_agnostic_fdo_desktop_entry_set_keyfile (DesktopAgnosticFDODesktopEntry* self,
                                                GKeyFile* value)
{
	DesktopAgnosticFDODesktopEntryIface* _iface_;
#line 93 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	g_return_if_fail (self != NULL);
#line 93 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	_iface_ = DESKTOP_AGNOSTIC_FDO_DESKTOP_ENTRY_GET_INTERFACE (self);
#line 93 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	if (_iface_->set_keyfile) {
#line 93 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
		_iface_->set_keyfile (self, value);
#line 500 "desktop-entry.c"
	}
}

void
desktop_agnostic_fdo_desktop_entry_set_data (DesktopAgnosticFDODesktopEntry* self,
                                             const gchar* value)
{
	DesktopAgnosticFDODesktopEntryIface* _iface_;
#line 101 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	g_return_if_fail (self != NULL);
#line 101 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	_iface_ = DESKTOP_AGNOSTIC_FDO_DESKTOP_ENTRY_GET_INTERFACE (self);
#line 101 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	if (_iface_->set_data) {
#line 101 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
		_iface_->set_data (self, value);
#line 517 "desktop-entry.c"
	}
}

DesktopAgnosticFDODesktopEntryType
desktop_agnostic_fdo_desktop_entry_get_entry_type (DesktopAgnosticFDODesktopEntry* self)
{
	DesktopAgnosticFDODesktopEntryIface* _iface_;
#line 106 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 106 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	_iface_ = DESKTOP_AGNOSTIC_FDO_DESKTOP_ENTRY_GET_INTERFACE (self);
#line 106 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	if (_iface_->get_entry_type) {
#line 106 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
		return _iface_->get_entry_type (self);
#line 533 "desktop-entry.c"
	}
#line 106 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	return 0;
#line 537 "desktop-entry.c"
}

void
desktop_agnostic_fdo_desktop_entry_set_entry_type (DesktopAgnosticFDODesktopEntry* self,
                                                   DesktopAgnosticFDODesktopEntryType value)
{
	DesktopAgnosticFDODesktopEntryIface* _iface_;
#line 106 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	g_return_if_fail (self != NULL);
#line 106 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	_iface_ = DESKTOP_AGNOSTIC_FDO_DESKTOP_ENTRY_GET_INTERFACE (self);
#line 106 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	if (_iface_->set_entry_type) {
#line 106 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
		_iface_->set_entry_type (self, value);
#line 553 "desktop-entry.c"
	}
}

gchar*
desktop_agnostic_fdo_desktop_entry_get_name (DesktopAgnosticFDODesktopEntry* self)
{
	DesktopAgnosticFDODesktopEntryIface* _iface_;
#line 107 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 107 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	_iface_ = DESKTOP_AGNOSTIC_FDO_DESKTOP_ENTRY_GET_INTERFACE (self);
#line 107 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	if (_iface_->get_name) {
#line 107 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
		return _iface_->get_name (self);
#line 569 "desktop-entry.c"
	}
#line 107 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	return NULL;
#line 573 "desktop-entry.c"
}

void
desktop_agnostic_fdo_desktop_entry_set_name (DesktopAgnosticFDODesktopEntry* self,
                                             const gchar* value)
{
	DesktopAgnosticFDODesktopEntryIface* _iface_;
#line 107 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	g_return_if_fail (self != NULL);
#line 107 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	_iface_ = DESKTOP_AGNOSTIC_FDO_DESKTOP_ENTRY_GET_INTERFACE (self);
#line 107 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	if (_iface_->set_name) {
#line 107 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
		_iface_->set_name (self, value);
#line 589 "desktop-entry.c"
	}
}

gchar*
desktop_agnostic_fdo_desktop_entry_get_icon (DesktopAgnosticFDODesktopEntry* self)
{
	DesktopAgnosticFDODesktopEntryIface* _iface_;
#line 108 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 108 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	_iface_ = DESKTOP_AGNOSTIC_FDO_DESKTOP_ENTRY_GET_INTERFACE (self);
#line 108 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	if (_iface_->get_icon) {
#line 108 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
		return _iface_->get_icon (self);
#line 605 "desktop-entry.c"
	}
#line 108 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	return NULL;
#line 609 "desktop-entry.c"
}

void
desktop_agnostic_fdo_desktop_entry_set_icon (DesktopAgnosticFDODesktopEntry* self,
                                             const gchar* value)
{
	DesktopAgnosticFDODesktopEntryIface* _iface_;
#line 108 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	g_return_if_fail (self != NULL);
#line 108 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	_iface_ = DESKTOP_AGNOSTIC_FDO_DESKTOP_ENTRY_GET_INTERFACE (self);
#line 108 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	if (_iface_->set_icon) {
#line 108 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
		_iface_->set_icon (self, value);
#line 625 "desktop-entry.c"
	}
}

static void
desktop_agnostic_fdo_desktop_entry_default_init (DesktopAgnosticFDODesktopEntryIface * iface,
                                                 gpointer iface_data)
{
	/**
	     * The file object which points to the desktop entry file. Cannot be
	     * constructed in conjunction with either keyfile or data.
	     * Note: these are really construct-only, but construct-only properties
	     * don't work with GModules.
	     */
#line 77 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	g_object_interface_install_property (iface, g_param_spec_object ("file", "file", "file", DESKTOP_AGNOSTIC_VFS_TYPE_FILE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 641 "desktop-entry.c"
	/**
	     * The URI of the desktop entry. Cannot be constructed with either file
	     * or data.
	     * Note: these are really construct-only, but construct-only properties
	     * don't work with GModules.
	     */
#line 77 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	g_object_interface_install_property (iface, g_param_spec_boxed ("keyfile", "keyfile", "keyfile", G_TYPE_KEY_FILE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 650 "desktop-entry.c"
	/**
	     * The raw data that is formatted according to the desktop entry
	     * specification. Cannot be constructed in conjunction with either file or
	     * keyfile.
	     * Note: these are really construct-only, but construct-only properties
	     * don't work with GModules.
	     */
#line 77 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	g_object_interface_install_property (iface, g_param_spec_string ("data", "data", "data", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 660 "desktop-entry.c"
	/**
	     * The type of desktop entry, corresponding to the "Type" key.
	     */
#line 77 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	g_object_interface_install_property (iface, g_param_spec_enum ("entry-type", "entry-type", "entry-type", DESKTOP_AGNOSTIC_FDO_TYPE_DESKTOP_ENTRY_TYPE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 77 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	g_object_interface_install_property (iface, g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 77 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	g_object_interface_install_property (iface, g_param_spec_string ("icon", "icon", "icon", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 670 "desktop-entry.c"
}

static GType
desktop_agnostic_fdo_desktop_entry_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DesktopAgnosticFDODesktopEntryIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) desktop_agnostic_fdo_desktop_entry_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType desktop_agnostic_fdo_desktop_entry_type_id;
	desktop_agnostic_fdo_desktop_entry_type_id = g_type_register_static (G_TYPE_INTERFACE, "DesktopAgnosticFDODesktopEntry", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (desktop_agnostic_fdo_desktop_entry_type_id, G_TYPE_OBJECT);
	return desktop_agnostic_fdo_desktop_entry_type_id;
}

GType
desktop_agnostic_fdo_desktop_entry_get_type (void)
{
	static volatile gsize desktop_agnostic_fdo_desktop_entry_type_id__once = 0;
	if (g_once_init_enter (&desktop_agnostic_fdo_desktop_entry_type_id__once)) {
		GType desktop_agnostic_fdo_desktop_entry_type_id;
		desktop_agnostic_fdo_desktop_entry_type_id = desktop_agnostic_fdo_desktop_entry_get_type_once ();
		g_once_init_leave (&desktop_agnostic_fdo_desktop_entry_type_id__once, desktop_agnostic_fdo_desktop_entry_type_id);
	}
	return desktop_agnostic_fdo_desktop_entry_type_id__once;
}

static GType*
_g_type_dup (GType* self)
{
	GType* dup;
#line 136 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	dup = g_new0 (GType, 1);
#line 136 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	memcpy (dup, self, sizeof (GType));
#line 136 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	return dup;
#line 705 "desktop-entry.c"
}

static gpointer
__g_type_dup0 (gpointer self)
{
#line 136 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	return self ? _g_type_dup (self) : NULL;
#line 713 "desktop-entry.c"
}

GType
desktop_agnostic_fdo_get_type (GError** error)
{
	GType* _tmp0_;
	GType* _tmp4_;
	GError* _inner_error0_ = NULL;
	GType result;
#line 134 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	_tmp0_ = desktop_agnostic_fdo_module_type;
#line 134 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	if (_tmp0_ == NULL) {
#line 727 "desktop-entry.c"
		GType _tmp1_ = 0UL;
		GType* _tmp3_;
#line 136 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
		_tmp1_ = desktop_agnostic_get_module_type ("fdo", "desktop-entry", &_inner_error0_);
#line 136 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 734 "desktop-entry.c"
			GType _tmp2_ = 0UL;
#line 136 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
			g_propagate_error (error, _inner_error0_);
#line 136 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
			return _tmp2_;
#line 740 "desktop-entry.c"
		}
#line 136 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
		_tmp3_ = __g_type_dup0 (&_tmp1_);
#line 136 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
		_g_free0 (desktop_agnostic_fdo_module_type);
#line 136 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
		desktop_agnostic_fdo_module_type = _tmp3_;
#line 748 "desktop-entry.c"
	}
#line 138 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	_tmp4_ = desktop_agnostic_fdo_module_type;
#line 138 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	result = *_tmp4_;
#line 138 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	return result;
#line 756 "desktop-entry.c"
}

/**
   * Convenience method for creating a new desktop entry from scratch.
   */
DesktopAgnosticFDODesktopEntry*
desktop_agnostic_fdo_desktop_entry_new (GError** error)
{
	GType type = 0UL;
	GError* _inner_error0_ = NULL;
	DesktopAgnosticFDODesktopEntry* result;
#line 147 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	type = desktop_agnostic_fdo_get_type (&_inner_error0_);
#line 147 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 147 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
		g_propagate_error (error, _inner_error0_);
#line 147 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
		return NULL;
#line 776 "desktop-entry.c"
	}
#line 148 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	if (type == G_TYPE_INVALID) {
#line 150 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
		result = NULL;
#line 150 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
		return result;
#line 784 "desktop-entry.c"
	} else {
		GObject* _tmp0_;
		GObject* _tmp1_;
#line 154 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
		_tmp0_ = g_object_new (type, NULL);
#line 154 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
		_tmp1_ = G_IS_INITIALLY_UNOWNED (_tmp0_) ? g_object_ref_sink (_tmp0_) : _tmp0_;
#line 154 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
		result = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, DESKTOP_AGNOSTIC_FDO_TYPE_DESKTOP_ENTRY, DesktopAgnosticFDODesktopEntry);
#line 154 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
		return result;
#line 796 "desktop-entry.c"
	}
}

/**
   * Convenience method for loading a desktop entry via a VFS.File.
   */
DesktopAgnosticFDODesktopEntry*
desktop_agnostic_fdo_desktop_entry_new_for_file (DesktopAgnosticVFSFile* file,
                                                 GError** error)
{
	GType type = 0UL;
	GError* _inner_error0_ = NULL;
	DesktopAgnosticFDODesktopEntry* result;
#line 161 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 164 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	type = desktop_agnostic_fdo_get_type (&_inner_error0_);
#line 164 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 164 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
		g_propagate_error (error, _inner_error0_);
#line 164 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
		return NULL;
#line 820 "desktop-entry.c"
	}
#line 165 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	if (type == G_TYPE_INVALID) {
#line 167 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
		result = NULL;
#line 167 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
		return result;
#line 828 "desktop-entry.c"
	} else {
		GObject* _tmp0_;
		GObject* _tmp1_;
#line 171 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
		_tmp0_ = g_object_new (type, "file", file, NULL);
#line 171 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
		_tmp1_ = G_IS_INITIALLY_UNOWNED (_tmp0_) ? g_object_ref_sink (_tmp0_) : _tmp0_;
#line 171 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
		result = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, DESKTOP_AGNOSTIC_FDO_TYPE_DESKTOP_ENTRY, DesktopAgnosticFDODesktopEntry);
#line 171 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
		return result;
#line 840 "desktop-entry.c"
	}
}

/**
   * Convenience method for loading a desktop entry from a KeyFile object.
   */
DesktopAgnosticFDODesktopEntry*
desktop_agnostic_fdo_desktop_entry_new_for_keyfile (GKeyFile* keyfile,
                                                    GError** error)
{
	GType type = 0UL;
	GError* _inner_error0_ = NULL;
	DesktopAgnosticFDODesktopEntry* result;
#line 178 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	g_return_val_if_fail (keyfile != NULL, NULL);
#line 181 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	type = desktop_agnostic_fdo_get_type (&_inner_error0_);
#line 181 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 181 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
		g_propagate_error (error, _inner_error0_);
#line 181 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
		return NULL;
#line 864 "desktop-entry.c"
	}
#line 182 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	if (type == G_TYPE_INVALID) {
#line 184 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
		result = NULL;
#line 184 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
		return result;
#line 872 "desktop-entry.c"
	} else {
		GObject* _tmp0_;
		GObject* _tmp1_;
#line 188 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
		_tmp0_ = g_object_new (type, "keyfile", keyfile, NULL);
#line 188 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
		_tmp1_ = G_IS_INITIALLY_UNOWNED (_tmp0_) ? g_object_ref_sink (_tmp0_) : _tmp0_;
#line 188 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
		result = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, DESKTOP_AGNOSTIC_FDO_TYPE_DESKTOP_ENTRY, DesktopAgnosticFDODesktopEntry);
#line 188 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
		return result;
#line 884 "desktop-entry.c"
	}
}

/**
   * Convenience method for loading a desktop entry from a string of data.
   */
DesktopAgnosticFDODesktopEntry*
desktop_agnostic_fdo_desktop_entry_new_for_data (const gchar* data,
                                                 GError** error)
{
	GType type = 0UL;
	GError* _inner_error0_ = NULL;
	DesktopAgnosticFDODesktopEntry* result;
#line 195 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	g_return_val_if_fail (data != NULL, NULL);
#line 198 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	type = desktop_agnostic_fdo_get_type (&_inner_error0_);
#line 198 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 198 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
		g_propagate_error (error, _inner_error0_);
#line 198 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
		return NULL;
#line 908 "desktop-entry.c"
	}
#line 199 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
	if (type == G_TYPE_INVALID) {
#line 201 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
		result = NULL;
#line 201 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
		return result;
#line 916 "desktop-entry.c"
	} else {
		GObject* _tmp0_;
		GObject* _tmp1_;
#line 205 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
		_tmp0_ = g_object_new (type, "data", data, NULL);
#line 205 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
		_tmp1_ = G_IS_INITIALLY_UNOWNED (_tmp0_) ? g_object_ref_sink (_tmp0_) : _tmp0_;
#line 205 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
		result = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, DESKTOP_AGNOSTIC_FDO_TYPE_DESKTOP_ENTRY, DesktopAgnosticFDODesktopEntry);
#line 205 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/desktop-entry.vala"
		return result;
#line 928 "desktop-entry.c"
	}
}

