/* module-guesser.c generated by valac 0.56.17, the Vala compiler
 * generated from module-guesser.vala, do not modify */

/*
 * Desktop Agnostic Module guesser function.
 *
 * Copyright (C) 2009 Mark Lee <libdesktop-agnostic@lazymalevolence.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 *
 * Author : Mark Lee <libdesktop-agnostic@lazymalevolence.com>
 */

#include "da-module-guesser.h"
#include <libdesktop-agnostic/desktop-agnostic.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <glib/gstdio.h>
#include <desktop-agnostic-vfs.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

/**
 * Given a valid library prefix, this function takes the first valid module
 * that is locates via the search paths and glob and loads it.
 */
GType
guess_module (DesktopAgnosticModuleLoader* loader,
              const gchar* library_prefix)
{
	gchar** paths = NULL;
	gint _tmp0_ = 0;
	gchar** _tmp1_;
	gint paths_length1;
	gint _paths_size_;
	gchar* module_glob_suffix = NULL;
	gchar* _tmp2_;
	GType _result_ = 0UL;
	gchar** _tmp3_;
	gint _tmp3__length1;
	GError* _inner_error0_ = NULL;
	GType result;
#line 30 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
	g_return_val_if_fail (loader != NULL, 0UL);
#line 30 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
	g_return_val_if_fail (library_prefix != NULL, 0UL);
#line 33 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
	_tmp1_ = desktop_agnostic_module_loader_get_search_paths (&_tmp0_);
#line 33 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
	paths = _tmp1_;
#line 33 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
	paths_length1 = _tmp0_;
#line 33 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
	_paths_size_ = paths_length1;
#line 34 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
	_tmp2_ = g_strdup_printf ("%s*", library_prefix);
#line 34 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
	module_glob_suffix = _tmp2_;
#line 35 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
	_result_ = G_TYPE_INVALID;
#line 37 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
	_tmp3_ = paths;
#line 37 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
	_tmp3__length1 = paths_length1;
#line 98 "module-guesser.c"
	{
		gchar** path_prefix_collection = NULL;
		gint path_prefix_collection_length1 = 0;
		gint _path_prefix_collection_size_ = 0;
		gint path_prefix_it = 0;
#line 37 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
		path_prefix_collection = _tmp3_;
#line 37 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
		path_prefix_collection_length1 = _tmp3__length1;
#line 37 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
		for (path_prefix_it = 0; path_prefix_it < path_prefix_collection_length1; path_prefix_it = path_prefix_it + 1) {
#line 110 "module-guesser.c"
			const gchar* path_prefix = NULL;
#line 37 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
			path_prefix = path_prefix_collection[path_prefix_it];
#line 114 "module-guesser.c"
			{
				gboolean _tmp4_ = FALSE;
				const gchar* _tmp5_;
				gchar* module_glob = NULL;
				const gchar* _tmp7_;
				const gchar* _tmp8_;
				gchar* _tmp9_;
#line 39 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
				_tmp5_ = path_prefix;
#line 39 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
				if (_tmp5_ == NULL) {
#line 39 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
					_tmp4_ = TRUE;
#line 128 "module-guesser.c"
				} else {
					const gchar* _tmp6_;
#line 39 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
					_tmp6_ = path_prefix;
#line 39 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
					_tmp4_ = !g_file_test (_tmp6_, G_FILE_TEST_IS_DIR);
#line 135 "module-guesser.c"
				}
#line 39 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
				if (_tmp4_) {
#line 41 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
					continue;
#line 141 "module-guesser.c"
				}
#line 44 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
				_tmp7_ = path_prefix;
#line 44 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
				_tmp8_ = module_glob_suffix;
#line 44 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
				_tmp9_ = g_build_filename (_tmp7_, _tmp8_, NULL);
#line 44 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
				module_glob = _tmp9_;
#line 151 "module-guesser.c"
				{
					DesktopAgnosticVFSGlob* found_modules = NULL;
					gchar** modules_paths = NULL;
					gint modules_paths_length1 = 0;
					gint _modules_paths_size_ = 0;
					DesktopAgnosticVFSGlob* _tmp10_ = NULL;
					const gchar* _tmp11_;
					DesktopAgnosticVFSGlob* _tmp12_;
					DesktopAgnosticVFSGlob* _tmp14_;
					DesktopAgnosticVFSGlob* _tmp15_;
					gint _tmp16_ = 0;
					gchar** _tmp17_;
					gchar** _tmp18_;
					gint _tmp18__length1;
#line 50 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
					_tmp11_ = module_glob;
#line 50 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
					_tmp12_ = desktop_agnostic_vfs_glob_execute (_tmp11_, &_inner_error0_);
#line 50 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
					_tmp10_ = _tmp12_;
#line 50 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 174 "module-guesser.c"
						GType _tmp13_ = 0UL;
#line 50 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
						_g_object_unref0 (found_modules);
#line 50 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
						if (_inner_error0_->domain == DESKTOP_AGNOSTIC_VFS_GLOB_ERROR) {
#line 180 "module-guesser.c"
							goto __catch0_desktop_agnostic_vfs_glob_error;
						}
#line 50 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
						_g_free0 (module_glob);
#line 50 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
						_g_free0 (module_glob_suffix);
#line 50 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
						paths = (_vala_array_free (paths, paths_length1, (GDestroyNotify) g_free), NULL);
#line 50 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 50 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
						g_clear_error (&_inner_error0_);
#line 50 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
						return _tmp13_;
#line 195 "module-guesser.c"
					}
#line 50 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
					_tmp14_ = _tmp10_;
#line 50 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
					_tmp10_ = NULL;
#line 50 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
					_g_object_unref0 (found_modules);
#line 50 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
					found_modules = _tmp14_;
#line 51 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
					_tmp15_ = found_modules;
#line 51 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
					_tmp17_ = desktop_agnostic_vfs_glob_get_paths (_tmp15_, &_tmp16_);
#line 51 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
					modules_paths = _tmp17_;
#line 51 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
					modules_paths_length1 = _tmp16_;
#line 51 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
					_modules_paths_size_ = modules_paths_length1;
#line 52 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
					_tmp18_ = modules_paths;
#line 52 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
					_tmp18__length1 = modules_paths_length1;
#line 219 "module-guesser.c"
					{
						gchar** module_collection = NULL;
						gint module_collection_length1 = 0;
						gint _module_collection_size_ = 0;
						gint module_it = 0;
#line 52 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
						module_collection = _tmp18_;
#line 52 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
						module_collection_length1 = _tmp18__length1;
#line 52 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
						for (module_it = 0; module_it < module_collection_length1; module_it = module_it + 1) {
#line 231 "module-guesser.c"
							const gchar* module = NULL;
#line 52 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
							module = module_collection[module_it];
#line 235 "module-guesser.c"
							{
								const gchar* _tmp19_;
								const gchar* _tmp20_;
#line 54 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
								_tmp19_ = path_prefix;
#line 54 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
								_tmp20_ = module;
#line 54 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
								_result_ = desktop_agnostic_module_loader_load_from_path (loader, _tmp19_, _tmp20_);
#line 55 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
								if (_result_ != G_TYPE_INVALID) {
#line 57 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
									break;
#line 249 "module-guesser.c"
								}
							}
						}
					}
#line 45 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
					_g_object_unref0 (_tmp10_);
#line 45 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
					_g_object_unref0 (found_modules);
#line 258 "module-guesser.c"
				}
				goto __finally0;
				__catch0_desktop_agnostic_vfs_glob_error:
				{
					GError* err = NULL;
					GError* _tmp21_;
#line 45 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
					err = _inner_error0_;
#line 45 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
					_inner_error0_ = NULL;
#line 63 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
					_tmp21_ = err;
#line 63 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
					if (!g_error_matches (_tmp21_, DESKTOP_AGNOSTIC_VFS_GLOB_ERROR, DESKTOP_AGNOSTIC_VFS_GLOB_ERROR_NOMATCH)) {
#line 273 "module-guesser.c"
						GError* _tmp22_;
						const gchar* _tmp23_;
#line 65 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
						_tmp22_ = err;
#line 65 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
						_tmp23_ = _tmp22_->message;
#line 65 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
						g_warning ("module-guesser.vala:65: Glob-related eror: %s", _tmp23_);
#line 282 "module-guesser.c"
					}
#line 45 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
					_g_error_free0 (err);
#line 286 "module-guesser.c"
				}
				__finally0:
#line 45 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 291 "module-guesser.c"
					GType _tmp24_ = 0UL;
#line 45 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
					_g_free0 (module_glob);
#line 45 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
					_g_free0 (module_glob_suffix);
#line 45 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
					paths = (_vala_array_free (paths, paths_length1, (GDestroyNotify) g_free), NULL);
#line 45 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 45 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
					g_clear_error (&_inner_error0_);
#line 45 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
					return _tmp24_;
#line 305 "module-guesser.c"
				}
#line 68 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
				if (_result_ != G_TYPE_INVALID) {
#line 70 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
					_g_free0 (module_glob);
#line 70 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
					break;
#line 313 "module-guesser.c"
				}
#line 37 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
				_g_free0 (module_glob);
#line 317 "module-guesser.c"
			}
		}
	}
#line 74 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
	result = _result_;
#line 74 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
	_g_free0 (module_glob_suffix);
#line 74 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
	paths = (_vala_array_free (paths, paths_length1, (GDestroyNotify) g_free), NULL);
#line 74 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/module-guesser.vala"
	return result;
#line 329 "module-guesser.c"
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

