/* vfs-file-impl-gio.c generated by valac 0.56.17, the Vala compiler
 * generated from vfs-file-impl-gio.vala, do not modify */

/*
 * Desktop Agnostic Library: File implementation (with GIO).
 *
 * Copyright (C) 2009 Mark Lee <libdesktop-agnostic@lazymalevolence.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 *
 * Author : Mark Lee <libdesktop-agnostic@lazymalevolence.com>
 */

#include "da-vfs-gio.h"
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <desktop-agnostic-vfs.h>
#include <glib-object.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	DESKTOP_AGNOSTIC_VFS_FILE_GIO_0_PROPERTY,
	DESKTOP_AGNOSTIC_VFS_FILE_GIO_IMPLEMENTATION_PROPERTY,
	DESKTOP_AGNOSTIC_VFS_FILE_GIO_IMPL_PATH_PROPERTY,
	DESKTOP_AGNOSTIC_VFS_FILE_GIO_IMPL_URI_PROPERTY,
	DESKTOP_AGNOSTIC_VFS_FILE_GIO_FILE_TYPE_PROPERTY,
	DESKTOP_AGNOSTIC_VFS_FILE_GIO_ACCESS_FLAGS_PROPERTY,
	DESKTOP_AGNOSTIC_VFS_FILE_GIO_PARENT_PROPERTY,
	DESKTOP_AGNOSTIC_VFS_FILE_GIO_NUM_PROPERTIES
};
static GParamSpec* desktop_agnostic_vfs_file_gio_properties[DESKTOP_AGNOSTIC_VFS_FILE_GIO_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _DesktopAgnosticVFSFileGIOPrivate {
	GFile* _file;
	gchar* _uri;
};

static gint DesktopAgnosticVFSFileGIO_private_offset;
static gpointer desktop_agnostic_vfs_file_gio_parent_class = NULL;

static void desktop_agnostic_vfs_file_gio_real_init (DesktopAgnosticVFSFile* base,
                                              const gchar* uri);
static gboolean desktop_agnostic_vfs_file_gio_real_exists (DesktopAgnosticVFSFile* base);
static DesktopAgnosticVFSFileMonitor* desktop_agnostic_vfs_file_gio_real_monitor (DesktopAgnosticVFSFile* base);
static gboolean desktop_agnostic_vfs_file_gio_real_load_contents (DesktopAgnosticVFSFile* base,
                                                           gchar** contents,
                                                           gsize* length,
                                                           GError** error);
static gboolean desktop_agnostic_vfs_file_gio_real_replace_contents (DesktopAgnosticVFSFile* base,
                                                              const gchar* contents,
                                                              GError** error);
static gboolean desktop_agnostic_vfs_file_gio_real_launch (DesktopAgnosticVFSFile* base,
                                                    GError** error);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static GSList* desktop_agnostic_vfs_file_gio_real_enumerate_children (DesktopAgnosticVFSFile* base,
                                                               GError** error);
static inline void _g_slist_free__g_object_unref0_ (GSList* self);
static gboolean desktop_agnostic_vfs_file_gio_real_copy (DesktopAgnosticVFSFile* base,
                                                  DesktopAgnosticVFSFile* destination,
                                                  gboolean overwrite,
                                                  GError** error);
static gboolean desktop_agnostic_vfs_file_gio_real_remove (DesktopAgnosticVFSFile* base,
                                                    GError** error);
static gboolean desktop_agnostic_vfs_file_gio_real_is_native (DesktopAgnosticVFSFile* base);
static gchar* desktop_agnostic_vfs_file_gio_real_get_mime_type (DesktopAgnosticVFSFile* base,
                                                         GError** error);
static gchar** desktop_agnostic_vfs_file_gio_real_get_icon_names (DesktopAgnosticVFSFile* base,
                                                           gint* result_length1,
                                                           GError** error);
static gchar** _vala_array_dup1 (gchar** self,
                          gssize length);
static gchar* desktop_agnostic_vfs_file_gio_real_get_thumbnail_path (DesktopAgnosticVFSFile* base);
static void desktop_agnostic_vfs_file_gio_finalize (GObject * obj);
static GType desktop_agnostic_vfs_file_gio_get_type_once (void);
static void _vala_desktop_agnostic_vfs_file_gio_get_property (GObject * object,
                                                       guint property_id,
                                                       GValue * value,
                                                       GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
desktop_agnostic_vfs_file_gio_get_instance_private (DesktopAgnosticVFSFileGIO* self)
{
	return G_STRUCT_MEMBER_P (self, DesktopAgnosticVFSFileGIO_private_offset);
}

static void
desktop_agnostic_vfs_file_gio_real_init (DesktopAgnosticVFSFile* base,
                                         const gchar* uri)
{
	DesktopAgnosticVFSFileGIO * self;
	GFile* _tmp0_;
#line 164 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	self = (DesktopAgnosticVFSFileGIO*) base;
#line 164 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	g_return_if_fail (uri != NULL);
#line 167 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	_tmp0_ = g_file_new_for_uri (uri);
#line 167 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	_g_object_unref0 (self->priv->_file);
#line 167 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	self->priv->_file = _tmp0_;
#line 135 "vfs-file-impl-gio.c"
}

static gboolean
desktop_agnostic_vfs_file_gio_real_exists (DesktopAgnosticVFSFile* base)
{
	DesktopAgnosticVFSFileGIO * self;
	GFile* _tmp0_;
	gboolean result;
#line 169 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	self = (DesktopAgnosticVFSFileGIO*) base;
#line 171 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	_tmp0_ = self->priv->_file;
#line 171 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	result = g_file_query_exists (_tmp0_, NULL);
#line 171 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	return result;
#line 152 "vfs-file-impl-gio.c"
}

static DesktopAgnosticVFSFileMonitor*
desktop_agnostic_vfs_file_gio_real_monitor (DesktopAgnosticVFSFile* base)
{
	DesktopAgnosticVFSFileGIO * self;
	DesktopAgnosticVFSFileMonitorGIO* _tmp0_;
	DesktopAgnosticVFSFileMonitor* result;
#line 173 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	self = (DesktopAgnosticVFSFileGIO*) base;
#line 175 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	_tmp0_ = desktop_agnostic_vfs_file_monitor_gio_new (self);
#line 175 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	result = (DesktopAgnosticVFSFileMonitor*) _tmp0_;
#line 175 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	return result;
#line 169 "vfs-file-impl-gio.c"
}

static gboolean
desktop_agnostic_vfs_file_gio_real_load_contents (DesktopAgnosticVFSFile* base,
                                                  gchar** contents,
                                                  gsize* length,
                                                  GError** error)
{
	DesktopAgnosticVFSFileGIO * self;
	gchar* _vala_contents = NULL;
	gsize _vala_length = 0UL;
	gboolean _tmp14_ = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 177 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	self = (DesktopAgnosticVFSFileGIO*) base;
#line 186 "vfs-file-impl-gio.c"
	{
		guint8* glib_contents = NULL;
		gint glib_contents_length1 = 0;
		gint _glib_contents_size_ = 0;
		GFile* _tmp0_;
		guint8* _tmp1_ = NULL;
		gsize _tmp2_ = 0;
		guint8* _tmp3_;
		gint _tmp3__length1;
		const gchar* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
#line 183 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_tmp0_ = self->priv->_file;
#line 183 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		g_file_load_contents (_tmp0_, NULL, &_tmp1_, &_tmp2_, NULL, &_inner_error0_);
#line 183 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		glib_contents = (g_free (glib_contents), NULL);
#line 183 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		glib_contents = _tmp1_;
#line 183 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		glib_contents_length1 = _tmp2_;
#line 183 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_glib_contents_size_ = glib_contents_length1;
#line 183 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 183 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			glib_contents = (g_free (glib_contents), NULL);
#line 215 "vfs-file-impl-gio.c"
			goto __catch0_g_error;
		}
#line 184 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_tmp3_ = glib_contents;
#line 184 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_tmp3__length1 = glib_contents_length1;
#line 184 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		glib_contents = NULL;
#line 184 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		glib_contents_length1 = 0;
#line 184 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_g_free0 (_vala_contents);
#line 184 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_vala_contents = (gchar*) _tmp3_;
#line 185 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_tmp4_ = _vala_contents;
#line 185 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_tmp5_ = strlen (_tmp4_);
#line 185 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_tmp6_ = _tmp5_;
#line 185 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_vala_length = (gsize) _tmp6_;
#line 186 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		result = TRUE;
#line 186 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		glib_contents = (g_free (glib_contents), NULL);
#line 186 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		if (contents) {
#line 186 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			*contents = _vala_contents;
#line 246 "vfs-file-impl-gio.c"
		} else {
#line 186 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_g_free0 (_vala_contents);
#line 250 "vfs-file-impl-gio.c"
		}
#line 186 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		if (length) {
#line 186 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			*length = _vala_length;
#line 256 "vfs-file-impl-gio.c"
		}
#line 186 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		return result;
#line 260 "vfs-file-impl-gio.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GFile* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		GError* _tmp10_;
		const gchar* _tmp11_;
		GError* _tmp12_;
		gchar* _tmp13_;
#line 180 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		e = _inner_error0_;
#line 180 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_inner_error0_ = NULL;
#line 190 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_tmp7_ = self->priv->_file;
#line 190 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_tmp8_ = g_file_get_parse_name (_tmp7_);
#line 190 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_tmp9_ = _tmp8_;
#line 190 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_tmp10_ = e;
#line 190 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_tmp11_ = _tmp10_->message;
#line 190 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_tmp12_ = e;
#line 190 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		g_warning ("vfs-file-impl-gio.vala:190: Failed to load the file '%s': %s Code:%d", _tmp9_, _tmp11_, _tmp12_->code);
#line 190 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_g_free0 (_tmp9_);
#line 192 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_tmp13_ = g_strdup ("");
#line 192 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_g_free0 (_vala_contents);
#line 192 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_vala_contents = _tmp13_;
#line 193 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_vala_length = (gsize) 0;
#line 194 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		result = FALSE;
#line 194 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_g_error_free0 (e);
#line 194 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		if (contents) {
#line 194 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			*contents = _vala_contents;
#line 309 "vfs-file-impl-gio.c"
		} else {
#line 194 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_g_free0 (_vala_contents);
#line 313 "vfs-file-impl-gio.c"
		}
#line 194 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		if (length) {
#line 194 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			*length = _vala_length;
#line 319 "vfs-file-impl-gio.c"
		}
#line 194 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		return result;
#line 323 "vfs-file-impl-gio.c"
	}
	__finally0:
#line 180 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	_g_free0 (_vala_contents);
#line 180 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 180 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	g_clear_error (&_inner_error0_);
#line 180 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	return _tmp14_;
#line 334 "vfs-file-impl-gio.c"
}

static guint8*
string_get_data (const gchar* self,
                 gint* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
#line 1609 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1610 "glib-2.0.vapi"
	res = (guint8*) self;
#line 1610 "glib-2.0.vapi"
	res_length1 = -1;
#line 1610 "glib-2.0.vapi"
	_res_size_ = res_length1;
#line 1611 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1611 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1611 "glib-2.0.vapi"
	res_length1 = (gint) _tmp1_;
#line 1612 "glib-2.0.vapi"
	_tmp2_ = res;
#line 1612 "glib-2.0.vapi"
	_tmp2__length1 = res_length1;
#line 1612 "glib-2.0.vapi"
	if (result_length1) {
#line 1612 "glib-2.0.vapi"
		*result_length1 = _tmp2__length1;
#line 371 "vfs-file-impl-gio.c"
	}
#line 1612 "glib-2.0.vapi"
	result = _tmp2_;
#line 1612 "glib-2.0.vapi"
	return result;
#line 377 "vfs-file-impl-gio.c"
}

static gboolean
desktop_agnostic_vfs_file_gio_real_replace_contents (DesktopAgnosticVFSFile* base,
                                                     const gchar* contents,
                                                     GError** error)
{
	DesktopAgnosticVFSFileGIO * self;
	gboolean _tmp0_ = FALSE;
	GFile* _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
	gint _tmp3_ = 0;
	guint8* _tmp4_;
	gint _tmp4__length1;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 197 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	self = (DesktopAgnosticVFSFileGIO*) base;
#line 197 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	g_return_val_if_fail (contents != NULL, FALSE);
#line 200 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	_tmp1_ = self->priv->_file;
#line 200 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	_tmp2_ = string_get_data (contents, &_tmp3_);
#line 200 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	_tmp2__length1 = _tmp3_;
#line 200 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	_tmp4_ = _tmp2_;
#line 200 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	_tmp4__length1 = _tmp2__length1;
#line 200 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	_tmp0_ = g_file_replace_contents (_tmp1_, (const char*) _tmp4_, (gsize) _tmp4__length1, NULL, FALSE, G_FILE_CREATE_NONE, NULL, NULL, &_inner_error0_);
#line 200 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 413 "vfs-file-impl-gio.c"
		gboolean _tmp5_ = FALSE;
#line 200 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		g_propagate_error (error, _inner_error0_);
#line 200 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		return _tmp5_;
#line 419 "vfs-file-impl-gio.c"
	}
#line 200 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	result = _tmp0_;
#line 200 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	return result;
#line 425 "vfs-file-impl-gio.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 209 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 433 "vfs-file-impl-gio.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 209 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 441 "vfs-file-impl-gio.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 210 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	return self ? g_object_ref (self) : NULL;
#line 449 "vfs-file-impl-gio.c"
}

static gboolean
desktop_agnostic_vfs_file_gio_real_launch (DesktopAgnosticVFSFile* base,
                                           GError** error)
{
	DesktopAgnosticVFSFileGIO * self;
	GAppInfo* app_info = NULL;
	GList* files = NULL;
	GAppInfo* _tmp0_ = NULL;
	GFile* _tmp1_;
	GAppInfo* _tmp2_;
	GAppInfo* _tmp4_;
	GFile* _tmp5_;
	GFile* _tmp6_;
	gboolean _tmp7_ = FALSE;
	GAppInfo* _tmp8_;
	GList* _tmp9_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 203 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	self = (DesktopAgnosticVFSFileGIO*) base;
#line 207 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	files = NULL;
#line 209 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	_tmp1_ = self->priv->_file;
#line 209 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	_tmp2_ = g_file_query_default_handler (_tmp1_, NULL, &_inner_error0_);
#line 209 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	_tmp0_ = _tmp2_;
#line 209 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 482 "vfs-file-impl-gio.c"
		gboolean _tmp3_ = FALSE;
#line 209 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		g_propagate_error (error, _inner_error0_);
#line 209 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		(files == NULL) ? NULL : (files = (_g_list_free__g_object_unref0_ (files), NULL));
#line 209 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_g_object_unref0 (app_info);
#line 209 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		return _tmp3_;
#line 492 "vfs-file-impl-gio.c"
	}
#line 209 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	_tmp4_ = _tmp0_;
#line 209 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	_tmp0_ = NULL;
#line 209 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	_g_object_unref0 (app_info);
#line 209 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	app_info = _tmp4_;
#line 210 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	_tmp5_ = self->priv->_file;
#line 210 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	_tmp6_ = _g_object_ref0 (_tmp5_);
#line 210 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	files = g_list_append (files, _tmp6_);
#line 211 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	_tmp8_ = app_info;
#line 211 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	_tmp9_ = files;
#line 211 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	_tmp7_ = g_app_info_launch (_tmp8_, _tmp9_, NULL, &_inner_error0_);
#line 211 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 516 "vfs-file-impl-gio.c"
		gboolean _tmp10_ = FALSE;
#line 211 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		g_propagate_error (error, _inner_error0_);
#line 211 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_g_object_unref0 (_tmp0_);
#line 211 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		(files == NULL) ? NULL : (files = (_g_list_free__g_object_unref0_ (files), NULL));
#line 211 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_g_object_unref0 (app_info);
#line 211 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		return _tmp10_;
#line 528 "vfs-file-impl-gio.c"
	}
#line 211 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	result = _tmp7_;
#line 211 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	_g_object_unref0 (_tmp0_);
#line 211 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	(files == NULL) ? NULL : (files = (_g_list_free__g_object_unref0_ (files), NULL));
#line 211 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	_g_object_unref0 (app_info);
#line 211 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	return result;
#line 540 "vfs-file-impl-gio.c"
}

static inline void
_g_slist_free__g_object_unref0_ (GSList* self)
{
#line 220 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	g_slist_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 548 "vfs-file-impl-gio.c"
}

static GSList*
desktop_agnostic_vfs_file_gio_real_enumerate_children (DesktopAgnosticVFSFile* base,
                                                       GError** error)
{
	DesktopAgnosticVFSFileGIO * self;
	GSList* children = NULL;
	GFileEnumerator* enumerator = NULL;
	GFileInfo* info = NULL;
	GFileEnumerator* _tmp0_ = NULL;
	GFile* _tmp1_;
	GFileEnumerator* _tmp2_;
	GFileEnumerator* _tmp3_;
	GError* _inner_error0_ = NULL;
	GSList* result;
#line 213 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	self = (DesktopAgnosticVFSFileGIO*) base;
#line 220 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	(children == NULL) ? NULL : (children = (_g_slist_free__g_object_unref0_ (children), NULL));
#line 220 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	children = NULL;
#line 221 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	_tmp1_ = self->priv->_file;
#line 221 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	_tmp2_ = g_file_enumerate_children (_tmp1_, G_FILE_ATTRIBUTE_STANDARD_NAME, G_FILE_QUERY_INFO_NONE, NULL, &_inner_error0_);
#line 221 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	_tmp0_ = _tmp2_;
#line 221 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 221 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		g_propagate_error (error, _inner_error0_);
#line 221 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_g_object_unref0 (info);
#line 221 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_g_object_unref0 (enumerator);
#line 221 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		(children == NULL) ? NULL : (children = (_g_slist_free__g_object_unref0_ (children), NULL));
#line 221 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		return NULL;
#line 589 "vfs-file-impl-gio.c"
	}
#line 221 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	_tmp3_ = _tmp0_;
#line 221 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	_tmp0_ = NULL;
#line 221 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	_g_object_unref0 (enumerator);
#line 221 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	enumerator = _tmp3_;
#line 224 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	while (TRUE) {
#line 601 "vfs-file-impl-gio.c"
		GFileInfo* _tmp4_ = NULL;
		GFileEnumerator* _tmp5_;
		GFileInfo* _tmp6_;
		GFileInfo* _tmp7_;
		GFileInfo* _tmp8_;
		GFile* gchild = NULL;
		DesktopAgnosticVFSFile* child = NULL;
		GFile* _tmp9_;
		GFileInfo* _tmp10_;
		const gchar* _tmp11_;
		GFile* _tmp12_;
		DesktopAgnosticVFSFile* _tmp13_ = NULL;
		GFile* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		DesktopAgnosticVFSFile* _tmp17_;
		DesktopAgnosticVFSFile* _tmp18_;
		DesktopAgnosticVFSFile* _tmp19_;
		DesktopAgnosticVFSFile* _tmp20_;
#line 224 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_tmp5_ = enumerator;
#line 224 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_tmp6_ = g_file_enumerator_next_file (_tmp5_, NULL, &_inner_error0_);
#line 224 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_tmp4_ = _tmp6_;
#line 224 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 224 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			g_propagate_error (error, _inner_error0_);
#line 224 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_g_object_unref0 (_tmp0_);
#line 224 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_g_object_unref0 (info);
#line 224 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_g_object_unref0 (enumerator);
#line 224 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			(children == NULL) ? NULL : (children = (_g_slist_free__g_object_unref0_ (children), NULL));
#line 224 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			return NULL;
#line 641 "vfs-file-impl-gio.c"
		}
#line 224 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_tmp7_ = _tmp4_;
#line 224 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_tmp4_ = NULL;
#line 224 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_g_object_unref0 (info);
#line 224 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		info = _tmp7_;
#line 224 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_tmp8_ = info;
#line 224 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		if (!(_tmp8_ != NULL)) {
#line 224 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_g_object_unref0 (_tmp4_);
#line 224 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			break;
#line 659 "vfs-file-impl-gio.c"
		}
#line 229 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_tmp9_ = self->priv->_file;
#line 229 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_tmp10_ = info;
#line 229 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_tmp11_ = g_file_info_get_name (_tmp10_);
#line 229 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_tmp12_ = g_file_get_child (_tmp9_, _tmp11_);
#line 229 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_g_object_unref0 (gchild);
#line 229 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		gchild = _tmp12_;
#line 230 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_tmp14_ = gchild;
#line 230 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_tmp15_ = g_file_get_uri (_tmp14_);
#line 230 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_tmp16_ = _tmp15_;
#line 230 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_tmp17_ = desktop_agnostic_vfs_file_new_for_uri (_tmp16_, &_inner_error0_);
#line 230 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_tmp18_ = _tmp17_;
#line 230 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_g_free0 (_tmp16_);
#line 230 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_tmp13_ = _tmp18_;
#line 230 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 230 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			g_propagate_error (error, _inner_error0_);
#line 230 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_g_object_unref0 (child);
#line 230 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_g_object_unref0 (gchild);
#line 230 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_g_object_unref0 (_tmp4_);
#line 230 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_g_object_unref0 (_tmp0_);
#line 230 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_g_object_unref0 (info);
#line 230 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_g_object_unref0 (enumerator);
#line 230 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			(children == NULL) ? NULL : (children = (_g_slist_free__g_object_unref0_ (children), NULL));
#line 230 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			return NULL;
#line 707 "vfs-file-impl-gio.c"
		}
#line 230 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_tmp19_ = _tmp13_;
#line 230 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_tmp13_ = NULL;
#line 230 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_g_object_unref0 (child);
#line 230 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		child = _tmp19_;
#line 231 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_tmp20_ = child;
#line 231 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		child = NULL;
#line 231 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		children = g_slist_append (children, _tmp20_);
#line 224 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_g_object_unref0 (_tmp13_);
#line 224 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_g_object_unref0 (child);
#line 224 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_g_object_unref0 (gchild);
#line 224 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_g_object_unref0 (_tmp4_);
#line 731 "vfs-file-impl-gio.c"
	}
#line 233 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	result = children;
#line 233 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	_g_object_unref0 (_tmp0_);
#line 233 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	_g_object_unref0 (info);
#line 233 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	_g_object_unref0 (enumerator);
#line 233 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	return result;
#line 743 "vfs-file-impl-gio.c"
}

static gboolean
desktop_agnostic_vfs_file_gio_real_copy (DesktopAgnosticVFSFile* base,
                                         DesktopAgnosticVFSFile* destination,
                                         gboolean overwrite,
                                         GError** error)
{
	DesktopAgnosticVFSFileGIO * self;
	GFileCopyFlags flags = 0U;
	gboolean _tmp0_ = FALSE;
	GFile* _tmp1_;
	void* _tmp2_;
	void* _tmp3_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 235 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	self = (DesktopAgnosticVFSFileGIO*) base;
#line 235 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	g_return_val_if_fail (destination != NULL, FALSE);
#line 238 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	flags = 0;
#line 240 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	if (overwrite) {
#line 242 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		flags = G_FILE_COPY_OVERWRITE;
#line 770 "vfs-file-impl-gio.c"
	}
#line 244 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	_tmp1_ = self->priv->_file;
#line 244 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	_tmp2_ = desktop_agnostic_vfs_file_get_implementation (destination);
#line 244 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	_tmp3_ = _tmp2_;
#line 244 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	_tmp0_ = g_file_copy (_tmp1_, G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, g_file_get_type (), GFile), flags, NULL, NULL, NULL, &_inner_error0_);
#line 244 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 782 "vfs-file-impl-gio.c"
		gboolean _tmp4_ = FALSE;
#line 244 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		g_propagate_error (error, _inner_error0_);
#line 244 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		return _tmp4_;
#line 788 "vfs-file-impl-gio.c"
	}
#line 244 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	result = _tmp0_;
#line 244 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	return result;
#line 794 "vfs-file-impl-gio.c"
}

static gboolean
desktop_agnostic_vfs_file_gio_real_remove (DesktopAgnosticVFSFile* base,
                                           GError** error)
{
	DesktopAgnosticVFSFileGIO * self;
	gboolean _tmp6_ = FALSE;
	GFile* _tmp7_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 247 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	self = (DesktopAgnosticVFSFileGIO*) base;
#line 250 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	if (!desktop_agnostic_vfs_file_exists ((DesktopAgnosticVFSFile*) self)) {
#line 810 "vfs-file-impl-gio.c"
		gchar* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
		GError* _tmp3_;
		GError* _tmp4_;
		gboolean _tmp5_ = FALSE;
#line 252 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_tmp0_ = desktop_agnostic_vfs_file_get_uri ((DesktopAgnosticVFSFile*) self);
#line 252 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_tmp1_ = _tmp0_;
#line 252 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_tmp2_ = _tmp1_;
#line 252 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_tmp3_ = g_error_new (DESKTOP_AGNOSTIC_VFS_FILE_ERROR, DESKTOP_AGNOSTIC_VFS_FILE_ERROR_FILE_NOT_FOUND, "The file '%s' does not exist.", _tmp2_);
#line 252 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_tmp4_ = _tmp3_;
#line 252 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_g_free0 (_tmp2_);
#line 252 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_inner_error0_ = _tmp4_;
#line 252 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		g_propagate_error (error, _inner_error0_);
#line 252 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		return _tmp5_;
#line 835 "vfs-file-impl-gio.c"
	}
#line 255 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	_tmp7_ = self->priv->_file;
#line 255 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	_tmp6_ = g_file_delete (_tmp7_, NULL, &_inner_error0_);
#line 255 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 843 "vfs-file-impl-gio.c"
		gboolean _tmp8_ = FALSE;
#line 255 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		g_propagate_error (error, _inner_error0_);
#line 255 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		return _tmp8_;
#line 849 "vfs-file-impl-gio.c"
	}
#line 255 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	result = _tmp6_;
#line 255 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	return result;
#line 855 "vfs-file-impl-gio.c"
}

static gboolean
desktop_agnostic_vfs_file_gio_real_is_native (DesktopAgnosticVFSFile* base)
{
	DesktopAgnosticVFSFileGIO * self;
	GFile* _tmp0_;
	gboolean result;
#line 258 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	self = (DesktopAgnosticVFSFileGIO*) base;
#line 260 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	_tmp0_ = self->priv->_file;
#line 260 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	result = g_file_is_native (_tmp0_);
#line 260 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	return result;
#line 872 "vfs-file-impl-gio.c"
}

static gchar*
desktop_agnostic_vfs_file_gio_real_get_mime_type (DesktopAgnosticVFSFile* base,
                                                  GError** error)
{
	DesktopAgnosticVFSFileGIO * self;
	GFileInfo* fi = NULL;
	GFile* _tmp0_;
	GFileInfo* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 263 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	self = (DesktopAgnosticVFSFileGIO*) base;
#line 265 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	_tmp0_ = self->priv->_file;
#line 265 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	_tmp1_ = g_file_query_info (_tmp0_, G_FILE_ATTRIBUTE_STANDARD_CONTENT_TYPE, 0, NULL, &_inner_error0_);
#line 265 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	fi = _tmp1_;
#line 265 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 265 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		g_propagate_error (error, _inner_error0_);
#line 265 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		return NULL;
#line 901 "vfs-file-impl-gio.c"
	}
#line 267 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	_tmp2_ = g_file_info_get_content_type (fi);
#line 267 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 267 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	result = _tmp3_;
#line 267 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	_g_object_unref0 (fi);
#line 267 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	return result;
#line 913 "vfs-file-impl-gio.c"
}

static gchar**
_vala_array_dup1 (gchar** self,
                  gssize length)
{
#line 282 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	if (length >= 0) {
#line 922 "vfs-file-impl-gio.c"
		gchar** result;
		gssize i;
#line 282 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		result = g_new0 (gchar*, length + 1);
#line 282 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		for (i = 0; i < length; i++) {
#line 929 "vfs-file-impl-gio.c"
			gchar* _tmp0_;
#line 282 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_tmp0_ = g_strdup (self[i]);
#line 282 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			result[i] = _tmp0_;
#line 935 "vfs-file-impl-gio.c"
		}
#line 282 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		return result;
#line 939 "vfs-file-impl-gio.c"
	}
#line 282 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	return NULL;
#line 943 "vfs-file-impl-gio.c"
}

static gchar**
desktop_agnostic_vfs_file_gio_real_get_icon_names (DesktopAgnosticVFSFile* base,
                                                   gint* result_length1,
                                                   GError** error)
{
	DesktopAgnosticVFSFileGIO * self;
	GFileInfo* fi = NULL;
	GFile* _tmp0_;
	GFileInfo* _tmp1_;
	GIcon* icon = NULL;
	GIcon* _tmp2_;
	GIcon* _tmp3_;
	GIcon* _tmp4_;
	gchar** unknown = NULL;
	gchar** _tmp20_;
	gint unknown_length1;
	gint _unknown_size_;
	gchar** _tmp21_;
	gint _tmp21__length1;
	GError* _inner_error0_ = NULL;
	gchar** result;
#line 270 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	self = (DesktopAgnosticVFSFileGIO*) base;
#line 272 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	_tmp0_ = self->priv->_file;
#line 272 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	_tmp1_ = g_file_query_info (_tmp0_, G_FILE_ATTRIBUTE_STANDARD_ICON, 0, NULL, &_inner_error0_);
#line 272 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	fi = _tmp1_;
#line 272 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 272 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		g_propagate_error (error, _inner_error0_);
#line 272 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		return NULL;
#line 981 "vfs-file-impl-gio.c"
	}
#line 274 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	_tmp2_ = g_file_info_get_icon (fi);
#line 274 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 274 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	icon = _tmp3_;
#line 275 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	_tmp4_ = icon;
#line 275 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	if (_tmp4_ != NULL) {
#line 993 "vfs-file-impl-gio.c"
		GIcon* _tmp5_;
		GIcon* _tmp12_;
#line 277 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_tmp5_ = icon;
#line 277 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp5_, g_themed_icon_get_type ())) {
#line 1000 "vfs-file-impl-gio.c"
			GValue v = {0};
			GValue _tmp6_ = {0};
			GIcon* _tmp7_;
			gchar** names = NULL;
			GValue _tmp8_;
			gchar** _tmp9_;
			gchar** _tmp10_;
			gint _tmp10__length1;
			gint names_length1;
			gint _names_size_;
			gchar** _tmp11_;
			gint _tmp11__length1;
#line 280 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			g_value_init (&_tmp6_, G_TYPE_STRV);
#line 280 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			v = _tmp6_;
#line 281 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_tmp7_ = icon;
#line 281 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			g_object_get_property ((GObject*) _tmp7_, "names", &v);
#line 282 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_tmp8_ = v;
#line 282 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_tmp9_ = g_value_get_boxed (&_tmp8_);
#line 282 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_tmp10_ = (_tmp9_ != NULL) ? _vala_array_dup1 (_tmp9_, g_strv_length (_tmp9_)) : _tmp9_;
#line 282 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_tmp10__length1 = g_strv_length (_tmp9_);
#line 282 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			names = _tmp10_;
#line 282 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			names_length1 = _tmp10__length1;
#line 282 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_names_size_ = names_length1;
#line 287 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_tmp11_ = names;
#line 287 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_tmp11__length1 = names_length1;
#line 287 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			if (result_length1) {
#line 287 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
				*result_length1 = _tmp11__length1;
#line 1043 "vfs-file-impl-gio.c"
			}
#line 287 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			result = _tmp11_;
#line 287 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
#line 287 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_g_object_unref0 (icon);
#line 287 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_g_object_unref0 (fi);
#line 287 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			return result;
#line 1055 "vfs-file-impl-gio.c"
		}
#line 290 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_tmp12_ = icon;
#line 290 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp12_, g_file_icon_get_type ())) {
#line 1061 "vfs-file-impl-gio.c"
			gchar* path = NULL;
			GIcon* _tmp13_;
			GFile* _tmp14_;
			gchar* _tmp15_;
			gchar** _result_ = NULL;
			const gchar* _tmp16_;
			gchar* _tmp17_;
			gchar** _tmp18_;
			gint _result__length1;
			gint __result__size_;
			gchar** _tmp19_;
			gint _tmp19__length1;
#line 292 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_tmp13_ = icon;
#line 292 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_tmp14_ = g_file_icon_get_file (G_TYPE_CHECK_INSTANCE_TYPE (_tmp13_, g_file_icon_get_type ()) ? ((GFileIcon*) _tmp13_) : NULL);
#line 292 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_tmp15_ = g_file_get_path (_tmp14_);
#line 292 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			path = _tmp15_;
#line 293 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_tmp16_ = path;
#line 293 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_tmp17_ = g_strdup (_tmp16_);
#line 293 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_tmp18_ = g_new0 (gchar*, 1 + 1);
#line 293 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_tmp18_[0] = _tmp17_;
#line 293 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_result_ = _tmp18_;
#line 293 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_result__length1 = 1;
#line 293 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			__result__size_ = _result__length1;
#line 295 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_tmp19_ = _result_;
#line 295 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_tmp19__length1 = _result__length1;
#line 295 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			if (result_length1) {
#line 295 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
				*result_length1 = _tmp19__length1;
#line 1104 "vfs-file-impl-gio.c"
			}
#line 295 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			result = _tmp19_;
#line 295 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_g_free0 (path);
#line 295 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_g_object_unref0 (icon);
#line 295 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_g_object_unref0 (fi);
#line 295 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			return result;
#line 1116 "vfs-file-impl-gio.c"
		}
	}
#line 300 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	_tmp20_ = g_new0 (gchar*, 0 + 1);
#line 300 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	unknown = _tmp20_;
#line 300 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	unknown_length1 = 0;
#line 300 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	_unknown_size_ = unknown_length1;
#line 301 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	_tmp21_ = unknown;
#line 301 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	_tmp21__length1 = unknown_length1;
#line 301 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	if (result_length1) {
#line 301 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		*result_length1 = _tmp21__length1;
#line 1135 "vfs-file-impl-gio.c"
	}
#line 301 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	result = _tmp21_;
#line 301 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	_g_object_unref0 (icon);
#line 301 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	_g_object_unref0 (fi);
#line 301 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	return result;
#line 1145 "vfs-file-impl-gio.c"
}

static gchar*
desktop_agnostic_vfs_file_gio_real_get_thumbnail_path (DesktopAgnosticVFSFile* base)
{
	DesktopAgnosticVFSFileGIO * self;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 304 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	self = (DesktopAgnosticVFSFileGIO*) base;
#line 1156 "vfs-file-impl-gio.c"
	{
		GFileInfo* fi = NULL;
		GFile* _tmp0_;
		GFileInfo* _tmp1_;
		GFileInfo* _tmp2_;
#line 309 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_tmp0_ = self->priv->_file;
#line 309 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_tmp1_ = g_file_query_info (_tmp0_, G_FILE_ATTRIBUTE_THUMBNAIL_PATH, 0, NULL, &_inner_error0_);
#line 309 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		fi = _tmp1_;
#line 309 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1170 "vfs-file-impl-gio.c"
			goto __catch0_g_error;
		}
#line 311 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_tmp2_ = fi;
#line 311 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		if (g_file_info_has_attribute (_tmp2_, G_FILE_ATTRIBUTE_THUMBNAIL_PATH)) {
#line 1177 "vfs-file-impl-gio.c"
			GFileInfo* _tmp3_;
			const gchar* _tmp4_;
			gchar* _tmp5_;
#line 313 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_tmp3_ = fi;
#line 313 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_tmp4_ = g_file_info_get_attribute_byte_string (_tmp3_, G_FILE_ATTRIBUTE_THUMBNAIL_PATH);
#line 313 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_tmp5_ = g_strdup (_tmp4_);
#line 313 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			result = _tmp5_;
#line 313 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_g_object_unref0 (fi);
#line 313 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			return result;
#line 1193 "vfs-file-impl-gio.c"
		}
#line 307 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_g_object_unref0 (fi);
#line 1197 "vfs-file-impl-gio.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 307 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		err = _inner_error0_;
#line 307 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_inner_error0_ = NULL;
#line 318 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_tmp6_ = err;
#line 318 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_tmp7_ = _tmp6_->message;
#line 318 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		g_warning ("vfs-file-impl-gio.vala:318: %s", _tmp7_);
#line 307 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_g_error_free0 (err);
#line 1217 "vfs-file-impl-gio.c"
	}
	__finally0:
#line 307 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 307 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 307 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		g_clear_error (&_inner_error0_);
#line 307 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		return NULL;
#line 1228 "vfs-file-impl-gio.c"
	}
#line 320 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	result = NULL;
#line 320 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	return result;
#line 1234 "vfs-file-impl-gio.c"
}

DesktopAgnosticVFSFileGIO*
desktop_agnostic_vfs_file_gio_construct (GType object_type)
{
	DesktopAgnosticVFSFileGIO * self = NULL;
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	self = (DesktopAgnosticVFSFileGIO*) desktop_agnostic_vfs_file_construct (object_type);
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	return self;
#line 1245 "vfs-file-impl-gio.c"
}

DesktopAgnosticVFSFileGIO*
desktop_agnostic_vfs_file_gio_new (void)
{
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	return desktop_agnostic_vfs_file_gio_construct (DESKTOP_AGNOSTIC_VFS_TYPE_FILE_GIO);
#line 1253 "vfs-file-impl-gio.c"
}

static void*
desktop_agnostic_vfs_file_gio_real_get_implementation (DesktopAgnosticVFSFile* base)
{
	void* result;
	DesktopAgnosticVFSFileGIO* self;
	GFile* _tmp0_;
#line 30 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	self = (DesktopAgnosticVFSFileGIO*) base;
#line 32 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	_tmp0_ = self->priv->_file;
#line 32 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	result = (void*) _tmp0_;
#line 32 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	return result;
#line 1270 "vfs-file-impl-gio.c"
}

static gchar*
desktop_agnostic_vfs_file_gio_real_get_impl_path (DesktopAgnosticVFSFile* base)
{
	gchar* result;
	DesktopAgnosticVFSFileGIO* self;
	GFile* _tmp0_;
	gchar* _tmp1_;
#line 38 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	self = (DesktopAgnosticVFSFileGIO*) base;
#line 40 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	_tmp0_ = self->priv->_file;
#line 40 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	_tmp1_ = g_file_get_path (_tmp0_);
#line 40 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	result = _tmp1_;
#line 40 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	return result;
#line 1290 "vfs-file-impl-gio.c"
}

static gchar*
desktop_agnostic_vfs_file_gio_real_get_impl_uri (DesktopAgnosticVFSFile* base)
{
	gchar* result;
	DesktopAgnosticVFSFileGIO* self;
	const gchar* _tmp0_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
#line 45 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	self = (DesktopAgnosticVFSFileGIO*) base;
#line 47 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	_tmp0_ = self->priv->_uri;
#line 47 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	if (_tmp0_ == NULL) {
#line 1307 "vfs-file-impl-gio.c"
		GFile* _tmp1_;
		gchar* _tmp2_;
#line 49 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_tmp1_ = self->priv->_file;
#line 49 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_tmp2_ = g_file_get_uri (_tmp1_);
#line 49 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_g_free0 (self->priv->_uri);
#line 49 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		self->priv->_uri = _tmp2_;
#line 1318 "vfs-file-impl-gio.c"
	}
#line 51 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	_tmp3_ = self->priv->_uri;
#line 51 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	_tmp4_ = g_strdup (_tmp3_);
#line 51 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	result = _tmp4_;
#line 51 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	return result;
#line 1328 "vfs-file-impl-gio.c"
}

static DesktopAgnosticVFSFileType
desktop_agnostic_vfs_file_gio_real_get_file_type (DesktopAgnosticVFSFile* base)
{
	DesktopAgnosticVFSFileType result;
	DesktopAgnosticVFSFileGIO* self;
	DesktopAgnosticVFSFileType ft = 0;
	GError* _inner_error0_ = NULL;
#line 56 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	self = (DesktopAgnosticVFSFileGIO*) base;
#line 58 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	ft = DESKTOP_AGNOSTIC_VFS_FILE_TYPE_UNKNOWN;
#line 59 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	if (desktop_agnostic_vfs_file_exists ((DesktopAgnosticVFSFile*) self)) {
#line 1344 "vfs-file-impl-gio.c"
		GFileInfo* info = NULL;
		GFileType gft = 0;
		{
			GFileInfo* _tmp0_ = NULL;
			GFile* _tmp1_;
			GFileInfo* _tmp2_;
			GFileInfo* _tmp3_;
			GFileInfo* _tmp4_;
#line 67 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_tmp1_ = self->priv->_file;
#line 67 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_tmp2_ = g_file_query_info (_tmp1_, G_FILE_ATTRIBUTE_STANDARD_TYPE, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error0_);
#line 67 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_tmp0_ = _tmp2_;
#line 67 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1361 "vfs-file-impl-gio.c"
				goto __catch0_g_error;
			}
#line 67 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_tmp3_ = _tmp0_;
#line 67 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_tmp0_ = NULL;
#line 67 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_g_object_unref0 (info);
#line 67 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			info = _tmp3_;
#line 70 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_tmp4_ = info;
#line 70 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			gft = (GFileType) g_file_info_get_attribute_uint32 (_tmp4_, G_FILE_ATTRIBUTE_STANDARD_TYPE);
#line 71 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			switch (gft) {
#line 71 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
				case G_FILE_TYPE_REGULAR:
#line 1380 "vfs-file-impl-gio.c"
				{
#line 74 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
					ft = DESKTOP_AGNOSTIC_VFS_FILE_TYPE_REGULAR;
#line 75 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
					break;
#line 1386 "vfs-file-impl-gio.c"
				}
#line 71 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
				case G_FILE_TYPE_DIRECTORY:
#line 71 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
				case G_FILE_TYPE_MOUNTABLE:
#line 1392 "vfs-file-impl-gio.c"
				{
#line 78 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
					ft = DESKTOP_AGNOSTIC_VFS_FILE_TYPE_DIRECTORY;
#line 79 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
					break;
#line 1398 "vfs-file-impl-gio.c"
				}
#line 71 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
				case G_FILE_TYPE_SYMBOLIC_LINK:
#line 71 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
				case G_FILE_TYPE_SHORTCUT:
#line 1404 "vfs-file-impl-gio.c"
				{
#line 82 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
					ft = DESKTOP_AGNOSTIC_VFS_FILE_TYPE_SYMBOLIC_LINK;
#line 83 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
					break;
#line 1410 "vfs-file-impl-gio.c"
				}
#line 71 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
				case G_FILE_TYPE_SPECIAL:
#line 1414 "vfs-file-impl-gio.c"
				{
#line 85 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
					ft = DESKTOP_AGNOSTIC_VFS_FILE_TYPE_SPECIAL;
#line 86 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
					break;
#line 1420 "vfs-file-impl-gio.c"
				}
#line 71 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
				case G_FILE_TYPE_UNKNOWN:
#line 1424 "vfs-file-impl-gio.c"
				{
#line 88 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
					ft = DESKTOP_AGNOSTIC_VFS_FILE_TYPE_UNKNOWN;
#line 89 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
					break;
#line 1430 "vfs-file-impl-gio.c"
				}
				default:
#line 71 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
				break;
#line 1435 "vfs-file-impl-gio.c"
			}
#line 65 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_g_object_unref0 (_tmp0_);
#line 1439 "vfs-file-impl-gio.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* err = NULL;
			GError* _tmp5_;
			const gchar* _tmp6_;
#line 65 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			err = _inner_error0_;
#line 65 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_inner_error0_ = NULL;
#line 94 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_tmp5_ = err;
#line 94 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_tmp6_ = _tmp5_->message;
#line 94 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			g_warning ("vfs-file-impl-gio.vala:94: An error occurred while querying the file t" \
"ype: %s", _tmp6_);
#line 96 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			ft = DESKTOP_AGNOSTIC_VFS_FILE_TYPE_UNKNOWN;
#line 65 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_g_error_free0 (err);
#line 1461 "vfs-file-impl-gio.c"
		}
		__finally0:
#line 65 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 65 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_g_object_unref0 (info);
#line 65 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 65 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			g_clear_error (&_inner_error0_);
#line 65 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			return 0;
#line 1474 "vfs-file-impl-gio.c"
		}
#line 59 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_g_object_unref0 (info);
#line 1478 "vfs-file-impl-gio.c"
	}
#line 99 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	result = ft;
#line 99 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	return result;
#line 1484 "vfs-file-impl-gio.c"
}

static DesktopAgnosticVFSAccessFlags
desktop_agnostic_vfs_file_gio_real_get_access_flags (DesktopAgnosticVFSFile* base)
{
	DesktopAgnosticVFSAccessFlags result;
	DesktopAgnosticVFSFileGIO* self;
	DesktopAgnosticVFSAccessFlags flags = 0;
	GError* _inner_error0_ = NULL;
#line 104 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	self = (DesktopAgnosticVFSFileGIO*) base;
#line 106 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	flags = DESKTOP_AGNOSTIC_VFS_ACCESS_FLAGS_NONE;
#line 107 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	if (desktop_agnostic_vfs_file_exists ((DesktopAgnosticVFSFile*) self)) {
#line 1500 "vfs-file-impl-gio.c"
		GFileInfo* info = NULL;
		{
			gchar* attrs = NULL;
			gchar* _tmp0_;
			GFileInfo* _tmp1_ = NULL;
			GFile* _tmp2_;
			const gchar* _tmp3_;
			GFileInfo* _tmp4_;
			GFileInfo* _tmp5_;
			GFileInfo* _tmp6_;
			GFileInfo* _tmp7_;
			GFileInfo* _tmp8_;
#line 115 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_tmp0_ = g_strdup_printf ("%s,%s,%s", G_FILE_ATTRIBUTE_ACCESS_CAN_READ, G_FILE_ATTRIBUTE_ACCESS_CAN_WRITE, G_FILE_ATTRIBUTE_ACCESS_CAN_EXECUTE);
#line 115 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_g_free0 (attrs);
#line 115 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			attrs = _tmp0_;
#line 118 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_tmp2_ = self->priv->_file;
#line 118 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_tmp3_ = attrs;
#line 118 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_tmp4_ = g_file_query_info (_tmp2_, _tmp3_, G_FILE_QUERY_INFO_NONE, NULL, &_inner_error0_);
#line 118 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_tmp1_ = _tmp4_;
#line 118 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 118 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
				_g_free0 (attrs);
#line 1531 "vfs-file-impl-gio.c"
				goto __catch0_g_error;
			}
#line 118 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_tmp5_ = _tmp1_;
#line 118 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_tmp1_ = NULL;
#line 118 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_g_object_unref0 (info);
#line 118 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			info = _tmp5_;
#line 120 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_tmp6_ = info;
#line 120 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			if (g_file_info_get_attribute_boolean (_tmp6_, G_FILE_ATTRIBUTE_ACCESS_CAN_READ)) {
#line 122 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
				flags |= DESKTOP_AGNOSTIC_VFS_ACCESS_FLAGS_READ;
#line 1548 "vfs-file-impl-gio.c"
			}
#line 124 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_tmp7_ = info;
#line 124 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			if (g_file_info_get_attribute_boolean (_tmp7_, G_FILE_ATTRIBUTE_ACCESS_CAN_WRITE)) {
#line 126 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
				flags |= DESKTOP_AGNOSTIC_VFS_ACCESS_FLAGS_WRITE;
#line 1556 "vfs-file-impl-gio.c"
			}
#line 128 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_tmp8_ = info;
#line 128 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			if (g_file_info_get_attribute_boolean (_tmp8_, G_FILE_ATTRIBUTE_ACCESS_CAN_EXECUTE)) {
#line 130 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
				flags |= DESKTOP_AGNOSTIC_VFS_ACCESS_FLAGS_EXECUTE;
#line 1564 "vfs-file-impl-gio.c"
			}
#line 111 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_g_object_unref0 (_tmp1_);
#line 111 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_g_free0 (attrs);
#line 1570 "vfs-file-impl-gio.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* err = NULL;
			GError* _tmp9_;
			const gchar* _tmp10_;
#line 111 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			err = _inner_error0_;
#line 111 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_inner_error0_ = NULL;
#line 135 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_tmp9_ = err;
#line 135 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_tmp10_ = _tmp9_->message;
#line 135 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			g_warning ("vfs-file-impl-gio.vala:135: An error occurred while querying the acces" \
"s flags: %s", _tmp10_);
#line 111 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_g_error_free0 (err);
#line 1590 "vfs-file-impl-gio.c"
		}
		__finally0:
#line 111 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 111 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			_g_object_unref0 (info);
#line 111 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 111 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			g_clear_error (&_inner_error0_);
#line 111 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
			return 0;
#line 1603 "vfs-file-impl-gio.c"
		}
#line 107 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_g_object_unref0 (info);
#line 1607 "vfs-file-impl-gio.c"
	}
#line 140 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	result = flags;
#line 140 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	return result;
#line 1613 "vfs-file-impl-gio.c"
}

static DesktopAgnosticVFSFile*
desktop_agnostic_vfs_file_gio_real_get_parent (DesktopAgnosticVFSFile* base)
{
	DesktopAgnosticVFSFile* result;
	DesktopAgnosticVFSFileGIO* self;
	GFile* file = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
#line 145 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	self = (DesktopAgnosticVFSFileGIO*) base;
#line 149 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	_tmp0_ = self->priv->_file;
#line 149 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	_tmp1_ = g_file_get_parent (_tmp0_);
#line 149 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	_g_object_unref0 (file);
#line 149 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	file = _tmp1_;
#line 150 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	_tmp2_ = file;
#line 150 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	if (_tmp2_ == NULL) {
#line 152 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		result = NULL;
#line 152 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_g_object_unref0 (file);
#line 152 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		return result;
#line 1645 "vfs-file-impl-gio.c"
	} else {
		DesktopAgnosticVFSFile* _result_ = NULL;
		DesktopAgnosticVFSFileGIO* _tmp3_;
		DesktopAgnosticVFSFile* _tmp4_;
		GFile* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
#line 158 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_tmp3_ = desktop_agnostic_vfs_file_gio_new ();
#line 158 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_g_object_unref0 (_result_);
#line 158 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_result_ = (DesktopAgnosticVFSFile*) _tmp3_;
#line 159 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_tmp4_ = _result_;
#line 159 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_tmp5_ = file;
#line 159 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_tmp6_ = g_file_get_uri (_tmp5_);
#line 159 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_tmp7_ = _tmp6_;
#line 159 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		desktop_agnostic_vfs_file_init (_tmp4_, _tmp7_);
#line 159 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_g_free0 (_tmp7_);
#line 160 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		result = _result_;
#line 160 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		_g_object_unref0 (file);
#line 160 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		return result;
#line 1677 "vfs-file-impl-gio.c"
	}
}

static void
desktop_agnostic_vfs_file_gio_class_init (DesktopAgnosticVFSFileGIOClass * klass,
                                          gpointer klass_data)
{
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	desktop_agnostic_vfs_file_gio_parent_class = g_type_class_peek_parent (klass);
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	g_type_class_adjust_private_offset (klass, &DesktopAgnosticVFSFileGIO_private_offset);
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	((DesktopAgnosticVFSFileClass *) klass)->init = (void (*) (DesktopAgnosticVFSFile*, const gchar*)) desktop_agnostic_vfs_file_gio_real_init;
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	((DesktopAgnosticVFSFileClass *) klass)->exists = (gboolean (*) (DesktopAgnosticVFSFile*)) desktop_agnostic_vfs_file_gio_real_exists;
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	((DesktopAgnosticVFSFileClass *) klass)->monitor = (DesktopAgnosticVFSFileMonitor* (*) (DesktopAgnosticVFSFile*)) desktop_agnostic_vfs_file_gio_real_monitor;
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	((DesktopAgnosticVFSFileClass *) klass)->load_contents = (gboolean (*) (DesktopAgnosticVFSFile*, gchar**, gsize*, GError**)) desktop_agnostic_vfs_file_gio_real_load_contents;
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	((DesktopAgnosticVFSFileClass *) klass)->replace_contents = (gboolean (*) (DesktopAgnosticVFSFile*, const gchar*, GError**)) desktop_agnostic_vfs_file_gio_real_replace_contents;
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	((DesktopAgnosticVFSFileClass *) klass)->launch = (gboolean (*) (DesktopAgnosticVFSFile*, GError**)) desktop_agnostic_vfs_file_gio_real_launch;
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	((DesktopAgnosticVFSFileClass *) klass)->enumerate_children = (GSList* (*) (DesktopAgnosticVFSFile*, GError**)) desktop_agnostic_vfs_file_gio_real_enumerate_children;
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	((DesktopAgnosticVFSFileClass *) klass)->copy = (gboolean (*) (DesktopAgnosticVFSFile*, DesktopAgnosticVFSFile*, gboolean, GError**)) desktop_agnostic_vfs_file_gio_real_copy;
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	((DesktopAgnosticVFSFileClass *) klass)->remove = (gboolean (*) (DesktopAgnosticVFSFile*, GError**)) desktop_agnostic_vfs_file_gio_real_remove;
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	((DesktopAgnosticVFSFileClass *) klass)->is_native = (gboolean (*) (DesktopAgnosticVFSFile*)) desktop_agnostic_vfs_file_gio_real_is_native;
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	((DesktopAgnosticVFSFileClass *) klass)->get_mime_type = (gchar* (*) (DesktopAgnosticVFSFile*, GError**)) desktop_agnostic_vfs_file_gio_real_get_mime_type;
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	((DesktopAgnosticVFSFileClass *) klass)->get_icon_names = (gchar** (*) (DesktopAgnosticVFSFile*, gint*, GError**)) desktop_agnostic_vfs_file_gio_real_get_icon_names;
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	((DesktopAgnosticVFSFileClass *) klass)->get_thumbnail_path = (gchar* (*) (DesktopAgnosticVFSFile*)) desktop_agnostic_vfs_file_gio_real_get_thumbnail_path;
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	DESKTOP_AGNOSTIC_VFS_FILE_CLASS (klass)->get_implementation = (void* (*) (DesktopAgnosticVFSFile*)) desktop_agnostic_vfs_file_gio_real_get_implementation;
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	DESKTOP_AGNOSTIC_VFS_FILE_CLASS (klass)->get_impl_path = (gchar* (*) (DesktopAgnosticVFSFile*)) desktop_agnostic_vfs_file_gio_real_get_impl_path;
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	DESKTOP_AGNOSTIC_VFS_FILE_CLASS (klass)->get_impl_uri = (gchar* (*) (DesktopAgnosticVFSFile*)) desktop_agnostic_vfs_file_gio_real_get_impl_uri;
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	DESKTOP_AGNOSTIC_VFS_FILE_CLASS (klass)->get_file_type = (DesktopAgnosticVFSFileType (*) (DesktopAgnosticVFSFile*)) desktop_agnostic_vfs_file_gio_real_get_file_type;
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	DESKTOP_AGNOSTIC_VFS_FILE_CLASS (klass)->get_access_flags = (DesktopAgnosticVFSAccessFlags (*) (DesktopAgnosticVFSFile*)) desktop_agnostic_vfs_file_gio_real_get_access_flags;
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	DESKTOP_AGNOSTIC_VFS_FILE_CLASS (klass)->get_parent = (DesktopAgnosticVFSFile* (*) (DesktopAgnosticVFSFile*)) desktop_agnostic_vfs_file_gio_real_get_parent;
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_desktop_agnostic_vfs_file_gio_get_property;
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	G_OBJECT_CLASS (klass)->finalize = desktop_agnostic_vfs_file_gio_finalize;
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DESKTOP_AGNOSTIC_VFS_FILE_GIO_IMPLEMENTATION_PROPERTY, desktop_agnostic_vfs_file_gio_properties[DESKTOP_AGNOSTIC_VFS_FILE_GIO_IMPLEMENTATION_PROPERTY] = g_param_spec_pointer ("implementation", "implementation", "implementation", G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DESKTOP_AGNOSTIC_VFS_FILE_GIO_IMPL_PATH_PROPERTY, desktop_agnostic_vfs_file_gio_properties[DESKTOP_AGNOSTIC_VFS_FILE_GIO_IMPL_PATH_PROPERTY] = g_param_spec_string ("impl-path", "impl-path", "impl-path", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DESKTOP_AGNOSTIC_VFS_FILE_GIO_IMPL_URI_PROPERTY, desktop_agnostic_vfs_file_gio_properties[DESKTOP_AGNOSTIC_VFS_FILE_GIO_IMPL_URI_PROPERTY] = g_param_spec_string ("impl-uri", "impl-uri", "impl-uri", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DESKTOP_AGNOSTIC_VFS_FILE_GIO_FILE_TYPE_PROPERTY, desktop_agnostic_vfs_file_gio_properties[DESKTOP_AGNOSTIC_VFS_FILE_GIO_FILE_TYPE_PROPERTY] = g_param_spec_enum ("file-type", "file-type", "file-type", DESKTOP_AGNOSTIC_VFS_TYPE_FILE_TYPE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DESKTOP_AGNOSTIC_VFS_FILE_GIO_ACCESS_FLAGS_PROPERTY, desktop_agnostic_vfs_file_gio_properties[DESKTOP_AGNOSTIC_VFS_FILE_GIO_ACCESS_FLAGS_PROPERTY] = g_param_spec_enum ("access-flags", "access-flags", "access-flags", DESKTOP_AGNOSTIC_VFS_TYPE_ACCESS_FLAGS, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DESKTOP_AGNOSTIC_VFS_FILE_GIO_PARENT_PROPERTY, desktop_agnostic_vfs_file_gio_properties[DESKTOP_AGNOSTIC_VFS_FILE_GIO_PARENT_PROPERTY] = g_param_spec_object ("parent", "parent", "parent", DESKTOP_AGNOSTIC_VFS_TYPE_FILE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1743 "vfs-file-impl-gio.c"
}

static void
desktop_agnostic_vfs_file_gio_instance_init (DesktopAgnosticVFSFileGIO * self,
                                             gpointer klass)
{
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	self->priv = desktop_agnostic_vfs_file_gio_get_instance_private (self);
#line 1752 "vfs-file-impl-gio.c"
}

static void
desktop_agnostic_vfs_file_gio_finalize (GObject * obj)
{
	DesktopAgnosticVFSFileGIO * self;
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DESKTOP_AGNOSTIC_VFS_TYPE_FILE_GIO, DesktopAgnosticVFSFileGIO);
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	_g_object_unref0 (self->priv->_file);
#line 35 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	_g_free0 (self->priv->_uri);
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	G_OBJECT_CLASS (desktop_agnostic_vfs_file_gio_parent_class)->finalize (obj);
#line 1767 "vfs-file-impl-gio.c"
}

static GType
desktop_agnostic_vfs_file_gio_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DesktopAgnosticVFSFileGIOClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) desktop_agnostic_vfs_file_gio_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DesktopAgnosticVFSFileGIO), 0, (GInstanceInitFunc) desktop_agnostic_vfs_file_gio_instance_init, NULL };
	GType desktop_agnostic_vfs_file_gio_type_id;
	desktop_agnostic_vfs_file_gio_type_id = g_type_register_static (DESKTOP_AGNOSTIC_VFS_TYPE_FILE, "DesktopAgnosticVFSFileGIO", &g_define_type_info, 0);
	DesktopAgnosticVFSFileGIO_private_offset = g_type_add_instance_private (desktop_agnostic_vfs_file_gio_type_id, sizeof (DesktopAgnosticVFSFileGIOPrivate));
	return desktop_agnostic_vfs_file_gio_type_id;
}

GType
desktop_agnostic_vfs_file_gio_get_type (void)
{
	static volatile gsize desktop_agnostic_vfs_file_gio_type_id__once = 0;
	if (g_once_init_enter (&desktop_agnostic_vfs_file_gio_type_id__once)) {
		GType desktop_agnostic_vfs_file_gio_type_id;
		desktop_agnostic_vfs_file_gio_type_id = desktop_agnostic_vfs_file_gio_get_type_once ();
		g_once_init_leave (&desktop_agnostic_vfs_file_gio_type_id__once, desktop_agnostic_vfs_file_gio_type_id);
	}
	return desktop_agnostic_vfs_file_gio_type_id__once;
}

static void
_vala_desktop_agnostic_vfs_file_gio_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec)
{
	DesktopAgnosticVFSFileGIO * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DESKTOP_AGNOSTIC_VFS_TYPE_FILE_GIO, DesktopAgnosticVFSFileGIO);
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
	switch (property_id) {
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		case DESKTOP_AGNOSTIC_VFS_FILE_GIO_IMPLEMENTATION_PROPERTY:
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		g_value_set_pointer (value, desktop_agnostic_vfs_file_get_implementation ((DesktopAgnosticVFSFile*) self));
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		break;
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		case DESKTOP_AGNOSTIC_VFS_FILE_GIO_IMPL_PATH_PROPERTY:
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		g_value_take_string (value, desktop_agnostic_vfs_file_get_impl_path ((DesktopAgnosticVFSFile*) self));
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		break;
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		case DESKTOP_AGNOSTIC_VFS_FILE_GIO_IMPL_URI_PROPERTY:
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		g_value_take_string (value, desktop_agnostic_vfs_file_get_impl_uri ((DesktopAgnosticVFSFile*) self));
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		break;
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		case DESKTOP_AGNOSTIC_VFS_FILE_GIO_FILE_TYPE_PROPERTY:
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		g_value_set_enum (value, desktop_agnostic_vfs_file_get_file_type ((DesktopAgnosticVFSFile*) self));
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		break;
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		case DESKTOP_AGNOSTIC_VFS_FILE_GIO_ACCESS_FLAGS_PROPERTY:
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		g_value_set_enum (value, desktop_agnostic_vfs_file_get_access_flags ((DesktopAgnosticVFSFile*) self));
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		break;
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		case DESKTOP_AGNOSTIC_VFS_FILE_GIO_PARENT_PROPERTY:
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		g_value_take_object (value, desktop_agnostic_vfs_file_get_parent ((DesktopAgnosticVFSFile*) self));
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		break;
#line 1838 "vfs-file-impl-gio.c"
		default:
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-impl-gio.vala"
		break;
#line 1844 "vfs-file-impl-gio.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

