/* vfs-file-monitor-impl-gio.c generated by valac 0.56.17, the Vala compiler
 * generated from vfs-file-monitor-impl-gio.vala, do not modify */

/*
 * Desktop Agnostic Library: File monitor implementation (with GIO).
 *
 * Copyright (C) 2009 Mark Lee <libdesktop-agnostic@lazymalevolence.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 *
 * Author : Mark Lee <libdesktop-agnostic@lazymalevolence.com>
 */

#include "da-vfs-gio.h"
#include <gio/gio.h>
#include <desktop-agnostic-vfs.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	DESKTOP_AGNOSTIC_VFS_FILE_MONITOR_GIO_0_PROPERTY,
	DESKTOP_AGNOSTIC_VFS_FILE_MONITOR_GIO_CANCELLED_PROPERTY,
	DESKTOP_AGNOSTIC_VFS_FILE_MONITOR_GIO_NUM_PROPERTIES
};
static GParamSpec* desktop_agnostic_vfs_file_monitor_gio_properties[DESKTOP_AGNOSTIC_VFS_FILE_MONITOR_GIO_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _DesktopAgnosticVFSFileMonitorGIOPrivate {
	GFileMonitor* monitor;
	DesktopAgnosticVFSFile* file;
};

static gint DesktopAgnosticVFSFileMonitorGIO_private_offset;
static gpointer desktop_agnostic_vfs_file_monitor_gio_parent_class = NULL;
static DesktopAgnosticVFSFileMonitorIface * desktop_agnostic_vfs_file_monitor_gio_desktop_agnostic_vfs_file_monitor_parent_iface = NULL;

static void desktop_agnostic_vfs_file_monitor_gio_monitor_callback (DesktopAgnosticVFSFileMonitorGIO* self,
                                                             GFileMonitor* monitor,
                                                             GFile* file,
                                                             GFile* other,
                                                             GFileMonitorEvent event_type);
static void _desktop_agnostic_vfs_file_monitor_gio_monitor_callback_g_file_monitor_changed (GFileMonitor* _sender,
                                                                                     GFile* file,
                                                                                     GFile* other_file,
                                                                                     GFileMonitorEvent event_type,
                                                                                     gpointer self);
static void desktop_agnostic_vfs_file_monitor_gio_real_emit (DesktopAgnosticVFSFileMonitor* base,
                                                      DesktopAgnosticVFSFile* other,
                                                      DesktopAgnosticVFSFileMonitorEvent event);
static gboolean desktop_agnostic_vfs_file_monitor_gio_real_cancel (DesktopAgnosticVFSFileMonitor* base);
static void desktop_agnostic_vfs_file_monitor_gio_finalize (GObject * obj);
static GType desktop_agnostic_vfs_file_monitor_gio_get_type_once (void);
static void _vala_desktop_agnostic_vfs_file_monitor_gio_get_property (GObject * object,
                                                               guint property_id,
                                                               GValue * value,
                                                               GParamSpec * pspec);

static inline gpointer
desktop_agnostic_vfs_file_monitor_gio_get_instance_private (DesktopAgnosticVFSFileMonitorGIO* self)
{
	return G_STRUCT_MEMBER_P (self, DesktopAgnosticVFSFileMonitorGIO_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 38 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
	return self ? g_object_ref (self) : NULL;
#line 94 "vfs-file-monitor-impl-gio.c"
}

static void
_desktop_agnostic_vfs_file_monitor_gio_monitor_callback_g_file_monitor_changed (GFileMonitor* _sender,
                                                                                GFile* file,
                                                                                GFile* other_file,
                                                                                GFileMonitorEvent event_type,
                                                                                gpointer self)
{
#line 48 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
	desktop_agnostic_vfs_file_monitor_gio_monitor_callback ((DesktopAgnosticVFSFileMonitorGIO*) self, _sender, file, other_file, event_type);
#line 106 "vfs-file-monitor-impl-gio.c"
}

DesktopAgnosticVFSFileMonitorGIO*
desktop_agnostic_vfs_file_monitor_gio_construct (GType object_type,
                                                 DesktopAgnosticVFSFileGIO* file)
{
	DesktopAgnosticVFSFileMonitorGIO * self = NULL;
	DesktopAgnosticVFSFile* _tmp0_;
	GFile* impl = NULL;
	void* _tmp1_;
	void* _tmp2_;
	GFile* _tmp3_;
	DesktopAgnosticVFSFileType _tmp4_;
	DesktopAgnosticVFSFileType _tmp5_;
	GFileMonitor* _tmp14_;
	GError* _inner_error0_ = NULL;
#line 36 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 36 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
	self = (DesktopAgnosticVFSFileMonitorGIO*) g_object_new (object_type, NULL);
#line 38 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
	_tmp0_ = _g_object_ref0 ((DesktopAgnosticVFSFile*) file);
#line 38 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
	_g_object_unref0 (self->priv->file);
#line 38 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
	self->priv->file = _tmp0_;
#line 39 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
	_tmp1_ = desktop_agnostic_vfs_file_get_implementation ((DesktopAgnosticVFSFile*) file);
#line 39 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
	_tmp2_ = _tmp1_;
#line 39 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, g_file_get_type (), GFile));
#line 39 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
	impl = _tmp3_;
#line 40 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
	_tmp4_ = desktop_agnostic_vfs_file_get_file_type ((DesktopAgnosticVFSFile*) file);
#line 40 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
	_tmp5_ = _tmp4_;
#line 40 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
	if (_tmp5_ == DESKTOP_AGNOSTIC_VFS_FILE_TYPE_DIRECTORY) {
#line 147 "vfs-file-monitor-impl-gio.c"
		GFileMonitor* _tmp6_ = NULL;
		GFile* _tmp7_;
		GFileMonitor* _tmp8_;
		GFileMonitor* _tmp9_;
#line 42 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
		_tmp7_ = impl;
#line 42 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
		_tmp8_ = g_file_monitor_directory (_tmp7_, G_FILE_MONITOR_NONE, NULL, &_inner_error0_);
#line 42 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
		_tmp6_ = _tmp8_;
#line 42 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 42 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
			_g_object_unref0 (impl);
#line 42 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 42 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
			g_clear_error (&_inner_error0_);
#line 42 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
			return NULL;
#line 168 "vfs-file-monitor-impl-gio.c"
		}
#line 42 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
		_tmp9_ = _tmp6_;
#line 42 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
		_tmp6_ = NULL;
#line 42 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
		_g_object_unref0 (self->priv->monitor);
#line 42 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
		self->priv->monitor = _tmp9_;
#line 40 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
		_g_object_unref0 (_tmp6_);
#line 180 "vfs-file-monitor-impl-gio.c"
	} else {
		GFileMonitor* _tmp10_ = NULL;
		GFile* _tmp11_;
		GFileMonitor* _tmp12_;
		GFileMonitor* _tmp13_;
#line 46 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
		_tmp11_ = impl;
#line 46 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
		_tmp12_ = g_file_monitor_file (_tmp11_, G_FILE_MONITOR_NONE, NULL, &_inner_error0_);
#line 46 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
		_tmp10_ = _tmp12_;
#line 46 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 46 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
			_g_object_unref0 (impl);
#line 46 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 46 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
			g_clear_error (&_inner_error0_);
#line 46 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
			return NULL;
#line 202 "vfs-file-monitor-impl-gio.c"
		}
#line 46 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
		_tmp13_ = _tmp10_;
#line 46 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
		_tmp10_ = NULL;
#line 46 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
		_g_object_unref0 (self->priv->monitor);
#line 46 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
		self->priv->monitor = _tmp13_;
#line 40 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
		_g_object_unref0 (_tmp10_);
#line 214 "vfs-file-monitor-impl-gio.c"
	}
#line 48 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
	_tmp14_ = self->priv->monitor;
#line 48 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
	g_signal_connect_object (_tmp14_, "changed", (GCallback) _desktop_agnostic_vfs_file_monitor_gio_monitor_callback_g_file_monitor_changed, self, 0);
#line 36 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
	_g_object_unref0 (impl);
#line 36 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
	return self;
#line 224 "vfs-file-monitor-impl-gio.c"
}

DesktopAgnosticVFSFileMonitorGIO*
desktop_agnostic_vfs_file_monitor_gio_new (DesktopAgnosticVFSFileGIO* file)
{
#line 36 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
	return desktop_agnostic_vfs_file_monitor_gio_construct (DESKTOP_AGNOSTIC_VFS_TYPE_FILE_MONITOR_GIO, file);
#line 232 "vfs-file-monitor-impl-gio.c"
}

/**
     * @param monitor is a monitor initialized with FileMonitorFlags.NONE.
     * @param file contains the file that sent the signal and is not guaranteed
     *             to be equal to the file associated with the monitor.
     * @param other is always null when using FileMonitorFlags.NONE.
     * @param event_type is the changed signal sent by file.
     */
static void
desktop_agnostic_vfs_file_monitor_gio_monitor_callback (DesktopAgnosticVFSFileMonitorGIO* self,
                                                        GFileMonitor* monitor,
                                                        GFile* file,
                                                        GFile* other,
                                                        GFileMonitorEvent event_type)
{
	DesktopAgnosticVFSFile* other_file = NULL;
	DesktopAgnosticVFSFile* _tmp0_;
	DesktopAgnosticVFSFileType _tmp1_;
	DesktopAgnosticVFSFileType _tmp2_;
	DesktopAgnosticVFSFileMonitorEvent da_event = 0;
	DesktopAgnosticVFSFile* _tmp14_;
	DesktopAgnosticVFSFile* _tmp15_;
	GError* _inner_error0_ = NULL;
#line 58 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
	g_return_if_fail (self != NULL);
#line 58 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
	g_return_if_fail (monitor != NULL);
#line 58 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
	g_return_if_fail (file != NULL);
#line 62 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
	other_file = NULL;
#line 67 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
	_tmp0_ = self->priv->file;
#line 67 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
	_tmp1_ = desktop_agnostic_vfs_file_get_file_type (_tmp0_);
#line 67 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
	_tmp2_ = _tmp1_;
#line 67 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
	if (_tmp2_ == DESKTOP_AGNOSTIC_VFS_FILE_TYPE_DIRECTORY) {
#line 273 "vfs-file-monitor-impl-gio.c"
		DesktopAgnosticVFSFile* _tmp3_ = NULL;
		gchar* _tmp4_;
		gchar* _tmp5_;
		DesktopAgnosticVFSFile* _tmp6_;
		DesktopAgnosticVFSFile* _tmp7_;
		DesktopAgnosticVFSFile* _tmp8_;
#line 69 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
		_tmp4_ = g_file_get_uri (file);
#line 69 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
		_tmp5_ = _tmp4_;
#line 69 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
		_tmp6_ = desktop_agnostic_vfs_file_new_for_uri (_tmp5_, &_inner_error0_);
#line 69 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
		_tmp7_ = _tmp6_;
#line 69 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
		_g_free0 (_tmp5_);
#line 69 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
		_tmp3_ = _tmp7_;
#line 69 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 69 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
			_g_object_unref0 (other_file);
#line 69 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 69 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
			g_clear_error (&_inner_error0_);
#line 69 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
			return;
#line 302 "vfs-file-monitor-impl-gio.c"
		}
#line 69 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
		_tmp8_ = _tmp3_;
#line 69 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
		_tmp3_ = NULL;
#line 69 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
		_g_object_unref0 (other_file);
#line 69 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
		other_file = _tmp8_;
#line 67 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
		_g_object_unref0 (_tmp3_);
#line 314 "vfs-file-monitor-impl-gio.c"
	} else {
		GFile* impl = NULL;
		DesktopAgnosticVFSFile* _tmp9_;
		void* _tmp10_;
		void* _tmp11_;
		GFile* _tmp12_;
		GFile* _tmp13_;
#line 76 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
		_tmp9_ = self->priv->file;
#line 76 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
		_tmp10_ = desktop_agnostic_vfs_file_get_implementation (_tmp9_);
#line 76 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
		_tmp11_ = _tmp10_;
#line 76 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
		_tmp12_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, g_file_get_type (), GFile));
#line 76 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
		impl = _tmp12_;
#line 77 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
		_tmp13_ = impl;
#line 77 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
		if (!g_file_equal (_tmp13_, file)) {
#line 79 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
			_g_object_unref0 (impl);
#line 79 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
			_g_object_unref0 (other_file);
#line 79 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
			return;
#line 342 "vfs-file-monitor-impl-gio.c"
		}
#line 67 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
		_g_object_unref0 (impl);
#line 346 "vfs-file-monitor-impl-gio.c"
	}
#line 84 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
	switch (event_type) {
#line 84 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
		case G_FILE_MONITOR_EVENT_CHANGES_DONE_HINT:
#line 352 "vfs-file-monitor-impl-gio.c"
		{
#line 88 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
			da_event = DESKTOP_AGNOSTIC_VFS_FILE_MONITOR_EVENT_CHANGED;
#line 89 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
			break;
#line 358 "vfs-file-monitor-impl-gio.c"
		}
#line 84 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
		case G_FILE_MONITOR_EVENT_CREATED:
#line 362 "vfs-file-monitor-impl-gio.c"
		{
#line 91 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
			da_event = DESKTOP_AGNOSTIC_VFS_FILE_MONITOR_EVENT_CREATED;
#line 92 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
			break;
#line 368 "vfs-file-monitor-impl-gio.c"
		}
#line 84 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
		case G_FILE_MONITOR_EVENT_DELETED:
#line 372 "vfs-file-monitor-impl-gio.c"
		{
#line 94 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
			da_event = DESKTOP_AGNOSTIC_VFS_FILE_MONITOR_EVENT_DELETED;
#line 95 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
			break;
#line 378 "vfs-file-monitor-impl-gio.c"
		}
#line 84 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
		case G_FILE_MONITOR_EVENT_ATTRIBUTE_CHANGED:
#line 382 "vfs-file-monitor-impl-gio.c"
		{
#line 97 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
			da_event = DESKTOP_AGNOSTIC_VFS_FILE_MONITOR_EVENT_ATTRIBUTE_CHANGED;
#line 98 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
			break;
#line 388 "vfs-file-monitor-impl-gio.c"
		}
		default:
		{
#line 100 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
			da_event = DESKTOP_AGNOSTIC_VFS_FILE_MONITOR_EVENT_UNKNOWN;
#line 101 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
			break;
#line 396 "vfs-file-monitor-impl-gio.c"
		}
	}
#line 103 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
	_tmp14_ = self->priv->file;
#line 103 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
	_tmp15_ = other_file;
#line 103 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
	g_signal_emit_by_name ((DesktopAgnosticVFSFileMonitor*) self, "changed", _tmp14_, _tmp15_, da_event);
#line 58 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
	_g_object_unref0 (other_file);
#line 407 "vfs-file-monitor-impl-gio.c"
}

static void
desktop_agnostic_vfs_file_monitor_gio_real_emit (DesktopAgnosticVFSFileMonitor* base,
                                                 DesktopAgnosticVFSFile* other,
                                                 DesktopAgnosticVFSFileMonitorEvent event)
{
	DesktopAgnosticVFSFileMonitorGIO * self;
	GFileMonitorEvent gio_event = 0;
	GFile* other_file = NULL;
	GFileMonitor* _tmp3_;
	DesktopAgnosticVFSFile* _tmp4_;
	void* _tmp5_;
	void* _tmp6_;
	GFile* _tmp7_;
#line 105 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
	self = (DesktopAgnosticVFSFileMonitorGIO*) base;
#line 108 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
	other_file = NULL;
#line 109 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
	switch (event) {
#line 109 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
		case DESKTOP_AGNOSTIC_VFS_FILE_MONITOR_EVENT_CHANGED:
#line 431 "vfs-file-monitor-impl-gio.c"
		{
#line 112 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
			gio_event = G_FILE_MONITOR_EVENT_CHANGED;
#line 113 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
			break;
#line 437 "vfs-file-monitor-impl-gio.c"
		}
#line 109 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
		case DESKTOP_AGNOSTIC_VFS_FILE_MONITOR_EVENT_CREATED:
#line 441 "vfs-file-monitor-impl-gio.c"
		{
#line 115 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
			gio_event = G_FILE_MONITOR_EVENT_CREATED;
#line 116 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
			break;
#line 447 "vfs-file-monitor-impl-gio.c"
		}
#line 109 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
		case DESKTOP_AGNOSTIC_VFS_FILE_MONITOR_EVENT_DELETED:
#line 451 "vfs-file-monitor-impl-gio.c"
		{
#line 118 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
			gio_event = G_FILE_MONITOR_EVENT_DELETED;
#line 119 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
			break;
#line 457 "vfs-file-monitor-impl-gio.c"
		}
#line 109 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
		case DESKTOP_AGNOSTIC_VFS_FILE_MONITOR_EVENT_ATTRIBUTE_CHANGED:
#line 461 "vfs-file-monitor-impl-gio.c"
		{
#line 121 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
			gio_event = G_FILE_MONITOR_EVENT_ATTRIBUTE_CHANGED;
#line 122 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
			break;
#line 467 "vfs-file-monitor-impl-gio.c"
		}
		default:
		{
#line 124 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
			_g_object_unref0 (other_file);
#line 124 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
			return;
#line 475 "vfs-file-monitor-impl-gio.c"
		}
	}
#line 126 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
	if (other != NULL) {
#line 480 "vfs-file-monitor-impl-gio.c"
		void* _tmp0_;
		void* _tmp1_;
		GFile* _tmp2_;
#line 128 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
		_tmp0_ = desktop_agnostic_vfs_file_get_implementation (other);
#line 128 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
		_tmp1_ = _tmp0_;
#line 128 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
		_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, g_file_get_type (), GFile));
#line 128 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
		_g_object_unref0 (other_file);
#line 128 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
		other_file = _tmp2_;
#line 494 "vfs-file-monitor-impl-gio.c"
	}
#line 130 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
	_tmp3_ = self->priv->monitor;
#line 130 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
	_tmp4_ = self->priv->file;
#line 130 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
	_tmp5_ = desktop_agnostic_vfs_file_get_implementation (_tmp4_);
#line 130 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
	_tmp6_ = _tmp5_;
#line 130 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
	_tmp7_ = other_file;
#line 130 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
	g_file_monitor_emit_event (_tmp3_, G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, g_file_get_type (), GFile), _tmp7_, gio_event);
#line 105 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
	_g_object_unref0 (other_file);
#line 510 "vfs-file-monitor-impl-gio.c"
}

static gboolean
desktop_agnostic_vfs_file_monitor_gio_real_cancel (DesktopAgnosticVFSFileMonitor* base)
{
	DesktopAgnosticVFSFileMonitorGIO * self;
	GFileMonitor* _tmp0_;
	gboolean result;
#line 133 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
	self = (DesktopAgnosticVFSFileMonitorGIO*) base;
#line 135 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
	_tmp0_ = self->priv->monitor;
#line 135 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
	result = g_file_monitor_cancel (_tmp0_);
#line 135 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
	return result;
#line 527 "vfs-file-monitor-impl-gio.c"
}

static gboolean
desktop_agnostic_vfs_file_monitor_gio_real_get_cancelled (DesktopAgnosticVFSFileMonitor* base)
{
	gboolean result;
	DesktopAgnosticVFSFileMonitorGIO* self;
	GFileMonitor* _tmp0_;
#line 30 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
	self = (DesktopAgnosticVFSFileMonitorGIO*) base;
#line 32 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
	_tmp0_ = self->priv->monitor;
#line 32 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
	result = g_file_monitor_is_cancelled (_tmp0_);
#line 32 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
	return result;
#line 544 "vfs-file-monitor-impl-gio.c"
}

static void
desktop_agnostic_vfs_file_monitor_gio_class_init (DesktopAgnosticVFSFileMonitorGIOClass * klass,
                                                  gpointer klass_data)
{
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
	desktop_agnostic_vfs_file_monitor_gio_parent_class = g_type_class_peek_parent (klass);
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
	g_type_class_adjust_private_offset (klass, &DesktopAgnosticVFSFileMonitorGIO_private_offset);
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_desktop_agnostic_vfs_file_monitor_gio_get_property;
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
	G_OBJECT_CLASS (klass)->finalize = desktop_agnostic_vfs_file_monitor_gio_finalize;
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DESKTOP_AGNOSTIC_VFS_FILE_MONITOR_GIO_CANCELLED_PROPERTY, desktop_agnostic_vfs_file_monitor_gio_properties[DESKTOP_AGNOSTIC_VFS_FILE_MONITOR_GIO_CANCELLED_PROPERTY] = g_param_spec_boolean ("cancelled", "cancelled", "cancelled", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 561 "vfs-file-monitor-impl-gio.c"
}

static void
desktop_agnostic_vfs_file_monitor_gio_desktop_agnostic_vfs_file_monitor_interface_init (DesktopAgnosticVFSFileMonitorIface * iface,
                                                                                        gpointer iface_data)
{
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
	desktop_agnostic_vfs_file_monitor_gio_desktop_agnostic_vfs_file_monitor_parent_iface = g_type_interface_peek_parent (iface);
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
	iface->emit = (void (*) (DesktopAgnosticVFSFileMonitor*, DesktopAgnosticVFSFile*, DesktopAgnosticVFSFileMonitorEvent)) desktop_agnostic_vfs_file_monitor_gio_real_emit;
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
	iface->cancel = (gboolean (*) (DesktopAgnosticVFSFileMonitor*)) desktop_agnostic_vfs_file_monitor_gio_real_cancel;
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
	iface->get_cancelled = desktop_agnostic_vfs_file_monitor_gio_real_get_cancelled;
#line 576 "vfs-file-monitor-impl-gio.c"
}

static void
desktop_agnostic_vfs_file_monitor_gio_instance_init (DesktopAgnosticVFSFileMonitorGIO * self,
                                                     gpointer klass)
{
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
	self->priv = desktop_agnostic_vfs_file_monitor_gio_get_instance_private (self);
#line 585 "vfs-file-monitor-impl-gio.c"
}

static void
desktop_agnostic_vfs_file_monitor_gio_finalize (GObject * obj)
{
	DesktopAgnosticVFSFileMonitorGIO * self;
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DESKTOP_AGNOSTIC_VFS_TYPE_FILE_MONITOR_GIO, DesktopAgnosticVFSFileMonitorGIO);
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
	_g_object_unref0 (self->priv->monitor);
#line 35 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
	_g_object_unref0 (self->priv->file);
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
	G_OBJECT_CLASS (desktop_agnostic_vfs_file_monitor_gio_parent_class)->finalize (obj);
#line 600 "vfs-file-monitor-impl-gio.c"
}

static GType
desktop_agnostic_vfs_file_monitor_gio_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DesktopAgnosticVFSFileMonitorGIOClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) desktop_agnostic_vfs_file_monitor_gio_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DesktopAgnosticVFSFileMonitorGIO), 0, (GInstanceInitFunc) desktop_agnostic_vfs_file_monitor_gio_instance_init, NULL };
	static const GInterfaceInfo desktop_agnostic_vfs_file_monitor_info = { (GInterfaceInitFunc) desktop_agnostic_vfs_file_monitor_gio_desktop_agnostic_vfs_file_monitor_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType desktop_agnostic_vfs_file_monitor_gio_type_id;
	desktop_agnostic_vfs_file_monitor_gio_type_id = g_type_register_static (G_TYPE_OBJECT, "DesktopAgnosticVFSFileMonitorGIO", &g_define_type_info, 0);
	g_type_add_interface_static (desktop_agnostic_vfs_file_monitor_gio_type_id, DESKTOP_AGNOSTIC_VFS_TYPE_FILE_MONITOR, &desktop_agnostic_vfs_file_monitor_info);
	DesktopAgnosticVFSFileMonitorGIO_private_offset = g_type_add_instance_private (desktop_agnostic_vfs_file_monitor_gio_type_id, sizeof (DesktopAgnosticVFSFileMonitorGIOPrivate));
	return desktop_agnostic_vfs_file_monitor_gio_type_id;
}

GType
desktop_agnostic_vfs_file_monitor_gio_get_type (void)
{
	static volatile gsize desktop_agnostic_vfs_file_monitor_gio_type_id__once = 0;
	if (g_once_init_enter (&desktop_agnostic_vfs_file_monitor_gio_type_id__once)) {
		GType desktop_agnostic_vfs_file_monitor_gio_type_id;
		desktop_agnostic_vfs_file_monitor_gio_type_id = desktop_agnostic_vfs_file_monitor_gio_get_type_once ();
		g_once_init_leave (&desktop_agnostic_vfs_file_monitor_gio_type_id__once, desktop_agnostic_vfs_file_monitor_gio_type_id);
	}
	return desktop_agnostic_vfs_file_monitor_gio_type_id__once;
}

static void
_vala_desktop_agnostic_vfs_file_monitor_gio_get_property (GObject * object,
                                                          guint property_id,
                                                          GValue * value,
                                                          GParamSpec * pspec)
{
	DesktopAgnosticVFSFileMonitorGIO * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DESKTOP_AGNOSTIC_VFS_TYPE_FILE_MONITOR_GIO, DesktopAgnosticVFSFileMonitorGIO);
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
	switch (property_id) {
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
		case DESKTOP_AGNOSTIC_VFS_FILE_MONITOR_GIO_CANCELLED_PROPERTY:
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
		g_value_set_boolean (value, desktop_agnostic_vfs_file_monitor_get_cancelled ((DesktopAgnosticVFSFileMonitor*) self));
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
		break;
#line 643 "vfs-file-monitor-impl-gio.c"
		default:
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor-impl-gio.vala"
		break;
#line 649 "vfs-file-monitor-impl-gio.c"
	}
}

