/* vfs-file-monitor.c generated by valac 0.56.17, the Vala compiler
 * generated from vfs-file-monitor.vala, do not modify */

/*
 * Desktop Agnostic Library: File monitor interface (similar to GFileMonitor).
 *
 * Copyright (C) 2009 Mark Lee <libdesktop-agnostic@lazymalevolence.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 *
 * Author : Mark Lee <libdesktop-agnostic@lazymalevolence.com>
 */

#include "desktop-agnostic-vfs.h"
#include <glib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	DESKTOP_AGNOSTIC_VFS_FILE_MONITOR_CHANGED_SIGNAL,
	DESKTOP_AGNOSTIC_VFS_FILE_MONITOR_NUM_SIGNALS
};
static guint desktop_agnostic_vfs_file_monitor_signals[DESKTOP_AGNOSTIC_VFS_FILE_MONITOR_NUM_SIGNALS] = {0};

static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT_ENUM (GClosure * closure,
                                                       GValue * return_value,
                                                       guint n_param_values,
                                                       const GValue * param_values,
                                                       gpointer invocation_hint,
                                                       gpointer marshal_data);
static GType desktop_agnostic_vfs_file_monitor_get_type_once (void);

/**
   * The file monitor events that will be propagated to the signal handlers.
   */
static GType
desktop_agnostic_vfs_file_monitor_event_get_type_once (void)
{
	static const GEnumValue values[] = {{DESKTOP_AGNOSTIC_VFS_FILE_MONITOR_EVENT_UNKNOWN, "DESKTOP_AGNOSTIC_VFS_FILE_MONITOR_EVENT_UNKNOWN", "unknown"}, {DESKTOP_AGNOSTIC_VFS_FILE_MONITOR_EVENT_CHANGED, "DESKTOP_AGNOSTIC_VFS_FILE_MONITOR_EVENT_CHANGED", "changed"}, {DESKTOP_AGNOSTIC_VFS_FILE_MONITOR_EVENT_CREATED, "DESKTOP_AGNOSTIC_VFS_FILE_MONITOR_EVENT_CREATED", "created"}, {DESKTOP_AGNOSTIC_VFS_FILE_MONITOR_EVENT_DELETED, "DESKTOP_AGNOSTIC_VFS_FILE_MONITOR_EVENT_DELETED", "deleted"}, {DESKTOP_AGNOSTIC_VFS_FILE_MONITOR_EVENT_ATTRIBUTE_CHANGED, "DESKTOP_AGNOSTIC_VFS_FILE_MONITOR_EVENT_ATTRIBUTE_CHANGED", "attribute-changed"}, {0, NULL, NULL}};
	GType desktop_agnostic_vfs_file_monitor_event_type_id;
	desktop_agnostic_vfs_file_monitor_event_type_id = g_enum_register_static ("DesktopAgnosticVFSFileMonitorEvent", values);
	return desktop_agnostic_vfs_file_monitor_event_type_id;
}

GType
desktop_agnostic_vfs_file_monitor_event_get_type (void)
{
	static volatile gsize desktop_agnostic_vfs_file_monitor_event_type_id__once = 0;
	if (g_once_init_enter (&desktop_agnostic_vfs_file_monitor_event_type_id__once)) {
		GType desktop_agnostic_vfs_file_monitor_event_type_id;
		desktop_agnostic_vfs_file_monitor_event_type_id = desktop_agnostic_vfs_file_monitor_event_get_type_once ();
		g_once_init_leave (&desktop_agnostic_vfs_file_monitor_event_type_id__once, desktop_agnostic_vfs_file_monitor_event_type_id);
	}
	return desktop_agnostic_vfs_file_monitor_event_type_id__once;
}

/**
     * Emits a file monitor event for the file backend associated with
     * the monitor.
     * @param other if the associated URI is a directory, the child file that
     * triggered the event. Otherwise, it should be NULL.
     * @param event the event type to emit.
     */
void
desktop_agnostic_vfs_file_monitor_emit (DesktopAgnosticVFSFileMonitor* self,
                                        DesktopAgnosticVFSFile* other,
                                        DesktopAgnosticVFSFileMonitorEvent event)
{
	DesktopAgnosticVFSFileMonitorIface* _iface_;
#line 48 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor.vala"
	g_return_if_fail (self != NULL);
#line 48 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor.vala"
	_iface_ = DESKTOP_AGNOSTIC_VFS_FILE_MONITOR_GET_INTERFACE (self);
#line 48 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor.vala"
	if (_iface_->emit) {
#line 48 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor.vala"
		_iface_->emit (self, other, event);
#line 98 "vfs-file-monitor.c"
	}
}

/**
     * Prevent the monitor from monitoring any events from the URI associated
     * with it.
     * @return whether the monitor was successfully cancelled.
     */
gboolean
desktop_agnostic_vfs_file_monitor_cancel (DesktopAgnosticVFSFileMonitor* self)
{
	DesktopAgnosticVFSFileMonitorIface* _iface_;
#line 54 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 54 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor.vala"
	_iface_ = DESKTOP_AGNOSTIC_VFS_FILE_MONITOR_GET_INTERFACE (self);
#line 54 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor.vala"
	if (_iface_->cancel) {
#line 54 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor.vala"
		return _iface_->cancel (self);
#line 119 "vfs-file-monitor.c"
	}
#line 54 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor.vala"
	return FALSE;
#line 123 "vfs-file-monitor.c"
}

gboolean
desktop_agnostic_vfs_file_monitor_get_cancelled (DesktopAgnosticVFSFileMonitor* self)
{
	DesktopAgnosticVFSFileMonitorIface* _iface_;
#line 58 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 58 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor.vala"
	_iface_ = DESKTOP_AGNOSTIC_VFS_FILE_MONITOR_GET_INTERFACE (self);
#line 58 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor.vala"
	if (_iface_->get_cancelled) {
#line 58 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor.vala"
		return _iface_->get_cancelled (self);
#line 138 "vfs-file-monitor.c"
	}
#line 58 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor.vala"
	return FALSE;
#line 142 "vfs-file-monitor.c"
}

static void
g_cclosure_user_marshal_VOID__OBJECT_OBJECT_ENUM (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT_ENUM) (gpointer data1, gpointer arg_1, gpointer arg_2, gint arg_3, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT_ENUM callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 39 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor.vala"
	g_return_if_fail (n_param_values == 4);
#line 39 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 39 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor.vala"
		data1 = closure->data;
#line 39 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor.vala"
		data2 = param_values->data[0].v_pointer;
#line 167 "vfs-file-monitor.c"
	} else {
#line 39 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor.vala"
		data1 = param_values->data[0].v_pointer;
#line 39 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor.vala"
		data2 = closure->data;
#line 173 "vfs-file-monitor.c"
	}
#line 39 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor.vala"
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT_ENUM) (marshal_data ? marshal_data : cc->callback);
#line 39 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), g_value_get_enum (param_values + 3), data2);
#line 179 "vfs-file-monitor.c"
}

static void
desktop_agnostic_vfs_file_monitor_default_init (DesktopAgnosticVFSFileMonitorIface * iface,
                                                gpointer iface_data)
{
	/**
	     * Whether the monitor has been cancelled via cancel().
	     */
#line 39 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor.vala"
	g_object_interface_install_property (iface, g_param_spec_boolean ("cancelled", "cancelled", "cancelled", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 191 "vfs-file-monitor.c"
	/**
	     * The signal emitted when something changes
	     * @param file the file associated with the monitor.
	     * @param other if the URI associated with the monitor is a directory, the
	     * child file that triggered the event. Otherwise, it should be NULL.
	     * @param event the event type to send
	     */
#line 39 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file-monitor.vala"
	desktop_agnostic_vfs_file_monitor_signals[DESKTOP_AGNOSTIC_VFS_FILE_MONITOR_CHANGED_SIGNAL] = g_signal_new ("changed", DESKTOP_AGNOSTIC_VFS_TYPE_FILE_MONITOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT_ENUM, G_TYPE_NONE, 3, DESKTOP_AGNOSTIC_VFS_TYPE_FILE, DESKTOP_AGNOSTIC_VFS_TYPE_FILE, DESKTOP_AGNOSTIC_VFS_TYPE_FILE_MONITOR_EVENT);
#line 201 "vfs-file-monitor.c"
}

/**
   * The base class for file/directory monitoring.
   */
static GType
desktop_agnostic_vfs_file_monitor_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DesktopAgnosticVFSFileMonitorIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) desktop_agnostic_vfs_file_monitor_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType desktop_agnostic_vfs_file_monitor_type_id;
	desktop_agnostic_vfs_file_monitor_type_id = g_type_register_static (G_TYPE_INTERFACE, "DesktopAgnosticVFSFileMonitor", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (desktop_agnostic_vfs_file_monitor_type_id, G_TYPE_OBJECT);
	return desktop_agnostic_vfs_file_monitor_type_id;
}

GType
desktop_agnostic_vfs_file_monitor_get_type (void)
{
	static volatile gsize desktop_agnostic_vfs_file_monitor_type_id__once = 0;
	if (g_once_init_enter (&desktop_agnostic_vfs_file_monitor_type_id__once)) {
		GType desktop_agnostic_vfs_file_monitor_type_id;
		desktop_agnostic_vfs_file_monitor_type_id = desktop_agnostic_vfs_file_monitor_get_type_once ();
		g_once_init_leave (&desktop_agnostic_vfs_file_monitor_type_id__once, desktop_agnostic_vfs_file_monitor_type_id);
	}
	return desktop_agnostic_vfs_file_monitor_type_id__once;
}

