/* vfs-file.c generated by valac 0.56.17, the Vala compiler
 * generated from vfs-file.vala, do not modify */

/*
 * Desktop Agnostic Library: File interface (similar to GFile).
 *
 * Copyright (C) 2009 Mark Lee <libdesktop-agnostic@lazymalevolence.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 *
 * Author : Mark Lee <libdesktop-agnostic@lazymalevolence.com>
 */

#include "desktop-agnostic-vfs.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	DESKTOP_AGNOSTIC_VFS_FILE_0_PROPERTY,
	DESKTOP_AGNOSTIC_VFS_FILE_IMPLEMENTATION_PROPERTY,
	DESKTOP_AGNOSTIC_VFS_FILE_IMPL_URI_PROPERTY,
	DESKTOP_AGNOSTIC_VFS_FILE_URI_PROPERTY,
	DESKTOP_AGNOSTIC_VFS_FILE_IMPL_PATH_PROPERTY,
	DESKTOP_AGNOSTIC_VFS_FILE_PATH_PROPERTY,
	DESKTOP_AGNOSTIC_VFS_FILE_FILE_TYPE_PROPERTY,
	DESKTOP_AGNOSTIC_VFS_FILE_ACCESS_FLAGS_PROPERTY,
	DESKTOP_AGNOSTIC_VFS_FILE_PARENT_PROPERTY,
	DESKTOP_AGNOSTIC_VFS_FILE_NUM_PROPERTIES
};
static GParamSpec* desktop_agnostic_vfs_file_properties[DESKTOP_AGNOSTIC_VFS_FILE_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

/**
   * File-related errors.
   */

static gpointer desktop_agnostic_vfs_file_parent_class = NULL;

static void desktop_agnostic_vfs_file_real_init (DesktopAgnosticVFSFile* self,
                                          const gchar* uri);
static gboolean desktop_agnostic_vfs_file_real_exists (DesktopAgnosticVFSFile* self);
static DesktopAgnosticVFSFileMonitor* desktop_agnostic_vfs_file_real_monitor (DesktopAgnosticVFSFile* self);
static gboolean desktop_agnostic_vfs_file_real_load_contents (DesktopAgnosticVFSFile* self,
                                                       gchar** contents,
                                                       gsize* length,
                                                       GError** error);
static gboolean desktop_agnostic_vfs_file_real_replace_contents (DesktopAgnosticVFSFile* self,
                                                          const gchar* contents,
                                                          GError** error);
static gboolean desktop_agnostic_vfs_file_real_launch (DesktopAgnosticVFSFile* self,
                                                GError** error);
static GSList* desktop_agnostic_vfs_file_real_enumerate_children (DesktopAgnosticVFSFile* self,
                                                           GError** error);
static gboolean desktop_agnostic_vfs_file_real_copy (DesktopAgnosticVFSFile* self,
                                              DesktopAgnosticVFSFile* destination,
                                              gboolean overwrite,
                                              GError** error);
static gboolean desktop_agnostic_vfs_file_real_remove (DesktopAgnosticVFSFile* self,
                                                GError** error);
static gboolean desktop_agnostic_vfs_file_real_is_native (DesktopAgnosticVFSFile* self);
static gchar* desktop_agnostic_vfs_file_real_get_mime_type (DesktopAgnosticVFSFile* self,
                                                     GError** error);
static gchar** desktop_agnostic_vfs_file_real_get_icon_names (DesktopAgnosticVFSFile* self,
                                                       gint* result_length1,
                                                       GError** error);
static gchar* desktop_agnostic_vfs_file_real_get_thumbnail_path (DesktopAgnosticVFSFile* self);
static GType desktop_agnostic_vfs_file_get_type_once (void);
static void _vala_desktop_agnostic_vfs_file_get_property (GObject * object,
                                                   guint property_id,
                                                   GValue * value,
                                                   GParamSpec * pspec);
static void _vala_desktop_agnostic_vfs_file_set_property (GObject * object,
                                                   guint property_id,
                                                   const GValue * value,
                                                   GParamSpec * pspec);
static void _vala_array_add1 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add2 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add3 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

GQuark
desktop_agnostic_vfs_file_error_quark (void)
{
#line 44 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs.vala"
	return g_quark_from_static_string ("desktop-agnostic-vfs-file-error-quark");
#line 126 "vfs-file.c"
}

static GType
desktop_agnostic_vfs_file_error_get_type_once (void)
{
	static const GEnumValue values[] = {{DESKTOP_AGNOSTIC_VFS_FILE_ERROR_FILE_NOT_FOUND, "DESKTOP_AGNOSTIC_VFS_FILE_ERROR_FILE_NOT_FOUND", "file-not-found"}, {DESKTOP_AGNOSTIC_VFS_FILE_ERROR_EXISTS, "DESKTOP_AGNOSTIC_VFS_FILE_ERROR_EXISTS", "exists"}, {DESKTOP_AGNOSTIC_VFS_FILE_ERROR_INVALID_TYPE, "DESKTOP_AGNOSTIC_VFS_FILE_ERROR_INVALID_TYPE", "invalid-type"}, {0, NULL, NULL}};
	GType desktop_agnostic_vfs_file_error_type_id;
	desktop_agnostic_vfs_file_error_type_id = g_enum_register_static ("DesktopAgnosticVFSFileError", values);
	return desktop_agnostic_vfs_file_error_type_id;
}

GType
desktop_agnostic_vfs_file_error_get_type (void)
{
	static volatile gsize desktop_agnostic_vfs_file_error_type_id__once = 0;
	if (g_once_init_enter (&desktop_agnostic_vfs_file_error_type_id__once)) {
		GType desktop_agnostic_vfs_file_error_type_id;
		desktop_agnostic_vfs_file_error_type_id = desktop_agnostic_vfs_file_error_get_type_once ();
		g_once_init_leave (&desktop_agnostic_vfs_file_error_type_id__once, desktop_agnostic_vfs_file_error_type_id);
	}
	return desktop_agnostic_vfs_file_error_type_id__once;
}

/**
   * The kinds of files recognized by the File backends.
   */
static GType
desktop_agnostic_vfs_file_type_get_type_once (void)
{
	static const GEnumValue values[] = {{DESKTOP_AGNOSTIC_VFS_FILE_TYPE_UNKNOWN, "DESKTOP_AGNOSTIC_VFS_FILE_TYPE_UNKNOWN", "unknown"}, {DESKTOP_AGNOSTIC_VFS_FILE_TYPE_REGULAR, "DESKTOP_AGNOSTIC_VFS_FILE_TYPE_REGULAR", "regular"}, {DESKTOP_AGNOSTIC_VFS_FILE_TYPE_DIRECTORY, "DESKTOP_AGNOSTIC_VFS_FILE_TYPE_DIRECTORY", "directory"}, {DESKTOP_AGNOSTIC_VFS_FILE_TYPE_SYMBOLIC_LINK, "DESKTOP_AGNOSTIC_VFS_FILE_TYPE_SYMBOLIC_LINK", "symbolic-link"}, {DESKTOP_AGNOSTIC_VFS_FILE_TYPE_SPECIAL, "DESKTOP_AGNOSTIC_VFS_FILE_TYPE_SPECIAL", "special"}, {0, NULL, NULL}};
	GType desktop_agnostic_vfs_file_type_type_id;
	desktop_agnostic_vfs_file_type_type_id = g_enum_register_static ("DesktopAgnosticVFSFileType", values);
	return desktop_agnostic_vfs_file_type_type_id;
}

GType
desktop_agnostic_vfs_file_type_get_type (void)
{
	static volatile gsize desktop_agnostic_vfs_file_type_type_id__once = 0;
	if (g_once_init_enter (&desktop_agnostic_vfs_file_type_type_id__once)) {
		GType desktop_agnostic_vfs_file_type_type_id;
		desktop_agnostic_vfs_file_type_type_id = desktop_agnostic_vfs_file_type_get_type_once ();
		g_once_init_leave (&desktop_agnostic_vfs_file_type_type_id__once, desktop_agnostic_vfs_file_type_type_id);
	}
	return desktop_agnostic_vfs_file_type_type_id__once;
}

static GType
desktop_agnostic_vfs_access_flags_get_type_once (void)
{
	static const GEnumValue values[] = {{DESKTOP_AGNOSTIC_VFS_ACCESS_FLAGS_NONE, "DESKTOP_AGNOSTIC_VFS_ACCESS_FLAGS_NONE", "none"}, {DESKTOP_AGNOSTIC_VFS_ACCESS_FLAGS_READ, "DESKTOP_AGNOSTIC_VFS_ACCESS_FLAGS_READ", "read"}, {DESKTOP_AGNOSTIC_VFS_ACCESS_FLAGS_WRITE, "DESKTOP_AGNOSTIC_VFS_ACCESS_FLAGS_WRITE", "write"}, {DESKTOP_AGNOSTIC_VFS_ACCESS_FLAGS_EXECUTE, "DESKTOP_AGNOSTIC_VFS_ACCESS_FLAGS_EXECUTE", "execute"}, {0, NULL, NULL}};
	GType desktop_agnostic_vfs_access_flags_type_id;
	desktop_agnostic_vfs_access_flags_type_id = g_enum_register_static ("DesktopAgnosticVFSAccessFlags", values);
	return desktop_agnostic_vfs_access_flags_type_id;
}

GType
desktop_agnostic_vfs_access_flags_get_type (void)
{
	static volatile gsize desktop_agnostic_vfs_access_flags_type_id__once = 0;
	if (g_once_init_enter (&desktop_agnostic_vfs_access_flags_type_id__once)) {
		GType desktop_agnostic_vfs_access_flags_type_id;
		desktop_agnostic_vfs_access_flags_type_id = desktop_agnostic_vfs_access_flags_get_type_once ();
		g_once_init_leave (&desktop_agnostic_vfs_access_flags_type_id__once, desktop_agnostic_vfs_access_flags_type_id);
	}
	return desktop_agnostic_vfs_access_flags_type_id__once;
}

/**
     * Implementation detail. Implementing classes override this to properly
     * associate the URI with the implementation pointer.
     */
static void
desktop_agnostic_vfs_file_real_init (DesktopAgnosticVFSFile* self,
                                     const gchar* uri)
{
#line 120 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	g_critical ("Type `%s' does not implement abstract method `desktop_agnostic_vfs_file_init'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 120 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	return;
#line 207 "vfs-file.c"
}

void
desktop_agnostic_vfs_file_init (DesktopAgnosticVFSFile* self,
                                const gchar* uri)
{
	DesktopAgnosticVFSFileClass* _klass_;
#line 120 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	g_return_if_fail (self != NULL);
#line 120 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	_klass_ = DESKTOP_AGNOSTIC_VFS_FILE_GET_CLASS (self);
#line 120 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	if (_klass_->init) {
#line 120 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
		_klass_->init (self, uri);
#line 223 "vfs-file.c"
	}
}

/**
     * Whether something exists at the URI that the object represents.
     */
static gboolean
desktop_agnostic_vfs_file_real_exists (DesktopAgnosticVFSFile* self)
{
	gboolean _tmp0_ = FALSE;
#line 124 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	g_critical ("Type `%s' does not implement abstract method `desktop_agnostic_vfs_file_exists'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 124 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	return _tmp0_;
#line 238 "vfs-file.c"
}

gboolean
desktop_agnostic_vfs_file_exists (DesktopAgnosticVFSFile* self)
{
	DesktopAgnosticVFSFileClass* _klass_;
#line 124 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 124 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	_klass_ = DESKTOP_AGNOSTIC_VFS_FILE_GET_CLASS (self);
#line 124 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	if (_klass_->exists) {
#line 124 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
		return _klass_->exists (self);
#line 253 "vfs-file.c"
	}
#line 124 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	return FALSE;
#line 257 "vfs-file.c"
}

/**
     * Whether the file is readable.
     */
gboolean
desktop_agnostic_vfs_file_is_readable (DesktopAgnosticVFSFile* self)
{
	DesktopAgnosticVFSAccessFlags _tmp0_;
	DesktopAgnosticVFSAccessFlags _tmp1_;
	gboolean result;
#line 128 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 130 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	_tmp0_ = desktop_agnostic_vfs_file_get_access_flags (self);
#line 130 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	_tmp1_ = _tmp0_;
#line 130 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	result = (_tmp1_ & DESKTOP_AGNOSTIC_VFS_ACCESS_FLAGS_READ) != 0;
#line 130 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	return result;
#line 279 "vfs-file.c"
}

/**
     * Whether the file is writable.
     */
gboolean
desktop_agnostic_vfs_file_is_writable (DesktopAgnosticVFSFile* self)
{
	DesktopAgnosticVFSAccessFlags _tmp0_;
	DesktopAgnosticVFSAccessFlags _tmp1_;
	gboolean result;
#line 135 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 137 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	_tmp0_ = desktop_agnostic_vfs_file_get_access_flags (self);
#line 137 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	_tmp1_ = _tmp0_;
#line 137 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	result = (_tmp1_ & DESKTOP_AGNOSTIC_VFS_ACCESS_FLAGS_WRITE) != 0;
#line 137 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	return result;
#line 301 "vfs-file.c"
}

/**
     * Whether the file is executable.
     */
gboolean
desktop_agnostic_vfs_file_is_executable (DesktopAgnosticVFSFile* self)
{
	DesktopAgnosticVFSAccessFlags _tmp0_;
	DesktopAgnosticVFSAccessFlags _tmp1_;
	gboolean result;
#line 142 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 144 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	_tmp0_ = desktop_agnostic_vfs_file_get_access_flags (self);
#line 144 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	_tmp1_ = _tmp0_;
#line 144 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	result = (_tmp1_ & DESKTOP_AGNOSTIC_VFS_ACCESS_FLAGS_EXECUTE) != 0;
#line 144 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	return result;
#line 323 "vfs-file.c"
}

/**
     * Adds a monitor to the file.
     * @return the monitor associated with the file
     */
static DesktopAgnosticVFSFileMonitor*
desktop_agnostic_vfs_file_real_monitor (DesktopAgnosticVFSFile* self)
{
#line 150 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	g_critical ("Type `%s' does not implement abstract method `desktop_agnostic_vfs_file_monitor'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 150 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	return NULL;
#line 337 "vfs-file.c"
}

DesktopAgnosticVFSFileMonitor*
desktop_agnostic_vfs_file_monitor (DesktopAgnosticVFSFile* self)
{
	DesktopAgnosticVFSFileClass* _klass_;
#line 150 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 150 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	_klass_ = DESKTOP_AGNOSTIC_VFS_FILE_GET_CLASS (self);
#line 150 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	if (_klass_->monitor) {
#line 150 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
		return _klass_->monitor (self);
#line 352 "vfs-file.c"
	}
#line 150 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	return NULL;
#line 356 "vfs-file.c"
}

/**
     * Loads the contents of the file to a string.
     * @return %TRUE on success, %FALSE on failure.
     */
static gboolean
desktop_agnostic_vfs_file_real_load_contents (DesktopAgnosticVFSFile* self,
                                              gchar** contents,
                                              gsize* length,
                                              GError** error)
{
	gboolean _tmp0_ = FALSE;
#line 156 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	g_critical ("Type `%s' does not implement abstract method `desktop_agnostic_vfs_file_load_contents'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 156 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	return _tmp0_;
#line 374 "vfs-file.c"
}

gboolean
desktop_agnostic_vfs_file_load_contents (DesktopAgnosticVFSFile* self,
                                         gchar** contents,
                                         gsize* length,
                                         GError** error)
{
	DesktopAgnosticVFSFileClass* _klass_;
#line 156 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 156 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	_klass_ = DESKTOP_AGNOSTIC_VFS_FILE_GET_CLASS (self);
#line 156 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	if (_klass_->load_contents) {
#line 156 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
		return _klass_->load_contents (self, contents, length, error);
#line 392 "vfs-file.c"
	}
#line 156 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	return FALSE;
#line 396 "vfs-file.c"
}

/**
     * Saves a string to the specified file, replacing any content that may
     * have been in it.
     * @return %TRUE on success, %FALSE on failure.
     */
static gboolean
desktop_agnostic_vfs_file_real_replace_contents (DesktopAgnosticVFSFile* self,
                                                 const gchar* contents,
                                                 GError** error)
{
	gboolean _tmp0_ = FALSE;
#line 164 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	g_critical ("Type `%s' does not implement abstract method `desktop_agnostic_vfs_file_replace_contents'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 164 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	return _tmp0_;
#line 414 "vfs-file.c"
}

gboolean
desktop_agnostic_vfs_file_replace_contents (DesktopAgnosticVFSFile* self,
                                            const gchar* contents,
                                            GError** error)
{
	DesktopAgnosticVFSFileClass* _klass_;
#line 164 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 164 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	_klass_ = DESKTOP_AGNOSTIC_VFS_FILE_GET_CLASS (self);
#line 164 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	if (_klass_->replace_contents) {
#line 164 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
		return _klass_->replace_contents (self, contents, error);
#line 431 "vfs-file.c"
	}
#line 164 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	return FALSE;
#line 435 "vfs-file.c"
}

/**
     * Launches the specified file with the default MIME application.
     * @return %TRUE on successful launch, %FALSE on failure.
     */
static gboolean
desktop_agnostic_vfs_file_real_launch (DesktopAgnosticVFSFile* self,
                                       GError** error)
{
	gboolean _tmp0_ = FALSE;
#line 170 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	g_critical ("Type `%s' does not implement abstract method `desktop_agnostic_vfs_file_launch'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 170 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	return _tmp0_;
#line 451 "vfs-file.c"
}

gboolean
desktop_agnostic_vfs_file_launch (DesktopAgnosticVFSFile* self,
                                  GError** error)
{
	DesktopAgnosticVFSFileClass* _klass_;
#line 170 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 170 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	_klass_ = DESKTOP_AGNOSTIC_VFS_FILE_GET_CLASS (self);
#line 170 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	if (_klass_->launch) {
#line 170 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
		return _klass_->launch (self, error);
#line 467 "vfs-file.c"
	}
#line 170 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	return FALSE;
#line 471 "vfs-file.c"
}

/**
     * Retrieves a list of child file objects for a given object. Only
     * guaranteed to work on directories.
     * @return a list of child file objects
     */
static GSList*
desktop_agnostic_vfs_file_real_enumerate_children (DesktopAgnosticVFSFile* self,
                                                   GError** error)
{
#line 177 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	g_critical ("Type `%s' does not implement abstract method `desktop_agnostic_vfs_file_enumerate_children'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 177 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	return NULL;
#line 487 "vfs-file.c"
}

GSList*
desktop_agnostic_vfs_file_enumerate_children (DesktopAgnosticVFSFile* self,
                                              GError** error)
{
	DesktopAgnosticVFSFileClass* _klass_;
#line 177 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 177 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	_klass_ = DESKTOP_AGNOSTIC_VFS_FILE_GET_CLASS (self);
#line 177 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	if (_klass_->enumerate_children) {
#line 177 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
		return _klass_->enumerate_children (self, error);
#line 503 "vfs-file.c"
	}
#line 177 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	return NULL;
#line 507 "vfs-file.c"
}

/**
     * Copies a file to another URI. This is a synchronous operation. Only
     * guaranteed to work on files, not directories.
     * @param destination the destination of the copied file.
     * @param overwrite if a file exists at the destination, whether to
     * overwrite it.
     */
static gboolean
desktop_agnostic_vfs_file_real_copy (DesktopAgnosticVFSFile* self,
                                     DesktopAgnosticVFSFile* destination,
                                     gboolean overwrite,
                                     GError** error)
{
	gboolean _tmp0_ = FALSE;
#line 186 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	g_critical ("Type `%s' does not implement abstract method `desktop_agnostic_vfs_file_copy'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 186 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	return _tmp0_;
#line 528 "vfs-file.c"
}

gboolean
desktop_agnostic_vfs_file_copy (DesktopAgnosticVFSFile* self,
                                DesktopAgnosticVFSFile* destination,
                                gboolean overwrite,
                                GError** error)
{
	DesktopAgnosticVFSFileClass* _klass_;
#line 186 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 186 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	_klass_ = DESKTOP_AGNOSTIC_VFS_FILE_GET_CLASS (self);
#line 186 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	if (_klass_->copy) {
#line 186 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
		return _klass_->copy (self, destination, overwrite, error);
#line 546 "vfs-file.c"
	}
#line 186 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	return FALSE;
#line 550 "vfs-file.c"
}

/**
     * Removes the specified file. Only works on files, not directories.
     * @return %TRUE on success, %FALSE on failure.
     */
static gboolean
desktop_agnostic_vfs_file_real_remove (DesktopAgnosticVFSFile* self,
                                       GError** error)
{
	gboolean _tmp0_ = FALSE;
#line 192 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	g_critical ("Type `%s' does not implement abstract method `desktop_agnostic_vfs_file_remove'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 192 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	return _tmp0_;
#line 566 "vfs-file.c"
}

gboolean
desktop_agnostic_vfs_file_remove (DesktopAgnosticVFSFile* self,
                                  GError** error)
{
	DesktopAgnosticVFSFileClass* _klass_;
#line 192 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 192 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	_klass_ = DESKTOP_AGNOSTIC_VFS_FILE_GET_CLASS (self);
#line 192 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	if (_klass_->remove) {
#line 192 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
		return _klass_->remove (self, error);
#line 582 "vfs-file.c"
	}
#line 192 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	return FALSE;
#line 586 "vfs-file.c"
}

/**
     * Checks to see if a file is native to the platform.
     * @return %TRUE if file is native, %FALSE otherwise.
     */
static gboolean
desktop_agnostic_vfs_file_real_is_native (DesktopAgnosticVFSFile* self)
{
	gboolean _tmp0_ = FALSE;
#line 198 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	g_critical ("Type `%s' does not implement abstract method `desktop_agnostic_vfs_file_is_native'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 198 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	return _tmp0_;
#line 601 "vfs-file.c"
}

gboolean
desktop_agnostic_vfs_file_is_native (DesktopAgnosticVFSFile* self)
{
	DesktopAgnosticVFSFileClass* _klass_;
#line 198 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 198 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	_klass_ = DESKTOP_AGNOSTIC_VFS_FILE_GET_CLASS (self);
#line 198 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	if (_klass_->is_native) {
#line 198 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
		return _klass_->is_native (self);
#line 616 "vfs-file.c"
	}
#line 198 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	return FALSE;
#line 620 "vfs-file.c"
}

/**
     * Gets the file's mime type. (might block)
     * @return String containing file's mime type.
     */
static gchar*
desktop_agnostic_vfs_file_real_get_mime_type (DesktopAgnosticVFSFile* self,
                                              GError** error)
{
#line 204 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	g_critical ("Type `%s' does not implement abstract method `desktop_agnostic_vfs_file_get_mime_type'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 204 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	return NULL;
#line 635 "vfs-file.c"
}

gchar*
desktop_agnostic_vfs_file_get_mime_type (DesktopAgnosticVFSFile* self,
                                         GError** error)
{
	DesktopAgnosticVFSFileClass* _klass_;
#line 204 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 204 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	_klass_ = DESKTOP_AGNOSTIC_VFS_FILE_GET_CLASS (self);
#line 204 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	if (_klass_->get_mime_type) {
#line 204 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
		return _klass_->get_mime_type (self, error);
#line 651 "vfs-file.c"
	}
#line 204 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	return NULL;
#line 655 "vfs-file.c"
}

/**
     * Gets list of possible icon names representing this file. (might block)
     * @return List of possible icon names.
     */
static gchar**
desktop_agnostic_vfs_file_real_get_icon_names (DesktopAgnosticVFSFile* self,
                                               gint* result_length1,
                                               GError** error)
{
#line 210 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	g_critical ("Type `%s' does not implement abstract method `desktop_agnostic_vfs_file_get_icon_names'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 210 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	return NULL;
#line 671 "vfs-file.c"
}

gchar**
desktop_agnostic_vfs_file_get_icon_names (DesktopAgnosticVFSFile* self,
                                          gint* result_length1,
                                          GError** error)
{
	DesktopAgnosticVFSFileClass* _klass_;
#line 210 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 210 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	_klass_ = DESKTOP_AGNOSTIC_VFS_FILE_GET_CLASS (self);
#line 210 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	if (_klass_->get_icon_names) {
#line 210 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
		return _klass_->get_icon_names (self, result_length1, error);
#line 688 "vfs-file.c"
	}
#line 210 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	return NULL;
#line 692 "vfs-file.c"
}

/**
     * Get path to thumbnail representing this file. (might block)
     * @return Path to file with thumbnail or %null if thumbnail cannot be
     * found or backend doesn't support it.
     */
static gchar*
desktop_agnostic_vfs_file_real_get_thumbnail_path (DesktopAgnosticVFSFile* self)
{
	gchar* result;
#line 219 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	result = NULL;
#line 219 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	return result;
#line 708 "vfs-file.c"
}

gchar*
desktop_agnostic_vfs_file_get_thumbnail_path (DesktopAgnosticVFSFile* self)
{
	DesktopAgnosticVFSFileClass* _klass_;
#line 217 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 217 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	_klass_ = DESKTOP_AGNOSTIC_VFS_FILE_GET_CLASS (self);
#line 217 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	if (_klass_->get_thumbnail_path) {
#line 217 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
		return _klass_->get_thumbnail_path (self);
#line 723 "vfs-file.c"
	}
#line 217 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	return NULL;
#line 727 "vfs-file.c"
}

DesktopAgnosticVFSFile*
desktop_agnostic_vfs_file_construct (GType object_type)
{
	DesktopAgnosticVFSFile * self = NULL;
#line 55 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	self = (DesktopAgnosticVFSFile*) g_object_new (object_type, NULL);
#line 55 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	return self;
#line 738 "vfs-file.c"
}

void*
desktop_agnostic_vfs_file_get_implementation (DesktopAgnosticVFSFile* self)
{
	DesktopAgnosticVFSFileClass* _klass_;
#line 60 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 60 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	_klass_ = DESKTOP_AGNOSTIC_VFS_FILE_GET_CLASS (self);
#line 60 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	if (_klass_->get_implementation) {
#line 60 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
		return _klass_->get_implementation (self);
#line 753 "vfs-file.c"
	}
#line 60 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	return NULL;
#line 757 "vfs-file.c"
}

gchar*
desktop_agnostic_vfs_file_get_impl_uri (DesktopAgnosticVFSFile* self)
{
	DesktopAgnosticVFSFileClass* _klass_;
#line 65 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 65 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	_klass_ = DESKTOP_AGNOSTIC_VFS_FILE_GET_CLASS (self);
#line 65 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	if (_klass_->get_impl_uri) {
#line 65 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
		return _klass_->get_impl_uri (self);
#line 772 "vfs-file.c"
	}
#line 65 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	return NULL;
#line 776 "vfs-file.c"
}

gchar*
desktop_agnostic_vfs_file_get_uri (DesktopAgnosticVFSFile* self)
{
	gchar* result;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 70 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 72 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	_tmp0_ = desktop_agnostic_vfs_file_get_impl_uri (self);
#line 72 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	_tmp1_ = _tmp0_;
#line 72 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	result = _tmp1_;
#line 72 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	return result;
#line 795 "vfs-file.c"
}

static void
desktop_agnostic_vfs_file_set_uri (DesktopAgnosticVFSFile* self,
                                   const gchar* value)
{
#line 74 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	g_return_if_fail (self != NULL);
#line 76 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	if (value != NULL) {
#line 78 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
		desktop_agnostic_vfs_file_init (self, value);
#line 808 "vfs-file.c"
	}
#line 74 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	g_object_notify_by_pspec ((GObject *) self, desktop_agnostic_vfs_file_properties[DESKTOP_AGNOSTIC_VFS_FILE_URI_PROPERTY]);
#line 812 "vfs-file.c"
}

gchar*
desktop_agnostic_vfs_file_get_impl_path (DesktopAgnosticVFSFile* self)
{
	DesktopAgnosticVFSFileClass* _klass_;
#line 86 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 86 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	_klass_ = DESKTOP_AGNOSTIC_VFS_FILE_GET_CLASS (self);
#line 86 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	if (_klass_->get_impl_path) {
#line 86 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
		return _klass_->get_impl_path (self);
#line 827 "vfs-file.c"
	}
#line 86 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	return NULL;
#line 831 "vfs-file.c"
}

gchar*
desktop_agnostic_vfs_file_get_path (DesktopAgnosticVFSFile* self)
{
	gchar* result;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 91 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 93 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	_tmp0_ = desktop_agnostic_vfs_file_get_impl_path (self);
#line 93 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	_tmp1_ = _tmp0_;
#line 93 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	result = _tmp1_;
#line 93 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	return result;
#line 850 "vfs-file.c"
}

static void
desktop_agnostic_vfs_file_set_path (DesktopAgnosticVFSFile* self,
                                    const gchar* value)
{
#line 95 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	g_return_if_fail (self != NULL);
#line 97 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	if (value != NULL) {
#line 861 "vfs-file.c"
		gchar* _tmp0_;
		gchar* _tmp1_;
#line 99 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
		_tmp0_ = g_strconcat ("file://", value, NULL);
#line 99 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
		_tmp1_ = _tmp0_;
#line 99 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
		desktop_agnostic_vfs_file_init (self, _tmp1_);
#line 99 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
		_g_free0 (_tmp1_);
#line 872 "vfs-file.c"
	}
#line 95 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	g_object_notify_by_pspec ((GObject *) self, desktop_agnostic_vfs_file_properties[DESKTOP_AGNOSTIC_VFS_FILE_PATH_PROPERTY]);
#line 876 "vfs-file.c"
}

DesktopAgnosticVFSFileType
desktop_agnostic_vfs_file_get_file_type (DesktopAgnosticVFSFile* self)
{
	DesktopAgnosticVFSFileClass* _klass_;
#line 106 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 106 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	_klass_ = DESKTOP_AGNOSTIC_VFS_FILE_GET_CLASS (self);
#line 106 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	if (_klass_->get_file_type) {
#line 106 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
		return _klass_->get_file_type (self);
#line 891 "vfs-file.c"
	}
#line 106 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	return 0;
#line 895 "vfs-file.c"
}

DesktopAgnosticVFSAccessFlags
desktop_agnostic_vfs_file_get_access_flags (DesktopAgnosticVFSFile* self)
{
	DesktopAgnosticVFSFileClass* _klass_;
#line 111 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 111 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	_klass_ = DESKTOP_AGNOSTIC_VFS_FILE_GET_CLASS (self);
#line 111 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	if (_klass_->get_access_flags) {
#line 111 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
		return _klass_->get_access_flags (self);
#line 910 "vfs-file.c"
	}
#line 111 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	return 0;
#line 914 "vfs-file.c"
}

DesktopAgnosticVFSFile*
desktop_agnostic_vfs_file_get_parent (DesktopAgnosticVFSFile* self)
{
	DesktopAgnosticVFSFileClass* _klass_;
#line 115 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 115 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	_klass_ = DESKTOP_AGNOSTIC_VFS_FILE_GET_CLASS (self);
#line 115 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	if (_klass_->get_parent) {
#line 115 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
		return _klass_->get_parent (self);
#line 929 "vfs-file.c"
	}
#line 115 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	return NULL;
#line 933 "vfs-file.c"
}

static void
desktop_agnostic_vfs_file_class_init (DesktopAgnosticVFSFileClass * klass,
                                      gpointer klass_data)
{
#line 55 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	desktop_agnostic_vfs_file_parent_class = g_type_class_peek_parent (klass);
#line 55 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	((DesktopAgnosticVFSFileClass *) klass)->init = (void (*) (DesktopAgnosticVFSFile*, const gchar*)) desktop_agnostic_vfs_file_real_init;
#line 55 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	((DesktopAgnosticVFSFileClass *) klass)->exists = (gboolean (*) (DesktopAgnosticVFSFile*)) desktop_agnostic_vfs_file_real_exists;
#line 55 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	((DesktopAgnosticVFSFileClass *) klass)->monitor = (DesktopAgnosticVFSFileMonitor* (*) (DesktopAgnosticVFSFile*)) desktop_agnostic_vfs_file_real_monitor;
#line 55 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	((DesktopAgnosticVFSFileClass *) klass)->load_contents = (gboolean (*) (DesktopAgnosticVFSFile*, gchar**, gsize*, GError**)) desktop_agnostic_vfs_file_real_load_contents;
#line 55 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	((DesktopAgnosticVFSFileClass *) klass)->replace_contents = (gboolean (*) (DesktopAgnosticVFSFile*, const gchar*, GError**)) desktop_agnostic_vfs_file_real_replace_contents;
#line 55 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	((DesktopAgnosticVFSFileClass *) klass)->launch = (gboolean (*) (DesktopAgnosticVFSFile*, GError**)) desktop_agnostic_vfs_file_real_launch;
#line 55 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	((DesktopAgnosticVFSFileClass *) klass)->enumerate_children = (GSList* (*) (DesktopAgnosticVFSFile*, GError**)) desktop_agnostic_vfs_file_real_enumerate_children;
#line 55 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	((DesktopAgnosticVFSFileClass *) klass)->copy = (gboolean (*) (DesktopAgnosticVFSFile*, DesktopAgnosticVFSFile*, gboolean, GError**)) desktop_agnostic_vfs_file_real_copy;
#line 55 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	((DesktopAgnosticVFSFileClass *) klass)->remove = (gboolean (*) (DesktopAgnosticVFSFile*, GError**)) desktop_agnostic_vfs_file_real_remove;
#line 55 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	((DesktopAgnosticVFSFileClass *) klass)->is_native = (gboolean (*) (DesktopAgnosticVFSFile*)) desktop_agnostic_vfs_file_real_is_native;
#line 55 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	((DesktopAgnosticVFSFileClass *) klass)->get_mime_type = (gchar* (*) (DesktopAgnosticVFSFile*, GError**)) desktop_agnostic_vfs_file_real_get_mime_type;
#line 55 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	((DesktopAgnosticVFSFileClass *) klass)->get_icon_names = (gchar** (*) (DesktopAgnosticVFSFile*, gint*, GError**)) desktop_agnostic_vfs_file_real_get_icon_names;
#line 55 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	((DesktopAgnosticVFSFileClass *) klass)->get_thumbnail_path = (gchar* (*) (DesktopAgnosticVFSFile*)) desktop_agnostic_vfs_file_real_get_thumbnail_path;
#line 55 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_desktop_agnostic_vfs_file_get_property;
#line 55 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_desktop_agnostic_vfs_file_set_property;
#line 972 "vfs-file.c"
	/**
	     * The pointer to the implementation used.
	     */
#line 55 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DESKTOP_AGNOSTIC_VFS_FILE_IMPLEMENTATION_PROPERTY, desktop_agnostic_vfs_file_properties[DESKTOP_AGNOSTIC_VFS_FILE_IMPLEMENTATION_PROPERTY] = g_param_spec_pointer ("implementation", "implementation", "implementation", G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 978 "vfs-file.c"
	/**
	     * Implementation detail. Implementing classes override this to allow the
	     * uri property to return the correct value.
	     */
#line 55 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DESKTOP_AGNOSTIC_VFS_FILE_IMPL_URI_PROPERTY, desktop_agnostic_vfs_file_properties[DESKTOP_AGNOSTIC_VFS_FILE_IMPL_URI_PROPERTY] = g_param_spec_string ("impl-uri", "impl-uri", "impl-uri", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 985 "vfs-file.c"
	/**
	     * The URI that the object represents.
	     */
#line 55 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DESKTOP_AGNOSTIC_VFS_FILE_URI_PROPERTY, desktop_agnostic_vfs_file_properties[DESKTOP_AGNOSTIC_VFS_FILE_URI_PROPERTY] = g_param_spec_string ("uri", "uri", "uri", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 991 "vfs-file.c"
	/**
	     * Implementation detail. Implementing classes override this to allow the
	     * path property to return the correct value.
	     */
#line 55 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DESKTOP_AGNOSTIC_VFS_FILE_IMPL_PATH_PROPERTY, desktop_agnostic_vfs_file_properties[DESKTOP_AGNOSTIC_VFS_FILE_IMPL_PATH_PROPERTY] = g_param_spec_string ("impl-path", "impl-path", "impl-path", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 998 "vfs-file.c"
	/**
	     * The path that the object represents.
	     */
#line 55 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DESKTOP_AGNOSTIC_VFS_FILE_PATH_PROPERTY, desktop_agnostic_vfs_file_properties[DESKTOP_AGNOSTIC_VFS_FILE_PATH_PROPERTY] = g_param_spec_string ("path", "path", "path", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 1004 "vfs-file.c"
	/**
	     * The kind of file that the object represents.
	     */
#line 55 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DESKTOP_AGNOSTIC_VFS_FILE_FILE_TYPE_PROPERTY, desktop_agnostic_vfs_file_properties[DESKTOP_AGNOSTIC_VFS_FILE_FILE_TYPE_PROPERTY] = g_param_spec_enum ("file-type", "file-type", "file-type", DESKTOP_AGNOSTIC_VFS_TYPE_FILE_TYPE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1010 "vfs-file.c"
	/**
	     * Access rights for the current user for the file.
	     * @see AccessFlags
	     */
#line 55 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DESKTOP_AGNOSTIC_VFS_FILE_ACCESS_FLAGS_PROPERTY, desktop_agnostic_vfs_file_properties[DESKTOP_AGNOSTIC_VFS_FILE_ACCESS_FLAGS_PROPERTY] = g_param_spec_enum ("access-flags", "access-flags", "access-flags", DESKTOP_AGNOSTIC_VFS_TYPE_ACCESS_FLAGS, DESKTOP_AGNOSTIC_VFS_ACCESS_FLAGS_NONE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1017 "vfs-file.c"
	/**
	     * The parent URI. If this is the root, returns %NULL.
	     */
#line 55 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DESKTOP_AGNOSTIC_VFS_FILE_PARENT_PROPERTY, desktop_agnostic_vfs_file_properties[DESKTOP_AGNOSTIC_VFS_FILE_PARENT_PROPERTY] = g_param_spec_object ("parent", "parent", "parent", DESKTOP_AGNOSTIC_VFS_TYPE_FILE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1023 "vfs-file.c"
}

static void
desktop_agnostic_vfs_file_instance_init (DesktopAgnosticVFSFile * self,
                                         gpointer klass)
{
}

/**
   * Abstract base class for representations of files.
   */
static GType
desktop_agnostic_vfs_file_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DesktopAgnosticVFSFileClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) desktop_agnostic_vfs_file_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DesktopAgnosticVFSFile), 0, (GInstanceInitFunc) desktop_agnostic_vfs_file_instance_init, NULL };
	GType desktop_agnostic_vfs_file_type_id;
	desktop_agnostic_vfs_file_type_id = g_type_register_static (G_TYPE_OBJECT, "DesktopAgnosticVFSFile", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	return desktop_agnostic_vfs_file_type_id;
}

GType
desktop_agnostic_vfs_file_get_type (void)
{
	static volatile gsize desktop_agnostic_vfs_file_type_id__once = 0;
	if (g_once_init_enter (&desktop_agnostic_vfs_file_type_id__once)) {
		GType desktop_agnostic_vfs_file_type_id;
		desktop_agnostic_vfs_file_type_id = desktop_agnostic_vfs_file_get_type_once ();
		g_once_init_leave (&desktop_agnostic_vfs_file_type_id__once, desktop_agnostic_vfs_file_type_id);
	}
	return desktop_agnostic_vfs_file_type_id__once;
}

static void
_vala_desktop_agnostic_vfs_file_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec)
{
	DesktopAgnosticVFSFile * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DESKTOP_AGNOSTIC_VFS_TYPE_FILE, DesktopAgnosticVFSFile);
#line 55 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	switch (property_id) {
#line 55 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
		case DESKTOP_AGNOSTIC_VFS_FILE_URI_PROPERTY:
#line 55 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
		g_value_take_string (value, desktop_agnostic_vfs_file_get_uri (self));
#line 55 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
		break;
#line 55 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
		case DESKTOP_AGNOSTIC_VFS_FILE_PATH_PROPERTY:
#line 55 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
		g_value_take_string (value, desktop_agnostic_vfs_file_get_path (self));
#line 55 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
		break;
#line 1078 "vfs-file.c"
		default:
#line 55 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 55 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
		break;
#line 1084 "vfs-file.c"
	}
}

static void
_vala_desktop_agnostic_vfs_file_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec)
{
	DesktopAgnosticVFSFile * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DESKTOP_AGNOSTIC_VFS_TYPE_FILE, DesktopAgnosticVFSFile);
#line 55 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	switch (property_id) {
#line 55 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
		case DESKTOP_AGNOSTIC_VFS_FILE_URI_PROPERTY:
#line 55 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
		desktop_agnostic_vfs_file_set_uri (self, g_value_get_string (value));
#line 55 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
		break;
#line 55 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
		case DESKTOP_AGNOSTIC_VFS_FILE_PATH_PROPERTY:
#line 55 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
		desktop_agnostic_vfs_file_set_path (self, g_value_get_string (value));
#line 55 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
		break;
#line 1110 "vfs-file.c"
		default:
#line 55 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 55 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
		break;
#line 1116 "vfs-file.c"
	}
}

DesktopAgnosticVFSFile*
desktop_agnostic_vfs_file_new_for_path (const gchar* path,
                                        GError** error)
{
	DesktopAgnosticVFSImplementation* vfs = NULL;
	DesktopAgnosticVFSImplementation* _tmp0_;
	GError* _inner_error0_ = NULL;
	DesktopAgnosticVFSFile* result;
#line 223 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 226 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	_tmp0_ = desktop_agnostic_vfs_get_default (&_inner_error0_);
#line 226 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	vfs = _tmp0_;
#line 226 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 226 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
		g_propagate_error (error, _inner_error0_);
#line 226 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
		return NULL;
#line 1140 "vfs-file.c"
	}
#line 227 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	if (vfs == NULL) {
#line 229 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
		result = NULL;
#line 229 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
		return result;
#line 1148 "vfs-file.c"
	} else {
		GType _tmp1_;
		GType _tmp2_;
		GObject* _tmp3_;
		GObject* _tmp4_;
#line 233 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
		_tmp1_ = desktop_agnostic_vfs_implementation_get_file_type (vfs);
#line 233 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
		_tmp2_ = _tmp1_;
#line 233 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
		_tmp3_ = g_object_new (_tmp2_, "path", path, NULL);
#line 233 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
		_tmp4_ = G_IS_INITIALLY_UNOWNED (_tmp3_) ? g_object_ref_sink (_tmp3_) : _tmp3_;
#line 233 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
		result = G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, DESKTOP_AGNOSTIC_VFS_TYPE_FILE, DesktopAgnosticVFSFile);
#line 233 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
		return result;
#line 1166 "vfs-file.c"
	}
}

DesktopAgnosticVFSFile*
desktop_agnostic_vfs_file_new_for_uri (const gchar* uri,
                                       GError** error)
{
	DesktopAgnosticVFSImplementation* vfs = NULL;
	DesktopAgnosticVFSImplementation* _tmp0_;
	GError* _inner_error0_ = NULL;
	DesktopAgnosticVFSFile* result;
#line 237 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	g_return_val_if_fail (uri != NULL, NULL);
#line 240 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	_tmp0_ = desktop_agnostic_vfs_get_default (&_inner_error0_);
#line 240 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	vfs = _tmp0_;
#line 240 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 240 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
		g_propagate_error (error, _inner_error0_);
#line 240 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
		return NULL;
#line 1190 "vfs-file.c"
	}
#line 241 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	if (vfs == NULL) {
#line 243 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
		result = NULL;
#line 243 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
		return result;
#line 1198 "vfs-file.c"
	} else {
		GType _tmp1_;
		GType _tmp2_;
		GObject* _tmp3_;
		GObject* _tmp4_;
#line 247 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
		_tmp1_ = desktop_agnostic_vfs_implementation_get_file_type (vfs);
#line 247 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
		_tmp2_ = _tmp1_;
#line 247 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
		_tmp3_ = g_object_new (_tmp2_, "uri", uri, NULL);
#line 247 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
		_tmp4_ = G_IS_INITIALLY_UNOWNED (_tmp3_) ? g_object_ref_sink (_tmp3_) : _tmp3_;
#line 247 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
		result = G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, DESKTOP_AGNOSTIC_VFS_TYPE_FILE, DesktopAgnosticVFSFile);
#line 247 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
		return result;
#line 1216 "vfs-file.c"
	}
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1589 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 1239 "vfs-file.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 1243 "vfs-file.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 1249 "vfs-file.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 1253 "vfs-file.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1257 "vfs-file.c"
		gchar* _tmp2_;
#line 1590 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1590 "glib-2.0.vapi"
		result = _tmp2_;
#line 1590 "glib-2.0.vapi"
		return result;
#line 1265 "vfs-file.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1593 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1593 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1593 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1593 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1593 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1593 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1593 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1593 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1293 "vfs-file.c"
				goto __catch0_g_regex_error;
			}
#line 1593 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1593 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1593 "glib-2.0.vapi"
			return NULL;
#line 1302 "vfs-file.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1594 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1594 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1594 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1594 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1316 "vfs-file.c"
				goto __catch0_g_regex_error;
			}
#line 1594 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1594 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1594 "glib-2.0.vapi"
			return NULL;
#line 1325 "vfs-file.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1594 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1594 "glib-2.0.vapi"
		result = _tmp10_;
#line 1594 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1594 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
		return result;
#line 1339 "vfs-file.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1592 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1596 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 1348 "vfs-file.c"
	}
	__finally0:
#line 1592 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1592 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1592 "glib-2.0.vapi"
	return NULL;
#line 1357 "vfs-file.c"
}

static void
_vala_array_add1 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 258 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	if ((*length) == (*size)) {
#line 258 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 258 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1372 "vfs-file.c"
	}
#line 258 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	(*array)[(*length)++] = value;
#line 258 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	(*array)[*length] = NULL;
#line 1378 "vfs-file.c"
}

static void
_vala_array_add2 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 259 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	if ((*length) == (*size)) {
#line 259 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 259 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1393 "vfs-file.c"
	}
#line 259 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	(*array)[(*length)++] = value;
#line 259 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	(*array)[*length] = NULL;
#line 1399 "vfs-file.c"
}

static void
_vala_array_add3 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 260 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	if ((*length) == (*size)) {
#line 260 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 260 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1414 "vfs-file.c"
	}
#line 260 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	(*array)[(*length)++] = value;
#line 260 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	(*array)[*length] = NULL;
#line 1420 "vfs-file.c"
}

gchar**
desktop_agnostic_vfs_get_icon_names_for_mime_type (const gchar* mime_type,
                                                   gint* result_length1)
{
	gchar** names = NULL;
	gint names_length1;
	gint _names_size_;
	gchar* _tmp0_;
	gchar** _tmp1_;
	gint _tmp1__length1;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar** _tmp4_;
	gchar** _tmp5_;
	gchar** _tmp6_;
	gint _tmp6__length1;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar** _tmp9_;
	gint _tmp9__length1;
	gchar** result;
#line 251 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	g_return_val_if_fail (mime_type != NULL, NULL);
#line 254 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	names = NULL;
#line 254 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	names_length1 = 0;
#line 254 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	_names_size_ = names_length1;
#line 256 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	g_return_val_if_fail (g_strcmp0 (mime_type, "") != 0, NULL);
#line 258 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	_tmp0_ = string_replace (mime_type, "/", "-");
#line 258 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	_vala_array_add1 (&names, &names_length1, &_names_size_, _tmp0_);
#line 259 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	_tmp1_ = names;
#line 259 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	_tmp1__length1 = names_length1;
#line 259 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	_tmp2_ = _tmp1_[0];
#line 259 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	_tmp3_ = g_strdup_printf ("gnome-mime-%s", _tmp2_);
#line 259 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	_vala_array_add2 (&names, &names_length1, &_names_size_, _tmp3_);
#line 260 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	_tmp5_ = _tmp4_ = g_regex_split_simple ("/.*", mime_type, 0, 0);
#line 260 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	_tmp6_ = _tmp5_;
#line 260 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	_tmp6__length1 = _vala_array_length (_tmp4_);
#line 260 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	_tmp7_ = _tmp6_[0];
#line 260 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	_tmp8_ = g_strdup_printf ("%s-x-generic", _tmp7_);
#line 260 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	_vala_array_add3 (&names, &names_length1, &_names_size_, _tmp8_);
#line 260 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	_tmp6_ = (_vala_array_free (_tmp6_, _tmp6__length1, (GDestroyNotify) g_free), NULL);
#line 262 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	_tmp9_ = names;
#line 262 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	_tmp9__length1 = names_length1;
#line 262 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	if (result_length1) {
#line 262 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
		*result_length1 = _tmp9__length1;
#line 1490 "vfs-file.c"
	}
#line 262 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	result = _tmp9_;
#line 262 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	return result;
#line 1496 "vfs-file.c"
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
#line 237 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	if ((array != NULL) && (destroy_func != NULL)) {
#line 1506 "vfs-file.c"
		gssize i;
#line 237 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 237 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
			if (((gpointer*) array)[i] != NULL) {
#line 237 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
				destroy_func (((gpointer*) array)[i]);
#line 1514 "vfs-file.c"
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
#line 237 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	_vala_array_destroy (array, array_length, destroy_func);
#line 237 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	g_free (array);
#line 1529 "vfs-file.c"
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
#line 237 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	if (array) {
#line 237 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
		while (((gpointer*) array)[length]) {
#line 237 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
			length++;
#line 1543 "vfs-file.c"
		}
	}
#line 237 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	return length;
#line 1548 "vfs-file.c"
}

