/* vfs-impl-gio.c generated by valac 0.56.17, the Vala compiler
 * generated from vfs-impl-gio.vala, do not modify */

/*
 * Desktop Agnostic Library: VFS implementation (with GIO).
 *
 * Copyright (C) 2009 Mark Lee <libdesktop-agnostic@lazymalevolence.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 *
 * Author : Mark Lee <libdesktop-agnostic@lazymalevolence.com>
 */

#include "da-vfs-gio.h"
#include <desktop-agnostic-vfs.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	DESKTOP_AGNOSTIC_VFS_GIO_IMPLEMENTATION_0_PROPERTY,
	DESKTOP_AGNOSTIC_VFS_GIO_IMPLEMENTATION_NAME_PROPERTY,
	DESKTOP_AGNOSTIC_VFS_GIO_IMPLEMENTATION_FILE_TYPE_PROPERTY,
	DESKTOP_AGNOSTIC_VFS_GIO_IMPLEMENTATION_FILE_MONITOR_TYPE_PROPERTY,
	DESKTOP_AGNOSTIC_VFS_GIO_IMPLEMENTATION_TRASH_TYPE_PROPERTY,
	DESKTOP_AGNOSTIC_VFS_GIO_IMPLEMENTATION_VOLUME_TYPE_PROPERTY,
	DESKTOP_AGNOSTIC_VFS_GIO_IMPLEMENTATION_NUM_PROPERTIES
};
static GParamSpec* desktop_agnostic_vfs_gio_implementation_properties[DESKTOP_AGNOSTIC_VFS_GIO_IMPLEMENTATION_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _DesktopAgnosticVFSGIOImplementationPrivate {
	DesktopAgnosticVFSVolumeMonitor* vmonitor;
};

static gint DesktopAgnosticVFSGIOImplementation_private_offset;
static gpointer desktop_agnostic_vfs_gio_implementation_parent_class = NULL;
static DesktopAgnosticVFSImplementationIface * desktop_agnostic_vfs_gio_implementation_desktop_agnostic_vfs_implementation_parent_iface = NULL;

static void desktop_agnostic_vfs_gio_implementation_real_init (DesktopAgnosticVFSImplementation* base);
static GSList* desktop_agnostic_vfs_gio_implementation_real_files_from_uri_list (DesktopAgnosticVFSImplementation* base,
                                                                          const gchar* uri_list,
                                                                          GError** error);
static void _g_object_unref0_ (gpointer var);
static inline void _g_slist_free__g_object_unref0_ (GSList* self);
static DesktopAgnosticVFSVolumeMonitor* desktop_agnostic_vfs_gio_implementation_real_volume_monitor_get_default (DesktopAgnosticVFSImplementation* base);
static void desktop_agnostic_vfs_gio_implementation_real_shutdown (DesktopAgnosticVFSImplementation* base);
static void desktop_agnostic_vfs_gio_implementation_finalize (GObject * obj);
static GType desktop_agnostic_vfs_gio_implementation_get_type_once (void);
static void _vala_desktop_agnostic_vfs_gio_implementation_get_property (GObject * object,
                                                                 guint property_id,
                                                                 GValue * value,
                                                                 GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
desktop_agnostic_vfs_gio_implementation_get_instance_private (DesktopAgnosticVFSGIOImplementation* self)
{
	return G_STRUCT_MEMBER_P (self, DesktopAgnosticVFSGIOImplementation_private_offset);
}

static void
desktop_agnostic_vfs_gio_implementation_real_init (DesktopAgnosticVFSImplementation* base)
{
	DesktopAgnosticVFSGIOImplementation * self;
#line 62 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
	self = (DesktopAgnosticVFSGIOImplementation*) base;
#line 97 "vfs-impl-gio.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 72 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 105 "vfs-impl-gio.c"
}

static inline void
_g_slist_free__g_object_unref0_ (GSList* self)
{
#line 72 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
	g_slist_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 113 "vfs-impl-gio.c"
}

static GSList*
desktop_agnostic_vfs_gio_implementation_real_files_from_uri_list (DesktopAgnosticVFSImplementation* base,
                                                                  const gchar* uri_list,
                                                                  GError** error)
{
	DesktopAgnosticVFSGIOImplementation * self;
	GSList* files = NULL;
	gchar** uris = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gint uris_length1;
	gint _uris_size_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	GError* _inner_error0_ = NULL;
	GSList* result;
#line 65 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
	self = (DesktopAgnosticVFSGIOImplementation*) base;
#line 65 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
	g_return_val_if_fail (uri_list != NULL, NULL);
#line 68 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
	files = NULL;
#line 69 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
	_tmp1_ = _tmp0_ = g_uri_list_extract_uris (uri_list);
#line 69 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
	uris = _tmp1_;
#line 69 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
	uris_length1 = _vala_array_length (_tmp0_);
#line 69 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
	_uris_size_ = uris_length1;
#line 70 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
	_tmp2_ = uris;
#line 70 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
	_tmp2__length1 = uris_length1;
#line 150 "vfs-impl-gio.c"
	{
		gchar** uri_collection = NULL;
		gint uri_collection_length1 = 0;
		gint _uri_collection_size_ = 0;
		gint uri_it = 0;
#line 70 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
		uri_collection = _tmp2_;
#line 70 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
		uri_collection_length1 = _tmp2__length1;
#line 70 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
		for (uri_it = 0; uri_it < uri_collection_length1; uri_it = uri_it + 1) {
#line 162 "vfs-impl-gio.c"
			const gchar* uri = NULL;
#line 70 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
			uri = uri_collection[uri_it];
#line 166 "vfs-impl-gio.c"
			{
				DesktopAgnosticVFSFile* file = NULL;
				const gchar* _tmp3_;
				DesktopAgnosticVFSFile* _tmp4_;
				DesktopAgnosticVFSFile* _tmp5_;
#line 72 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
				_tmp3_ = uri;
#line 72 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
				_tmp4_ = desktop_agnostic_vfs_file_new_for_uri (_tmp3_, &_inner_error0_);
#line 72 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
				file = _tmp4_;
#line 72 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 72 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
					g_propagate_error (error, _inner_error0_);
#line 72 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
					uris = (_vala_array_free (uris, uris_length1, (GDestroyNotify) g_free), NULL);
#line 72 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
					(files == NULL) ? NULL : (files = (_g_slist_free__g_object_unref0_ (files), NULL));
#line 72 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
					return NULL;
#line 188 "vfs-impl-gio.c"
				}
#line 73 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
				_tmp5_ = file;
#line 73 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
				file = NULL;
#line 73 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
				files = g_slist_append (files, _tmp5_);
#line 70 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
				_g_object_unref0 (file);
#line 198 "vfs-impl-gio.c"
			}
		}
	}
#line 75 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
	result = files;
#line 75 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
	uris = (_vala_array_free (uris, uris_length1, (GDestroyNotify) g_free), NULL);
#line 75 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
	return result;
#line 208 "vfs-impl-gio.c"
}

static DesktopAgnosticVFSVolumeMonitor*
desktop_agnostic_vfs_gio_implementation_real_volume_monitor_get_default (DesktopAgnosticVFSImplementation* base)
{
	DesktopAgnosticVFSGIOImplementation * self;
	DesktopAgnosticVFSVolumeMonitor* _tmp0_;
	DesktopAgnosticVFSVolumeMonitor* _tmp2_;
	DesktopAgnosticVFSVolumeMonitor* result;
#line 78 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
	self = (DesktopAgnosticVFSGIOImplementation*) base;
#line 81 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
	_tmp0_ = self->priv->vmonitor;
#line 81 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
	if (_tmp0_ == NULL) {
#line 224 "vfs-impl-gio.c"
		DesktopAgnosticVFSVolumeMonitorGIO* _tmp1_;
#line 83 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
		_tmp1_ = desktop_agnostic_vfs_volume_monitor_gio_new ();
#line 83 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
		_g_object_unref0 (self->priv->vmonitor);
#line 83 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
		self->priv->vmonitor = (DesktopAgnosticVFSVolumeMonitor*) _tmp1_;
#line 232 "vfs-impl-gio.c"
	}
#line 85 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
	_tmp2_ = self->priv->vmonitor;
#line 85 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
	result = _tmp2_;
#line 85 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
	return result;
#line 240 "vfs-impl-gio.c"
}

static void
desktop_agnostic_vfs_gio_implementation_real_shutdown (DesktopAgnosticVFSImplementation* base)
{
	DesktopAgnosticVFSGIOImplementation * self;
#line 87 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
	self = (DesktopAgnosticVFSGIOImplementation*) base;
#line 249 "vfs-impl-gio.c"
}

DesktopAgnosticVFSGIOImplementation*
desktop_agnostic_vfs_gio_implementation_construct (GType object_type)
{
	DesktopAgnosticVFSGIOImplementation * self = NULL;
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
	self = (DesktopAgnosticVFSGIOImplementation*) g_object_new (object_type, NULL);
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
	return self;
#line 260 "vfs-impl-gio.c"
}

DesktopAgnosticVFSGIOImplementation*
desktop_agnostic_vfs_gio_implementation_new (void)
{
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
	return desktop_agnostic_vfs_gio_implementation_construct (DESKTOP_AGNOSTIC_VFS_TYPE_GIO_IMPLEMENTATION);
#line 268 "vfs-impl-gio.c"
}

static const gchar*
desktop_agnostic_vfs_gio_implementation_real_get_name (DesktopAgnosticVFSImplementation* base)
{
	const gchar* result;
	DesktopAgnosticVFSGIOImplementation* self;
#line 29 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
	self = (DesktopAgnosticVFSGIOImplementation*) base;
#line 31 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
	result = "GIO";
#line 31 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
	return result;
#line 282 "vfs-impl-gio.c"
}

static GType
desktop_agnostic_vfs_gio_implementation_real_get_file_type (DesktopAgnosticVFSImplementation* base)
{
	GType result;
	DesktopAgnosticVFSGIOImplementation* self;
#line 36 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
	self = (DesktopAgnosticVFSGIOImplementation*) base;
#line 38 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
	result = DESKTOP_AGNOSTIC_VFS_TYPE_FILE_GIO;
#line 38 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
	return result;
#line 296 "vfs-impl-gio.c"
}

static GType
desktop_agnostic_vfs_gio_implementation_real_get_file_monitor_type (DesktopAgnosticVFSImplementation* base)
{
	GType result;
	DesktopAgnosticVFSGIOImplementation* self;
#line 43 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
	self = (DesktopAgnosticVFSGIOImplementation*) base;
#line 45 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
	result = DESKTOP_AGNOSTIC_VFS_TYPE_FILE_MONITOR_GIO;
#line 45 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
	return result;
#line 310 "vfs-impl-gio.c"
}

static GType
desktop_agnostic_vfs_gio_implementation_real_get_trash_type (DesktopAgnosticVFSImplementation* base)
{
	GType result;
	DesktopAgnosticVFSGIOImplementation* self;
#line 50 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
	self = (DesktopAgnosticVFSGIOImplementation*) base;
#line 52 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
	result = DESKTOP_AGNOSTIC_VFS_TYPE_TRASH_GIO;
#line 52 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
	return result;
#line 324 "vfs-impl-gio.c"
}

static GType
desktop_agnostic_vfs_gio_implementation_real_get_volume_type (DesktopAgnosticVFSImplementation* base)
{
	GType result;
	DesktopAgnosticVFSGIOImplementation* self;
#line 57 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
	self = (DesktopAgnosticVFSGIOImplementation*) base;
#line 59 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
	result = DESKTOP_AGNOSTIC_VFS_TYPE_VOLUME_GIO;
#line 59 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
	return result;
#line 338 "vfs-impl-gio.c"
}

static void
desktop_agnostic_vfs_gio_implementation_class_init (DesktopAgnosticVFSGIOImplementationClass * klass,
                                                    gpointer klass_data)
{
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
	desktop_agnostic_vfs_gio_implementation_parent_class = g_type_class_peek_parent (klass);
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
	g_type_class_adjust_private_offset (klass, &DesktopAgnosticVFSGIOImplementation_private_offset);
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_desktop_agnostic_vfs_gio_implementation_get_property;
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
	G_OBJECT_CLASS (klass)->finalize = desktop_agnostic_vfs_gio_implementation_finalize;
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DESKTOP_AGNOSTIC_VFS_GIO_IMPLEMENTATION_NAME_PROPERTY, desktop_agnostic_vfs_gio_implementation_properties[DESKTOP_AGNOSTIC_VFS_GIO_IMPLEMENTATION_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DESKTOP_AGNOSTIC_VFS_GIO_IMPLEMENTATION_FILE_TYPE_PROPERTY, desktop_agnostic_vfs_gio_implementation_properties[DESKTOP_AGNOSTIC_VFS_GIO_IMPLEMENTATION_FILE_TYPE_PROPERTY] = g_param_spec_gtype ("file-type", "file-type", "file-type", G_TYPE_NONE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DESKTOP_AGNOSTIC_VFS_GIO_IMPLEMENTATION_FILE_MONITOR_TYPE_PROPERTY, desktop_agnostic_vfs_gio_implementation_properties[DESKTOP_AGNOSTIC_VFS_GIO_IMPLEMENTATION_FILE_MONITOR_TYPE_PROPERTY] = g_param_spec_gtype ("file-monitor-type", "file-monitor-type", "file-monitor-type", G_TYPE_NONE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DESKTOP_AGNOSTIC_VFS_GIO_IMPLEMENTATION_TRASH_TYPE_PROPERTY, desktop_agnostic_vfs_gio_implementation_properties[DESKTOP_AGNOSTIC_VFS_GIO_IMPLEMENTATION_TRASH_TYPE_PROPERTY] = g_param_spec_gtype ("trash-type", "trash-type", "trash-type", G_TYPE_NONE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DESKTOP_AGNOSTIC_VFS_GIO_IMPLEMENTATION_VOLUME_TYPE_PROPERTY, desktop_agnostic_vfs_gio_implementation_properties[DESKTOP_AGNOSTIC_VFS_GIO_IMPLEMENTATION_VOLUME_TYPE_PROPERTY] = g_param_spec_gtype ("volume-type", "volume-type", "volume-type", G_TYPE_NONE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 363 "vfs-impl-gio.c"
}

static void
desktop_agnostic_vfs_gio_implementation_desktop_agnostic_vfs_implementation_interface_init (DesktopAgnosticVFSImplementationIface * iface,
                                                                                            gpointer iface_data)
{
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
	desktop_agnostic_vfs_gio_implementation_desktop_agnostic_vfs_implementation_parent_iface = g_type_interface_peek_parent (iface);
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
	iface->init = (void (*) (DesktopAgnosticVFSImplementation*)) desktop_agnostic_vfs_gio_implementation_real_init;
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
	iface->files_from_uri_list = (GSList* (*) (DesktopAgnosticVFSImplementation*, const gchar*, GError**)) desktop_agnostic_vfs_gio_implementation_real_files_from_uri_list;
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
	iface->volume_monitor_get_default = (DesktopAgnosticVFSVolumeMonitor* (*) (DesktopAgnosticVFSImplementation*)) desktop_agnostic_vfs_gio_implementation_real_volume_monitor_get_default;
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
	iface->shutdown = (void (*) (DesktopAgnosticVFSImplementation*)) desktop_agnostic_vfs_gio_implementation_real_shutdown;
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
	iface->get_name = desktop_agnostic_vfs_gio_implementation_real_get_name;
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
	iface->get_file_type = desktop_agnostic_vfs_gio_implementation_real_get_file_type;
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
	iface->get_file_monitor_type = desktop_agnostic_vfs_gio_implementation_real_get_file_monitor_type;
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
	iface->get_trash_type = desktop_agnostic_vfs_gio_implementation_real_get_trash_type;
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
	iface->get_volume_type = desktop_agnostic_vfs_gio_implementation_real_get_volume_type;
#line 390 "vfs-impl-gio.c"
}

static void
desktop_agnostic_vfs_gio_implementation_instance_init (DesktopAgnosticVFSGIOImplementation * self,
                                                       gpointer klass)
{
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
	self->priv = desktop_agnostic_vfs_gio_implementation_get_instance_private (self);
#line 399 "vfs-impl-gio.c"
}

static void
desktop_agnostic_vfs_gio_implementation_finalize (GObject * obj)
{
	DesktopAgnosticVFSGIOImplementation * self;
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DESKTOP_AGNOSTIC_VFS_TYPE_GIO_IMPLEMENTATION, DesktopAgnosticVFSGIOImplementation);
#line 77 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
	_g_object_unref0 (self->priv->vmonitor);
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
	G_OBJECT_CLASS (desktop_agnostic_vfs_gio_implementation_parent_class)->finalize (obj);
#line 412 "vfs-impl-gio.c"
}

static GType
desktop_agnostic_vfs_gio_implementation_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DesktopAgnosticVFSGIOImplementationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) desktop_agnostic_vfs_gio_implementation_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DesktopAgnosticVFSGIOImplementation), 0, (GInstanceInitFunc) desktop_agnostic_vfs_gio_implementation_instance_init, NULL };
	static const GInterfaceInfo desktop_agnostic_vfs_implementation_info = { (GInterfaceInitFunc) desktop_agnostic_vfs_gio_implementation_desktop_agnostic_vfs_implementation_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType desktop_agnostic_vfs_gio_implementation_type_id;
	desktop_agnostic_vfs_gio_implementation_type_id = g_type_register_static (G_TYPE_OBJECT, "DesktopAgnosticVFSGIOImplementation", &g_define_type_info, 0);
	g_type_add_interface_static (desktop_agnostic_vfs_gio_implementation_type_id, DESKTOP_AGNOSTIC_VFS_TYPE_IMPLEMENTATION, &desktop_agnostic_vfs_implementation_info);
	DesktopAgnosticVFSGIOImplementation_private_offset = g_type_add_instance_private (desktop_agnostic_vfs_gio_implementation_type_id, sizeof (DesktopAgnosticVFSGIOImplementationPrivate));
	return desktop_agnostic_vfs_gio_implementation_type_id;
}

GType
desktop_agnostic_vfs_gio_implementation_get_type (void)
{
	static volatile gsize desktop_agnostic_vfs_gio_implementation_type_id__once = 0;
	if (g_once_init_enter (&desktop_agnostic_vfs_gio_implementation_type_id__once)) {
		GType desktop_agnostic_vfs_gio_implementation_type_id;
		desktop_agnostic_vfs_gio_implementation_type_id = desktop_agnostic_vfs_gio_implementation_get_type_once ();
		g_once_init_leave (&desktop_agnostic_vfs_gio_implementation_type_id__once, desktop_agnostic_vfs_gio_implementation_type_id);
	}
	return desktop_agnostic_vfs_gio_implementation_type_id__once;
}

static void
_vala_desktop_agnostic_vfs_gio_implementation_get_property (GObject * object,
                                                            guint property_id,
                                                            GValue * value,
                                                            GParamSpec * pspec)
{
	DesktopAgnosticVFSGIOImplementation * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DESKTOP_AGNOSTIC_VFS_TYPE_GIO_IMPLEMENTATION, DesktopAgnosticVFSGIOImplementation);
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
	switch (property_id) {
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
		case DESKTOP_AGNOSTIC_VFS_GIO_IMPLEMENTATION_NAME_PROPERTY:
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
		g_value_set_string (value, desktop_agnostic_vfs_implementation_get_name ((DesktopAgnosticVFSImplementation*) self));
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
		break;
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
		case DESKTOP_AGNOSTIC_VFS_GIO_IMPLEMENTATION_FILE_TYPE_PROPERTY:
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
		g_value_set_gtype (value, desktop_agnostic_vfs_implementation_get_file_type ((DesktopAgnosticVFSImplementation*) self));
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
		break;
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
		case DESKTOP_AGNOSTIC_VFS_GIO_IMPLEMENTATION_FILE_MONITOR_TYPE_PROPERTY:
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
		g_value_set_gtype (value, desktop_agnostic_vfs_implementation_get_file_monitor_type ((DesktopAgnosticVFSImplementation*) self));
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
		break;
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
		case DESKTOP_AGNOSTIC_VFS_GIO_IMPLEMENTATION_TRASH_TYPE_PROPERTY:
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
		g_value_set_gtype (value, desktop_agnostic_vfs_implementation_get_trash_type ((DesktopAgnosticVFSImplementation*) self));
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
		break;
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
		case DESKTOP_AGNOSTIC_VFS_GIO_IMPLEMENTATION_VOLUME_TYPE_PROPERTY:
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
		g_value_set_gtype (value, desktop_agnostic_vfs_implementation_get_volume_type ((DesktopAgnosticVFSImplementation*) self));
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
		break;
#line 479 "vfs-impl-gio.c"
		default:
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
		break;
#line 485 "vfs-impl-gio.c"
	}
}

GType
register_plugin (void)
{
	GType result;
#line 95 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
	result = DESKTOP_AGNOSTIC_VFS_TYPE_GIO_IMPLEMENTATION;
#line 95 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-impl-gio.vala"
	return result;
#line 497 "vfs-impl-gio.c"
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

