/* vfs-volume-impl-gio.c generated by valac 0.56.17, the Vala compiler
 * generated from vfs-volume-impl-gio.vala, do not modify */

/*
 * Desktop Agnostic Library: VFS Volume implementation (GIO).
 *
 * Copyright (C) 2009 Mark Lee <libdesktop-agnostic@lazymalevolence.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 *
 * Author : Mark Lee <libdesktop-agnostic@lazymalevolence.com>
 */

#include "da-vfs-gio.h"
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <desktop-agnostic-vfs.h>
#include <glib-object.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	DESKTOP_AGNOSTIC_VFS_VOLUME_GIO_0_PROPERTY,
	DESKTOP_AGNOSTIC_VFS_VOLUME_GIO_IMPLEMENTATION_PROPERTY,
	DESKTOP_AGNOSTIC_VFS_VOLUME_GIO_NAME_PROPERTY,
	DESKTOP_AGNOSTIC_VFS_VOLUME_GIO_URI_PROPERTY,
	DESKTOP_AGNOSTIC_VFS_VOLUME_GIO_ICON_PROPERTY,
	DESKTOP_AGNOSTIC_VFS_VOLUME_GIO_NUM_PROPERTIES
};
static GParamSpec* desktop_agnostic_vfs_volume_gio_properties[DESKTOP_AGNOSTIC_VFS_VOLUME_GIO_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
enum  {
	DESKTOP_AGNOSTIC_VFS_VOLUME_MONITOR_GIO_0_PROPERTY,
	DESKTOP_AGNOSTIC_VFS_VOLUME_MONITOR_GIO_IMPLEMENTATION_PROPERTY,
	DESKTOP_AGNOSTIC_VFS_VOLUME_MONITOR_GIO_VOLUMES_PROPERTY,
	DESKTOP_AGNOSTIC_VFS_VOLUME_MONITOR_GIO_NUM_PROPERTIES
};
static GParamSpec* desktop_agnostic_vfs_volume_monitor_gio_properties[DESKTOP_AGNOSTIC_VFS_VOLUME_MONITOR_GIO_NUM_PROPERTIES];
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))

struct _DesktopAgnosticVFSVolumeGIOPrivate {
	GVolume* vol;
	gchar* _name;
	DesktopAgnosticVFSFile* _uri;
	gchar* _icon;
	DesktopAgnosticVFSVolumeCallback _mount_callback;
	gpointer _mount_callback_target;
	GDestroyNotify _mount_callback_target_destroy_notify;
	GAsyncResult* async_result;
	DesktopAgnosticVFSVolumeCallback _unmount_callback;
	gpointer _unmount_callback_target;
	GDestroyNotify _unmount_callback_target_destroy_notify;
	DesktopAgnosticVFSVolumeCallback _eject_callback;
	gpointer _eject_callback_target;
	GDestroyNotify _eject_callback_target_destroy_notify;
};

struct _DesktopAgnosticVFSVolumeMonitorGIOPrivate {
	GVolumeMonitor* monitor;
	GHashTable* _volumes;
};

static gint DesktopAgnosticVFSVolumeGIO_private_offset;
static gpointer desktop_agnostic_vfs_volume_gio_parent_class = NULL;
static DesktopAgnosticVFSVolumeIface * desktop_agnostic_vfs_volume_gio_desktop_agnostic_vfs_volume_parent_iface = NULL;
static gint DesktopAgnosticVFSVolumeMonitorGIO_private_offset;
static gpointer desktop_agnostic_vfs_volume_monitor_gio_parent_class = NULL;
static DesktopAgnosticVFSVolumeMonitorIface * desktop_agnostic_vfs_volume_monitor_gio_desktop_agnostic_vfs_volume_monitor_parent_iface = NULL;

static gboolean desktop_agnostic_vfs_volume_gio_real_is_mounted (DesktopAgnosticVFSVolume* base);
static void desktop_agnostic_vfs_volume_gio_on_mount (DesktopAgnosticVFSVolumeGIO* self,
                                               GObject* obj,
                                               GAsyncResult* res);
static void desktop_agnostic_vfs_volume_gio_real_mount (DesktopAgnosticVFSVolume* base,
                                                 DesktopAgnosticVFSVolumeCallback callback,
                                                 gpointer callback_target);
static void _desktop_agnostic_vfs_volume_gio_on_mount_gasync_ready_callback (GObject* source_object,
                                                                      GAsyncResult* res,
                                                                      gpointer self);
static gboolean desktop_agnostic_vfs_volume_gio_real_mount_finish (DesktopAgnosticVFSVolume* base,
                                                            GError** error);
static void desktop_agnostic_vfs_volume_gio_on_unmount (DesktopAgnosticVFSVolumeGIO* self,
                                                 GObject* obj,
                                                 GAsyncResult* res);
static void desktop_agnostic_vfs_volume_gio_real_unmount (DesktopAgnosticVFSVolume* base,
                                                   DesktopAgnosticVFSVolumeCallback callback,
                                                   gpointer callback_target);
static void _desktop_agnostic_vfs_volume_gio_on_unmount_gasync_ready_callback (GObject* source_object,
                                                                        GAsyncResult* res,
                                                                        gpointer self);
static gboolean desktop_agnostic_vfs_volume_gio_real_unmount_finish (DesktopAgnosticVFSVolume* base,
                                                              GError** error);
static gboolean desktop_agnostic_vfs_volume_gio_real_can_eject (DesktopAgnosticVFSVolume* base);
static void desktop_agnostic_vfs_volume_gio_on_eject (DesktopAgnosticVFSVolumeGIO* self,
                                               GObject* obj,
                                               GAsyncResult* res);
static void desktop_agnostic_vfs_volume_gio_real_eject (DesktopAgnosticVFSVolume* base,
                                                 DesktopAgnosticVFSVolumeCallback callback,
                                                 gpointer callback_target);
static void _desktop_agnostic_vfs_volume_gio_on_eject_gasync_ready_callback (GObject* source_object,
                                                                      GAsyncResult* res,
                                                                      gpointer self);
static gboolean desktop_agnostic_vfs_volume_gio_real_eject_finish (DesktopAgnosticVFSVolume* base,
                                                            GError** error);
static void desktop_agnostic_vfs_volume_gio_finalize (GObject * obj);
static GType desktop_agnostic_vfs_volume_gio_get_type_once (void);
static void _vala_desktop_agnostic_vfs_volume_gio_get_property (GObject * object,
                                                         guint property_id,
                                                         GValue * value,
                                                         GParamSpec * pspec);
static void _vala_desktop_agnostic_vfs_volume_gio_set_property (GObject * object,
                                                         guint property_id,
                                                         const GValue * value,
                                                         GParamSpec * pspec);
static DesktopAgnosticVFSVolume* desktop_agnostic_vfs_volume_monitor_gio_create_volume (DesktopAgnosticVFSVolumeMonitorGIO* self,
                                                                                 GVolume* vol);
static DesktopAgnosticVFSVolume* desktop_agnostic_vfs_volume_monitor_gio_check_volume (DesktopAgnosticVFSVolumeMonitorGIO* self,
                                                                                GVolume* gvol);
static DesktopAgnosticVFSVolume* desktop_agnostic_vfs_volume_monitor_gio_get_volume_from_mount (DesktopAgnosticVFSVolumeMonitorGIO* self,
                                                                                         GMount* mount);
static void desktop_agnostic_vfs_volume_monitor_gio_on_mount_added (DesktopAgnosticVFSVolumeMonitorGIO* self,
                                                             GVolumeMonitor* vmonitor,
                                                             GMount* mount);
static void desktop_agnostic_vfs_volume_monitor_gio_on_mount_removed (DesktopAgnosticVFSVolumeMonitorGIO* self,
                                                               GVolumeMonitor* vmonitor,
                                                               GMount* mount);
static void desktop_agnostic_vfs_volume_monitor_gio_on_volume_added (DesktopAgnosticVFSVolumeMonitorGIO* self,
                                                              GVolumeMonitor* vmonitor,
                                                              GVolume* gvol);
static void desktop_agnostic_vfs_volume_monitor_gio_on_volume_removed (DesktopAgnosticVFSVolumeMonitorGIO* self,
                                                                GVolumeMonitor* vmonitor,
                                                                GVolume* gvol);
static GObject * desktop_agnostic_vfs_volume_monitor_gio_constructor (GType type,
                                                               guint n_construct_properties,
                                                               GObjectConstructParam * construct_properties);
static void _g_object_unref0_ (gpointer var);
static void _desktop_agnostic_vfs_volume_monitor_gio_on_mount_added_g_volume_monitor_mount_added (GVolumeMonitor* _sender,
                                                                                           GMount* mount,
                                                                                           gpointer self);
static void _desktop_agnostic_vfs_volume_monitor_gio_on_mount_removed_g_volume_monitor_mount_removed (GVolumeMonitor* _sender,
                                                                                               GMount* mount,
                                                                                               gpointer self);
static void _desktop_agnostic_vfs_volume_monitor_gio_on_volume_added_g_volume_monitor_volume_added (GVolumeMonitor* _sender,
                                                                                             GVolume* volume,
                                                                                             gpointer self);
static void _desktop_agnostic_vfs_volume_monitor_gio_on_volume_removed_g_volume_monitor_volume_removed (GVolumeMonitor* _sender,
                                                                                                 GVolume* volume,
                                                                                                 gpointer self);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void desktop_agnostic_vfs_volume_monitor_gio_finalize (GObject * obj);
static GType desktop_agnostic_vfs_volume_monitor_gio_get_type_once (void);
static void _vala_desktop_agnostic_vfs_volume_monitor_gio_get_property (GObject * object,
                                                                 guint property_id,
                                                                 GValue * value,
                                                                 GParamSpec * pspec);
static gssize _vala_array_length (gpointer array);

static inline gpointer
desktop_agnostic_vfs_volume_gio_get_instance_private (DesktopAgnosticVFSVolumeGIO* self)
{
	return G_STRUCT_MEMBER_P (self, DesktopAgnosticVFSVolumeGIO_private_offset);
}

static gboolean
desktop_agnostic_vfs_volume_gio_real_is_mounted (DesktopAgnosticVFSVolume* base)
{
	DesktopAgnosticVFSVolumeGIO * self;
	GVolume* _tmp0_;
	GMount* _tmp1_;
	GMount* _tmp2_;
	gboolean _tmp3_;
	gboolean result;
#line 100 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	self = (DesktopAgnosticVFSVolumeGIO*) base;
#line 103 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_tmp0_ = self->priv->vol;
#line 103 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_tmp1_ = g_volume_get_mount (_tmp0_);
#line 103 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_tmp2_ = _tmp1_;
#line 103 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_tmp3_ = _tmp2_ != NULL;
#line 103 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_g_object_unref0 (_tmp2_);
#line 103 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	result = _tmp3_;
#line 103 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	return result;
#line 213 "vfs-volume-impl-gio.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 109 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	return self ? g_object_ref (self) : NULL;
#line 221 "vfs-volume-impl-gio.c"
}

static void
desktop_agnostic_vfs_volume_gio_on_mount (DesktopAgnosticVFSVolumeGIO* self,
                                          GObject* obj,
                                          GAsyncResult* res)
{
	GAsyncResult* _tmp0_;
	DesktopAgnosticVFSVolumeCallback _tmp1_;
	gpointer _tmp1__target;
#line 107 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	g_return_if_fail (self != NULL);
#line 107 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	g_return_if_fail (res != NULL);
#line 109 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_tmp0_ = _g_object_ref0 (res);
#line 109 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_g_object_unref0 (self->priv->async_result);
#line 109 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	self->priv->async_result = _tmp0_;
#line 110 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_tmp1_ = self->priv->_mount_callback;
#line 110 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_tmp1__target = self->priv->_mount_callback_target;
#line 110 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_tmp1_ (_tmp1__target);
#line 111 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	(self->priv->_mount_callback_target_destroy_notify == NULL) ? NULL : (self->priv->_mount_callback_target_destroy_notify (self->priv->_mount_callback_target), NULL);
#line 111 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	self->priv->_mount_callback = NULL;
#line 111 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	self->priv->_mount_callback_target = NULL;
#line 111 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	self->priv->_mount_callback_target_destroy_notify = NULL;
#line 111 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	self->priv->_mount_callback = NULL;
#line 111 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	self->priv->_mount_callback_target = NULL;
#line 111 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	self->priv->_mount_callback_target_destroy_notify = NULL;
#line 262 "vfs-volume-impl-gio.c"
}

static void
_desktop_agnostic_vfs_volume_gio_on_mount_gasync_ready_callback (GObject* source_object,
                                                                 GAsyncResult* res,
                                                                 gpointer self)
{
#line 119 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	desktop_agnostic_vfs_volume_gio_on_mount ((DesktopAgnosticVFSVolumeGIO*) self, source_object, res);
#line 119 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	g_object_unref (self);
#line 274 "vfs-volume-impl-gio.c"
}

static void
desktop_agnostic_vfs_volume_gio_real_mount (DesktopAgnosticVFSVolume* base,
                                            DesktopAgnosticVFSVolumeCallback callback,
                                            gpointer callback_target)
{
	DesktopAgnosticVFSVolumeGIO * self;
	DesktopAgnosticVFSVolumeCallback _tmp0_;
	gpointer _tmp0__target;
#line 113 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	self = (DesktopAgnosticVFSVolumeGIO*) base;
#line 116 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_tmp0_ = self->priv->_mount_callback;
#line 116 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_tmp0__target = self->priv->_mount_callback_target;
#line 116 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	if (_tmp0_ == NULL) {
#line 293 "vfs-volume-impl-gio.c"
		GVolume* _tmp1_;
#line 118 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		(self->priv->_mount_callback_target_destroy_notify == NULL) ? NULL : (self->priv->_mount_callback_target_destroy_notify (self->priv->_mount_callback_target), NULL);
#line 118 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		self->priv->_mount_callback = NULL;
#line 118 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		self->priv->_mount_callback_target = NULL;
#line 118 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		self->priv->_mount_callback_target_destroy_notify = NULL;
#line 118 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		self->priv->_mount_callback = callback;
#line 118 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		self->priv->_mount_callback_target = callback_target;
#line 118 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		self->priv->_mount_callback_target_destroy_notify = NULL;
#line 119 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		_tmp1_ = self->priv->vol;
#line 119 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		g_volume_mount (_tmp1_, G_MOUNT_MOUNT_NONE, NULL, NULL, _desktop_agnostic_vfs_volume_gio_on_mount_gasync_ready_callback, g_object_ref (self));
#line 313 "vfs-volume-impl-gio.c"
	}
}

static gboolean
desktop_agnostic_vfs_volume_gio_real_mount_finish (DesktopAgnosticVFSVolume* base,
                                                   GError** error)
{
	DesktopAgnosticVFSVolumeGIO * self;
	gboolean _result_ = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 122 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	self = (DesktopAgnosticVFSVolumeGIO*) base;
#line 124 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_result_ = FALSE;
#line 329 "vfs-volume-impl-gio.c"
	{
		gboolean _tmp0_ = FALSE;
		GVolume* _tmp1_;
		GAsyncResult* _tmp2_;
#line 127 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		_tmp1_ = self->priv->vol;
#line 127 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		_tmp2_ = self->priv->async_result;
#line 127 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		_tmp0_ = g_volume_mount_finish (_tmp1_, _tmp2_, &_inner_error0_);
#line 127 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 342 "vfs-volume-impl-gio.c"
			goto __catch0_g_error;
		}
#line 127 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		_result_ = _tmp0_;
#line 347 "vfs-volume-impl-gio.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
		GError* _tmp5_;
#line 125 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		err = _inner_error0_;
#line 125 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		_inner_error0_ = NULL;
#line 131 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		_tmp3_ = err;
#line 131 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		_tmp4_ = _tmp3_->message;
#line 131 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		_tmp5_ = g_error_new_literal (DESKTOP_AGNOSTIC_VFS_VOLUME_ERROR, DESKTOP_AGNOSTIC_VFS_VOLUME_ERROR_MOUNT, _tmp4_);
#line 131 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		_inner_error0_ = _tmp5_;
#line 131 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		_g_error_free0 (err);
#line 370 "vfs-volume-impl-gio.c"
		goto __finally0;
	}
	__finally0:
#line 125 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 125 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		if (_inner_error0_->domain == DESKTOP_AGNOSTIC_VFS_VOLUME_ERROR) {
#line 378 "vfs-volume-impl-gio.c"
			gboolean _tmp6_ = FALSE;
#line 125 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
			g_propagate_error (error, _inner_error0_);
#line 125 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
			return _tmp6_;
#line 384 "vfs-volume-impl-gio.c"
		} else {
			gboolean _tmp7_ = FALSE;
#line 125 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 125 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
			g_clear_error (&_inner_error0_);
#line 125 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
			return _tmp7_;
#line 393 "vfs-volume-impl-gio.c"
		}
	}
#line 133 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_g_object_unref0 (self->priv->async_result);
#line 133 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	self->priv->async_result = NULL;
#line 134 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	result = _result_;
#line 134 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	return result;
#line 404 "vfs-volume-impl-gio.c"
}

static void
desktop_agnostic_vfs_volume_gio_on_unmount (DesktopAgnosticVFSVolumeGIO* self,
                                            GObject* obj,
                                            GAsyncResult* res)
{
	GAsyncResult* _tmp0_;
	DesktopAgnosticVFSVolumeCallback _tmp1_;
	gpointer _tmp1__target;
#line 137 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	g_return_if_fail (self != NULL);
#line 137 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	g_return_if_fail (res != NULL);
#line 139 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_tmp0_ = _g_object_ref0 (res);
#line 139 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_g_object_unref0 (self->priv->async_result);
#line 139 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	self->priv->async_result = _tmp0_;
#line 140 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_tmp1_ = self->priv->_unmount_callback;
#line 140 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_tmp1__target = self->priv->_unmount_callback_target;
#line 140 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_tmp1_ (_tmp1__target);
#line 141 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	(self->priv->_unmount_callback_target_destroy_notify == NULL) ? NULL : (self->priv->_unmount_callback_target_destroy_notify (self->priv->_unmount_callback_target), NULL);
#line 141 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	self->priv->_unmount_callback = NULL;
#line 141 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	self->priv->_unmount_callback_target = NULL;
#line 141 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	self->priv->_unmount_callback_target_destroy_notify = NULL;
#line 141 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	self->priv->_unmount_callback = NULL;
#line 141 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	self->priv->_unmount_callback_target = NULL;
#line 141 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	self->priv->_unmount_callback_target_destroy_notify = NULL;
#line 445 "vfs-volume-impl-gio.c"
}

static void
_desktop_agnostic_vfs_volume_gio_on_unmount_gasync_ready_callback (GObject* source_object,
                                                                   GAsyncResult* res,
                                                                   gpointer self)
{
#line 153 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	desktop_agnostic_vfs_volume_gio_on_unmount ((DesktopAgnosticVFSVolumeGIO*) self, source_object, res);
#line 153 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	g_object_unref (self);
#line 457 "vfs-volume-impl-gio.c"
}

static void
desktop_agnostic_vfs_volume_gio_real_unmount (DesktopAgnosticVFSVolume* base,
                                              DesktopAgnosticVFSVolumeCallback callback,
                                              gpointer callback_target)
{
	DesktopAgnosticVFSVolumeGIO * self;
	DesktopAgnosticVFSVolumeCallback _tmp0_;
	gpointer _tmp0__target;
#line 143 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	self = (DesktopAgnosticVFSVolumeGIO*) base;
#line 146 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_tmp0_ = self->priv->_unmount_callback;
#line 146 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_tmp0__target = self->priv->_unmount_callback_target;
#line 146 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	if (_tmp0_ == NULL) {
#line 476 "vfs-volume-impl-gio.c"
		GMount* mount = NULL;
		GVolume* _tmp1_;
		GMount* _tmp2_;
		GMount* _tmp3_;
#line 149 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		(self->priv->_unmount_callback_target_destroy_notify == NULL) ? NULL : (self->priv->_unmount_callback_target_destroy_notify (self->priv->_unmount_callback_target), NULL);
#line 149 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		self->priv->_unmount_callback = NULL;
#line 149 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		self->priv->_unmount_callback_target = NULL;
#line 149 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		self->priv->_unmount_callback_target_destroy_notify = NULL;
#line 149 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		self->priv->_unmount_callback = callback;
#line 149 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		self->priv->_unmount_callback_target = callback_target;
#line 149 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		self->priv->_unmount_callback_target_destroy_notify = NULL;
#line 150 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		_tmp1_ = self->priv->vol;
#line 150 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		_tmp2_ = g_volume_get_mount (_tmp1_);
#line 150 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		_g_object_unref0 (mount);
#line 150 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		mount = _tmp2_;
#line 151 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		_tmp3_ = mount;
#line 151 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		if (_tmp3_ != NULL) {
#line 507 "vfs-volume-impl-gio.c"
			GMount* _tmp4_;
#line 153 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
			_tmp4_ = mount;
#line 153 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
			g_mount_unmount (_tmp4_, G_MOUNT_UNMOUNT_NONE, NULL, _desktop_agnostic_vfs_volume_gio_on_unmount_gasync_ready_callback, g_object_ref (self));
#line 513 "vfs-volume-impl-gio.c"
		}
#line 146 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		_g_object_unref0 (mount);
#line 517 "vfs-volume-impl-gio.c"
	}
}

static gboolean
desktop_agnostic_vfs_volume_gio_real_unmount_finish (DesktopAgnosticVFSVolume* base,
                                                     GError** error)
{
	DesktopAgnosticVFSVolumeGIO * self;
	gboolean _result_ = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 157 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	self = (DesktopAgnosticVFSVolumeGIO*) base;
#line 159 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_result_ = FALSE;
#line 533 "vfs-volume-impl-gio.c"
	{
		gboolean _tmp0_ = FALSE;
		GVolume* _tmp1_;
		GMount* _tmp2_;
		GMount* _tmp3_;
		GAsyncResult* _tmp4_;
		gboolean _tmp5_;
#line 162 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		_tmp1_ = self->priv->vol;
#line 162 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		_tmp2_ = g_volume_get_mount (_tmp1_);
#line 162 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		_tmp3_ = _tmp2_;
#line 162 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		_tmp4_ = self->priv->async_result;
#line 162 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		_tmp5_ = g_mount_unmount_finish (_tmp3_, _tmp4_, &_inner_error0_);
#line 162 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		_g_object_unref0 (_tmp3_);
#line 162 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		_tmp0_ = _tmp5_;
#line 162 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 557 "vfs-volume-impl-gio.c"
			goto __catch0_g_error;
		}
#line 162 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		_result_ = _tmp0_;
#line 562 "vfs-volume-impl-gio.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
		GError* _tmp8_;
#line 160 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		err = _inner_error0_;
#line 160 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		_inner_error0_ = NULL;
#line 166 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		_tmp6_ = err;
#line 166 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		_tmp7_ = _tmp6_->message;
#line 166 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		_tmp8_ = g_error_new_literal (DESKTOP_AGNOSTIC_VFS_VOLUME_ERROR, DESKTOP_AGNOSTIC_VFS_VOLUME_ERROR_UNMOUNT, _tmp7_);
#line 166 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		_inner_error0_ = _tmp8_;
#line 166 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		_g_error_free0 (err);
#line 585 "vfs-volume-impl-gio.c"
		goto __finally0;
	}
	__finally0:
#line 160 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 160 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		if (_inner_error0_->domain == DESKTOP_AGNOSTIC_VFS_VOLUME_ERROR) {
#line 593 "vfs-volume-impl-gio.c"
			gboolean _tmp9_ = FALSE;
#line 160 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
			g_propagate_error (error, _inner_error0_);
#line 160 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
			return _tmp9_;
#line 599 "vfs-volume-impl-gio.c"
		} else {
			gboolean _tmp10_ = FALSE;
#line 160 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 160 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
			g_clear_error (&_inner_error0_);
#line 160 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
			return _tmp10_;
#line 608 "vfs-volume-impl-gio.c"
		}
	}
#line 168 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_g_object_unref0 (self->priv->async_result);
#line 168 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	self->priv->async_result = NULL;
#line 169 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	result = _result_;
#line 169 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	return result;
#line 619 "vfs-volume-impl-gio.c"
}

static gboolean
desktop_agnostic_vfs_volume_gio_real_can_eject (DesktopAgnosticVFSVolume* base)
{
	DesktopAgnosticVFSVolumeGIO * self;
	GVolume* _tmp0_;
	gboolean result;
#line 171 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	self = (DesktopAgnosticVFSVolumeGIO*) base;
#line 174 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_tmp0_ = self->priv->vol;
#line 174 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	result = g_volume_can_eject (_tmp0_);
#line 174 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	return result;
#line 636 "vfs-volume-impl-gio.c"
}

static void
desktop_agnostic_vfs_volume_gio_on_eject (DesktopAgnosticVFSVolumeGIO* self,
                                          GObject* obj,
                                          GAsyncResult* res)
{
	GAsyncResult* _tmp0_;
	DesktopAgnosticVFSVolumeCallback _tmp1_;
	gpointer _tmp1__target;
#line 177 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	g_return_if_fail (self != NULL);
#line 177 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	g_return_if_fail (res != NULL);
#line 180 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_tmp0_ = _g_object_ref0 (res);
#line 180 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_g_object_unref0 (self->priv->async_result);
#line 180 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	self->priv->async_result = _tmp0_;
#line 181 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_tmp1_ = self->priv->_eject_callback;
#line 181 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_tmp1__target = self->priv->_eject_callback_target;
#line 181 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_tmp1_ (_tmp1__target);
#line 182 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	(self->priv->_eject_callback_target_destroy_notify == NULL) ? NULL : (self->priv->_eject_callback_target_destroy_notify (self->priv->_eject_callback_target), NULL);
#line 182 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	self->priv->_eject_callback = NULL;
#line 182 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	self->priv->_eject_callback_target = NULL;
#line 182 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	self->priv->_eject_callback_target_destroy_notify = NULL;
#line 182 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	self->priv->_eject_callback = NULL;
#line 182 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	self->priv->_eject_callback_target = NULL;
#line 182 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	self->priv->_eject_callback_target_destroy_notify = NULL;
#line 677 "vfs-volume-impl-gio.c"
}

static void
_desktop_agnostic_vfs_volume_gio_on_eject_gasync_ready_callback (GObject* source_object,
                                                                 GAsyncResult* res,
                                                                 gpointer self)
{
#line 190 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	desktop_agnostic_vfs_volume_gio_on_eject ((DesktopAgnosticVFSVolumeGIO*) self, source_object, res);
#line 190 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	g_object_unref (self);
#line 689 "vfs-volume-impl-gio.c"
}

static void
desktop_agnostic_vfs_volume_gio_real_eject (DesktopAgnosticVFSVolume* base,
                                            DesktopAgnosticVFSVolumeCallback callback,
                                            gpointer callback_target)
{
	DesktopAgnosticVFSVolumeGIO * self;
	DesktopAgnosticVFSVolumeCallback _tmp0_;
	gpointer _tmp0__target;
#line 184 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	self = (DesktopAgnosticVFSVolumeGIO*) base;
#line 187 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_tmp0_ = self->priv->_eject_callback;
#line 187 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_tmp0__target = self->priv->_eject_callback_target;
#line 187 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	if (_tmp0_ == NULL) {
#line 708 "vfs-volume-impl-gio.c"
		GVolume* _tmp1_;
#line 189 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		(self->priv->_eject_callback_target_destroy_notify == NULL) ? NULL : (self->priv->_eject_callback_target_destroy_notify (self->priv->_eject_callback_target), NULL);
#line 189 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		self->priv->_eject_callback = NULL;
#line 189 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		self->priv->_eject_callback_target = NULL;
#line 189 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		self->priv->_eject_callback_target_destroy_notify = NULL;
#line 189 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		self->priv->_eject_callback = callback;
#line 189 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		self->priv->_eject_callback_target = callback_target;
#line 189 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		self->priv->_eject_callback_target_destroy_notify = NULL;
#line 190 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		_tmp1_ = self->priv->vol;
#line 190 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		g_volume_eject (_tmp1_, G_MOUNT_UNMOUNT_NONE, NULL, _desktop_agnostic_vfs_volume_gio_on_eject_gasync_ready_callback, g_object_ref (self));
#line 728 "vfs-volume-impl-gio.c"
	}
}

static gboolean
desktop_agnostic_vfs_volume_gio_real_eject_finish (DesktopAgnosticVFSVolume* base,
                                                   GError** error)
{
	DesktopAgnosticVFSVolumeGIO * self;
	gboolean _result_ = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 193 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	self = (DesktopAgnosticVFSVolumeGIO*) base;
#line 195 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_result_ = FALSE;
#line 744 "vfs-volume-impl-gio.c"
	{
		gboolean _tmp0_ = FALSE;
		GVolume* _tmp1_;
		GAsyncResult* _tmp2_;
#line 198 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		_tmp1_ = self->priv->vol;
#line 198 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		_tmp2_ = self->priv->async_result;
#line 198 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		_tmp0_ = g_volume_eject_finish (_tmp1_, _tmp2_, &_inner_error0_);
#line 198 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 757 "vfs-volume-impl-gio.c"
			goto __catch0_g_error;
		}
#line 198 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		_result_ = _tmp0_;
#line 762 "vfs-volume-impl-gio.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
		GError* _tmp5_;
#line 196 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		err = _inner_error0_;
#line 196 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		_inner_error0_ = NULL;
#line 202 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		_tmp3_ = err;
#line 202 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		_tmp4_ = _tmp3_->message;
#line 202 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		_tmp5_ = g_error_new_literal (DESKTOP_AGNOSTIC_VFS_VOLUME_ERROR, DESKTOP_AGNOSTIC_VFS_VOLUME_ERROR_EJECT, _tmp4_);
#line 202 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		_inner_error0_ = _tmp5_;
#line 202 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		_g_error_free0 (err);
#line 785 "vfs-volume-impl-gio.c"
		goto __finally0;
	}
	__finally0:
#line 196 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 196 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		if (_inner_error0_->domain == DESKTOP_AGNOSTIC_VFS_VOLUME_ERROR) {
#line 793 "vfs-volume-impl-gio.c"
			gboolean _tmp6_ = FALSE;
#line 196 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
			g_propagate_error (error, _inner_error0_);
#line 196 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
			return _tmp6_;
#line 799 "vfs-volume-impl-gio.c"
		} else {
			gboolean _tmp7_ = FALSE;
#line 196 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 196 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
			g_clear_error (&_inner_error0_);
#line 196 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
			return _tmp7_;
#line 808 "vfs-volume-impl-gio.c"
		}
	}
#line 204 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_g_object_unref0 (self->priv->async_result);
#line 204 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	self->priv->async_result = NULL;
#line 205 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	result = _result_;
#line 205 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	return result;
#line 819 "vfs-volume-impl-gio.c"
}

DesktopAgnosticVFSVolumeGIO*
desktop_agnostic_vfs_volume_gio_construct (GType object_type)
{
	DesktopAgnosticVFSVolumeGIO * self = NULL;
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	self = (DesktopAgnosticVFSVolumeGIO*) g_object_new (object_type, NULL);
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	return self;
#line 830 "vfs-volume-impl-gio.c"
}

DesktopAgnosticVFSVolumeGIO*
desktop_agnostic_vfs_volume_gio_new (void)
{
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	return desktop_agnostic_vfs_volume_gio_construct (DESKTOP_AGNOSTIC_VFS_TYPE_VOLUME_GIO);
#line 838 "vfs-volume-impl-gio.c"
}

static void
desktop_agnostic_vfs_volume_gio_set_implementation (DesktopAgnosticVFSVolumeGIO* self,
                                                    GVolume* value)
{
	GVolume* _tmp0_;
#line 33 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	g_return_if_fail (self != NULL);
#line 35 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 35 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_g_object_unref0 (self->priv->vol);
#line 35 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	self->priv->vol = _tmp0_;
#line 33 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	g_object_notify_by_pspec ((GObject *) self, desktop_agnostic_vfs_volume_gio_properties[DESKTOP_AGNOSTIC_VFS_VOLUME_GIO_IMPLEMENTATION_PROPERTY]);
#line 856 "vfs-volume-impl-gio.c"
}

static gchar*
desktop_agnostic_vfs_volume_gio_real_get_name (DesktopAgnosticVFSVolume* base)
{
	gchar* result;
	DesktopAgnosticVFSVolumeGIO* self;
	const gchar* _tmp0_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
#line 40 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	self = (DesktopAgnosticVFSVolumeGIO*) base;
#line 42 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_tmp0_ = self->priv->_name;
#line 42 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	if (_tmp0_ == NULL) {
#line 873 "vfs-volume-impl-gio.c"
		GVolume* _tmp1_;
		gchar* _tmp2_;
#line 43 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		_tmp1_ = self->priv->vol;
#line 43 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		_tmp2_ = g_volume_get_name (_tmp1_);
#line 43 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		_g_free0 (self->priv->_name);
#line 43 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		self->priv->_name = (gchar*) _tmp2_;
#line 884 "vfs-volume-impl-gio.c"
	}
#line 44 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_tmp3_ = self->priv->_name;
#line 44 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_tmp4_ = g_strdup (_tmp3_);
#line 44 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	result = _tmp4_;
#line 44 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	return result;
#line 894 "vfs-volume-impl-gio.c"
}

static DesktopAgnosticVFSFile*
desktop_agnostic_vfs_volume_gio_real_get_uri (DesktopAgnosticVFSVolume* base)
{
	DesktopAgnosticVFSFile* result;
	DesktopAgnosticVFSVolumeGIO* self;
	DesktopAgnosticVFSFile* _tmp0_;
	DesktopAgnosticVFSFile* _tmp13_;
	GError* _inner_error0_ = NULL;
#line 50 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	self = (DesktopAgnosticVFSVolumeGIO*) base;
#line 52 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_tmp0_ = self->priv->_uri;
#line 52 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	if (_tmp0_ == NULL) {
#line 911 "vfs-volume-impl-gio.c"
		GMount* mount = NULL;
		GVolume* _tmp1_;
		GMount* _tmp2_;
		GMount* _tmp3_;
#line 54 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		_tmp1_ = self->priv->vol;
#line 54 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		_tmp2_ = g_volume_get_mount (_tmp1_);
#line 54 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		mount = _tmp2_;
#line 55 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		_tmp3_ = mount;
#line 55 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		if (_tmp3_ != NULL) {
#line 926 "vfs-volume-impl-gio.c"
			GFile* file = NULL;
			GMount* _tmp4_;
			GFile* _tmp5_;
			DesktopAgnosticVFSFile* _tmp6_ = NULL;
			GFile* _tmp7_;
			gchar* _tmp8_;
			gchar* _tmp9_;
			DesktopAgnosticVFSFile* _tmp10_;
			DesktopAgnosticVFSFile* _tmp11_;
			DesktopAgnosticVFSFile* _tmp12_;
#line 57 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
			_tmp4_ = mount;
#line 57 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
			_tmp5_ = g_mount_get_root (_tmp4_);
#line 57 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
			file = _tmp5_;
#line 58 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
			_tmp7_ = file;
#line 58 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
			_tmp8_ = g_file_get_uri (_tmp7_);
#line 58 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
			_tmp9_ = _tmp8_;
#line 58 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
			_tmp10_ = desktop_agnostic_vfs_file_new_for_uri (_tmp9_, &_inner_error0_);
#line 58 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
			_tmp11_ = _tmp10_;
#line 58 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
			_g_free0 (_tmp9_);
#line 58 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
			_tmp6_ = _tmp11_;
#line 58 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 58 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
				_g_object_unref0 (file);
#line 58 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
				_g_object_unref0 (mount);
#line 58 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 58 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
				g_clear_error (&_inner_error0_);
#line 58 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
				return NULL;
#line 969 "vfs-volume-impl-gio.c"
			}
#line 58 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
			_tmp12_ = _tmp6_;
#line 58 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
			_tmp6_ = NULL;
#line 58 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
			_g_object_unref0 (self->priv->_uri);
#line 58 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
			self->priv->_uri = _tmp12_;
#line 55 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
			_g_object_unref0 (_tmp6_);
#line 55 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
			_g_object_unref0 (file);
#line 983 "vfs-volume-impl-gio.c"
		}
#line 52 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		_g_object_unref0 (mount);
#line 987 "vfs-volume-impl-gio.c"
	}
#line 61 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_tmp13_ = self->priv->_uri;
#line 61 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	result = _tmp13_;
#line 61 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	return result;
#line 995 "vfs-volume-impl-gio.c"
}

static gchar*
desktop_agnostic_vfs_volume_gio_real_get_icon (DesktopAgnosticVFSVolume* base)
{
	gchar* result;
	DesktopAgnosticVFSVolumeGIO* self;
	const gchar* _tmp0_;
	const gchar* _tmp21_;
	gchar* _tmp22_;
#line 67 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	self = (DesktopAgnosticVFSVolumeGIO*) base;
#line 69 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_tmp0_ = self->priv->_icon;
#line 69 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	if (_tmp0_ == NULL) {
#line 1012 "vfs-volume-impl-gio.c"
		GIcon* icon = NULL;
		GVolume* _tmp1_;
		GIcon* _tmp2_;
		GIcon* _tmp3_;
#line 71 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		_tmp1_ = self->priv->vol;
#line 71 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		_tmp2_ = g_volume_get_icon (_tmp1_);
#line 71 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		icon = _tmp2_;
#line 72 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		_tmp3_ = icon;
#line 72 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp3_, g_themed_icon_get_type ())) {
#line 1027 "vfs-volume-impl-gio.c"
			gchar** icon_names = NULL;
			GIcon* _tmp4_;
			gchar** _tmp5_;
			gchar** _tmp6_;
			gint icon_names_length1;
			gint _icon_names_size_;
			gchar** _tmp7_;
			gint _tmp7__length1;
#line 74 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
			_tmp4_ = icon;
#line 74 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
			_tmp6_ = _tmp5_ = g_themed_icon_get_names (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, g_themed_icon_get_type (), GThemedIcon));
#line 74 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
			icon_names = (gchar**) _tmp6_;
#line 74 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
			icon_names_length1 = (_vala_array_length (_tmp5_) * sizeof (gchar*)) / sizeof (gchar*);
#line 74 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
			_icon_names_size_ = icon_names_length1;
#line 75 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
			_tmp7_ = icon_names;
#line 75 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
			_tmp7__length1 = icon_names_length1;
#line 75 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
			if (_tmp7__length1 > 0) {
#line 1052 "vfs-volume-impl-gio.c"
				gchar** _tmp8_;
				gint _tmp8__length1;
				const gchar* _tmp9_;
				gchar* _tmp10_;
#line 77 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
				_tmp8_ = icon_names;
#line 77 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
				_tmp8__length1 = icon_names_length1;
#line 77 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
				_tmp9_ = _tmp8_[0];
#line 77 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
				_tmp10_ = g_strdup (_tmp9_);
#line 77 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
				_g_free0 (self->priv->_icon);
#line 77 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
				self->priv->_icon = _tmp10_;
#line 1069 "vfs-volume-impl-gio.c"
			} else {
				gchar* _tmp11_;
#line 82 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
				_tmp11_ = g_strdup ("drive-harddisk");
#line 82 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
				_g_free0 (self->priv->_icon);
#line 82 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
				self->priv->_icon = _tmp11_;
#line 1078 "vfs-volume-impl-gio.c"
			}
		} else {
			GIcon* _tmp12_;
#line 85 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
			_tmp12_ = icon;
#line 85 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
			if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp12_, g_file_icon_get_type ())) {
#line 1086 "vfs-volume-impl-gio.c"
				gchar* path = NULL;
				GIcon* _tmp13_;
				GFile* _tmp14_;
				gchar* _tmp15_;
				const gchar* _tmp16_;
				gchar* _tmp17_;
#line 87 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
				_tmp13_ = icon;
#line 87 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
				_tmp14_ = g_file_icon_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, g_file_icon_get_type (), GFileIcon));
#line 87 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
				_tmp15_ = g_file_get_path (_tmp14_);
#line 87 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
				path = _tmp15_;
#line 88 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
				_tmp16_ = path;
#line 88 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
				_tmp17_ = g_strdup (_tmp16_);
#line 88 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
				_g_free0 (self->priv->_icon);
#line 88 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
				self->priv->_icon = _tmp17_;
#line 85 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
				_g_free0 (path);
#line 1111 "vfs-volume-impl-gio.c"
			} else {
				GIcon* _tmp18_;
				const gchar* _tmp19_;
				gchar* _tmp20_;
#line 93 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
				_tmp18_ = icon;
#line 93 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
				_tmp19_ = g_type_name (G_TYPE_FROM_INSTANCE ((GObject*) _tmp18_));
#line 93 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
				g_warning ("vfs-volume-impl-gio.vala:93: Unknown icon type: %s", _tmp19_);
#line 94 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
				_tmp20_ = g_strdup ("drive-harddisk");
#line 94 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
				_g_free0 (self->priv->_icon);
#line 94 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
				self->priv->_icon = _tmp20_;
#line 1128 "vfs-volume-impl-gio.c"
			}
		}
#line 69 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		_g_object_unref0 (icon);
#line 1133 "vfs-volume-impl-gio.c"
	}
#line 97 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_tmp21_ = self->priv->_icon;
#line 97 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_tmp22_ = g_strdup (_tmp21_);
#line 97 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	result = _tmp22_;
#line 97 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	return result;
#line 1143 "vfs-volume-impl-gio.c"
}

static void
desktop_agnostic_vfs_volume_gio_class_init (DesktopAgnosticVFSVolumeGIOClass * klass,
                                            gpointer klass_data)
{
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	desktop_agnostic_vfs_volume_gio_parent_class = g_type_class_peek_parent (klass);
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	g_type_class_adjust_private_offset (klass, &DesktopAgnosticVFSVolumeGIO_private_offset);
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_desktop_agnostic_vfs_volume_gio_get_property;
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_desktop_agnostic_vfs_volume_gio_set_property;
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	G_OBJECT_CLASS (klass)->finalize = desktop_agnostic_vfs_volume_gio_finalize;
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DESKTOP_AGNOSTIC_VFS_VOLUME_GIO_IMPLEMENTATION_PROPERTY, desktop_agnostic_vfs_volume_gio_properties[DESKTOP_AGNOSTIC_VFS_VOLUME_GIO_IMPLEMENTATION_PROPERTY] = g_param_spec_object ("implementation", "implementation", "implementation", g_volume_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DESKTOP_AGNOSTIC_VFS_VOLUME_GIO_NAME_PROPERTY, desktop_agnostic_vfs_volume_gio_properties[DESKTOP_AGNOSTIC_VFS_VOLUME_GIO_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DESKTOP_AGNOSTIC_VFS_VOLUME_GIO_URI_PROPERTY, desktop_agnostic_vfs_volume_gio_properties[DESKTOP_AGNOSTIC_VFS_VOLUME_GIO_URI_PROPERTY] = g_param_spec_object ("uri", "uri", "uri", DESKTOP_AGNOSTIC_VFS_TYPE_FILE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DESKTOP_AGNOSTIC_VFS_VOLUME_GIO_ICON_PROPERTY, desktop_agnostic_vfs_volume_gio_properties[DESKTOP_AGNOSTIC_VFS_VOLUME_GIO_ICON_PROPERTY] = g_param_spec_string ("icon", "icon", "icon", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1168 "vfs-volume-impl-gio.c"
}

static void
desktop_agnostic_vfs_volume_gio_desktop_agnostic_vfs_volume_interface_init (DesktopAgnosticVFSVolumeIface * iface,
                                                                            gpointer iface_data)
{
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	desktop_agnostic_vfs_volume_gio_desktop_agnostic_vfs_volume_parent_iface = g_type_interface_peek_parent (iface);
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	iface->is_mounted = (gboolean (*) (DesktopAgnosticVFSVolume*)) desktop_agnostic_vfs_volume_gio_real_is_mounted;
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	iface->mount = (void (*) (DesktopAgnosticVFSVolume*, DesktopAgnosticVFSVolumeCallback, gpointer)) desktop_agnostic_vfs_volume_gio_real_mount;
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	iface->mount_finish = (gboolean (*) (DesktopAgnosticVFSVolume*, GError**)) desktop_agnostic_vfs_volume_gio_real_mount_finish;
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	iface->unmount = (void (*) (DesktopAgnosticVFSVolume*, DesktopAgnosticVFSVolumeCallback, gpointer)) desktop_agnostic_vfs_volume_gio_real_unmount;
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	iface->unmount_finish = (gboolean (*) (DesktopAgnosticVFSVolume*, GError**)) desktop_agnostic_vfs_volume_gio_real_unmount_finish;
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	iface->can_eject = (gboolean (*) (DesktopAgnosticVFSVolume*)) desktop_agnostic_vfs_volume_gio_real_can_eject;
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	iface->eject = (void (*) (DesktopAgnosticVFSVolume*, DesktopAgnosticVFSVolumeCallback, gpointer)) desktop_agnostic_vfs_volume_gio_real_eject;
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	iface->eject_finish = (gboolean (*) (DesktopAgnosticVFSVolume*, GError**)) desktop_agnostic_vfs_volume_gio_real_eject_finish;
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	iface->get_name = desktop_agnostic_vfs_volume_gio_real_get_name;
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	iface->get_uri = desktop_agnostic_vfs_volume_gio_real_get_uri;
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	iface->get_icon = desktop_agnostic_vfs_volume_gio_real_get_icon;
#line 1199 "vfs-volume-impl-gio.c"
}

static void
desktop_agnostic_vfs_volume_gio_instance_init (DesktopAgnosticVFSVolumeGIO * self,
                                               gpointer klass)
{
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	self->priv = desktop_agnostic_vfs_volume_gio_get_instance_private (self);
#line 1208 "vfs-volume-impl-gio.c"
}

static void
desktop_agnostic_vfs_volume_gio_finalize (GObject * obj)
{
	DesktopAgnosticVFSVolumeGIO * self;
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DESKTOP_AGNOSTIC_VFS_TYPE_VOLUME_GIO, DesktopAgnosticVFSVolumeGIO);
#line 29 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_g_object_unref0 (self->priv->vol);
#line 30 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_g_free0 (self->priv->_name);
#line 47 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_g_object_unref0 (self->priv->_uri);
#line 64 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_g_free0 (self->priv->_icon);
#line 105 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	(self->priv->_mount_callback_target_destroy_notify == NULL) ? NULL : (self->priv->_mount_callback_target_destroy_notify (self->priv->_mount_callback_target), NULL);
#line 105 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	self->priv->_mount_callback = NULL;
#line 105 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	self->priv->_mount_callback_target = NULL;
#line 105 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	self->priv->_mount_callback_target_destroy_notify = NULL;
#line 106 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_g_object_unref0 (self->priv->async_result);
#line 136 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	(self->priv->_unmount_callback_target_destroy_notify == NULL) ? NULL : (self->priv->_unmount_callback_target_destroy_notify (self->priv->_unmount_callback_target), NULL);
#line 136 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	self->priv->_unmount_callback = NULL;
#line 136 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	self->priv->_unmount_callback_target = NULL;
#line 136 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	self->priv->_unmount_callback_target_destroy_notify = NULL;
#line 176 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	(self->priv->_eject_callback_target_destroy_notify == NULL) ? NULL : (self->priv->_eject_callback_target_destroy_notify (self->priv->_eject_callback_target), NULL);
#line 176 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	self->priv->_eject_callback = NULL;
#line 176 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	self->priv->_eject_callback_target = NULL;
#line 176 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	self->priv->_eject_callback_target_destroy_notify = NULL;
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	G_OBJECT_CLASS (desktop_agnostic_vfs_volume_gio_parent_class)->finalize (obj);
#line 1253 "vfs-volume-impl-gio.c"
}

static GType
desktop_agnostic_vfs_volume_gio_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DesktopAgnosticVFSVolumeGIOClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) desktop_agnostic_vfs_volume_gio_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DesktopAgnosticVFSVolumeGIO), 0, (GInstanceInitFunc) desktop_agnostic_vfs_volume_gio_instance_init, NULL };
	static const GInterfaceInfo desktop_agnostic_vfs_volume_info = { (GInterfaceInitFunc) desktop_agnostic_vfs_volume_gio_desktop_agnostic_vfs_volume_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType desktop_agnostic_vfs_volume_gio_type_id;
	desktop_agnostic_vfs_volume_gio_type_id = g_type_register_static (G_TYPE_OBJECT, "DesktopAgnosticVFSVolumeGIO", &g_define_type_info, 0);
	g_type_add_interface_static (desktop_agnostic_vfs_volume_gio_type_id, DESKTOP_AGNOSTIC_VFS_TYPE_VOLUME, &desktop_agnostic_vfs_volume_info);
	DesktopAgnosticVFSVolumeGIO_private_offset = g_type_add_instance_private (desktop_agnostic_vfs_volume_gio_type_id, sizeof (DesktopAgnosticVFSVolumeGIOPrivate));
	return desktop_agnostic_vfs_volume_gio_type_id;
}

GType
desktop_agnostic_vfs_volume_gio_get_type (void)
{
	static volatile gsize desktop_agnostic_vfs_volume_gio_type_id__once = 0;
	if (g_once_init_enter (&desktop_agnostic_vfs_volume_gio_type_id__once)) {
		GType desktop_agnostic_vfs_volume_gio_type_id;
		desktop_agnostic_vfs_volume_gio_type_id = desktop_agnostic_vfs_volume_gio_get_type_once ();
		g_once_init_leave (&desktop_agnostic_vfs_volume_gio_type_id__once, desktop_agnostic_vfs_volume_gio_type_id);
	}
	return desktop_agnostic_vfs_volume_gio_type_id__once;
}

static void
_vala_desktop_agnostic_vfs_volume_gio_get_property (GObject * object,
                                                    guint property_id,
                                                    GValue * value,
                                                    GParamSpec * pspec)
{
	DesktopAgnosticVFSVolumeGIO * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DESKTOP_AGNOSTIC_VFS_TYPE_VOLUME_GIO, DesktopAgnosticVFSVolumeGIO);
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	switch (property_id) {
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		case DESKTOP_AGNOSTIC_VFS_VOLUME_GIO_NAME_PROPERTY:
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		g_value_take_string (value, desktop_agnostic_vfs_volume_get_name ((DesktopAgnosticVFSVolume*) self));
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		break;
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		case DESKTOP_AGNOSTIC_VFS_VOLUME_GIO_URI_PROPERTY:
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		g_value_set_object (value, desktop_agnostic_vfs_volume_get_uri ((DesktopAgnosticVFSVolume*) self));
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		break;
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		case DESKTOP_AGNOSTIC_VFS_VOLUME_GIO_ICON_PROPERTY:
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		g_value_take_string (value, desktop_agnostic_vfs_volume_get_icon ((DesktopAgnosticVFSVolume*) self));
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		break;
#line 1308 "vfs-volume-impl-gio.c"
		default:
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		break;
#line 1314 "vfs-volume-impl-gio.c"
	}
}

static void
_vala_desktop_agnostic_vfs_volume_gio_set_property (GObject * object,
                                                    guint property_id,
                                                    const GValue * value,
                                                    GParamSpec * pspec)
{
	DesktopAgnosticVFSVolumeGIO * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DESKTOP_AGNOSTIC_VFS_TYPE_VOLUME_GIO, DesktopAgnosticVFSVolumeGIO);
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	switch (property_id) {
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		case DESKTOP_AGNOSTIC_VFS_VOLUME_GIO_IMPLEMENTATION_PROPERTY:
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		desktop_agnostic_vfs_volume_gio_set_implementation (self, g_value_get_object (value));
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		break;
#line 1334 "vfs-volume-impl-gio.c"
		default:
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		break;
#line 1340 "vfs-volume-impl-gio.c"
	}
}

static inline gpointer
desktop_agnostic_vfs_volume_monitor_gio_get_instance_private (DesktopAgnosticVFSVolumeMonitorGIO* self)
{
	return G_STRUCT_MEMBER_P (self, DesktopAgnosticVFSVolumeMonitorGIO_private_offset);
}

static DesktopAgnosticVFSVolume*
desktop_agnostic_vfs_volume_monitor_gio_create_volume (DesktopAgnosticVFSVolumeMonitorGIO* self,
                                                       GVolume* vol)
{
	GObject* _tmp0_;
	GObject* _tmp1_;
	DesktopAgnosticVFSVolume* result;
#line 228 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 228 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	g_return_val_if_fail (vol != NULL, NULL);
#line 231 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_tmp0_ = g_object_new (DESKTOP_AGNOSTIC_VFS_TYPE_VOLUME_GIO, "implementation", vol, NULL);
#line 231 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_tmp1_ = G_IS_INITIALLY_UNOWNED (_tmp0_) ? g_object_ref_sink (_tmp0_) : _tmp0_;
#line 231 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, DESKTOP_AGNOSTIC_VFS_TYPE_VOLUME, DesktopAgnosticVFSVolume);
#line 231 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	return result;
#line 1369 "vfs-volume-impl-gio.c"
}

static DesktopAgnosticVFSVolume*
desktop_agnostic_vfs_volume_monitor_gio_check_volume (DesktopAgnosticVFSVolumeMonitorGIO* self,
                                                      GVolume* gvol)
{
	DesktopAgnosticVFSVolume* vol = NULL;
	GHashTable* _tmp0_;
	gconstpointer _tmp1_;
	DesktopAgnosticVFSVolume* _tmp2_;
	DesktopAgnosticVFSVolume* _tmp3_;
	DesktopAgnosticVFSVolume* result;
#line 234 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 234 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	g_return_val_if_fail (gvol != NULL, NULL);
#line 237 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_tmp0_ = self->priv->_volumes;
#line 237 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_tmp1_ = g_hash_table_lookup (_tmp0_, gvol);
#line 237 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_tmp2_ = _g_object_ref0 ((DesktopAgnosticVFSVolume*) _tmp1_);
#line 237 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	vol = _tmp2_;
#line 238 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_tmp3_ = vol;
#line 238 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	if (_tmp3_ == NULL) {
#line 1398 "vfs-volume-impl-gio.c"
		DesktopAgnosticVFSVolume* _tmp4_;
		GHashTable* _tmp5_;
		GVolume* _tmp6_;
		DesktopAgnosticVFSVolume* _tmp7_;
		DesktopAgnosticVFSVolume* _tmp8_;
#line 240 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		_tmp4_ = desktop_agnostic_vfs_volume_monitor_gio_create_volume (self, gvol);
#line 240 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		_g_object_unref0 (vol);
#line 240 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		vol = _tmp4_;
#line 241 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		_tmp5_ = self->priv->_volumes;
#line 241 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		_tmp6_ = _g_object_ref0 (gvol);
#line 241 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		_tmp7_ = vol;
#line 241 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		_tmp8_ = _g_object_ref0 (_tmp7_);
#line 241 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		g_hash_table_insert (_tmp5_, _tmp6_, _tmp8_);
#line 1420 "vfs-volume-impl-gio.c"
	}
#line 243 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	result = vol;
#line 243 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	return result;
#line 1426 "vfs-volume-impl-gio.c"
}

static DesktopAgnosticVFSVolume*
desktop_agnostic_vfs_volume_monitor_gio_get_volume_from_mount (DesktopAgnosticVFSVolumeMonitorGIO* self,
                                                               GMount* mount)
{
	GVolume* gvol = NULL;
	GVolume* _tmp0_;
	GVolume* _tmp1_;
	DesktopAgnosticVFSVolume* result;
#line 245 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 245 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	g_return_val_if_fail (mount != NULL, NULL);
#line 248 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_tmp0_ = g_mount_get_volume (mount);
#line 248 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	gvol = _tmp0_;
#line 249 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_tmp1_ = gvol;
#line 249 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	if (_tmp1_ == NULL) {
#line 251 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		result = NULL;
#line 251 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		_g_object_unref0 (gvol);
#line 251 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		return result;
#line 1455 "vfs-volume-impl-gio.c"
	} else {
		GVolume* _tmp2_;
		DesktopAgnosticVFSVolume* _tmp3_;
#line 255 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		_tmp2_ = gvol;
#line 255 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		_tmp3_ = desktop_agnostic_vfs_volume_monitor_gio_check_volume (self, _tmp2_);
#line 255 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		result = _tmp3_;
#line 255 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		_g_object_unref0 (gvol);
#line 255 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		return result;
#line 1469 "vfs-volume-impl-gio.c"
	}
}

static void
desktop_agnostic_vfs_volume_monitor_gio_on_mount_added (DesktopAgnosticVFSVolumeMonitorGIO* self,
                                                        GVolumeMonitor* vmonitor,
                                                        GMount* mount)
{
	DesktopAgnosticVFSVolume* volume = NULL;
	DesktopAgnosticVFSVolume* _tmp0_;
	DesktopAgnosticVFSVolume* _tmp1_;
#line 258 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	g_return_if_fail (self != NULL);
#line 258 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	g_return_if_fail (vmonitor != NULL);
#line 258 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	g_return_if_fail (mount != NULL);
#line 261 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_tmp0_ = desktop_agnostic_vfs_volume_monitor_gio_get_volume_from_mount (self, mount);
#line 261 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	volume = _tmp0_;
#line 262 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_tmp1_ = volume;
#line 262 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	if (_tmp1_ != NULL) {
#line 1495 "vfs-volume-impl-gio.c"
		DesktopAgnosticVFSVolume* _tmp2_;
#line 264 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		_tmp2_ = volume;
#line 264 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		g_signal_emit_by_name ((DesktopAgnosticVFSVolumeMonitor*) self, "volume-mounted", _tmp2_);
#line 1501 "vfs-volume-impl-gio.c"
	}
#line 258 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_g_object_unref0 (volume);
#line 1505 "vfs-volume-impl-gio.c"
}

static void
desktop_agnostic_vfs_volume_monitor_gio_on_mount_removed (DesktopAgnosticVFSVolumeMonitorGIO* self,
                                                          GVolumeMonitor* vmonitor,
                                                          GMount* mount)
{
	DesktopAgnosticVFSVolume* volume = NULL;
	DesktopAgnosticVFSVolume* _tmp0_;
	DesktopAgnosticVFSVolume* _tmp1_;
#line 267 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	g_return_if_fail (self != NULL);
#line 267 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	g_return_if_fail (vmonitor != NULL);
#line 267 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	g_return_if_fail (mount != NULL);
#line 270 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_tmp0_ = desktop_agnostic_vfs_volume_monitor_gio_get_volume_from_mount (self, mount);
#line 270 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	volume = _tmp0_;
#line 271 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_tmp1_ = volume;
#line 271 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	if (_tmp1_ != NULL) {
#line 1530 "vfs-volume-impl-gio.c"
		DesktopAgnosticVFSVolume* _tmp2_;
#line 273 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		_tmp2_ = volume;
#line 273 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		g_signal_emit_by_name ((DesktopAgnosticVFSVolumeMonitor*) self, "volume-unmounted", _tmp2_);
#line 1536 "vfs-volume-impl-gio.c"
	}
#line 267 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_g_object_unref0 (volume);
#line 1540 "vfs-volume-impl-gio.c"
}

static void
desktop_agnostic_vfs_volume_monitor_gio_on_volume_added (DesktopAgnosticVFSVolumeMonitorGIO* self,
                                                         GVolumeMonitor* vmonitor,
                                                         GVolume* gvol)
{
	DesktopAgnosticVFSVolume* _tmp0_;
	DesktopAgnosticVFSVolume* _tmp1_;
#line 276 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	g_return_if_fail (self != NULL);
#line 276 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	g_return_if_fail (vmonitor != NULL);
#line 276 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	g_return_if_fail (gvol != NULL);
#line 279 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_tmp0_ = desktop_agnostic_vfs_volume_monitor_gio_check_volume (self, gvol);
#line 279 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_tmp1_ = _tmp0_;
#line 279 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_g_object_unref0 (_tmp1_);
#line 1562 "vfs-volume-impl-gio.c"
}

static void
desktop_agnostic_vfs_volume_monitor_gio_on_volume_removed (DesktopAgnosticVFSVolumeMonitorGIO* self,
                                                           GVolumeMonitor* vmonitor,
                                                           GVolume* gvol)
{
	DesktopAgnosticVFSVolume* vol = NULL;
	GHashTable* _tmp0_;
	gconstpointer _tmp1_;
	DesktopAgnosticVFSVolume* _tmp2_;
	DesktopAgnosticVFSVolume* _tmp3_;
#line 281 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	g_return_if_fail (self != NULL);
#line 281 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	g_return_if_fail (vmonitor != NULL);
#line 281 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	g_return_if_fail (gvol != NULL);
#line 284 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_tmp0_ = self->priv->_volumes;
#line 284 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_tmp1_ = g_hash_table_lookup (_tmp0_, gvol);
#line 284 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_tmp2_ = _g_object_ref0 ((DesktopAgnosticVFSVolume*) _tmp1_);
#line 284 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	vol = _tmp2_;
#line 285 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_tmp3_ = vol;
#line 285 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	if (_tmp3_ != NULL) {
#line 1593 "vfs-volume-impl-gio.c"
		GHashTable* _tmp4_;
		DesktopAgnosticVFSVolume* _tmp5_;
#line 287 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		_tmp4_ = self->priv->_volumes;
#line 287 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		g_hash_table_remove (_tmp4_, gvol);
#line 288 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		_tmp5_ = vol;
#line 288 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		g_signal_emit_by_name ((DesktopAgnosticVFSVolumeMonitor*) self, "volume-unmounted", _tmp5_);
#line 1604 "vfs-volume-impl-gio.c"
	}
#line 281 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_g_object_unref0 (vol);
#line 1608 "vfs-volume-impl-gio.c"
}

DesktopAgnosticVFSVolumeMonitorGIO*
desktop_agnostic_vfs_volume_monitor_gio_construct (GType object_type)
{
	DesktopAgnosticVFSVolumeMonitorGIO * self = NULL;
#line 208 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	self = (DesktopAgnosticVFSVolumeMonitorGIO*) g_object_new (object_type, NULL);
#line 208 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	return self;
#line 1619 "vfs-volume-impl-gio.c"
}

DesktopAgnosticVFSVolumeMonitorGIO*
desktop_agnostic_vfs_volume_monitor_gio_new (void)
{
#line 208 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	return desktop_agnostic_vfs_volume_monitor_gio_construct (DESKTOP_AGNOSTIC_VFS_TYPE_VOLUME_MONITOR_GIO);
#line 1627 "vfs-volume-impl-gio.c"
}

static void*
desktop_agnostic_vfs_volume_monitor_gio_real_get_implementation (DesktopAgnosticVFSVolumeMonitor* base)
{
	void* result;
	DesktopAgnosticVFSVolumeMonitorGIO* self;
	GVolumeMonitor* _tmp0_;
#line 293 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	self = (DesktopAgnosticVFSVolumeMonitorGIO*) base;
#line 295 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_tmp0_ = self->priv->monitor;
#line 295 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	result = (void*) _tmp0_;
#line 295 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	return result;
#line 1644 "vfs-volume-impl-gio.c"
}

static GList*
desktop_agnostic_vfs_volume_monitor_gio_real_get_volumes (DesktopAgnosticVFSVolumeMonitor* base)
{
	GList* result;
	DesktopAgnosticVFSVolumeMonitorGIO* self;
	GHashTable* _tmp0_;
	GList* _tmp1_;
#line 300 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	self = (DesktopAgnosticVFSVolumeMonitorGIO*) base;
#line 302 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_tmp0_ = self->priv->_volumes;
#line 302 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_tmp1_ = g_hash_table_get_values (_tmp0_);
#line 302 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	result = _tmp1_;
#line 302 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	return result;
#line 1664 "vfs-volume-impl-gio.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 215 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 1672 "vfs-volume-impl-gio.c"
}

static void
_desktop_agnostic_vfs_volume_monitor_gio_on_mount_added_g_volume_monitor_mount_added (GVolumeMonitor* _sender,
                                                                                      GMount* mount,
                                                                                      gpointer self)
{
#line 223 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	desktop_agnostic_vfs_volume_monitor_gio_on_mount_added ((DesktopAgnosticVFSVolumeMonitorGIO*) self, _sender, mount);
#line 1682 "vfs-volume-impl-gio.c"
}

static void
_desktop_agnostic_vfs_volume_monitor_gio_on_mount_removed_g_volume_monitor_mount_removed (GVolumeMonitor* _sender,
                                                                                          GMount* mount,
                                                                                          gpointer self)
{
#line 224 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	desktop_agnostic_vfs_volume_monitor_gio_on_mount_removed ((DesktopAgnosticVFSVolumeMonitorGIO*) self, _sender, mount);
#line 1692 "vfs-volume-impl-gio.c"
}

static void
_desktop_agnostic_vfs_volume_monitor_gio_on_volume_added_g_volume_monitor_volume_added (GVolumeMonitor* _sender,
                                                                                        GVolume* volume,
                                                                                        gpointer self)
{
#line 225 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	desktop_agnostic_vfs_volume_monitor_gio_on_volume_added ((DesktopAgnosticVFSVolumeMonitorGIO*) self, _sender, volume);
#line 1702 "vfs-volume-impl-gio.c"
}

static void
_desktop_agnostic_vfs_volume_monitor_gio_on_volume_removed_g_volume_monitor_volume_removed (GVolumeMonitor* _sender,
                                                                                            GVolume* volume,
                                                                                            gpointer self)
{
#line 226 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	desktop_agnostic_vfs_volume_monitor_gio_on_volume_removed ((DesktopAgnosticVFSVolumeMonitorGIO*) self, _sender, volume);
#line 1712 "vfs-volume-impl-gio.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 212 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 1720 "vfs-volume-impl-gio.c"
}

static GObject *
desktop_agnostic_vfs_volume_monitor_gio_constructor (GType type,
                                                     guint n_construct_properties,
                                                     GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	DesktopAgnosticVFSVolumeMonitorGIO * self;
	GVolumeMonitor* _tmp0_;
	GHashFunc _tmp1_;
	GEqualFunc _tmp2_;
	GHashTable* _tmp3_;
	GList* vols = NULL;
	GVolumeMonitor* _tmp4_;
	GList* _tmp5_;
	GList* _tmp6_;
	GVolumeMonitor* _tmp14_;
	GVolumeMonitor* _tmp15_;
	GVolumeMonitor* _tmp16_;
	GVolumeMonitor* _tmp17_;
#line 212 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	parent_class = G_OBJECT_CLASS (desktop_agnostic_vfs_volume_monitor_gio_parent_class);
#line 212 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 212 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DESKTOP_AGNOSTIC_VFS_TYPE_VOLUME_MONITOR_GIO, DesktopAgnosticVFSVolumeMonitorGIO);
#line 214 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_tmp0_ = g_volume_monitor_get ();
#line 214 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_g_object_unref0 (self->priv->monitor);
#line 214 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	self->priv->monitor = _tmp0_;
#line 215 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_tmp1_ = g_direct_hash;
#line 215 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_tmp2_ = g_direct_equal;
#line 215 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_tmp3_ = g_hash_table_new_full (_tmp1_, _tmp2_, _g_object_unref0_, _g_object_unref0_);
#line 215 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_g_hash_table_unref0 (self->priv->_volumes);
#line 215 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	self->priv->_volumes = _tmp3_;
#line 217 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_tmp4_ = self->priv->monitor;
#line 217 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_tmp5_ = g_volume_monitor_get_volumes (_tmp4_);
#line 217 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	vols = _tmp5_;
#line 218 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_tmp6_ = vols;
#line 1773 "vfs-volume-impl-gio.c"
	{
		GList* gvol_collection = NULL;
		GList* gvol_it = NULL;
#line 218 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		gvol_collection = _tmp6_;
#line 218 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		for (gvol_it = gvol_collection; gvol_it != NULL; gvol_it = gvol_it->next) {
#line 1781 "vfs-volume-impl-gio.c"
			GVolume* gvol = NULL;
#line 218 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
			gvol = (GVolume*) gvol_it->data;
#line 1785 "vfs-volume-impl-gio.c"
			{
				DesktopAgnosticVFSVolume* vol = NULL;
				GVolume* _tmp7_;
				DesktopAgnosticVFSVolume* _tmp8_;
				GHashTable* _tmp9_;
				GVolume* _tmp10_;
				GVolume* _tmp11_;
				DesktopAgnosticVFSVolume* _tmp12_;
				DesktopAgnosticVFSVolume* _tmp13_;
#line 220 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
				_tmp7_ = gvol;
#line 220 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
				_tmp8_ = desktop_agnostic_vfs_volume_monitor_gio_create_volume (self, _tmp7_);
#line 220 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
				vol = _tmp8_;
#line 221 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
				_tmp9_ = self->priv->_volumes;
#line 221 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
				_tmp10_ = gvol;
#line 221 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
				_tmp11_ = _g_object_ref0 (_tmp10_);
#line 221 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
				_tmp12_ = vol;
#line 221 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
				_tmp13_ = _g_object_ref0 (_tmp12_);
#line 221 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
				g_hash_table_insert (_tmp9_, _tmp11_, _tmp13_);
#line 218 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
				_g_object_unref0 (vol);
#line 1815 "vfs-volume-impl-gio.c"
			}
		}
	}
#line 223 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_tmp14_ = self->priv->monitor;
#line 223 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	g_signal_connect_object (_tmp14_, "mount-added", (GCallback) _desktop_agnostic_vfs_volume_monitor_gio_on_mount_added_g_volume_monitor_mount_added, self, 0);
#line 224 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_tmp15_ = self->priv->monitor;
#line 224 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	g_signal_connect_object (_tmp15_, "mount-removed", (GCallback) _desktop_agnostic_vfs_volume_monitor_gio_on_mount_removed_g_volume_monitor_mount_removed, self, 0);
#line 225 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_tmp16_ = self->priv->monitor;
#line 225 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	g_signal_connect_object (_tmp16_, "volume-added", (GCallback) _desktop_agnostic_vfs_volume_monitor_gio_on_volume_added_g_volume_monitor_volume_added, self, 0);
#line 226 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_tmp17_ = self->priv->monitor;
#line 226 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	g_signal_connect_object (_tmp17_, "volume-removed", (GCallback) _desktop_agnostic_vfs_volume_monitor_gio_on_volume_removed_g_volume_monitor_volume_removed, self, 0);
#line 212 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	(vols == NULL) ? NULL : (vols = (_g_list_free__g_object_unref0_ (vols), NULL));
#line 212 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	return obj;
#line 1839 "vfs-volume-impl-gio.c"
}

static void
desktop_agnostic_vfs_volume_monitor_gio_class_init (DesktopAgnosticVFSVolumeMonitorGIOClass * klass,
                                                    gpointer klass_data)
{
#line 208 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	desktop_agnostic_vfs_volume_monitor_gio_parent_class = g_type_class_peek_parent (klass);
#line 208 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	g_type_class_adjust_private_offset (klass, &DesktopAgnosticVFSVolumeMonitorGIO_private_offset);
#line 208 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_desktop_agnostic_vfs_volume_monitor_gio_get_property;
#line 208 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	G_OBJECT_CLASS (klass)->constructor = desktop_agnostic_vfs_volume_monitor_gio_constructor;
#line 208 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	G_OBJECT_CLASS (klass)->finalize = desktop_agnostic_vfs_volume_monitor_gio_finalize;
#line 208 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DESKTOP_AGNOSTIC_VFS_VOLUME_MONITOR_GIO_IMPLEMENTATION_PROPERTY, desktop_agnostic_vfs_volume_monitor_gio_properties[DESKTOP_AGNOSTIC_VFS_VOLUME_MONITOR_GIO_IMPLEMENTATION_PROPERTY] = g_param_spec_pointer ("implementation", "implementation", "implementation", G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 208 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DESKTOP_AGNOSTIC_VFS_VOLUME_MONITOR_GIO_VOLUMES_PROPERTY, desktop_agnostic_vfs_volume_monitor_gio_properties[DESKTOP_AGNOSTIC_VFS_VOLUME_MONITOR_GIO_VOLUMES_PROPERTY] = g_param_spec_pointer ("volumes", "volumes", "volumes", G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1860 "vfs-volume-impl-gio.c"
}

static void
desktop_agnostic_vfs_volume_monitor_gio_desktop_agnostic_vfs_volume_monitor_interface_init (DesktopAgnosticVFSVolumeMonitorIface * iface,
                                                                                            gpointer iface_data)
{
#line 228 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	desktop_agnostic_vfs_volume_monitor_gio_desktop_agnostic_vfs_volume_monitor_parent_iface = g_type_interface_peek_parent (iface);
#line 228 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	iface->get_implementation = desktop_agnostic_vfs_volume_monitor_gio_real_get_implementation;
#line 228 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	iface->get_volumes = desktop_agnostic_vfs_volume_monitor_gio_real_get_volumes;
#line 1873 "vfs-volume-impl-gio.c"
}

static void
desktop_agnostic_vfs_volume_monitor_gio_instance_init (DesktopAgnosticVFSVolumeMonitorGIO * self,
                                                       gpointer klass)
{
#line 208 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	self->priv = desktop_agnostic_vfs_volume_monitor_gio_get_instance_private (self);
#line 1882 "vfs-volume-impl-gio.c"
}

static void
desktop_agnostic_vfs_volume_monitor_gio_finalize (GObject * obj)
{
	DesktopAgnosticVFSVolumeMonitorGIO * self;
#line 208 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DESKTOP_AGNOSTIC_VFS_TYPE_VOLUME_MONITOR_GIO, DesktopAgnosticVFSVolumeMonitorGIO);
#line 210 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_g_object_unref0 (self->priv->monitor);
#line 211 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	_g_hash_table_unref0 (self->priv->_volumes);
#line 228 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	G_OBJECT_CLASS (desktop_agnostic_vfs_volume_monitor_gio_parent_class)->finalize (obj);
#line 1897 "vfs-volume-impl-gio.c"
}

static GType
desktop_agnostic_vfs_volume_monitor_gio_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DesktopAgnosticVFSVolumeMonitorGIOClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) desktop_agnostic_vfs_volume_monitor_gio_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DesktopAgnosticVFSVolumeMonitorGIO), 0, (GInstanceInitFunc) desktop_agnostic_vfs_volume_monitor_gio_instance_init, NULL };
	static const GInterfaceInfo desktop_agnostic_vfs_volume_monitor_info = { (GInterfaceInitFunc) desktop_agnostic_vfs_volume_monitor_gio_desktop_agnostic_vfs_volume_monitor_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType desktop_agnostic_vfs_volume_monitor_gio_type_id;
	desktop_agnostic_vfs_volume_monitor_gio_type_id = g_type_register_static (G_TYPE_OBJECT, "DesktopAgnosticVFSVolumeMonitorGIO", &g_define_type_info, 0);
	g_type_add_interface_static (desktop_agnostic_vfs_volume_monitor_gio_type_id, DESKTOP_AGNOSTIC_VFS_TYPE_VOLUME_MONITOR, &desktop_agnostic_vfs_volume_monitor_info);
	DesktopAgnosticVFSVolumeMonitorGIO_private_offset = g_type_add_instance_private (desktop_agnostic_vfs_volume_monitor_gio_type_id, sizeof (DesktopAgnosticVFSVolumeMonitorGIOPrivate));
	return desktop_agnostic_vfs_volume_monitor_gio_type_id;
}

GType
desktop_agnostic_vfs_volume_monitor_gio_get_type (void)
{
	static volatile gsize desktop_agnostic_vfs_volume_monitor_gio_type_id__once = 0;
	if (g_once_init_enter (&desktop_agnostic_vfs_volume_monitor_gio_type_id__once)) {
		GType desktop_agnostic_vfs_volume_monitor_gio_type_id;
		desktop_agnostic_vfs_volume_monitor_gio_type_id = desktop_agnostic_vfs_volume_monitor_gio_get_type_once ();
		g_once_init_leave (&desktop_agnostic_vfs_volume_monitor_gio_type_id__once, desktop_agnostic_vfs_volume_monitor_gio_type_id);
	}
	return desktop_agnostic_vfs_volume_monitor_gio_type_id__once;
}

static void
_vala_desktop_agnostic_vfs_volume_monitor_gio_get_property (GObject * object,
                                                            guint property_id,
                                                            GValue * value,
                                                            GParamSpec * pspec)
{
	DesktopAgnosticVFSVolumeMonitorGIO * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DESKTOP_AGNOSTIC_VFS_TYPE_VOLUME_MONITOR_GIO, DesktopAgnosticVFSVolumeMonitorGIO);
#line 208 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	switch (property_id) {
#line 208 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		case DESKTOP_AGNOSTIC_VFS_VOLUME_MONITOR_GIO_IMPLEMENTATION_PROPERTY:
#line 208 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		g_value_set_pointer (value, desktop_agnostic_vfs_volume_monitor_get_implementation ((DesktopAgnosticVFSVolumeMonitor*) self));
#line 208 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		break;
#line 208 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		case DESKTOP_AGNOSTIC_VFS_VOLUME_MONITOR_GIO_VOLUMES_PROPERTY:
#line 208 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		g_value_set_pointer (value, desktop_agnostic_vfs_volume_monitor_get_volumes ((DesktopAgnosticVFSVolumeMonitor*) self));
#line 208 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		break;
#line 1946 "vfs-volume-impl-gio.c"
		default:
#line 208 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 208 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		break;
#line 1952 "vfs-volume-impl-gio.c"
	}
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
#line 208 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	if (array) {
#line 208 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
		while (((gpointer*) array)[length]) {
#line 208 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
			length++;
#line 1967 "vfs-volume-impl-gio.c"
		}
	}
#line 208 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume-impl-gio.vala"
	return length;
#line 1972 "vfs-volume-impl-gio.c"
}

