/* vfs-volume.c generated by valac 0.56.17, the Vala compiler
 * generated from vfs-volume.vala, do not modify */

/*
 * Desktop Agnostic Library: VFS Volume interface.
 *
 * Copyright (C) 2009 Mark Lee <libdesktop-agnostic@lazymalevolence.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 *
 * Author : Mark Lee <libdesktop-agnostic@lazymalevolence.com>
 */

#include "desktop-agnostic-vfs.h"
#include <glib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	DESKTOP_AGNOSTIC_VFS_VOLUME_MONITOR_VOLUME_MOUNTED_SIGNAL,
	DESKTOP_AGNOSTIC_VFS_VOLUME_MONITOR_VOLUME_UNMOUNTED_SIGNAL,
	DESKTOP_AGNOSTIC_VFS_VOLUME_MONITOR_NUM_SIGNALS
};
static guint desktop_agnostic_vfs_volume_monitor_signals[DESKTOP_AGNOSTIC_VFS_VOLUME_MONITOR_NUM_SIGNALS] = {0};

static GType desktop_agnostic_vfs_volume_get_type_once (void);
static GType desktop_agnostic_vfs_volume_monitor_get_type_once (void);

GQuark
desktop_agnostic_vfs_volume_error_quark (void)
{
#line 35 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash.vala"
	return g_quark_from_static_string ("desktop-agnostic-vfs-volume-error-quark");
#line 54 "vfs-volume.c"
}

static GType
desktop_agnostic_vfs_volume_error_get_type_once (void)
{
	static const GEnumValue values[] = {{DESKTOP_AGNOSTIC_VFS_VOLUME_ERROR_MOUNT, "DESKTOP_AGNOSTIC_VFS_VOLUME_ERROR_MOUNT", "mount"}, {DESKTOP_AGNOSTIC_VFS_VOLUME_ERROR_UNMOUNT, "DESKTOP_AGNOSTIC_VFS_VOLUME_ERROR_UNMOUNT", "unmount"}, {DESKTOP_AGNOSTIC_VFS_VOLUME_ERROR_EJECT, "DESKTOP_AGNOSTIC_VFS_VOLUME_ERROR_EJECT", "eject"}, {0, NULL, NULL}};
	GType desktop_agnostic_vfs_volume_error_type_id;
	desktop_agnostic_vfs_volume_error_type_id = g_enum_register_static ("DesktopAgnosticVFSVolumeError", values);
	return desktop_agnostic_vfs_volume_error_type_id;
}

GType
desktop_agnostic_vfs_volume_error_get_type (void)
{
	static volatile gsize desktop_agnostic_vfs_volume_error_type_id__once = 0;
	if (g_once_init_enter (&desktop_agnostic_vfs_volume_error_type_id__once)) {
		GType desktop_agnostic_vfs_volume_error_type_id;
		desktop_agnostic_vfs_volume_error_type_id = desktop_agnostic_vfs_volume_error_get_type_once ();
		g_once_init_leave (&desktop_agnostic_vfs_volume_error_type_id__once, desktop_agnostic_vfs_volume_error_type_id);
	}
	return desktop_agnostic_vfs_volume_error_type_id__once;
}

/**
     * Tells whether the volume is mounted.
     */
gboolean
desktop_agnostic_vfs_volume_is_mounted (DesktopAgnosticVFSVolume* self)
{
	DesktopAgnosticVFSVolumeIface* _iface_;
#line 52 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 52 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
	_iface_ = DESKTOP_AGNOSTIC_VFS_VOLUME_GET_INTERFACE (self);
#line 52 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
	if (_iface_->is_mounted) {
#line 52 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
		return _iface_->is_mounted (self);
#line 93 "vfs-volume.c"
	}
#line 52 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
	return FALSE;
#line 97 "vfs-volume.c"
}

void
desktop_agnostic_vfs_volume_mount (DesktopAgnosticVFSVolume* self,
                                   DesktopAgnosticVFSVolumeCallback callback,
                                   gpointer callback_target)
{
	DesktopAgnosticVFSVolumeIface* _iface_;
#line 53 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
	g_return_if_fail (self != NULL);
#line 53 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
	_iface_ = DESKTOP_AGNOSTIC_VFS_VOLUME_GET_INTERFACE (self);
#line 53 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
	if (_iface_->mount) {
#line 53 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
		_iface_->mount (self, callback, callback_target);
#line 114 "vfs-volume.c"
	}
}

gboolean
desktop_agnostic_vfs_volume_mount_finish (DesktopAgnosticVFSVolume* self,
                                          GError** error)
{
	DesktopAgnosticVFSVolumeIface* _iface_;
#line 54 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 54 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
	_iface_ = DESKTOP_AGNOSTIC_VFS_VOLUME_GET_INTERFACE (self);
#line 54 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
	if (_iface_->mount_finish) {
#line 54 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
		return _iface_->mount_finish (self, error);
#line 131 "vfs-volume.c"
	}
#line 54 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
	return FALSE;
#line 135 "vfs-volume.c"
}

void
desktop_agnostic_vfs_volume_unmount (DesktopAgnosticVFSVolume* self,
                                     DesktopAgnosticVFSVolumeCallback callback,
                                     gpointer callback_target)
{
	DesktopAgnosticVFSVolumeIface* _iface_;
#line 55 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
	g_return_if_fail (self != NULL);
#line 55 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
	_iface_ = DESKTOP_AGNOSTIC_VFS_VOLUME_GET_INTERFACE (self);
#line 55 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
	if (_iface_->unmount) {
#line 55 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
		_iface_->unmount (self, callback, callback_target);
#line 152 "vfs-volume.c"
	}
}

gboolean
desktop_agnostic_vfs_volume_unmount_finish (DesktopAgnosticVFSVolume* self,
                                            GError** error)
{
	DesktopAgnosticVFSVolumeIface* _iface_;
#line 56 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 56 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
	_iface_ = DESKTOP_AGNOSTIC_VFS_VOLUME_GET_INTERFACE (self);
#line 56 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
	if (_iface_->unmount_finish) {
#line 56 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
		return _iface_->unmount_finish (self, error);
#line 169 "vfs-volume.c"
	}
#line 56 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
	return FALSE;
#line 173 "vfs-volume.c"
}

gboolean
desktop_agnostic_vfs_volume_can_eject (DesktopAgnosticVFSVolume* self)
{
	DesktopAgnosticVFSVolumeIface* _iface_;
#line 57 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 57 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
	_iface_ = DESKTOP_AGNOSTIC_VFS_VOLUME_GET_INTERFACE (self);
#line 57 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
	if (_iface_->can_eject) {
#line 57 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
		return _iface_->can_eject (self);
#line 188 "vfs-volume.c"
	}
#line 57 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
	return FALSE;
#line 192 "vfs-volume.c"
}

void
desktop_agnostic_vfs_volume_eject (DesktopAgnosticVFSVolume* self,
                                   DesktopAgnosticVFSVolumeCallback callback,
                                   gpointer callback_target)
{
	DesktopAgnosticVFSVolumeIface* _iface_;
#line 58 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
	g_return_if_fail (self != NULL);
#line 58 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
	_iface_ = DESKTOP_AGNOSTIC_VFS_VOLUME_GET_INTERFACE (self);
#line 58 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
	if (_iface_->eject) {
#line 58 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
		_iface_->eject (self, callback, callback_target);
#line 209 "vfs-volume.c"
	}
}

gboolean
desktop_agnostic_vfs_volume_eject_finish (DesktopAgnosticVFSVolume* self,
                                          GError** error)
{
	DesktopAgnosticVFSVolumeIface* _iface_;
#line 59 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 59 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
	_iface_ = DESKTOP_AGNOSTIC_VFS_VOLUME_GET_INTERFACE (self);
#line 59 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
	if (_iface_->eject_finish) {
#line 59 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
		return _iface_->eject_finish (self, error);
#line 226 "vfs-volume.c"
	}
#line 59 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
	return FALSE;
#line 230 "vfs-volume.c"
}

gchar*
desktop_agnostic_vfs_volume_get_name (DesktopAgnosticVFSVolume* self)
{
	DesktopAgnosticVFSVolumeIface* _iface_;
#line 39 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 39 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
	_iface_ = DESKTOP_AGNOSTIC_VFS_VOLUME_GET_INTERFACE (self);
#line 39 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
	if (_iface_->get_name) {
#line 39 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
		return _iface_->get_name (self);
#line 245 "vfs-volume.c"
	}
#line 39 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
	return NULL;
#line 249 "vfs-volume.c"
}

DesktopAgnosticVFSFile*
desktop_agnostic_vfs_volume_get_uri (DesktopAgnosticVFSVolume* self)
{
	DesktopAgnosticVFSVolumeIface* _iface_;
#line 43 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 43 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
	_iface_ = DESKTOP_AGNOSTIC_VFS_VOLUME_GET_INTERFACE (self);
#line 43 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
	if (_iface_->get_uri) {
#line 43 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
		return _iface_->get_uri (self);
#line 264 "vfs-volume.c"
	}
#line 43 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
	return NULL;
#line 268 "vfs-volume.c"
}

gchar*
desktop_agnostic_vfs_volume_get_icon (DesktopAgnosticVFSVolume* self)
{
	DesktopAgnosticVFSVolumeIface* _iface_;
#line 48 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 48 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
	_iface_ = DESKTOP_AGNOSTIC_VFS_VOLUME_GET_INTERFACE (self);
#line 48 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
	if (_iface_->get_icon) {
#line 48 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
		return _iface_->get_icon (self);
#line 283 "vfs-volume.c"
	}
#line 48 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
	return NULL;
#line 287 "vfs-volume.c"
}

static void
desktop_agnostic_vfs_volume_default_init (DesktopAgnosticVFSVolumeIface * iface,
                                          gpointer iface_data)
{
	/**
	     * The name of the volume.
	     */
#line 33 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
	g_object_interface_install_property (iface, g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 299 "vfs-volume.c"
	/**
	     * Usually, the mount point of the volume.
	     */
#line 33 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
	g_object_interface_install_property (iface, g_param_spec_object ("uri", "uri", "uri", DESKTOP_AGNOSTIC_VFS_TYPE_FILE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 305 "vfs-volume.c"
	/**
	     * Either an icon name usable with gtk.IconTheme, or an absolute path to
	     * an image (either of which are associated with the volume).
	     */
#line 33 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
	g_object_interface_install_property (iface, g_param_spec_string ("icon", "icon", "icon", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 312 "vfs-volume.c"
}

static GType
desktop_agnostic_vfs_volume_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DesktopAgnosticVFSVolumeIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) desktop_agnostic_vfs_volume_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType desktop_agnostic_vfs_volume_type_id;
	desktop_agnostic_vfs_volume_type_id = g_type_register_static (G_TYPE_INTERFACE, "DesktopAgnosticVFSVolume", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (desktop_agnostic_vfs_volume_type_id, G_TYPE_OBJECT);
	return desktop_agnostic_vfs_volume_type_id;
}

GType
desktop_agnostic_vfs_volume_get_type (void)
{
	static volatile gsize desktop_agnostic_vfs_volume_type_id__once = 0;
	if (g_once_init_enter (&desktop_agnostic_vfs_volume_type_id__once)) {
		GType desktop_agnostic_vfs_volume_type_id;
		desktop_agnostic_vfs_volume_type_id = desktop_agnostic_vfs_volume_get_type_once ();
		g_once_init_leave (&desktop_agnostic_vfs_volume_type_id__once, desktop_agnostic_vfs_volume_type_id);
	}
	return desktop_agnostic_vfs_volume_type_id__once;
}

void*
desktop_agnostic_vfs_volume_monitor_get_implementation (DesktopAgnosticVFSVolumeMonitor* self)
{
	DesktopAgnosticVFSVolumeMonitorIface* _iface_;
#line 63 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 63 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
	_iface_ = DESKTOP_AGNOSTIC_VFS_VOLUME_MONITOR_GET_INTERFACE (self);
#line 63 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
	if (_iface_->get_implementation) {
#line 63 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
		return _iface_->get_implementation (self);
#line 349 "vfs-volume.c"
	}
#line 63 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
	return NULL;
#line 353 "vfs-volume.c"
}

GList*
desktop_agnostic_vfs_volume_monitor_get_volumes (DesktopAgnosticVFSVolumeMonitor* self)
{
	DesktopAgnosticVFSVolumeMonitorIface* _iface_;
#line 64 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 64 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
	_iface_ = DESKTOP_AGNOSTIC_VFS_VOLUME_MONITOR_GET_INTERFACE (self);
#line 64 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
	if (_iface_->get_volumes) {
#line 64 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
		return _iface_->get_volumes (self);
#line 368 "vfs-volume.c"
	}
#line 64 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
	return NULL;
#line 372 "vfs-volume.c"
}

static void
desktop_agnostic_vfs_volume_monitor_default_init (DesktopAgnosticVFSVolumeMonitorIface * iface,
                                                  gpointer iface_data)
{
#line 61 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
	g_object_interface_install_property (iface, g_param_spec_pointer ("implementation", "implementation", "implementation", G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 61 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
	g_object_interface_install_property (iface, g_param_spec_pointer ("volumes", "volumes", "volumes", G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 61 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
	desktop_agnostic_vfs_volume_monitor_signals[DESKTOP_AGNOSTIC_VFS_VOLUME_MONITOR_VOLUME_MOUNTED_SIGNAL] = g_signal_new ("volume-mounted", DESKTOP_AGNOSTIC_VFS_TYPE_VOLUME_MONITOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, DESKTOP_AGNOSTIC_VFS_TYPE_VOLUME);
#line 61 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
	desktop_agnostic_vfs_volume_monitor_signals[DESKTOP_AGNOSTIC_VFS_VOLUME_MONITOR_VOLUME_UNMOUNTED_SIGNAL] = g_signal_new ("volume-unmounted", DESKTOP_AGNOSTIC_VFS_TYPE_VOLUME_MONITOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, DESKTOP_AGNOSTIC_VFS_TYPE_VOLUME);
#line 387 "vfs-volume.c"
}

static GType
desktop_agnostic_vfs_volume_monitor_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DesktopAgnosticVFSVolumeMonitorIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) desktop_agnostic_vfs_volume_monitor_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType desktop_agnostic_vfs_volume_monitor_type_id;
	desktop_agnostic_vfs_volume_monitor_type_id = g_type_register_static (G_TYPE_INTERFACE, "DesktopAgnosticVFSVolumeMonitor", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (desktop_agnostic_vfs_volume_monitor_type_id, G_TYPE_OBJECT);
	return desktop_agnostic_vfs_volume_monitor_type_id;
}

GType
desktop_agnostic_vfs_volume_monitor_get_type (void)
{
	static volatile gsize desktop_agnostic_vfs_volume_monitor_type_id__once = 0;
	if (g_once_init_enter (&desktop_agnostic_vfs_volume_monitor_type_id__once)) {
		GType desktop_agnostic_vfs_volume_monitor_type_id;
		desktop_agnostic_vfs_volume_monitor_type_id = desktop_agnostic_vfs_volume_monitor_get_type_once ();
		g_once_init_leave (&desktop_agnostic_vfs_volume_monitor_type_id__once, desktop_agnostic_vfs_volume_monitor_type_id);
	}
	return desktop_agnostic_vfs_volume_monitor_type_id__once;
}

DesktopAgnosticVFSVolumeMonitor*
desktop_agnostic_vfs_volume_monitor_get_default (GError** error)
{
	DesktopAgnosticVFSImplementation* vfs = NULL;
	DesktopAgnosticVFSImplementation* _tmp0_;
	GError* _inner_error0_ = NULL;
	DesktopAgnosticVFSVolumeMonitor* result;
#line 71 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
	_tmp0_ = desktop_agnostic_vfs_get_default (&_inner_error0_);
#line 71 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
	vfs = _tmp0_;
#line 71 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 71 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
		g_propagate_error (error, _inner_error0_);
#line 71 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
		return NULL;
#line 429 "vfs-volume.c"
	}
#line 72 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
	if (vfs == NULL) {
#line 74 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
		result = NULL;
#line 74 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
		return result;
#line 437 "vfs-volume.c"
	} else {
		DesktopAgnosticVFSVolumeMonitor* _tmp1_;
#line 78 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
		_tmp1_ = desktop_agnostic_vfs_implementation_volume_monitor_get_default (vfs);
#line 78 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
		result = _tmp1_;
#line 78 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-volume.vala"
		return result;
#line 446 "vfs-volume.c"
	}
}

