/* config-impl-gconf.c generated by valac 0.56.17, the Vala compiler
 * generated from config-impl-gconf.vala, do not modify */

/*
 * GConf implementation of the configuration interface.
 *
 * Copyright (C) 2008, 2009 Mark Lee <libdesktop-agnostic@lazymalevolence.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 *
 * Author : Mark Lee <libdesktop-agnostic@lazymalevolence.com>
 */

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include "da-cfg-gconf.h"
#include <gconf/gconf-client.h>
#include <config-notify-delegate.c>
#include <glib-object.h>
#include <desktop-agnostic-cfg.h>
#include <float.h>
#include <math.h>
#include <gconf/gconf.h>

#define DESKTOP_AGNOSTIC_CONFIG_BACKEND_NAME "GConf"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	DESKTOP_AGNOSTIC_CONFIG_GCONF_BACKEND_0_PROPERTY,
	DESKTOP_AGNOSTIC_CONFIG_GCONF_BACKEND_NAME_PROPERTY,
	DESKTOP_AGNOSTIC_CONFIG_GCONF_BACKEND_NUM_PROPERTIES
};
static GParamSpec* desktop_agnostic_config_gconf_backend_properties[DESKTOP_AGNOSTIC_CONFIG_GCONF_BACKEND_NUM_PROPERTIES];
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define __vala_GValue_free0(var) ((var == NULL) ? NULL : (var = (_vala_GValue_free (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _gconf_entry_unref0(var) ((var == NULL) ? NULL : (var = (gconf_entry_unref (var), NULL)))
#define _g_value_array_free0(var) ((var == NULL) ? NULL : (var = (g_value_array_free (var), NULL)))
#define _desktop_agnostic_config_notify_delegate_free0(var) ((var == NULL) ? NULL : (var = (desktop_agnostic_config_notify_delegate_free (var), NULL)))
#define _gconf_value_free0(var) ((var == NULL) ? NULL : (var = (gconf_value_free (var), NULL)))

struct _DesktopAgnosticConfigGConfBackendPrivate {
	gchar* schema_path;
	gchar* path;
	GConfClient* client;
	guint connection_id;
	GData* _notifiers;
};

static gint DesktopAgnosticConfigGConfBackend_private_offset;
static gpointer desktop_agnostic_config_gconf_backend_parent_class = NULL;

static void desktop_agnostic_config_gconf_backend_real_constructed (GObject* base);
static void _vala_GValue_free (GValue* self);
static void desktop_agnostic_config_gconf_backend_associate_schemas_in_dir (DesktopAgnosticConfigGConfBackend* self,
                                                                     const gchar* schema_dir,
                                                                     const gchar* pref_dir,
                                                                     GError** error);
static void desktop_agnostic_config_gconf_backend_notify_proxy (DesktopAgnosticConfigGConfBackend* self,
                                                         GConfClient* client,
                                                         guint cnxn_id,
                                                         GConfEntry* entry);
static void _desktop_agnostic_config_gconf_backend_notify_proxy_gconf_client_notify_func (GConfClient* client,
                                                                                   guint cnxn_id,
                                                                                   GConfEntry* entry,
                                                                                   gpointer self);
static void _g_free0_ (gpointer var);
static inline void _g_slist_free__g_free0_ (GSList* self);
static void _gconf_entry_unref0_ (gpointer var);
static inline void _g_slist_free__gconf_entry_unref0_ (GSList* self);
static GConfEntry* _vala_gconf_entry_ref (GConfEntry* self);
static void desktop_agnostic_config_gconf_backend_parse_group_and_key (DesktopAgnosticConfigGConfBackend* self,
                                                                const gchar* full_key,
                                                                gchar** group,
                                                                gchar** key);
static gchar* desktop_agnostic_config_gconf_backend_generate_key (DesktopAgnosticConfigGConfBackend* self,
                                                           const gchar* group,
                                                           const gchar* key);
static GConfValueType desktop_agnostic_config_gconf_backend_type_to_valuetype (DesktopAgnosticConfigGConfBackend* self,
                                                                        GType type);
static void desktop_agnostic_config_gconf_backend_gconfvalue_to_gvalue (DesktopAgnosticConfigGConfBackend* self,
                                                                 const gchar* group,
                                                                 const gchar* key,
                                                                 GConfValue* gc_val,
                                                                 GValue* result,
                                                                 GError** error);
static GValueArray* desktop_agnostic_config_gconf_backend_slist_to_valuearray (DesktopAgnosticConfigGConfBackend* self,
                                                                        GSList* list,
                                                                        GType type,
                                                                        GError** error);
static void _desktop_agnostic_config_gconf_backend_ensure_key_exists (DesktopAgnosticConfigGConfBackend* self,
                                                               const gchar* group,
                                                               const gchar* key,
                                                               GError** error);
static void desktop_agnostic_config_gconf_backend_real_remove (DesktopAgnosticConfigBackend* base,
                                                        GError** error);
static void desktop_agnostic_config_gconf_backend_real_notify_add (DesktopAgnosticConfigBackend* base,
                                                            const gchar* group,
                                                            const gchar* key,
                                                            DesktopAgnosticConfigNotifyFunc callback,
                                                            gpointer callback_target,
                                                            GError** error);
static void desktop_agnostic_config_gconf_backend_real_notify (DesktopAgnosticConfigBackend* base,
                                                        const gchar* group,
                                                        const gchar* key,
                                                        GError** error);
static void desktop_agnostic_config_gconf_backend_real_notify_remove (DesktopAgnosticConfigBackend* base,
                                                               const gchar* group,
                                                               const gchar* key,
                                                               DesktopAgnosticConfigNotifyFunc callback,
                                                               gpointer callback_target,
                                                               GError** error);
static void desktop_agnostic_config_gconf_backend_real_reset (DesktopAgnosticConfigBackend* base,
                                                       GError** error);
static void desktop_agnostic_config_gconf_backend_real_get_value (DesktopAgnosticConfigBackend* base,
                                                           const gchar* group,
                                                           const gchar* key,
                                                           GValue* result,
                                                           GError** error);
static gboolean desktop_agnostic_config_gconf_backend_real_get_bool (DesktopAgnosticConfigBackend* base,
                                                              const gchar* group,
                                                              const gchar* key,
                                                              GError** error);
static void desktop_agnostic_config_gconf_backend_real_set_bool (DesktopAgnosticConfigBackend* base,
                                                          const gchar* group,
                                                          const gchar* key,
                                                          gboolean value,
                                                          GError** error);
static gfloat desktop_agnostic_config_gconf_backend_real_get_float (DesktopAgnosticConfigBackend* base,
                                                             const gchar* group,
                                                             const gchar* key,
                                                             GError** error);
static void desktop_agnostic_config_gconf_backend_real_set_float (DesktopAgnosticConfigBackend* base,
                                                           const gchar* group,
                                                           const gchar* key,
                                                           gfloat value,
                                                           GError** error);
static gint desktop_agnostic_config_gconf_backend_real_get_int (DesktopAgnosticConfigBackend* base,
                                                         const gchar* group,
                                                         const gchar* key,
                                                         GError** error);
static void desktop_agnostic_config_gconf_backend_real_set_int (DesktopAgnosticConfigBackend* base,
                                                         const gchar* group,
                                                         const gchar* key,
                                                         gint value,
                                                         GError** error);
static gchar* desktop_agnostic_config_gconf_backend_real_get_string (DesktopAgnosticConfigBackend* base,
                                                              const gchar* group,
                                                              const gchar* key,
                                                              GError** error);
static void desktop_agnostic_config_gconf_backend_real_set_string (DesktopAgnosticConfigBackend* base,
                                                            const gchar* group,
                                                            const gchar* key,
                                                            const gchar* value,
                                                            GError** error);
static GValueArray* desktop_agnostic_config_gconf_backend_real_get_list (DesktopAgnosticConfigBackend* base,
                                                                  const gchar* group,
                                                                  const gchar* key,
                                                                  GError** error);
static void desktop_agnostic_config_gconf_backend_real_set_list (DesktopAgnosticConfigBackend* base,
                                                          const gchar* group,
                                                          const gchar* key,
                                                          GValueArray* value,
                                                          GError** error);
static void _gconf_value_free0_ (gpointer var);
static inline void _g_slist_free__gconf_value_free0_ (GSList* self);
static GObject * desktop_agnostic_config_gconf_backend_constructor (GType type,
                                                             guint n_construct_properties,
                                                             GObjectConstructParam * construct_properties);
static void desktop_agnostic_config_gconf_backend_finalize (GObject * obj);
static GType desktop_agnostic_config_gconf_backend_get_type_once (void);
static void _vala_desktop_agnostic_config_gconf_backend_get_property (GObject * object,
                                                               guint property_id,
                                                               GValue * value,
                                                               GParamSpec * pspec);
static GValue* _g_value_dup (GValue* self);

static inline gpointer
desktop_agnostic_config_gconf_backend_get_instance_private (DesktopAgnosticConfigGConfBackend* self)
{
	return G_STRUCT_MEMBER_P (self, DesktopAgnosticConfigGConfBackend_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 54 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	return self ? g_object_ref (self) : NULL;
#line 212 "config-impl-gconf.c"
}

static void
_vala_GValue_free (GValue* self)
{
#line 67 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	g_boxed_free (G_TYPE_VALUE, self);
#line 220 "config-impl-gconf.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1589 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 242 "config-impl-gconf.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 246 "config-impl-gconf.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 252 "config-impl-gconf.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 256 "config-impl-gconf.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp0_) {
#line 260 "config-impl-gconf.c"
		gchar* _tmp2_;
#line 1590 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1590 "glib-2.0.vapi"
		result = _tmp2_;
#line 1590 "glib-2.0.vapi"
		return result;
#line 268 "config-impl-gconf.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1593 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1593 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1593 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1593 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1593 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1593 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1593 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1593 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 296 "config-impl-gconf.c"
				goto __catch0_g_regex_error;
			}
#line 1593 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1593 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1593 "glib-2.0.vapi"
			return NULL;
#line 305 "config-impl-gconf.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1594 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1594 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1594 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1594 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 319 "config-impl-gconf.c"
				goto __catch0_g_regex_error;
			}
#line 1594 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1594 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1594 "glib-2.0.vapi"
			return NULL;
#line 328 "config-impl-gconf.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1594 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1594 "glib-2.0.vapi"
		result = _tmp10_;
#line 1594 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1594 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
		return result;
#line 342 "config-impl-gconf.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1592 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1596 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 351 "config-impl-gconf.c"
	}
	__finally0:
#line 1592 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1592 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1592 "glib-2.0.vapi"
	return NULL;
#line 360 "config-impl-gconf.c"
}

static void
_desktop_agnostic_config_gconf_backend_notify_proxy_gconf_client_notify_func (GConfClient* client,
                                                                              guint cnxn_id,
                                                                              GConfEntry* entry,
                                                                              gpointer self)
{
#line 87 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	desktop_agnostic_config_gconf_backend_notify_proxy ((DesktopAgnosticConfigGConfBackend*) self, client, cnxn_id, entry);
#line 371 "config-impl-gconf.c"
}

static void
desktop_agnostic_config_gconf_backend_real_constructed (GObject* base)
{
	DesktopAgnosticConfigGConfBackend * self;
	gchar* opt_prefix = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* base_path = NULL;
	DesktopAgnosticConfigSchema* schema = NULL;
	DesktopAgnosticConfigSchema* _tmp5_;
	DesktopAgnosticConfigSchema* _tmp6_;
	DesktopAgnosticConfigSchema* _tmp7_;
	GValue* _tmp8_ = NULL;
	DesktopAgnosticConfigSchema* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	GValue* _tmp13_;
	GValue* _tmp14_;
	const gchar* _tmp15_;
	gchar* _tmp16_;
	const gchar* _tmp17_;
	DesktopAgnosticConfigSchema* _tmp18_;
	const gchar* _tmp19_;
	const gchar* _tmp20_;
	gchar* _tmp21_;
	const gchar* _tmp22_;
	const gchar* _tmp23_;
	GError* _inner_error0_ = NULL;
#line 49 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	self = (DesktopAgnosticConfigGConfBackend*) base;
#line 52 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp0_ = desktop_agnostic_config_backend_get_name ((DesktopAgnosticConfigBackend*) self);
#line 52 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp1_ = _tmp0_;
#line 52 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp2_ = _tmp1_;
#line 52 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp3_ = g_strconcat (_tmp2_, ".", NULL);
#line 52 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp4_ = _tmp3_;
#line 52 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_g_free0 (_tmp2_);
#line 52 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	opt_prefix = _tmp4_;
#line 54 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp5_ = desktop_agnostic_config_backend_get_schema ((DesktopAgnosticConfigBackend*) self);
#line 54 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp6_ = _tmp5_;
#line 54 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp7_ = _g_object_ref0 (_tmp6_);
#line 54 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	schema = _tmp7_;
#line 56 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	self->priv->connection_id = (guint) 0;
#line 57 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	g_datalist_init (&self->priv->_notifiers);
#line 58 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp9_ = schema;
#line 58 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp10_ = opt_prefix;
#line 58 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp11_ = g_strconcat (_tmp10_, "base_path", NULL);
#line 58 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp12_ = _tmp11_;
#line 58 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp13_ = desktop_agnostic_config_schema_get_metadata_option (_tmp9_, _tmp12_, &_inner_error0_);
#line 58 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp14_ = _tmp13_;
#line 58 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_g_free0 (_tmp12_);
#line 58 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp8_ = _tmp14_;
#line 58 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 58 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_g_object_unref0 (schema);
#line 58 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_g_free0 (base_path);
#line 58 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_g_free0 (opt_prefix);
#line 58 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 58 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		g_clear_error (&_inner_error0_);
#line 58 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		return;
#line 464 "config-impl-gconf.c"
	}
#line 58 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp15_ = g_value_get_string (_tmp8_);
#line 58 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp16_ = g_strdup (_tmp15_);
#line 58 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_g_free0 (base_path);
#line 58 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	base_path = _tmp16_;
#line 60 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp17_ = base_path;
#line 60 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp18_ = schema;
#line 60 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp19_ = desktop_agnostic_config_schema_get_app_name (_tmp18_);
#line 60 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp20_ = _tmp19_;
#line 60 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp21_ = g_strdup_printf ("/schemas%s/%s", _tmp17_, _tmp20_);
#line 60 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_g_free0 (self->priv->schema_path);
#line 60 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	self->priv->schema_path = _tmp21_;
#line 61 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp22_ = desktop_agnostic_config_backend_get_instance_id ((DesktopAgnosticConfigBackend*) self);
#line 61 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp23_ = _tmp22_;
#line 61 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	if (_tmp23_ == NULL) {
#line 494 "config-impl-gconf.c"
		const gchar* _tmp24_;
		DesktopAgnosticConfigSchema* _tmp25_;
		const gchar* _tmp26_;
		const gchar* _tmp27_;
		gchar* _tmp28_;
#line 63 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_tmp24_ = base_path;
#line 63 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_tmp25_ = schema;
#line 63 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_tmp26_ = desktop_agnostic_config_schema_get_app_name (_tmp25_);
#line 63 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_tmp27_ = _tmp26_;
#line 63 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_tmp28_ = g_strdup_printf ("%s/%s", _tmp24_, _tmp27_);
#line 63 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_g_free0 (self->priv->path);
#line 63 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		self->priv->path = _tmp28_;
#line 514 "config-impl-gconf.c"
	} else {
		GValue* _tmp29_ = NULL;
		DesktopAgnosticConfigSchema* _tmp30_;
		const gchar* _tmp31_;
		gchar* _tmp32_;
		gchar* _tmp33_;
		GValue* _tmp34_;
		GValue* _tmp35_;
		gchar* option = NULL;
		const gchar* _tmp36_;
		gchar* _tmp37_;
		const gchar* _tmp38_;
		const gchar* _tmp39_;
		gchar* _tmp40_;
		gchar* _tmp41_;
		DesktopAgnosticConfigSchema* _tmp42_;
		const gchar* _tmp43_;
		const gchar* _tmp44_;
		const gchar* _tmp45_;
		const gchar* _tmp46_;
		gchar* _tmp47_;
#line 67 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_tmp30_ = schema;
#line 67 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_tmp31_ = opt_prefix;
#line 67 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_tmp32_ = g_strconcat (_tmp31_, "base_instance_path", NULL);
#line 67 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_tmp33_ = _tmp32_;
#line 67 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_tmp34_ = desktop_agnostic_config_schema_get_metadata_option (_tmp30_, _tmp33_, &_inner_error0_);
#line 67 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_tmp35_ = _tmp34_;
#line 67 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_g_free0 (_tmp33_);
#line 67 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_tmp29_ = _tmp35_;
#line 67 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 67 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			__vala_GValue_free0 (_tmp8_);
#line 67 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			_g_object_unref0 (schema);
#line 67 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			_g_free0 (base_path);
#line 67 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			_g_free0 (opt_prefix);
#line 67 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 67 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			g_clear_error (&_inner_error0_);
#line 67 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			return;
#line 568 "config-impl-gconf.c"
		}
#line 67 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_tmp36_ = g_value_get_string (_tmp29_);
#line 67 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_tmp37_ = g_strdup (_tmp36_);
#line 67 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		option = _tmp37_;
#line 69 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_tmp38_ = option;
#line 69 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_tmp39_ = base_path;
#line 69 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_tmp40_ = string_replace (_tmp38_, "${base_path}", _tmp39_);
#line 69 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_tmp41_ = _tmp40_;
#line 69 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_tmp42_ = schema;
#line 69 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_tmp43_ = desktop_agnostic_config_schema_get_app_name (_tmp42_);
#line 69 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_tmp44_ = _tmp43_;
#line 69 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_tmp45_ = desktop_agnostic_config_backend_get_instance_id ((DesktopAgnosticConfigBackend*) self);
#line 69 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_tmp46_ = _tmp45_;
#line 69 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_tmp47_ = g_strdup_printf ("%s/%s/%s", _tmp41_, _tmp44_, _tmp46_);
#line 69 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_g_free0 (self->priv->path);
#line 69 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		self->priv->path = _tmp47_;
#line 69 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_g_free0 (_tmp41_);
#line 602 "config-impl-gconf.c"
		{
			const gchar* _tmp48_;
			const gchar* _tmp49_;
#line 74 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			_tmp48_ = self->priv->schema_path;
#line 74 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			_tmp49_ = self->priv->path;
#line 74 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			desktop_agnostic_config_gconf_backend_associate_schemas_in_dir (self, _tmp48_, _tmp49_, &_inner_error0_);
#line 74 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 614 "config-impl-gconf.c"
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* err = NULL;
			GError* _tmp50_;
			const gchar* _tmp51_;
#line 72 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			err = _inner_error0_;
#line 72 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			_inner_error0_ = NULL;
#line 78 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			_tmp50_ = err;
#line 78 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			_tmp51_ = _tmp50_->message;
#line 78 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			g_critical ("config-impl-gconf.vala:78: Error associating instance with schema: %s", _tmp51_);
#line 72 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			_g_error_free0 (err);
#line 636 "config-impl-gconf.c"
		}
		__finally0:
#line 72 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 72 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			_g_free0 (option);
#line 72 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			__vala_GValue_free0 (_tmp29_);
#line 72 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			__vala_GValue_free0 (_tmp8_);
#line 72 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			_g_object_unref0 (schema);
#line 72 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			_g_free0 (base_path);
#line 72 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			_g_free0 (opt_prefix);
#line 72 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 72 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			g_clear_error (&_inner_error0_);
#line 72 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			return;
#line 659 "config-impl-gconf.c"
		}
#line 61 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_g_free0 (option);
#line 61 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		__vala_GValue_free0 (_tmp29_);
#line 665 "config-impl-gconf.c"
	}
	{
		GConfClient* _tmp52_;
		const gchar* _tmp53_;
		guint _tmp54_ = 0U;
		GConfClient* _tmp55_;
		const gchar* _tmp56_;
#line 86 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_tmp52_ = self->priv->client;
#line 86 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_tmp53_ = self->priv->path;
#line 86 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		gconf_client_add_dir (_tmp52_, _tmp53_, GCONF_CLIENT_PRELOAD_RECURSIVE, &_inner_error0_);
#line 86 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 681 "config-impl-gconf.c"
			goto __catch1_g_error;
		}
#line 87 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_tmp55_ = self->priv->client;
#line 87 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_tmp56_ = self->priv->path;
#line 87 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_tmp54_ = gconf_client_notify_add (_tmp55_, _tmp56_, _desktop_agnostic_config_gconf_backend_notify_proxy_gconf_client_notify_func, g_object_ref (self), g_object_unref, &_inner_error0_);
#line 87 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 692 "config-impl-gconf.c"
			goto __catch1_g_error;
		}
#line 87 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		self->priv->connection_id = _tmp54_;
#line 697 "config-impl-gconf.c"
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* err = NULL;
		GError* _tmp57_;
		const gchar* _tmp58_;
#line 84 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		err = _inner_error0_;
#line 84 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_inner_error0_ = NULL;
#line 91 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_tmp57_ = err;
#line 91 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_tmp58_ = _tmp57_->message;
#line 91 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		g_critical ("config-impl-gconf.vala:91: Config (GConf) error: %s", _tmp58_);
#line 84 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_g_error_free0 (err);
#line 717 "config-impl-gconf.c"
	}
	__finally1:
#line 84 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 84 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		__vala_GValue_free0 (_tmp8_);
#line 84 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_g_object_unref0 (schema);
#line 84 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_g_free0 (base_path);
#line 84 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_g_free0 (opt_prefix);
#line 84 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 84 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		g_clear_error (&_inner_error0_);
#line 84 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		return;
#line 736 "config-impl-gconf.c"
	}
#line 49 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	__vala_GValue_free0 (_tmp8_);
#line 49 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_g_object_unref0 (schema);
#line 49 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_g_free0 (base_path);
#line 49 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_g_free0 (opt_prefix);
#line 746 "config-impl-gconf.c"
}

/**
     * Ported from #panel_applet_associate_schemas_in_dir ().
     */
static void
_g_free0_ (gpointer var)
{
#line 118 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	var = (g_free (var), NULL);
#line 757 "config-impl-gconf.c"
}

static inline void
_g_slist_free__g_free0_ (GSList* self)
{
#line 118 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	g_slist_free_full (self, (GDestroyNotify) _g_free0_);
#line 765 "config-impl-gconf.c"
}

static void
_gconf_entry_unref0_ (gpointer var)
{
#line 118 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	(var == NULL) ? NULL : (var = (gconf_entry_unref (var), NULL));
#line 773 "config-impl-gconf.c"
}

static inline void
_g_slist_free__gconf_entry_unref0_ (GSList* self)
{
#line 118 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	g_slist_free_full (self, (GDestroyNotify) _gconf_entry_unref0_);
#line 781 "config-impl-gconf.c"
}

static GConfEntry*
_vala_gconf_entry_ref (GConfEntry* self)
{
#line 120 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	if (self != NULL) {
#line 120 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		gconf_entry_ref (self);
#line 791 "config-impl-gconf.c"
	}
#line 120 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	return self;
#line 795 "config-impl-gconf.c"
}

static void
desktop_agnostic_config_gconf_backend_associate_schemas_in_dir (DesktopAgnosticConfigGConfBackend* self,
                                                                const gchar* schema_dir,
                                                                const gchar* pref_dir,
                                                                GError** error)
{
	GSList* entries = NULL;
	GSList* subdirs = NULL;
	GSList* _tmp0_ = NULL;
	GConfClient* _tmp1_;
	GSList* _tmp2_;
	GSList* _tmp3_;
	GSList* _tmp4_;
	GSList* _tmp49_ = NULL;
	GConfClient* _tmp50_;
	GSList* _tmp51_;
	GSList* _tmp52_;
	GSList* _tmp53_;
	GError* _inner_error0_ = NULL;
#line 111 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	g_return_if_fail (self != NULL);
#line 111 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	g_return_if_fail (schema_dir != NULL);
#line 111 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	g_return_if_fail (pref_dir != NULL);
#line 118 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp1_ = self->priv->client;
#line 118 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp2_ = gconf_client_all_entries (_tmp1_, schema_dir, &_inner_error0_);
#line 118 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp0_ = _tmp2_;
#line 118 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 118 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		g_propagate_error (error, _inner_error0_);
#line 118 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		(subdirs == NULL) ? NULL : (subdirs = (_g_slist_free__g_free0_ (subdirs), NULL));
#line 118 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		(entries == NULL) ? NULL : (entries = (_g_slist_free__gconf_entry_unref0_ (entries), NULL));
#line 118 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		return;
#line 839 "config-impl-gconf.c"
	}
#line 118 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp3_ = _tmp0_;
#line 118 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp0_ = NULL;
#line 118 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	(entries == NULL) ? NULL : (entries = (_g_slist_free__gconf_entry_unref0_ (entries), NULL));
#line 118 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	entries = _tmp3_;
#line 120 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp4_ = entries;
#line 851 "config-impl-gconf.c"
	{
		GSList* entry_collection = NULL;
		GSList* entry_it = NULL;
#line 120 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		entry_collection = _tmp4_;
#line 120 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		for (entry_it = entry_collection; entry_it != NULL; entry_it = entry_it->next) {
#line 859 "config-impl-gconf.c"
			GConfEntry* entry = NULL;
#line 120 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			if (((GConfEntry*) entry_it->data) != NULL) {
#line 120 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				_vala_gconf_entry_ref ((GConfEntry*) entry_it->data);
#line 865 "config-impl-gconf.c"
			}
#line 120 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			entry = (GConfEntry*) entry_it->data;
#line 869 "config-impl-gconf.c"
			{
				gchar* schema_key = NULL;
				gchar* key = NULL;
				GConfEntry* pref_entry = NULL;
				gchar* pref_schema_key = NULL;
				gchar* cgroup = NULL;
				gchar* ckey = NULL;
				DesktopAgnosticConfigSchemaOption* option = NULL;
				GConfEntry* _tmp5_;
				const gchar* _tmp6_;
				gchar* _tmp7_;
				const gchar* _tmp8_;
				gchar* _tmp9_;
				gchar* _tmp10_;
				gchar* _tmp11_;
				GConfEntry* _tmp12_ = NULL;
				GConfClient* _tmp13_;
				const gchar* _tmp14_;
				GConfEntry* _tmp15_;
				GConfEntry* _tmp16_;
				const gchar* _tmp17_;
				gchar* _tmp18_ = NULL;
				gchar* _tmp19_ = NULL;
				DesktopAgnosticConfigSchema* _tmp20_;
				DesktopAgnosticConfigSchema* _tmp21_;
				const gchar* _tmp22_;
				const gchar* _tmp23_;
				DesktopAgnosticConfigSchemaOption* _tmp24_;
				DesktopAgnosticConfigSchemaOption* _tmp25_;
				gboolean _tmp26_ = FALSE;
				DesktopAgnosticConfigSchemaOption* _tmp27_;
				GConfEntry* _tmp31_;
				const gchar* _tmp35_;
				const gchar* _tmp36_;
#line 130 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				_tmp5_ = entry;
#line 130 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				_tmp6_ = gconf_entry_get_key (_tmp5_);
#line 130 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				_tmp7_ = g_strdup (_tmp6_);
#line 130 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				_g_free0 (schema_key);
#line 130 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				schema_key = _tmp7_;
#line 131 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				_tmp8_ = schema_key;
#line 131 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				_tmp9_ = g_path_get_basename (_tmp8_);
#line 131 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				_tmp10_ = _tmp9_;
#line 131 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				_tmp11_ = g_strdup_printf ("%s/%s", pref_dir, _tmp10_);
#line 131 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				_g_free0 (key);
#line 131 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				key = _tmp11_;
#line 131 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				_g_free0 (_tmp10_);
#line 137 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				_tmp13_ = self->priv->client;
#line 137 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				_tmp14_ = key;
#line 137 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				_tmp15_ = gconf_client_get_entry (_tmp13_, _tmp14_, NULL, TRUE, &_inner_error0_);
#line 137 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				_tmp12_ = _tmp15_;
#line 137 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 137 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					g_propagate_error (error, _inner_error0_);
#line 137 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					_g_object_unref0 (option);
#line 137 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					_g_free0 (ckey);
#line 137 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					_g_free0 (cgroup);
#line 137 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					_g_free0 (pref_schema_key);
#line 137 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					_gconf_entry_unref0 (pref_entry);
#line 137 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					_g_free0 (key);
#line 137 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					_g_free0 (schema_key);
#line 137 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					_gconf_entry_unref0 (entry);
#line 137 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					(_tmp0_ == NULL) ? NULL : (_tmp0_ = (_g_slist_free__gconf_entry_unref0_ (_tmp0_), NULL));
#line 137 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					(subdirs == NULL) ? NULL : (subdirs = (_g_slist_free__g_free0_ (subdirs), NULL));
#line 137 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					(entries == NULL) ? NULL : (entries = (_g_slist_free__gconf_entry_unref0_ (entries), NULL));
#line 137 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					return;
#line 964 "config-impl-gconf.c"
				}
#line 137 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				_tmp16_ = _tmp12_;
#line 137 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				_tmp12_ = NULL;
#line 137 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				_gconf_entry_unref0 (pref_entry);
#line 137 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				pref_entry = _tmp16_;
#line 139 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				_tmp17_ = key;
#line 139 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				desktop_agnostic_config_gconf_backend_parse_group_and_key (self, _tmp17_, &_tmp18_, &_tmp19_);
#line 139 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				_g_free0 (cgroup);
#line 139 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				cgroup = _tmp18_;
#line 139 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				_g_free0 (ckey);
#line 139 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				ckey = _tmp19_;
#line 140 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				_tmp20_ = desktop_agnostic_config_backend_get_schema ((DesktopAgnosticConfigBackend*) self);
#line 140 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				_tmp21_ = _tmp20_;
#line 140 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				_tmp22_ = cgroup;
#line 140 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				_tmp23_ = ckey;
#line 140 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				_tmp24_ = desktop_agnostic_config_schema_get_option (_tmp21_, _tmp22_, _tmp23_);
#line 140 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				_tmp25_ = _g_object_ref0 (_tmp24_);
#line 140 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				_g_object_unref0 (option);
#line 140 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				option = _tmp25_;
#line 141 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				_tmp27_ = option;
#line 141 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				if (_tmp27_ == NULL) {
#line 141 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					_tmp26_ = TRUE;
#line 1008 "config-impl-gconf.c"
				} else {
					DesktopAgnosticConfigSchemaOption* _tmp28_;
					gboolean _tmp29_;
					gboolean _tmp30_;
#line 141 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					_tmp28_ = option;
#line 141 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					_tmp29_ = desktop_agnostic_config_schema_option_get_per_instance (_tmp28_);
#line 141 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					_tmp30_ = _tmp29_;
#line 141 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					_tmp26_ = !_tmp30_;
#line 1021 "config-impl-gconf.c"
				}
#line 141 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				if (_tmp26_) {
#line 143 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					_gconf_entry_unref0 (_tmp12_);
#line 143 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					_g_object_unref0 (option);
#line 143 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					_g_free0 (ckey);
#line 143 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					_g_free0 (cgroup);
#line 143 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					_g_free0 (pref_schema_key);
#line 143 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					_gconf_entry_unref0 (pref_entry);
#line 143 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					_g_free0 (key);
#line 143 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					_g_free0 (schema_key);
#line 143 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					_gconf_entry_unref0 (entry);
#line 143 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					continue;
#line 1045 "config-impl-gconf.c"
				}
#line 146 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				_tmp31_ = pref_entry;
#line 146 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				if (_tmp31_ == NULL) {
#line 148 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					_g_free0 (pref_schema_key);
#line 148 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					pref_schema_key = NULL;
#line 1055 "config-impl-gconf.c"
				} else {
					GConfEntry* _tmp32_;
					const gchar* _tmp33_;
					gchar* _tmp34_;
#line 152 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					_tmp32_ = pref_entry;
#line 152 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					_tmp33_ = gconf_entry_get_schema_name (_tmp32_);
#line 152 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					_tmp34_ = g_strdup (_tmp33_);
#line 152 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					_g_free0 (pref_schema_key);
#line 152 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					pref_schema_key = _tmp34_;
#line 1070 "config-impl-gconf.c"
				}
#line 154 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				_tmp35_ = schema_key;
#line 154 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				_tmp36_ = pref_schema_key;
#line 154 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				if (g_strcmp0 (_tmp35_, _tmp36_) != 0) {
#line 1078 "config-impl-gconf.c"
					GConfClient* _tmp37_;
					GConfEngine* _tmp38_;
					const gchar* _tmp39_;
					const gchar* _tmp40_;
					gboolean _tmp41_ = FALSE;
					gboolean _tmp42_ = FALSE;
					GConfEntry* _tmp43_;
#line 156 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					_tmp37_ = self->priv->client;
#line 156 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					_tmp38_ = _tmp37_->engine;
#line 156 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					_tmp39_ = key;
#line 156 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					_tmp40_ = schema_key;
#line 156 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					gconf_engine_associate_schema (_tmp38_, _tmp39_, _tmp40_, &_inner_error0_);
#line 156 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 156 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						g_propagate_error (error, _inner_error0_);
#line 156 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						_gconf_entry_unref0 (_tmp12_);
#line 156 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						_g_object_unref0 (option);
#line 156 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						_g_free0 (ckey);
#line 156 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						_g_free0 (cgroup);
#line 156 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						_g_free0 (pref_schema_key);
#line 156 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						_gconf_entry_unref0 (pref_entry);
#line 156 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						_g_free0 (key);
#line 156 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						_g_free0 (schema_key);
#line 156 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						_gconf_entry_unref0 (entry);
#line 156 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						(_tmp0_ == NULL) ? NULL : (_tmp0_ = (_g_slist_free__gconf_entry_unref0_ (_tmp0_), NULL));
#line 156 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						(subdirs == NULL) ? NULL : (subdirs = (_g_slist_free__g_free0_ (subdirs), NULL));
#line 156 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						(entries == NULL) ? NULL : (entries = (_g_slist_free__gconf_entry_unref0_ (entries), NULL));
#line 156 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						return;
#line 1126 "config-impl-gconf.c"
					}
#line 158 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					_tmp43_ = pref_entry;
#line 158 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					if (_tmp43_ == NULL) {
#line 158 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						_tmp42_ = TRUE;
#line 1134 "config-impl-gconf.c"
					} else {
						GConfEntry* _tmp44_;
						GConfValue* _tmp45_;
#line 159 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						_tmp44_ = pref_entry;
#line 159 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						_tmp45_ = gconf_entry_get_value (_tmp44_);
#line 159 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						_tmp42_ = _tmp45_ == NULL;
#line 1144 "config-impl-gconf.c"
					}
#line 158 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					if (_tmp42_) {
#line 158 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						_tmp41_ = TRUE;
#line 1150 "config-impl-gconf.c"
					} else {
						GConfEntry* _tmp46_;
#line 160 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						_tmp46_ = pref_entry;
#line 160 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						_tmp41_ = gconf_entry_get_is_default (_tmp46_);
#line 1157 "config-impl-gconf.c"
					}
#line 158 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					if (_tmp41_) {
#line 1161 "config-impl-gconf.c"
						GConfClient* _tmp47_;
						const gchar* _tmp48_;
#line 166 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						_tmp47_ = self->priv->client;
#line 166 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						_tmp48_ = key;
#line 166 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						gconf_client_unset (_tmp47_, _tmp48_, &_inner_error0_);
#line 166 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 166 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
							g_propagate_error (error, _inner_error0_);
#line 166 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
							_gconf_entry_unref0 (_tmp12_);
#line 166 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
							_g_object_unref0 (option);
#line 166 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
							_g_free0 (ckey);
#line 166 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
							_g_free0 (cgroup);
#line 166 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
							_g_free0 (pref_schema_key);
#line 166 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
							_gconf_entry_unref0 (pref_entry);
#line 166 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
							_g_free0 (key);
#line 166 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
							_g_free0 (schema_key);
#line 166 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
							_gconf_entry_unref0 (entry);
#line 166 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
							(_tmp0_ == NULL) ? NULL : (_tmp0_ = (_g_slist_free__gconf_entry_unref0_ (_tmp0_), NULL));
#line 166 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
							(subdirs == NULL) ? NULL : (subdirs = (_g_slist_free__g_free0_ (subdirs), NULL));
#line 166 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
							(entries == NULL) ? NULL : (entries = (_g_slist_free__gconf_entry_unref0_ (entries), NULL));
#line 166 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
							return;
#line 1200 "config-impl-gconf.c"
						}
					}
				}
#line 120 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				_gconf_entry_unref0 (_tmp12_);
#line 120 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				_g_object_unref0 (option);
#line 120 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				_g_free0 (ckey);
#line 120 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				_g_free0 (cgroup);
#line 120 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				_g_free0 (pref_schema_key);
#line 120 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				_gconf_entry_unref0 (pref_entry);
#line 120 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				_g_free0 (key);
#line 120 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				_g_free0 (schema_key);
#line 120 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				_gconf_entry_unref0 (entry);
#line 1222 "config-impl-gconf.c"
			}
		}
	}
#line 171 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp50_ = self->priv->client;
#line 171 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp51_ = gconf_client_all_dirs (_tmp50_, schema_dir, &_inner_error0_);
#line 171 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp49_ = _tmp51_;
#line 171 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 171 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		g_propagate_error (error, _inner_error0_);
#line 171 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		(_tmp0_ == NULL) ? NULL : (_tmp0_ = (_g_slist_free__gconf_entry_unref0_ (_tmp0_), NULL));
#line 171 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		(subdirs == NULL) ? NULL : (subdirs = (_g_slist_free__g_free0_ (subdirs), NULL));
#line 171 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		(entries == NULL) ? NULL : (entries = (_g_slist_free__gconf_entry_unref0_ (entries), NULL));
#line 171 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		return;
#line 1244 "config-impl-gconf.c"
	}
#line 171 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp52_ = _tmp49_;
#line 171 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp49_ = NULL;
#line 171 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	(subdirs == NULL) ? NULL : (subdirs = (_g_slist_free__g_free0_ (subdirs), NULL));
#line 171 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	subdirs = _tmp52_;
#line 173 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp53_ = subdirs;
#line 1256 "config-impl-gconf.c"
	{
		GSList* dir_collection = NULL;
		GSList* dir_it = NULL;
#line 173 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		dir_collection = _tmp53_;
#line 173 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		for (dir_it = dir_collection; dir_it != NULL; dir_it = dir_it->next) {
#line 1264 "config-impl-gconf.c"
			const gchar* dir = NULL;
#line 173 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			dir = (const gchar*) dir_it->data;
#line 1268 "config-impl-gconf.c"
			{
				gchar* base_key = NULL;
				gchar* schema_subdir = NULL;
				gchar* pref_subdir = NULL;
				const gchar* _tmp54_;
				gchar* _tmp55_;
				const gchar* _tmp56_;
				gchar* _tmp57_;
				const gchar* _tmp58_;
				gchar* _tmp59_;
				const gchar* _tmp60_;
				const gchar* _tmp61_;
#line 179 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				_tmp54_ = dir;
#line 179 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				_tmp55_ = g_path_get_basename (_tmp54_);
#line 179 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				_g_free0 (base_key);
#line 179 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				base_key = _tmp55_;
#line 180 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				_tmp56_ = base_key;
#line 180 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				_tmp57_ = g_strdup_printf ("%s/%s", schema_dir, _tmp56_);
#line 180 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				_g_free0 (schema_subdir);
#line 180 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				schema_subdir = _tmp57_;
#line 181 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				_tmp58_ = base_key;
#line 181 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				_tmp59_ = g_strdup_printf ("%s/%s", pref_dir, _tmp58_);
#line 181 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				_g_free0 (pref_subdir);
#line 181 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				pref_subdir = _tmp59_;
#line 183 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				_tmp60_ = schema_subdir;
#line 183 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				_tmp61_ = pref_subdir;
#line 183 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				desktop_agnostic_config_gconf_backend_associate_schemas_in_dir (self, _tmp60_, _tmp61_, &_inner_error0_);
#line 183 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 183 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					g_propagate_error (error, _inner_error0_);
#line 183 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					_g_free0 (pref_subdir);
#line 183 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					_g_free0 (schema_subdir);
#line 183 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					_g_free0 (base_key);
#line 183 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					(_tmp49_ == NULL) ? NULL : (_tmp49_ = (_g_slist_free__g_free0_ (_tmp49_), NULL));
#line 183 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					(_tmp0_ == NULL) ? NULL : (_tmp0_ = (_g_slist_free__gconf_entry_unref0_ (_tmp0_), NULL));
#line 183 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					(subdirs == NULL) ? NULL : (subdirs = (_g_slist_free__g_free0_ (subdirs), NULL));
#line 183 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					(entries == NULL) ? NULL : (entries = (_g_slist_free__gconf_entry_unref0_ (entries), NULL));
#line 183 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					return;
#line 1331 "config-impl-gconf.c"
				}
#line 173 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				_g_free0 (pref_subdir);
#line 173 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				_g_free0 (schema_subdir);
#line 173 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				_g_free0 (base_key);
#line 1339 "config-impl-gconf.c"
			}
		}
	}
#line 111 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	(_tmp49_ == NULL) ? NULL : (_tmp49_ = (_g_slist_free__g_free0_ (_tmp49_), NULL));
#line 111 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	(_tmp0_ == NULL) ? NULL : (_tmp0_ = (_g_slist_free__gconf_entry_unref0_ (_tmp0_), NULL));
#line 111 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	(subdirs == NULL) ? NULL : (subdirs = (_g_slist_free__g_free0_ (subdirs), NULL));
#line 111 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	(entries == NULL) ? NULL : (entries = (_g_slist_free__gconf_entry_unref0_ (entries), NULL));
#line 1351 "config-impl-gconf.c"
}

static gchar*
desktop_agnostic_config_gconf_backend_generate_key (DesktopAgnosticConfigGConfBackend* self,
                                                    const gchar* group,
                                                    const gchar* key)
{
	gchar* full_key = NULL;
	gchar* result;
#line 187 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 187 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	g_return_val_if_fail (group != NULL, NULL);
#line 191 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	if (key == NULL) {
#line 193 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		if (g_strcmp0 (group, DESKTOP_AGNOSTIC_CONFIG_GROUP_DEFAULT) == 0) {
#line 1369 "config-impl-gconf.c"
			const gchar* _tmp0_;
			gchar* _tmp1_;
#line 195 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			_tmp0_ = self->priv->path;
#line 195 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			_tmp1_ = g_strdup (_tmp0_);
#line 195 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			_g_free0 (full_key);
#line 195 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			full_key = _tmp1_;
#line 1380 "config-impl-gconf.c"
		} else {
			const gchar* _tmp2_;
			gchar* _tmp3_;
#line 199 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			_tmp2_ = self->priv->path;
#line 199 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			_tmp3_ = g_strdup_printf ("%s/%s", _tmp2_, group);
#line 199 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			_g_free0 (full_key);
#line 199 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			full_key = _tmp3_;
#line 1392 "config-impl-gconf.c"
		}
	} else {
#line 204 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		if (g_strcmp0 (group, DESKTOP_AGNOSTIC_CONFIG_GROUP_DEFAULT) == 0) {
#line 1397 "config-impl-gconf.c"
			const gchar* _tmp4_;
			gchar* _tmp5_;
#line 206 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			_tmp4_ = self->priv->path;
#line 206 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			_tmp5_ = g_strdup_printf ("%s/%s", _tmp4_, key);
#line 206 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			_g_free0 (full_key);
#line 206 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			full_key = _tmp5_;
#line 1408 "config-impl-gconf.c"
		} else {
			const gchar* _tmp6_;
			gchar* _tmp7_;
#line 210 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			_tmp6_ = self->priv->path;
#line 210 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			_tmp7_ = g_strdup_printf ("%s/%s/%s", _tmp6_, group, key);
#line 210 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			_g_free0 (full_key);
#line 210 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			full_key = _tmp7_;
#line 1420 "config-impl-gconf.c"
		}
	}
#line 214 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	result = full_key;
#line 214 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	return result;
#line 1427 "config-impl-gconf.c"
}

static const gchar*
string_offset (const gchar* self,
               glong offset)
{
	const gchar* result;
#line 1322 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1323 "glib-2.0.vapi"
	result = (const gchar*) (((gchar*) self) + offset);
#line 1323 "glib-2.0.vapi"
	return result;
#line 1441 "config-impl-gconf.c"
}

static glong
string_pointer_to_offset (const gchar* self,
                          const gchar* pos)
{
	glong result;
#line 1326 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0L);
#line 1326 "glib-2.0.vapi"
	g_return_val_if_fail (pos != NULL, 0L);
#line 1327 "glib-2.0.vapi"
	result = (glong) (((gchar*) pos) - ((gchar*) self));
#line 1327 "glib-2.0.vapi"
	return result;
#line 1457 "config-impl-gconf.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1501 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1501 "glib-2.0.vapi"
	end = _tmp0_;
#line 1502 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1502 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1503 "glib-2.0.vapi"
		result = maxlen;
#line 1503 "glib-2.0.vapi"
		return result;
#line 1480 "config-impl-gconf.c"
	} else {
		gchar* _tmp2_;
#line 1505 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1505 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1505 "glib-2.0.vapi"
		return result;
#line 1489 "config-impl-gconf.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1512 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1514 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 1508 "config-impl-gconf.c"
	} else {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 1512 "config-impl-gconf.c"
	}
#line 1514 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1516 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 1518 "config-impl-gconf.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1518 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1518 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1518 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 1528 "config-impl-gconf.c"
	}
#line 1521 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1522 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1523 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 1536 "config-impl-gconf.c"
	} else {
#line 1525 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 1540 "config-impl-gconf.c"
	}
#line 1527 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1528 "glib-2.0.vapi"
		len = string_length - offset;
#line 1546 "config-impl-gconf.c"
	}
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1531 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1531 "glib-2.0.vapi"
	result = _tmp3_;
#line 1531 "glib-2.0.vapi"
	return result;
#line 1556 "config-impl-gconf.c"
}

static void
desktop_agnostic_config_gconf_backend_parse_group_and_key (DesktopAgnosticConfigGConfBackend* self,
                                                           const gchar* full_key,
                                                           gchar** group,
                                                           gchar** key)
{
	gchar* _vala_group = NULL;
	gchar* _vala_key = NULL;
	const gchar* key_to_parse = NULL;
	const gchar* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	const gchar* _tmp3_;
	const gchar* last_slash = NULL;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
#line 217 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	g_return_if_fail (self != NULL);
#line 217 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	g_return_if_fail (full_key != NULL);
#line 220 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp0_ = self->priv->path;
#line 220 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp1_ = strlen (_tmp0_);
#line 220 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp2_ = _tmp1_;
#line 220 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp3_ = string_offset (full_key, (glong) (_tmp2_ + 1));
#line 220 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	key_to_parse = _tmp3_;
#line 221 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp4_ = key_to_parse;
#line 221 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp5_ = key_to_parse;
#line 221 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp6_ = strlen (_tmp5_);
#line 221 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp7_ = _tmp6_;
#line 221 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp8_ = g_utf8_strrchr (_tmp4_, (gssize) _tmp7_, (gunichar) '/');
#line 221 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	last_slash = _tmp8_;
#line 222 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp9_ = last_slash;
#line 222 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	if (_tmp9_ == NULL) {
#line 1609 "config-impl-gconf.c"
		gchar* _tmp10_;
		const gchar* _tmp11_;
		gchar* _tmp12_;
#line 224 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_tmp10_ = g_strdup (DESKTOP_AGNOSTIC_CONFIG_GROUP_DEFAULT);
#line 224 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_g_free0 (_vala_group);
#line 224 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_vala_group = _tmp10_;
#line 225 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_tmp11_ = key_to_parse;
#line 225 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_tmp12_ = g_strdup (_tmp11_);
#line 225 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_g_free0 (_vala_key);
#line 225 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_vala_key = _tmp12_;
#line 1627 "config-impl-gconf.c"
	} else {
		glong offset = 0L;
		const gchar* _tmp13_;
		const gchar* _tmp14_;
		const gchar* _tmp15_;
		gchar* _tmp16_;
		const gchar* _tmp17_;
		const gchar* _tmp18_;
		gchar* _tmp19_;
#line 229 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_tmp13_ = key_to_parse;
#line 229 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_tmp14_ = last_slash;
#line 229 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		offset = string_pointer_to_offset (_tmp13_, _tmp14_);
#line 230 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_tmp15_ = key_to_parse;
#line 230 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_tmp16_ = string_substring (_tmp15_, (glong) 0, offset);
#line 230 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_g_free0 (_vala_group);
#line 230 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_vala_group = _tmp16_;
#line 231 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_tmp17_ = key_to_parse;
#line 231 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_tmp18_ = string_offset (_tmp17_, offset + 1);
#line 231 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_tmp19_ = g_strdup (_tmp18_);
#line 231 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_g_free0 (_vala_key);
#line 231 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_vala_key = _tmp19_;
#line 1661 "config-impl-gconf.c"
	}
#line 217 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	if (group) {
#line 217 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		*group = _vala_group;
#line 1667 "config-impl-gconf.c"
	} else {
#line 217 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_g_free0 (_vala_group);
#line 1671 "config-impl-gconf.c"
	}
#line 217 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	if (key) {
#line 217 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		*key = _vala_key;
#line 1677 "config-impl-gconf.c"
	} else {
#line 217 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_g_free0 (_vala_key);
#line 1681 "config-impl-gconf.c"
	}
}

static GConfValueType
desktop_agnostic_config_gconf_backend_type_to_valuetype (DesktopAgnosticConfigGConfBackend* self,
                                                         GType type)
{
	GConfValueType vt = 0;
	GConfValueType result;
#line 235 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 239 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	if (type == G_TYPE_BOOLEAN) {
#line 241 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		vt = GCONF_VALUE_BOOL;
#line 1697 "config-impl-gconf.c"
	} else {
#line 243 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		if (type == G_TYPE_FLOAT) {
#line 245 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			vt = GCONF_VALUE_FLOAT;
#line 1703 "config-impl-gconf.c"
		} else {
#line 247 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			if (type == G_TYPE_INT) {
#line 249 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				vt = GCONF_VALUE_INT;
#line 1709 "config-impl-gconf.c"
			} else {
#line 251 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				if (type == G_TYPE_STRING) {
#line 253 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					vt = GCONF_VALUE_STRING;
#line 1715 "config-impl-gconf.c"
				} else {
#line 255 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					if (type == G_TYPE_VALUE_ARRAY) {
#line 257 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						vt = GCONF_VALUE_LIST;
#line 1721 "config-impl-gconf.c"
					} else {
						DesktopAgnosticConfigSchemaType* _tmp0_;
#line 259 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						_tmp0_ = desktop_agnostic_config_schema_find_type (type);
#line 259 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						if (_tmp0_ != NULL) {
#line 261 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
							vt = GCONF_VALUE_STRING;
#line 1730 "config-impl-gconf.c"
						} else {
#line 265 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
							vt = GCONF_VALUE_INVALID;
#line 1734 "config-impl-gconf.c"
						}
					}
				}
			}
		}
	}
#line 267 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	result = vt;
#line 267 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	return result;
#line 1745 "config-impl-gconf.c"
}

static void
desktop_agnostic_config_gconf_backend_gconfvalue_to_gvalue (DesktopAgnosticConfigGConfBackend* self,
                                                            const gchar* group,
                                                            const gchar* key,
                                                            GConfValue* gc_val,
                                                            GValue* result,
                                                            GError** error)
{
	DesktopAgnosticConfigSchemaOption* schema_option = NULL;
	GType type = 0UL;
	GValue value = {0};
	DesktopAgnosticConfigSchema* _tmp0_;
	DesktopAgnosticConfigSchema* _tmp1_;
	DesktopAgnosticConfigSchemaOption* _tmp2_;
	DesktopAgnosticConfigSchemaOption* _tmp3_;
	DesktopAgnosticConfigSchemaOption* _tmp4_;
	DesktopAgnosticConfigSchemaOption* _tmp6_;
	GType _tmp7_;
	GType _tmp8_;
	GError* _inner_error0_ = NULL;
#line 270 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	g_return_if_fail (self != NULL);
#line 270 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	g_return_if_fail (group != NULL);
#line 270 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	g_return_if_fail (key != NULL);
#line 270 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	g_return_if_fail (gc_val != NULL);
#line 278 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp0_ = desktop_agnostic_config_backend_get_schema ((DesktopAgnosticConfigBackend*) self);
#line 278 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp1_ = _tmp0_;
#line 278 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp2_ = desktop_agnostic_config_schema_get_option (_tmp1_, group, key);
#line 278 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 278 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_g_object_unref0 (schema_option);
#line 278 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	schema_option = _tmp3_;
#line 279 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp4_ = schema_option;
#line 279 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	if (_tmp4_ == NULL) {
#line 1792 "config-impl-gconf.c"
		GError* _tmp5_;
#line 281 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_tmp5_ = g_error_new (DESKTOP_AGNOSTIC_CONFIG_ERROR, DESKTOP_AGNOSTIC_CONFIG_ERROR_KEY_NOT_FOUND, "The config key '%s/%s' does not exist in the schema.", group, key);
#line 281 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_inner_error0_ = _tmp5_;
#line 281 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		if (_inner_error0_->domain == DESKTOP_AGNOSTIC_CONFIG_ERROR) {
#line 281 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			g_propagate_error (error, _inner_error0_);
#line 281 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			G_IS_VALUE (&value) ? (g_value_unset (&value), NULL) : NULL;
#line 281 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			_g_object_unref0 (schema_option);
#line 281 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			return;
#line 1808 "config-impl-gconf.c"
		} else {
#line 281 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			G_IS_VALUE (&value) ? (g_value_unset (&value), NULL) : NULL;
#line 281 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			_g_object_unref0 (schema_option);
#line 281 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 281 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			g_clear_error (&_inner_error0_);
#line 281 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			return;
#line 1820 "config-impl-gconf.c"
		}
	}
#line 284 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp6_ = schema_option;
#line 284 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp7_ = desktop_agnostic_config_schema_option_get_option_type (_tmp6_);
#line 284 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp8_ = _tmp7_;
#line 284 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	type = _tmp8_;
#line 285 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	if (type == G_TYPE_BOOLEAN) {
#line 1833 "config-impl-gconf.c"
		GValue _tmp9_ = {0};
#line 287 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		g_value_init (&_tmp9_, G_TYPE_BOOLEAN);
#line 287 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		g_value_set_boolean (&_tmp9_, gconf_value_get_bool (gc_val));
#line 287 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		G_IS_VALUE (&value) ? (g_value_unset (&value), NULL) : NULL;
#line 287 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		value = _tmp9_;
#line 1843 "config-impl-gconf.c"
	} else {
#line 289 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		if (type == G_TYPE_FLOAT) {
#line 1847 "config-impl-gconf.c"
			GValue _tmp10_ = {0};
#line 291 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			g_value_init (&_tmp10_, G_TYPE_FLOAT);
#line 291 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			g_value_set_float (&_tmp10_, (gfloat) gconf_value_get_float (gc_val));
#line 291 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			G_IS_VALUE (&value) ? (g_value_unset (&value), NULL) : NULL;
#line 291 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			value = _tmp10_;
#line 1857 "config-impl-gconf.c"
		} else {
#line 293 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			if (type == G_TYPE_INT) {
#line 1861 "config-impl-gconf.c"
				GValue _tmp11_ = {0};
#line 295 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				g_value_init (&_tmp11_, G_TYPE_INT);
#line 295 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				g_value_set_int (&_tmp11_, gconf_value_get_int (gc_val));
#line 295 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				G_IS_VALUE (&value) ? (g_value_unset (&value), NULL) : NULL;
#line 295 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				value = _tmp11_;
#line 1871 "config-impl-gconf.c"
			} else {
#line 297 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				if (type == G_TYPE_STRING) {
#line 1875 "config-impl-gconf.c"
					const gchar* _tmp12_;
					GValue _tmp13_ = {0};
#line 299 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					_tmp12_ = gconf_value_get_string (gc_val);
#line 299 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					g_value_init (&_tmp13_, G_TYPE_STRING);
#line 299 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					g_value_set_string (&_tmp13_, _tmp12_);
#line 299 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					G_IS_VALUE (&value) ? (g_value_unset (&value), NULL) : NULL;
#line 299 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					value = _tmp13_;
#line 1888 "config-impl-gconf.c"
				} else {
#line 301 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					if (type == G_TYPE_VALUE_ARRAY) {
#line 1892 "config-impl-gconf.c"
						GType list_type = 0UL;
						GValueArray* array = NULL;
						GValue _tmp14_ = {0};
						DesktopAgnosticConfigSchemaOption* _tmp15_;
						GType _tmp16_;
						GType _tmp17_;
						GValueArray* _tmp18_ = NULL;
						GSList* _tmp19_;
						GValueArray* _tmp20_;
						GValueArray* _tmp21_;
						GValueArray* _tmp22_;
#line 306 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						g_value_init (&_tmp14_, type);
#line 306 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						G_IS_VALUE (&value) ? (g_value_unset (&value), NULL) : NULL;
#line 306 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						value = _tmp14_;
#line 307 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						_tmp15_ = schema_option;
#line 307 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						_tmp16_ = desktop_agnostic_config_schema_option_get_list_type (_tmp15_);
#line 307 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						_tmp17_ = _tmp16_;
#line 307 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						list_type = _tmp17_;
#line 308 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						_tmp19_ = gconf_value_get_list (gc_val);
#line 308 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						_tmp20_ = desktop_agnostic_config_gconf_backend_slist_to_valuearray (self, _tmp19_, list_type, &_inner_error0_);
#line 308 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						_tmp18_ = _tmp20_;
#line 308 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 308 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
							if (_inner_error0_->domain == DESKTOP_AGNOSTIC_CONFIG_ERROR) {
#line 308 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
								g_propagate_error (error, _inner_error0_);
#line 308 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
								_g_value_array_free0 (array);
#line 308 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
								G_IS_VALUE (&value) ? (g_value_unset (&value), NULL) : NULL;
#line 308 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
								_g_object_unref0 (schema_option);
#line 308 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
								return;
#line 1938 "config-impl-gconf.c"
							} else {
#line 308 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
								_g_value_array_free0 (array);
#line 308 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
								G_IS_VALUE (&value) ? (g_value_unset (&value), NULL) : NULL;
#line 308 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
								_g_object_unref0 (schema_option);
#line 308 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
								g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 308 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
								g_clear_error (&_inner_error0_);
#line 308 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
								return;
#line 1952 "config-impl-gconf.c"
							}
						}
#line 308 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						_tmp21_ = _tmp18_;
#line 308 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						_tmp18_ = NULL;
#line 308 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						_g_value_array_free0 (array);
#line 308 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						array = _tmp21_;
#line 309 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						_tmp22_ = array;
#line 309 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						array = NULL;
#line 309 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						g_value_set_boxed (&value, _tmp22_);
#line 301 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						_g_value_array_free0 (_tmp18_);
#line 301 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						_g_value_array_free0 (array);
#line 1973 "config-impl-gconf.c"
					} else {
						DesktopAgnosticConfigSchemaType* st = NULL;
						DesktopAgnosticConfigSchemaType* _tmp23_;
						DesktopAgnosticConfigSchemaType* _tmp24_;
						DesktopAgnosticConfigSchemaType* _tmp25_;
#line 313 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						_tmp23_ = desktop_agnostic_config_schema_find_type (type);
#line 313 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						_tmp24_ = _g_object_ref0 (_tmp23_);
#line 313 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						st = _tmp24_;
#line 314 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						_tmp25_ = st;
#line 314 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						if (_tmp25_ == NULL) {
#line 1989 "config-impl-gconf.c"
							GError* _tmp26_;
#line 316 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
							_tmp26_ = g_error_new_literal (DESKTOP_AGNOSTIC_CONFIG_ERROR, DESKTOP_AGNOSTIC_CONFIG_ERROR_INVALID_TYPE, "Invalid config value type.");
#line 316 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
							_inner_error0_ = _tmp26_;
#line 316 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
							if (_inner_error0_->domain == DESKTOP_AGNOSTIC_CONFIG_ERROR) {
#line 316 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
								g_propagate_error (error, _inner_error0_);
#line 316 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
								_g_object_unref0 (st);
#line 316 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
								G_IS_VALUE (&value) ? (g_value_unset (&value), NULL) : NULL;
#line 316 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
								_g_object_unref0 (schema_option);
#line 316 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
								return;
#line 2007 "config-impl-gconf.c"
							} else {
#line 316 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
								_g_object_unref0 (st);
#line 316 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
								G_IS_VALUE (&value) ? (g_value_unset (&value), NULL) : NULL;
#line 316 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
								_g_object_unref0 (schema_option);
#line 316 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
								g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 316 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
								g_clear_error (&_inner_error0_);
#line 316 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
								return;
#line 2021 "config-impl-gconf.c"
							}
						} else {
							GValue _tmp27_ = {0};
							DesktopAgnosticConfigSchemaType* _tmp28_;
							const gchar* _tmp29_;
							GValue _tmp30_ = {0};
							GValue _tmp31_;
#line 320 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
							_tmp28_ = st;
#line 320 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
							_tmp29_ = gconf_value_get_string (gc_val);
#line 320 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
							desktop_agnostic_config_schema_type_deserialize (_tmp28_, _tmp29_, &_tmp30_, &_inner_error0_);
#line 320 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
							_tmp27_ = _tmp30_;
#line 320 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 320 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
								if (_inner_error0_->domain == DESKTOP_AGNOSTIC_CONFIG_ERROR) {
#line 320 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
									g_propagate_error (error, _inner_error0_);
#line 320 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
									_g_object_unref0 (st);
#line 320 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
									G_IS_VALUE (&value) ? (g_value_unset (&value), NULL) : NULL;
#line 320 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
									_g_object_unref0 (schema_option);
#line 320 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
									return;
#line 2051 "config-impl-gconf.c"
								} else {
#line 320 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
									_g_object_unref0 (st);
#line 320 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
									G_IS_VALUE (&value) ? (g_value_unset (&value), NULL) : NULL;
#line 320 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
									_g_object_unref0 (schema_option);
#line 320 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
									g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 320 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
									g_clear_error (&_inner_error0_);
#line 320 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
									return;
#line 2065 "config-impl-gconf.c"
								}
							}
#line 320 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
							_tmp31_ = _tmp27_;
#line 320 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
							memset (&_tmp27_, 0, sizeof (GValue));
#line 320 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
							G_IS_VALUE (&value) ? (g_value_unset (&value), NULL) : NULL;
#line 320 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
							value = _tmp31_;
#line 314 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
							G_IS_VALUE (&_tmp27_) ? (g_value_unset (&_tmp27_), NULL) : NULL;
#line 2078 "config-impl-gconf.c"
						}
#line 301 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						_g_object_unref0 (st);
#line 2082 "config-impl-gconf.c"
					}
				}
			}
		}
	}
#line 323 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	*result = value;
#line 323 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_g_object_unref0 (schema_option);
#line 323 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	return;
#line 2094 "config-impl-gconf.c"
}

static GValueArray*
desktop_agnostic_config_gconf_backend_slist_to_valuearray (DesktopAgnosticConfigGConfBackend* self,
                                                           GSList* list,
                                                           GType type,
                                                           GError** error)
{
	GValueArray* arr = NULL;
	GValueArray* _tmp0_;
	GError* _inner_error0_ = NULL;
	GValueArray* result;
#line 326 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 329 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp0_ = g_value_array_new (g_slist_length (list));
#line 329 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	arr = _tmp0_;
#line 2113 "config-impl-gconf.c"
	{
		GSList* gc_val_collection = NULL;
		GSList* gc_val_it = NULL;
#line 330 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		gc_val_collection = list;
#line 330 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		for (gc_val_it = gc_val_collection; gc_val_it != NULL; gc_val_it = gc_val_it->next) {
#line 2121 "config-impl-gconf.c"
			GConfValue* gc_val = NULL;
#line 330 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			gc_val = (GConfValue*) gc_val_it->data;
#line 2125 "config-impl-gconf.c"
			{
				GValue val = {0};
				GValueArray* _tmp21_;
				GValue _tmp22_;
#line 334 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				if (type == G_TYPE_BOOLEAN) {
#line 2132 "config-impl-gconf.c"
					GConfValue* _tmp1_;
					GValue _tmp2_ = {0};
#line 336 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					_tmp1_ = gc_val;
#line 336 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					g_value_init (&_tmp2_, G_TYPE_BOOLEAN);
#line 336 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					g_value_set_boolean (&_tmp2_, gconf_value_get_bool (_tmp1_));
#line 336 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 336 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					val = _tmp2_;
#line 2145 "config-impl-gconf.c"
				} else {
#line 338 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					if (type == G_TYPE_FLOAT) {
#line 2149 "config-impl-gconf.c"
						GConfValue* _tmp3_;
						GValue _tmp4_ = {0};
#line 340 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						_tmp3_ = gc_val;
#line 340 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						g_value_init (&_tmp4_, G_TYPE_FLOAT);
#line 340 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						g_value_set_float (&_tmp4_, (gfloat) gconf_value_get_float (_tmp3_));
#line 340 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 340 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						val = _tmp4_;
#line 2162 "config-impl-gconf.c"
					} else {
#line 342 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						if (type == G_TYPE_INT) {
#line 2166 "config-impl-gconf.c"
							GConfValue* _tmp5_;
							GValue _tmp6_ = {0};
#line 344 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
							_tmp5_ = gc_val;
#line 344 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
							g_value_init (&_tmp6_, G_TYPE_INT);
#line 344 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
							g_value_set_int (&_tmp6_, gconf_value_get_int (_tmp5_));
#line 344 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
							G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 344 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
							val = _tmp6_;
#line 2179 "config-impl-gconf.c"
						} else {
#line 346 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
							if (type == G_TYPE_STRING) {
#line 2183 "config-impl-gconf.c"
								GConfValue* _tmp7_;
								const gchar* _tmp8_;
								GValue _tmp9_ = {0};
#line 348 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
								_tmp7_ = gc_val;
#line 348 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
								_tmp8_ = gconf_value_get_string (_tmp7_);
#line 348 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
								g_value_init (&_tmp9_, G_TYPE_STRING);
#line 348 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
								g_value_set_string (&_tmp9_, _tmp8_);
#line 348 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
								G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 348 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
								val = _tmp9_;
#line 2199 "config-impl-gconf.c"
							} else {
								DesktopAgnosticConfigSchemaType* st = NULL;
								DesktopAgnosticConfigSchemaType* _tmp10_;
								DesktopAgnosticConfigSchemaType* _tmp11_;
								DesktopAgnosticConfigSchemaType* _tmp12_;
#line 352 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
								_tmp10_ = desktop_agnostic_config_schema_find_type (type);
#line 352 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
								_tmp11_ = _g_object_ref0 (_tmp10_);
#line 352 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
								st = _tmp11_;
#line 353 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
								_tmp12_ = st;
#line 353 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
								if (_tmp12_ == NULL) {
#line 2215 "config-impl-gconf.c"
									const gchar* _tmp13_;
									GError* _tmp14_;
#line 355 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
									_tmp13_ = g_type_name (type);
#line 355 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
									_tmp14_ = g_error_new (DESKTOP_AGNOSTIC_CONFIG_ERROR, DESKTOP_AGNOSTIC_CONFIG_ERROR_INVALID_TYPE, "Invalid config value type: %s.", _tmp13_);
#line 355 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
									_inner_error0_ = _tmp14_;
#line 355 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
									if (_inner_error0_->domain == DESKTOP_AGNOSTIC_CONFIG_ERROR) {
#line 355 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
										g_propagate_error (error, _inner_error0_);
#line 355 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
										_g_object_unref0 (st);
#line 355 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
										G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 355 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
										_g_value_array_free0 (arr);
#line 355 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
										return NULL;
#line 2236 "config-impl-gconf.c"
									} else {
#line 355 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
										_g_object_unref0 (st);
#line 355 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
										G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 355 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
										_g_value_array_free0 (arr);
#line 355 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
										g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 355 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
										g_clear_error (&_inner_error0_);
#line 355 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
										return NULL;
#line 2250 "config-impl-gconf.c"
									}
								} else {
									GValue _tmp15_ = {0};
									DesktopAgnosticConfigSchemaType* _tmp16_;
									GConfValue* _tmp17_;
									const gchar* _tmp18_;
									GValue _tmp19_ = {0};
									GValue _tmp20_;
#line 360 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
									_tmp16_ = st;
#line 360 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
									_tmp17_ = gc_val;
#line 360 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
									_tmp18_ = gconf_value_get_string (_tmp17_);
#line 360 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
									desktop_agnostic_config_schema_type_deserialize (_tmp16_, _tmp18_, &_tmp19_, &_inner_error0_);
#line 360 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
									_tmp15_ = _tmp19_;
#line 360 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
									if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 360 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
										if (_inner_error0_->domain == DESKTOP_AGNOSTIC_CONFIG_ERROR) {
#line 360 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
											g_propagate_error (error, _inner_error0_);
#line 360 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
											_g_object_unref0 (st);
#line 360 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
											G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 360 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
											_g_value_array_free0 (arr);
#line 360 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
											return NULL;
#line 2283 "config-impl-gconf.c"
										} else {
#line 360 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
											_g_object_unref0 (st);
#line 360 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
											G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 360 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
											_g_value_array_free0 (arr);
#line 360 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
											g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 360 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
											g_clear_error (&_inner_error0_);
#line 360 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
											return NULL;
#line 2297 "config-impl-gconf.c"
										}
									}
#line 360 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
									_tmp20_ = _tmp15_;
#line 360 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
									memset (&_tmp15_, 0, sizeof (GValue));
#line 360 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
									G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 360 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
									val = _tmp20_;
#line 353 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
									G_IS_VALUE (&_tmp15_) ? (g_value_unset (&_tmp15_), NULL) : NULL;
#line 2310 "config-impl-gconf.c"
								}
#line 346 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
								_g_object_unref0 (st);
#line 2314 "config-impl-gconf.c"
							}
						}
					}
				}
#line 363 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				_tmp21_ = arr;
#line 363 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				_tmp22_ = val;
#line 363 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				g_value_array_append (_tmp21_, &_tmp22_);
#line 330 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 2327 "config-impl-gconf.c"
			}
		}
	}
#line 365 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	result = arr;
#line 365 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	return result;
#line 2335 "config-impl-gconf.c"
}

static void
desktop_agnostic_config_gconf_backend_notify_proxy (DesktopAgnosticConfigGConfBackend* self,
                                                    GConfClient* client,
                                                    guint cnxn_id,
                                                    GConfEntry* entry)
{
	gchar* full_key = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* group = NULL;
	gchar* key = NULL;
	GValue value = {0};
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	GValue _tmp4_ = {0};
	GConfValue* _tmp5_;
	GValue _tmp6_ = {0};
	GValue _tmp7_;
	GSList* notify_func_list = NULL;
	gconstpointer _tmp8_;
	GSList* _tmp9_;
	GError* _inner_error0_ = NULL;
#line 368 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	g_return_if_fail (self != NULL);
#line 368 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	g_return_if_fail (client != NULL);
#line 368 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	g_return_if_fail (entry != NULL);
#line 371 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp0_ = gconf_entry_get_key (entry);
#line 371 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 371 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	full_key = _tmp1_;
#line 376 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	desktop_agnostic_config_gconf_backend_parse_group_and_key (self, full_key, &_tmp2_, &_tmp3_);
#line 376 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_g_free0 (group);
#line 376 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	group = _tmp2_;
#line 376 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_g_free0 (key);
#line 376 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	key = _tmp3_;
#line 377 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp5_ = gconf_entry_get_value (entry);
#line 377 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	desktop_agnostic_config_gconf_backend_gconfvalue_to_gvalue (self, group, key, _tmp5_, &_tmp6_, &_inner_error0_);
#line 377 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp4_ = _tmp6_;
#line 377 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 377 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		G_IS_VALUE (&value) ? (g_value_unset (&value), NULL) : NULL;
#line 377 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_g_free0 (key);
#line 377 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_g_free0 (group);
#line 377 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_g_free0 (full_key);
#line 377 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 377 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		g_clear_error (&_inner_error0_);
#line 377 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		return;
#line 2404 "config-impl-gconf.c"
	}
#line 377 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp7_ = _tmp4_;
#line 377 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	memset (&_tmp4_, 0, sizeof (GValue));
#line 377 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	G_IS_VALUE (&value) ? (g_value_unset (&value), NULL) : NULL;
#line 377 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	value = _tmp7_;
#line 378 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp8_ = g_datalist_get_data (&self->priv->_notifiers, full_key);
#line 378 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	notify_func_list = (GSList*) _tmp8_;
#line 380 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp9_ = notify_func_list;
#line 2420 "config-impl-gconf.c"
	{
		GSList* notify_func_collection = NULL;
		GSList* notify_func_it = NULL;
#line 380 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		notify_func_collection = _tmp9_;
#line 380 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		for (notify_func_it = notify_func_collection; notify_func_it != NULL; notify_func_it = notify_func_it->next) {
#line 2428 "config-impl-gconf.c"
			DesktopAgnosticConfigNotifyDelegate* notify_func = NULL;
#line 380 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			notify_func = (DesktopAgnosticConfigNotifyDelegate*) notify_func_it->data;
#line 2432 "config-impl-gconf.c"
			{
				DesktopAgnosticConfigNotifyDelegate* _tmp10_;
				GValue _tmp11_;
#line 382 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				_tmp10_ = notify_func;
#line 382 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				_tmp11_ = value;
#line 382 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				desktop_agnostic_config_notify_delegate_execute (_tmp10_, group, key, &_tmp11_);
#line 2442 "config-impl-gconf.c"
			}
		}
	}
#line 368 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	G_IS_VALUE (&_tmp4_) ? (g_value_unset (&_tmp4_), NULL) : NULL;
#line 368 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	G_IS_VALUE (&value) ? (g_value_unset (&value), NULL) : NULL;
#line 368 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_g_free0 (key);
#line 368 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_g_free0 (group);
#line 368 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_g_free0 (full_key);
#line 2456 "config-impl-gconf.c"
}

static void
_desktop_agnostic_config_gconf_backend_ensure_key_exists (DesktopAgnosticConfigGConfBackend* self,
                                                          const gchar* group,
                                                          const gchar* key,
                                                          GError** error)
{
	DesktopAgnosticConfigSchema* _tmp0_;
	DesktopAgnosticConfigSchema* _tmp1_;
	DesktopAgnosticConfigSchemaOption* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 386 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	g_return_if_fail (self != NULL);
#line 386 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	g_return_if_fail (group != NULL);
#line 386 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	g_return_if_fail (key != NULL);
#line 389 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp0_ = desktop_agnostic_config_backend_get_schema ((DesktopAgnosticConfigBackend*) self);
#line 389 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp1_ = _tmp0_;
#line 389 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp2_ = desktop_agnostic_config_schema_get_option (_tmp1_, group, key);
#line 389 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	if (_tmp2_ == NULL) {
#line 2483 "config-impl-gconf.c"
		GError* _tmp3_;
#line 391 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_tmp3_ = g_error_new (DESKTOP_AGNOSTIC_CONFIG_ERROR, DESKTOP_AGNOSTIC_CONFIG_ERROR_KEY_NOT_FOUND, "The config key '%s/%s' does not exist in the schema.", group, key);
#line 391 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_inner_error0_ = _tmp3_;
#line 391 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		if (_inner_error0_->domain == DESKTOP_AGNOSTIC_CONFIG_ERROR) {
#line 391 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			g_propagate_error (error, _inner_error0_);
#line 391 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			return;
#line 2495 "config-impl-gconf.c"
		} else {
#line 391 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 391 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			g_clear_error (&_inner_error0_);
#line 391 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			return;
#line 2503 "config-impl-gconf.c"
		}
	}
}

static void
desktop_agnostic_config_gconf_backend_real_remove (DesktopAgnosticConfigBackend* base,
                                                   GError** error)
{
	DesktopAgnosticConfigGConfBackend * self;
	GConfClient* _tmp0_;
	const gchar* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 396 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	self = (DesktopAgnosticConfigGConfBackend*) base;
#line 399 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp0_ = self->priv->client;
#line 399 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp1_ = self->priv->path;
#line 399 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	gconf_client_recursive_unset (_tmp0_, _tmp1_, 0, &_inner_error0_);
#line 399 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 399 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		g_propagate_error (error, _inner_error0_);
#line 399 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		return;
#line 2530 "config-impl-gconf.c"
	}
}

static void
desktop_agnostic_config_gconf_backend_real_notify_add (DesktopAgnosticConfigBackend* base,
                                                       const gchar* group,
                                                       const gchar* key,
                                                       DesktopAgnosticConfigNotifyFunc callback,
                                                       gpointer callback_target,
                                                       GError** error)
{
	DesktopAgnosticConfigGConfBackend * self;
	DesktopAgnosticConfigNotifyDelegate* notify = NULL;
	gchar* full_key = NULL;
	GSList* callbacks = NULL;
	DesktopAgnosticConfigNotifyDelegate* _tmp0_;
	gchar* _tmp1_;
	gconstpointer _tmp2_;
	DesktopAgnosticConfigNotifyDelegate* _tmp3_;
#line 402 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	self = (DesktopAgnosticConfigGConfBackend*) base;
#line 402 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	g_return_if_fail (group != NULL);
#line 402 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	g_return_if_fail (key != NULL);
#line 409 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp0_ = desktop_agnostic_config_notify_delegate_new (callback, callback_target);
#line 409 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_desktop_agnostic_config_notify_delegate_free0 (notify);
#line 409 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	notify = _tmp0_;
#line 410 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp1_ = desktop_agnostic_config_gconf_backend_generate_key (self, group, key);
#line 410 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_g_free0 (full_key);
#line 410 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	full_key = _tmp1_;
#line 411 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp2_ = g_datalist_get_data (&self->priv->_notifiers, full_key);
#line 411 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	callbacks = (GSList*) _tmp2_;
#line 412 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp3_ = notify;
#line 412 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	notify = NULL;
#line 412 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	callbacks = g_slist_append (callbacks, _tmp3_);
#line 413 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	g_datalist_set_data (&self->priv->_notifiers, full_key, callbacks);
#line 402 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_g_free0 (full_key);
#line 402 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_desktop_agnostic_config_notify_delegate_free0 (notify);
#line 2584 "config-impl-gconf.c"
}

static void
desktop_agnostic_config_gconf_backend_real_notify (DesktopAgnosticConfigBackend* base,
                                                   const gchar* group,
                                                   const gchar* key,
                                                   GError** error)
{
	DesktopAgnosticConfigGConfBackend * self;
	gchar* full_key = NULL;
	gchar* _tmp0_;
	GSList* notifications = NULL;
	GValue value = {0};
	gconstpointer _tmp1_;
	GValue _tmp2_ = {0};
	GValue _tmp3_ = {0};
	GValue _tmp4_;
	GError* _inner_error0_ = NULL;
#line 416 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	self = (DesktopAgnosticConfigGConfBackend*) base;
#line 416 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	g_return_if_fail (group != NULL);
#line 416 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	g_return_if_fail (key != NULL);
#line 419 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp0_ = desktop_agnostic_config_gconf_backend_generate_key (self, group, key);
#line 419 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	full_key = _tmp0_;
#line 423 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp1_ = g_datalist_get_data (&self->priv->_notifiers, full_key);
#line 423 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	notifications = (GSList*) _tmp1_;
#line 424 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	desktop_agnostic_config_backend_get_value ((DesktopAgnosticConfigBackend*) self, group, key, &_tmp3_, &_inner_error0_);
#line 424 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp2_ = _tmp3_;
#line 424 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 424 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		g_propagate_error (error, _inner_error0_);
#line 424 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		G_IS_VALUE (&value) ? (g_value_unset (&value), NULL) : NULL;
#line 424 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_g_free0 (full_key);
#line 424 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		return;
#line 2631 "config-impl-gconf.c"
	}
#line 424 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp4_ = _tmp2_;
#line 424 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	memset (&_tmp2_, 0, sizeof (GValue));
#line 424 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	G_IS_VALUE (&value) ? (g_value_unset (&value), NULL) : NULL;
#line 424 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	value = _tmp4_;
#line 2641 "config-impl-gconf.c"
	{
		GSList* notify_collection = NULL;
		GSList* notify_it = NULL;
#line 425 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		notify_collection = notifications;
#line 425 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		for (notify_it = notify_collection; notify_it != NULL; notify_it = notify_it->next) {
#line 2649 "config-impl-gconf.c"
			DesktopAgnosticConfigNotifyDelegate* notify = NULL;
#line 425 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			notify = (DesktopAgnosticConfigNotifyDelegate*) notify_it->data;
#line 2653 "config-impl-gconf.c"
			{
				DesktopAgnosticConfigNotifyDelegate* _tmp5_;
				GValue _tmp6_;
#line 427 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				_tmp5_ = notify;
#line 427 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				_tmp6_ = value;
#line 427 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				desktop_agnostic_config_notify_delegate_execute (_tmp5_, group, key, &_tmp6_);
#line 2663 "config-impl-gconf.c"
			}
		}
	}
#line 416 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	G_IS_VALUE (&_tmp2_) ? (g_value_unset (&_tmp2_), NULL) : NULL;
#line 416 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	G_IS_VALUE (&value) ? (g_value_unset (&value), NULL) : NULL;
#line 416 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_g_free0 (full_key);
#line 2673 "config-impl-gconf.c"
}

static void
desktop_agnostic_config_gconf_backend_real_notify_remove (DesktopAgnosticConfigBackend* base,
                                                          const gchar* group,
                                                          const gchar* key,
                                                          DesktopAgnosticConfigNotifyFunc callback,
                                                          gpointer callback_target,
                                                          GError** error)
{
	DesktopAgnosticConfigGConfBackend * self;
	gchar* full_key = NULL;
	gchar* _tmp0_;
	GSList* funcs = NULL;
	const gchar* _tmp1_;
	gconstpointer _tmp2_;
	DesktopAgnosticConfigNotifyDelegate* ndata = NULL;
	DesktopAgnosticConfigNotifyDelegate* _tmp3_;
	GSList* node = NULL;
	GSList* _tmp4_;
	DesktopAgnosticConfigNotifyDelegate* _tmp5_;
	GSList* _tmp6_;
	GSList* _tmp7_;
#line 431 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	self = (DesktopAgnosticConfigGConfBackend*) base;
#line 431 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	g_return_if_fail (group != NULL);
#line 431 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	g_return_if_fail (key != NULL);
#line 435 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp0_ = desktop_agnostic_config_gconf_backend_generate_key (self, group, key);
#line 435 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	full_key = _tmp0_;
#line 436 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp1_ = full_key;
#line 436 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp2_ = g_datalist_get_data (&self->priv->_notifiers, _tmp1_);
#line 436 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	funcs = (GSList*) _tmp2_;
#line 437 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp3_ = desktop_agnostic_config_notify_delegate_new (callback, callback_target);
#line 437 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	ndata = _tmp3_;
#line 440 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp4_ = funcs;
#line 440 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp5_ = ndata;
#line 440 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp6_ = g_slist_find_custom (_tmp4_, _tmp5_, (GCompareFunc) desktop_agnostic_config_notify_delegate_compare);
#line 440 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	node = _tmp6_;
#line 441 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp7_ = node;
#line 441 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	if (_tmp7_ != NULL) {
#line 2729 "config-impl-gconf.c"
		GSList* _tmp8_;
		GSList* _tmp9_;
		const gchar* _tmp10_;
		GSList* _tmp11_;
#line 443 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_tmp8_ = node;
#line 443 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_desktop_agnostic_config_notify_delegate_free0 (_tmp8_->data);
#line 443 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_tmp8_->data = NULL;
#line 444 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_tmp9_ = node;
#line 444 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		funcs = g_slist_delete_link (funcs, _tmp9_);
#line 445 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_tmp10_ = full_key;
#line 445 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_tmp11_ = funcs;
#line 445 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		g_datalist_set_data (&self->priv->_notifiers, _tmp10_, _tmp11_);
#line 2750 "config-impl-gconf.c"
	}
#line 431 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_desktop_agnostic_config_notify_delegate_free0 (ndata);
#line 431 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_g_free0 (full_key);
#line 2756 "config-impl-gconf.c"
}

static void
desktop_agnostic_config_gconf_backend_real_reset (DesktopAgnosticConfigBackend* base,
                                                  GError** error)
{
	DesktopAgnosticConfigGConfBackend * self;
	DesktopAgnosticConfigSchema* schema = NULL;
	DesktopAgnosticConfigSchema* _tmp0_;
	DesktopAgnosticConfigSchema* _tmp1_;
	DesktopAgnosticConfigSchema* _tmp2_;
	DesktopAgnosticConfigSchema* _tmp3_;
	GList* _tmp4_;
	GError* _inner_error0_ = NULL;
#line 449 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	self = (DesktopAgnosticConfigGConfBackend*) base;
#line 452 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp0_ = desktop_agnostic_config_backend_get_schema ((DesktopAgnosticConfigBackend*) self);
#line 452 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp1_ = _tmp0_;
#line 452 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 452 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	schema = _tmp2_;
#line 454 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp3_ = schema;
#line 454 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp4_ = desktop_agnostic_config_schema_get_groups (_tmp3_);
#line 2785 "config-impl-gconf.c"
	{
		GList* group_collection = NULL;
		GList* group_it = NULL;
#line 454 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		group_collection = _tmp4_;
#line 454 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		for (group_it = group_collection; group_it != NULL; group_it = group_it->next) {
#line 2793 "config-impl-gconf.c"
			const gchar* group = NULL;
#line 454 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			group = (const gchar*) group_it->data;
#line 2797 "config-impl-gconf.c"
			{
				DesktopAgnosticConfigSchema* _tmp5_;
				const gchar* _tmp6_;
				GList* _tmp7_;
#line 456 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				_tmp5_ = schema;
#line 456 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				_tmp6_ = group;
#line 456 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				_tmp7_ = desktop_agnostic_config_schema_get_keys (_tmp5_, _tmp6_);
#line 2808 "config-impl-gconf.c"
				{
					GList* key_collection = NULL;
					GList* key_it = NULL;
#line 456 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					key_collection = _tmp7_;
#line 456 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					for (key_it = key_collection; key_it != NULL; key_it = key_it->next) {
#line 2816 "config-impl-gconf.c"
						const gchar* key = NULL;
#line 456 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						key = (const gchar*) key_it->data;
#line 2820 "config-impl-gconf.c"
						{
							gchar* full_key = NULL;
							GConfValue* val = NULL;
							const gchar* _tmp8_;
							const gchar* _tmp9_;
							gchar* _tmp10_;
							GConfValue* _tmp11_ = NULL;
							GConfClient* _tmp12_;
							const gchar* _tmp13_;
							GConfValue* _tmp14_;
							GConfValue* _tmp15_;
							GConfClient* _tmp16_;
							const gchar* _tmp17_;
							GConfValue* _tmp18_;
#line 461 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
							_tmp8_ = group;
#line 461 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
							_tmp9_ = key;
#line 461 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
							_tmp10_ = desktop_agnostic_config_gconf_backend_generate_key (self, _tmp8_, _tmp9_);
#line 461 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
							_g_free0 (full_key);
#line 461 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
							full_key = _tmp10_;
#line 462 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
							_tmp12_ = self->priv->client;
#line 462 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
							_tmp13_ = full_key;
#line 462 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
							_tmp14_ = gconf_client_get_default_from_schema (_tmp12_, _tmp13_, &_inner_error0_);
#line 462 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
							_tmp11_ = _tmp14_;
#line 462 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 462 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
								g_propagate_error (error, _inner_error0_);
#line 462 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
								_gconf_value_free0 (val);
#line 462 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
								_g_free0 (full_key);
#line 462 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
								(group_collection == NULL) ? NULL : (group_collection = (g_list_free (group_collection), NULL));
#line 462 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
								_g_object_unref0 (schema);
#line 462 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
								return;
#line 2867 "config-impl-gconf.c"
							}
#line 462 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
							_tmp15_ = _tmp11_;
#line 462 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
							_tmp11_ = NULL;
#line 462 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
							_gconf_value_free0 (val);
#line 462 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
							val = _tmp15_;
#line 463 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
							_tmp16_ = self->priv->client;
#line 463 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
							_tmp17_ = full_key;
#line 463 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
							_tmp18_ = val;
#line 463 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
							gconf_client_set (_tmp16_, _tmp17_, _tmp18_, &_inner_error0_);
#line 463 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 463 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
								g_propagate_error (error, _inner_error0_);
#line 463 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
								_gconf_value_free0 (_tmp11_);
#line 463 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
								_gconf_value_free0 (val);
#line 463 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
								_g_free0 (full_key);
#line 463 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
								(group_collection == NULL) ? NULL : (group_collection = (g_list_free (group_collection), NULL));
#line 463 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
								_g_object_unref0 (schema);
#line 463 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
								return;
#line 2901 "config-impl-gconf.c"
							}
#line 456 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
							_gconf_value_free0 (_tmp11_);
#line 456 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
							_gconf_value_free0 (val);
#line 456 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
							_g_free0 (full_key);
#line 2909 "config-impl-gconf.c"
						}
					}
				}
			}
		}
#line 454 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		(group_collection == NULL) ? NULL : (group_collection = (g_list_free (group_collection), NULL));
#line 2917 "config-impl-gconf.c"
	}
#line 449 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_g_object_unref0 (schema);
#line 2921 "config-impl-gconf.c"
}

static void
desktop_agnostic_config_gconf_backend_real_get_value (DesktopAgnosticConfigBackend* base,
                                                      const gchar* group,
                                                      const gchar* key,
                                                      GValue* result,
                                                      GError** error)
{
	DesktopAgnosticConfigGConfBackend * self;
	gchar* full_key = NULL;
	GConfValue* gc_val = NULL;
	GConfEntry* entry = NULL;
	GValue val = {0};
	gchar* _tmp0_;
	GConfEntry* _tmp1_ = NULL;
	GConfClient* _tmp2_;
	const gchar* _tmp3_;
	GConfEntry* _tmp4_;
	GConfEntry* _tmp5_;
	GConfEntry* _tmp6_;
	GConfValue* _tmp7_;
	GConfValue* _tmp8_;
	GError* _inner_error0_ = NULL;
#line 468 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	self = (DesktopAgnosticConfigGConfBackend*) base;
#line 468 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	g_return_if_fail (group != NULL);
#line 468 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	g_return_if_fail (key != NULL);
#line 476 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp0_ = desktop_agnostic_config_gconf_backend_generate_key (self, group, key);
#line 476 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_g_free0 (full_key);
#line 476 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	full_key = _tmp0_;
#line 477 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp2_ = self->priv->client;
#line 477 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp3_ = full_key;
#line 477 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp4_ = gconf_client_get_entry (_tmp2_, _tmp3_, NULL, TRUE, &_inner_error0_);
#line 477 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp1_ = _tmp4_;
#line 477 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 477 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		g_propagate_error (error, _inner_error0_);
#line 477 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 477 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_gconf_entry_unref0 (entry);
#line 477 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_g_free0 (full_key);
#line 477 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		return;
#line 2978 "config-impl-gconf.c"
	}
#line 477 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp5_ = _tmp1_;
#line 477 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp1_ = NULL;
#line 477 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_gconf_entry_unref0 (entry);
#line 477 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	entry = _tmp5_;
#line 478 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp6_ = entry;
#line 478 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp7_ = gconf_entry_get_value (_tmp6_);
#line 478 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	gc_val = _tmp7_;
#line 479 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp8_ = gc_val;
#line 479 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	if (_tmp8_ == NULL) {
#line 2998 "config-impl-gconf.c"
		const gchar* _tmp9_;
		GError* _tmp10_;
#line 481 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_tmp9_ = full_key;
#line 481 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_tmp10_ = g_error_new (DESKTOP_AGNOSTIC_CONFIG_ERROR, DESKTOP_AGNOSTIC_CONFIG_ERROR_KEY_NOT_FOUND, "Could not find the key specified: %s.", _tmp9_);
#line 481 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_inner_error0_ = _tmp10_;
#line 481 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		g_propagate_error (error, _inner_error0_);
#line 481 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_gconf_entry_unref0 (_tmp1_);
#line 481 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 481 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_gconf_entry_unref0 (entry);
#line 481 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_g_free0 (full_key);
#line 481 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		return;
#line 3019 "config-impl-gconf.c"
	} else {
		GValue _tmp11_ = {0};
		GConfValue* _tmp12_;
		GValue _tmp13_ = {0};
		GValue _tmp14_;
#line 486 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_tmp12_ = gc_val;
#line 486 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		desktop_agnostic_config_gconf_backend_gconfvalue_to_gvalue (self, group, key, _tmp12_, &_tmp13_, &_inner_error0_);
#line 486 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_tmp11_ = _tmp13_;
#line 486 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 486 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			g_propagate_error (error, _inner_error0_);
#line 486 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			_gconf_entry_unref0 (_tmp1_);
#line 486 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 486 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			_gconf_entry_unref0 (entry);
#line 486 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			_g_free0 (full_key);
#line 486 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			return;
#line 3045 "config-impl-gconf.c"
		}
#line 486 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_tmp14_ = _tmp11_;
#line 486 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		memset (&_tmp11_, 0, sizeof (GValue));
#line 486 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 486 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		val = _tmp14_;
#line 479 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		G_IS_VALUE (&_tmp11_) ? (g_value_unset (&_tmp11_), NULL) : NULL;
#line 3057 "config-impl-gconf.c"
	}
#line 489 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	*result = val;
#line 489 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_gconf_entry_unref0 (_tmp1_);
#line 489 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_gconf_entry_unref0 (entry);
#line 489 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_g_free0 (full_key);
#line 489 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	return;
#line 3069 "config-impl-gconf.c"
}

static gboolean
desktop_agnostic_config_gconf_backend_real_get_bool (DesktopAgnosticConfigBackend* base,
                                                     const gchar* group,
                                                     const gchar* key,
                                                     GError** error)
{
	DesktopAgnosticConfigGConfBackend * self;
	gchar* full_key = NULL;
	gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	GConfClient* _tmp3_;
	const gchar* _tmp4_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 491 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	self = (DesktopAgnosticConfigGConfBackend*) base;
#line 491 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	g_return_val_if_fail (group != NULL, FALSE);
#line 491 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	g_return_val_if_fail (key != NULL, FALSE);
#line 496 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_desktop_agnostic_config_gconf_backend_ensure_key_exists (self, group, key, &_inner_error0_);
#line 496 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3096 "config-impl-gconf.c"
		gboolean _tmp0_ = FALSE;
#line 496 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		g_propagate_error (error, _inner_error0_);
#line 496 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_g_free0 (full_key);
#line 496 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		return _tmp0_;
#line 3104 "config-impl-gconf.c"
	}
#line 497 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp1_ = desktop_agnostic_config_gconf_backend_generate_key (self, group, key);
#line 497 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_g_free0 (full_key);
#line 497 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	full_key = _tmp1_;
#line 498 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp3_ = self->priv->client;
#line 498 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp4_ = full_key;
#line 498 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp2_ = gconf_client_get_bool (_tmp3_, _tmp4_, &_inner_error0_);
#line 498 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3120 "config-impl-gconf.c"
		gboolean _tmp5_ = FALSE;
#line 498 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		g_propagate_error (error, _inner_error0_);
#line 498 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_g_free0 (full_key);
#line 498 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		return _tmp5_;
#line 3128 "config-impl-gconf.c"
	}
#line 498 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	result = _tmp2_;
#line 498 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_g_free0 (full_key);
#line 498 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	return result;
#line 3136 "config-impl-gconf.c"
}

static void
desktop_agnostic_config_gconf_backend_real_set_bool (DesktopAgnosticConfigBackend* base,
                                                     const gchar* group,
                                                     const gchar* key,
                                                     gboolean value,
                                                     GError** error)
{
	DesktopAgnosticConfigGConfBackend * self;
	gchar* full_key = NULL;
	gchar* _tmp0_;
	GConfClient* _tmp1_;
	const gchar* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 500 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	self = (DesktopAgnosticConfigGConfBackend*) base;
#line 500 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	g_return_if_fail (group != NULL);
#line 500 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	g_return_if_fail (key != NULL);
#line 505 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_desktop_agnostic_config_gconf_backend_ensure_key_exists (self, group, key, &_inner_error0_);
#line 505 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 505 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		g_propagate_error (error, _inner_error0_);
#line 505 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_g_free0 (full_key);
#line 505 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		return;
#line 3168 "config-impl-gconf.c"
	}
#line 506 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp0_ = desktop_agnostic_config_gconf_backend_generate_key (self, group, key);
#line 506 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_g_free0 (full_key);
#line 506 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	full_key = _tmp0_;
#line 507 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp1_ = self->priv->client;
#line 507 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp2_ = full_key;
#line 507 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	gconf_client_set_bool (_tmp1_, _tmp2_, value, &_inner_error0_);
#line 507 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 507 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		g_propagate_error (error, _inner_error0_);
#line 507 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_g_free0 (full_key);
#line 507 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		return;
#line 3190 "config-impl-gconf.c"
	}
#line 500 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_g_free0 (full_key);
#line 3194 "config-impl-gconf.c"
}

static gfloat
desktop_agnostic_config_gconf_backend_real_get_float (DesktopAgnosticConfigBackend* base,
                                                      const gchar* group,
                                                      const gchar* key,
                                                      GError** error)
{
	DesktopAgnosticConfigGConfBackend * self;
	gchar* full_key = NULL;
	gchar* _tmp1_;
	gdouble _tmp2_ = 0.0;
	GConfClient* _tmp3_;
	const gchar* _tmp4_;
	GError* _inner_error0_ = NULL;
	gfloat result;
#line 509 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	self = (DesktopAgnosticConfigGConfBackend*) base;
#line 509 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	g_return_val_if_fail (group != NULL, 0.0F);
#line 509 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	g_return_val_if_fail (key != NULL, 0.0F);
#line 514 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_desktop_agnostic_config_gconf_backend_ensure_key_exists (self, group, key, &_inner_error0_);
#line 514 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3221 "config-impl-gconf.c"
		gfloat _tmp0_ = -1.0F;
#line 514 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		g_propagate_error (error, _inner_error0_);
#line 514 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_g_free0 (full_key);
#line 514 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		return _tmp0_;
#line 3229 "config-impl-gconf.c"
	}
#line 515 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp1_ = desktop_agnostic_config_gconf_backend_generate_key (self, group, key);
#line 515 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_g_free0 (full_key);
#line 515 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	full_key = _tmp1_;
#line 516 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp3_ = self->priv->client;
#line 516 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp4_ = full_key;
#line 516 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp2_ = gconf_client_get_float (_tmp3_, _tmp4_, &_inner_error0_);
#line 516 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3245 "config-impl-gconf.c"
		gfloat _tmp5_ = -1.0F;
#line 516 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		g_propagate_error (error, _inner_error0_);
#line 516 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_g_free0 (full_key);
#line 516 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		return _tmp5_;
#line 3253 "config-impl-gconf.c"
	}
#line 516 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	result = (gfloat) _tmp2_;
#line 516 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_g_free0 (full_key);
#line 516 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	return result;
#line 3261 "config-impl-gconf.c"
}

static void
desktop_agnostic_config_gconf_backend_real_set_float (DesktopAgnosticConfigBackend* base,
                                                      const gchar* group,
                                                      const gchar* key,
                                                      gfloat value,
                                                      GError** error)
{
	DesktopAgnosticConfigGConfBackend * self;
	gchar* full_key = NULL;
	gchar* _tmp0_;
	GConfClient* _tmp1_;
	const gchar* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 518 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	self = (DesktopAgnosticConfigGConfBackend*) base;
#line 518 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	g_return_if_fail (group != NULL);
#line 518 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	g_return_if_fail (key != NULL);
#line 523 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_desktop_agnostic_config_gconf_backend_ensure_key_exists (self, group, key, &_inner_error0_);
#line 523 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 523 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		g_propagate_error (error, _inner_error0_);
#line 523 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_g_free0 (full_key);
#line 523 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		return;
#line 3293 "config-impl-gconf.c"
	}
#line 524 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp0_ = desktop_agnostic_config_gconf_backend_generate_key (self, group, key);
#line 524 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_g_free0 (full_key);
#line 524 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	full_key = _tmp0_;
#line 525 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp1_ = self->priv->client;
#line 525 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp2_ = full_key;
#line 525 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	gconf_client_set_float (_tmp1_, _tmp2_, (gdouble) value, &_inner_error0_);
#line 525 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 525 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		g_propagate_error (error, _inner_error0_);
#line 525 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_g_free0 (full_key);
#line 525 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		return;
#line 3315 "config-impl-gconf.c"
	}
#line 518 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_g_free0 (full_key);
#line 3319 "config-impl-gconf.c"
}

static gint
desktop_agnostic_config_gconf_backend_real_get_int (DesktopAgnosticConfigBackend* base,
                                                    const gchar* group,
                                                    const gchar* key,
                                                    GError** error)
{
	DesktopAgnosticConfigGConfBackend * self;
	gchar* full_key = NULL;
	gchar* _tmp1_;
	gint _tmp2_ = 0;
	GConfClient* _tmp3_;
	const gchar* _tmp4_;
	GError* _inner_error0_ = NULL;
	gint result;
#line 527 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	self = (DesktopAgnosticConfigGConfBackend*) base;
#line 527 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	g_return_val_if_fail (group != NULL, 0);
#line 527 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	g_return_val_if_fail (key != NULL, 0);
#line 532 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_desktop_agnostic_config_gconf_backend_ensure_key_exists (self, group, key, &_inner_error0_);
#line 532 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3346 "config-impl-gconf.c"
		gint _tmp0_ = -1;
#line 532 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		g_propagate_error (error, _inner_error0_);
#line 532 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_g_free0 (full_key);
#line 532 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		return _tmp0_;
#line 3354 "config-impl-gconf.c"
	}
#line 533 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp1_ = desktop_agnostic_config_gconf_backend_generate_key (self, group, key);
#line 533 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_g_free0 (full_key);
#line 533 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	full_key = _tmp1_;
#line 534 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp3_ = self->priv->client;
#line 534 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp4_ = full_key;
#line 534 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp2_ = gconf_client_get_int (_tmp3_, _tmp4_, &_inner_error0_);
#line 534 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3370 "config-impl-gconf.c"
		gint _tmp5_ = -1;
#line 534 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		g_propagate_error (error, _inner_error0_);
#line 534 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_g_free0 (full_key);
#line 534 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		return _tmp5_;
#line 3378 "config-impl-gconf.c"
	}
#line 534 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	result = _tmp2_;
#line 534 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_g_free0 (full_key);
#line 534 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	return result;
#line 3386 "config-impl-gconf.c"
}

static void
desktop_agnostic_config_gconf_backend_real_set_int (DesktopAgnosticConfigBackend* base,
                                                    const gchar* group,
                                                    const gchar* key,
                                                    gint value,
                                                    GError** error)
{
	DesktopAgnosticConfigGConfBackend * self;
	gchar* full_key = NULL;
	gchar* _tmp0_;
	GConfClient* _tmp1_;
	const gchar* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 536 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	self = (DesktopAgnosticConfigGConfBackend*) base;
#line 536 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	g_return_if_fail (group != NULL);
#line 536 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	g_return_if_fail (key != NULL);
#line 541 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_desktop_agnostic_config_gconf_backend_ensure_key_exists (self, group, key, &_inner_error0_);
#line 541 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 541 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		g_propagate_error (error, _inner_error0_);
#line 541 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_g_free0 (full_key);
#line 541 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		return;
#line 3418 "config-impl-gconf.c"
	}
#line 542 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp0_ = desktop_agnostic_config_gconf_backend_generate_key (self, group, key);
#line 542 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_g_free0 (full_key);
#line 542 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	full_key = _tmp0_;
#line 543 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp1_ = self->priv->client;
#line 543 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp2_ = full_key;
#line 543 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	gconf_client_set_int (_tmp1_, _tmp2_, value, &_inner_error0_);
#line 543 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 543 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		g_propagate_error (error, _inner_error0_);
#line 543 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_g_free0 (full_key);
#line 543 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		return;
#line 3440 "config-impl-gconf.c"
	}
#line 536 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_g_free0 (full_key);
#line 3444 "config-impl-gconf.c"
}

static gchar*
desktop_agnostic_config_gconf_backend_real_get_string (DesktopAgnosticConfigBackend* base,
                                                       const gchar* group,
                                                       const gchar* key,
                                                       GError** error)
{
	DesktopAgnosticConfigGConfBackend * self;
	gchar* full_key = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_ = NULL;
	GConfClient* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 545 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	self = (DesktopAgnosticConfigGConfBackend*) base;
#line 545 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	g_return_val_if_fail (group != NULL, NULL);
#line 545 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	g_return_val_if_fail (key != NULL, NULL);
#line 550 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_desktop_agnostic_config_gconf_backend_ensure_key_exists (self, group, key, &_inner_error0_);
#line 550 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 550 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		g_propagate_error (error, _inner_error0_);
#line 550 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_g_free0 (full_key);
#line 550 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		return NULL;
#line 3479 "config-impl-gconf.c"
	}
#line 551 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp0_ = desktop_agnostic_config_gconf_backend_generate_key (self, group, key);
#line 551 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_g_free0 (full_key);
#line 551 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	full_key = _tmp0_;
#line 552 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp2_ = self->priv->client;
#line 552 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp3_ = full_key;
#line 552 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp4_ = gconf_client_get_string (_tmp2_, _tmp3_, &_inner_error0_);
#line 552 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp1_ = _tmp4_;
#line 552 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 552 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		g_propagate_error (error, _inner_error0_);
#line 552 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_g_free0 (full_key);
#line 552 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		return NULL;
#line 3503 "config-impl-gconf.c"
	}
#line 552 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp5_ = _tmp1_;
#line 552 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp1_ = NULL;
#line 552 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	result = _tmp5_;
#line 552 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_g_free0 (_tmp1_);
#line 552 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_g_free0 (full_key);
#line 552 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	return result;
#line 3517 "config-impl-gconf.c"
}

static void
desktop_agnostic_config_gconf_backend_real_set_string (DesktopAgnosticConfigBackend* base,
                                                       const gchar* group,
                                                       const gchar* key,
                                                       const gchar* value,
                                                       GError** error)
{
	DesktopAgnosticConfigGConfBackend * self;
	gchar* full_key = NULL;
	gchar* _tmp0_;
	GConfClient* _tmp1_;
	const gchar* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 554 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	self = (DesktopAgnosticConfigGConfBackend*) base;
#line 554 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	g_return_if_fail (group != NULL);
#line 554 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	g_return_if_fail (key != NULL);
#line 554 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	g_return_if_fail (value != NULL);
#line 559 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_desktop_agnostic_config_gconf_backend_ensure_key_exists (self, group, key, &_inner_error0_);
#line 559 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 559 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		g_propagate_error (error, _inner_error0_);
#line 559 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_g_free0 (full_key);
#line 559 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		return;
#line 3551 "config-impl-gconf.c"
	}
#line 560 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp0_ = desktop_agnostic_config_gconf_backend_generate_key (self, group, key);
#line 560 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_g_free0 (full_key);
#line 560 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	full_key = _tmp0_;
#line 561 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp1_ = self->priv->client;
#line 561 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp2_ = full_key;
#line 561 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	gconf_client_set_string (_tmp1_, _tmp2_, value, &_inner_error0_);
#line 561 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 561 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		g_propagate_error (error, _inner_error0_);
#line 561 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_g_free0 (full_key);
#line 561 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		return;
#line 3573 "config-impl-gconf.c"
	}
#line 554 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_g_free0 (full_key);
#line 3577 "config-impl-gconf.c"
}

static GValueArray*
desktop_agnostic_config_gconf_backend_real_get_list (DesktopAgnosticConfigBackend* base,
                                                     const gchar* group,
                                                     const gchar* key,
                                                     GError** error)
{
	DesktopAgnosticConfigGConfBackend * self;
	gchar* full_key = NULL;
	GType list_type = 0UL;
	GConfValue* gc_val = NULL;
	gchar* _tmp0_;
	DesktopAgnosticConfigSchema* _tmp1_;
	DesktopAgnosticConfigSchema* _tmp2_;
	DesktopAgnosticConfigSchemaOption* _tmp3_;
	GType _tmp4_;
	GType _tmp5_;
	GConfValue* _tmp6_ = NULL;
	GConfClient* _tmp7_;
	const gchar* _tmp8_;
	GConfValue* _tmp9_;
	GConfValue* _tmp10_;
	GValueArray* _tmp11_ = NULL;
	GConfValue* _tmp12_;
	GSList* _tmp13_;
	GValueArray* _tmp14_;
	GValueArray* _tmp15_;
	GError* _inner_error0_ = NULL;
	GValueArray* result;
#line 563 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	self = (DesktopAgnosticConfigGConfBackend*) base;
#line 563 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	g_return_val_if_fail (group != NULL, NULL);
#line 563 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	g_return_val_if_fail (key != NULL, NULL);
#line 570 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_desktop_agnostic_config_gconf_backend_ensure_key_exists (self, group, key, &_inner_error0_);
#line 570 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 570 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		g_propagate_error (error, _inner_error0_);
#line 570 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_gconf_value_free0 (gc_val);
#line 570 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_g_free0 (full_key);
#line 570 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		return NULL;
#line 3626 "config-impl-gconf.c"
	}
#line 571 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp0_ = desktop_agnostic_config_gconf_backend_generate_key (self, group, key);
#line 571 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_g_free0 (full_key);
#line 571 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	full_key = _tmp0_;
#line 572 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp1_ = desktop_agnostic_config_backend_get_schema ((DesktopAgnosticConfigBackend*) self);
#line 572 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp2_ = _tmp1_;
#line 572 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp3_ = desktop_agnostic_config_schema_get_option (_tmp2_, group, key);
#line 572 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp4_ = desktop_agnostic_config_schema_option_get_list_type (_tmp3_);
#line 572 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp5_ = _tmp4_;
#line 572 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	list_type = _tmp5_;
#line 573 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp7_ = self->priv->client;
#line 573 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp8_ = full_key;
#line 573 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp9_ = gconf_client_get (_tmp7_, _tmp8_, &_inner_error0_);
#line 573 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp6_ = _tmp9_;
#line 573 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 573 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		g_propagate_error (error, _inner_error0_);
#line 573 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_gconf_value_free0 (gc_val);
#line 573 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_g_free0 (full_key);
#line 573 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		return NULL;
#line 3664 "config-impl-gconf.c"
	}
#line 573 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp10_ = _tmp6_;
#line 573 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp6_ = NULL;
#line 573 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_gconf_value_free0 (gc_val);
#line 573 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	gc_val = _tmp10_;
#line 574 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp12_ = gc_val;
#line 574 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp13_ = gconf_value_get_list (_tmp12_);
#line 574 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp14_ = desktop_agnostic_config_gconf_backend_slist_to_valuearray (self, _tmp13_, list_type, &_inner_error0_);
#line 574 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp11_ = _tmp14_;
#line 574 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 574 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		g_propagate_error (error, _inner_error0_);
#line 574 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_gconf_value_free0 (_tmp6_);
#line 574 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_gconf_value_free0 (gc_val);
#line 574 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_g_free0 (full_key);
#line 574 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		return NULL;
#line 3694 "config-impl-gconf.c"
	}
#line 574 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp15_ = _tmp11_;
#line 574 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp11_ = NULL;
#line 574 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	result = _tmp15_;
#line 574 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_g_value_array_free0 (_tmp11_);
#line 574 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_gconf_value_free0 (_tmp6_);
#line 574 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_gconf_value_free0 (gc_val);
#line 574 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_g_free0 (full_key);
#line 574 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	return result;
#line 3712 "config-impl-gconf.c"
}

static void
_gconf_value_free0_ (gpointer var)
{
#line 592 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	(var == NULL) ? NULL : (var = (gconf_value_free (var), NULL));
#line 3720 "config-impl-gconf.c"
}

static inline void
_g_slist_free__gconf_value_free0_ (GSList* self)
{
#line 592 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	g_slist_free_full (self, (GDestroyNotify) _gconf_value_free0_);
#line 3728 "config-impl-gconf.c"
}

static void
desktop_agnostic_config_gconf_backend_real_set_list (DesktopAgnosticConfigBackend* base,
                                                     const gchar* group,
                                                     const gchar* key,
                                                     GValueArray* value,
                                                     GError** error)
{
	DesktopAgnosticConfigGConfBackend * self;
	gchar* full_key = NULL;
	GType type = 0UL;
	gchar* _tmp0_;
	DesktopAgnosticConfigSchema* _tmp1_;
	DesktopAgnosticConfigSchema* _tmp2_;
	DesktopAgnosticConfigSchemaOption* _tmp3_;
	GType _tmp4_;
	GType _tmp5_;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 576 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	self = (DesktopAgnosticConfigGConfBackend*) base;
#line 576 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	g_return_if_fail (group != NULL);
#line 576 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	g_return_if_fail (key != NULL);
#line 576 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	g_return_if_fail (value != NULL);
#line 582 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_desktop_agnostic_config_gconf_backend_ensure_key_exists (self, group, key, &_inner_error0_);
#line 582 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 582 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		g_propagate_error (error, _inner_error0_);
#line 582 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_g_free0 (full_key);
#line 582 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		return;
#line 3768 "config-impl-gconf.c"
	}
#line 583 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp0_ = desktop_agnostic_config_gconf_backend_generate_key (self, group, key);
#line 583 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_g_free0 (full_key);
#line 583 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	full_key = _tmp0_;
#line 584 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp1_ = desktop_agnostic_config_backend_get_schema ((DesktopAgnosticConfigBackend*) self);
#line 584 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp2_ = _tmp1_;
#line 584 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp3_ = desktop_agnostic_config_schema_get_option (_tmp2_, group, key);
#line 584 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp4_ = desktop_agnostic_config_schema_option_get_list_type (_tmp3_);
#line 584 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp5_ = _tmp4_;
#line 584 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	type = _tmp5_;
#line 585 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	if (type == G_TYPE_BOOLEAN) {
#line 585 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_tmp7_ = TRUE;
#line 3792 "config-impl-gconf.c"
	} else {
#line 585 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_tmp7_ = type == G_TYPE_FLOAT;
#line 3796 "config-impl-gconf.c"
	}
#line 585 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	if (_tmp7_) {
#line 585 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_tmp6_ = TRUE;
#line 3802 "config-impl-gconf.c"
	} else {
#line 586 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_tmp6_ = type == G_TYPE_INT;
#line 3806 "config-impl-gconf.c"
	}
#line 585 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	if (_tmp6_) {
#line 3810 "config-impl-gconf.c"
		GSList* list = NULL;
		GConfValue* val = NULL;
		GConfValueType gc_type = 0;
		GConfValue* _tmp19_;
		GConfValue* _tmp20_;
		GConfValue* _tmp21_;
		GSList* _tmp22_;
		GConfClient* _tmp23_;
		const gchar* _tmp24_;
		GConfValue* _tmp25_;
#line 590 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		gc_type = desktop_agnostic_config_gconf_backend_type_to_valuetype (self, type);
#line 592 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		(list == NULL) ? NULL : (list = (_g_slist_free__gconf_value_free0_ (list), NULL));
#line 592 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		list = NULL;
#line 3827 "config-impl-gconf.c"
		{
			GValueArray* list_val_collection = NULL;
			guint list_val_index = 0U;
#line 593 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			list_val_collection = value;
#line 593 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			for (list_val_index = 0; list_val_index < list_val_collection->n_values; list_val_index = list_val_index + 1) {
#line 3835 "config-impl-gconf.c"
				GValue list_val = {0};
#line 593 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				list_val = *g_value_array_get_nth (list_val_collection, list_val_index);
#line 3839 "config-impl-gconf.c"
				{
					GConfValue* gc_val = NULL;
					GConfValue* _tmp8_;
					GConfValue* _tmp18_;
#line 597 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					_tmp8_ = gconf_value_new (gc_type);
#line 597 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					_gconf_value_free0 (gc_val);
#line 597 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					gc_val = _tmp8_;
#line 598 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					if (type == G_TYPE_BOOLEAN) {
#line 3852 "config-impl-gconf.c"
						GConfValue* _tmp9_;
#line 600 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						_tmp9_ = gc_val;
#line 600 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						gconf_value_set_bool (_tmp9_, g_value_get_boolean (&list_val));
#line 3858 "config-impl-gconf.c"
					} else {
#line 602 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						if (type == G_TYPE_FLOAT) {
#line 3862 "config-impl-gconf.c"
							gfloat _tmp10_ = 0.0F;
							GValue _tmp11_;
							GConfValue* _tmp12_;
#line 604 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
							_tmp11_ = list_val;
#line 604 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
							_tmp10_ = desktop_agnostic_config_backend_get_float_from_value (&_tmp11_, &_inner_error0_);
#line 604 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 604 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
								g_propagate_error (error, _inner_error0_);
#line 604 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
								_gconf_value_free0 (gc_val);
#line 604 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
								_gconf_value_free0 (val);
#line 604 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
								(list == NULL) ? NULL : (list = (_g_slist_free__gconf_value_free0_ (list), NULL));
#line 604 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
								_g_free0 (full_key);
#line 604 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
								return;
#line 3884 "config-impl-gconf.c"
							}
#line 604 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
							_tmp12_ = gc_val;
#line 604 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
							gconf_value_set_float (_tmp12_, (gdouble) _tmp10_);
#line 3890 "config-impl-gconf.c"
						} else {
#line 606 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
							if (type == G_TYPE_INT) {
#line 3894 "config-impl-gconf.c"
								gint _tmp13_ = 0;
								GValue _tmp14_;
								GConfValue* _tmp15_;
#line 608 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
								_tmp14_ = list_val;
#line 608 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
								_tmp13_ = desktop_agnostic_config_backend_get_int_from_value (&_tmp14_, &_inner_error0_);
#line 608 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
								if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 608 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
									g_propagate_error (error, _inner_error0_);
#line 608 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
									_gconf_value_free0 (gc_val);
#line 608 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
									_gconf_value_free0 (val);
#line 608 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
									(list == NULL) ? NULL : (list = (_g_slist_free__gconf_value_free0_ (list), NULL));
#line 608 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
									_g_free0 (full_key);
#line 608 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
									return;
#line 3916 "config-impl-gconf.c"
								}
#line 608 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
								_tmp15_ = gc_val;
#line 608 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
								gconf_value_set_int (_tmp15_, _tmp13_);
#line 3922 "config-impl-gconf.c"
							} else {
								const gchar* _tmp16_;
								GError* _tmp17_;
#line 613 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
								_tmp16_ = g_type_name (type);
#line 613 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
								_tmp17_ = g_error_new (DESKTOP_AGNOSTIC_CONFIG_ERROR, DESKTOP_AGNOSTIC_CONFIG_ERROR_INVALID_TYPE, "Invalid config value type: %s.", _tmp16_);
#line 613 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
								_inner_error0_ = _tmp17_;
#line 613 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
								g_propagate_error (error, _inner_error0_);
#line 613 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
								_gconf_value_free0 (gc_val);
#line 613 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
								_gconf_value_free0 (val);
#line 613 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
								(list == NULL) ? NULL : (list = (_g_slist_free__gconf_value_free0_ (list), NULL));
#line 613 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
								_g_free0 (full_key);
#line 613 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
								return;
#line 3944 "config-impl-gconf.c"
							}
						}
					}
#line 616 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					_tmp18_ = gc_val;
#line 616 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					gc_val = NULL;
#line 616 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					list = g_slist_append (list, _tmp18_);
#line 593 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					_gconf_value_free0 (gc_val);
#line 3956 "config-impl-gconf.c"
				}
			}
		}
#line 618 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_tmp19_ = gconf_value_new (GCONF_VALUE_LIST);
#line 618 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_gconf_value_free0 (val);
#line 618 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		val = _tmp19_;
#line 619 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_tmp20_ = val;
#line 619 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		gconf_value_set_list_type (_tmp20_, gc_type);
#line 620 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_tmp21_ = val;
#line 620 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_tmp22_ = list;
#line 620 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		gconf_value_set_list (_tmp21_, _tmp22_);
#line 621 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_tmp23_ = self->priv->client;
#line 621 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_tmp24_ = full_key;
#line 621 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_tmp25_ = val;
#line 621 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		gconf_client_set (_tmp23_, _tmp24_, _tmp25_, &_inner_error0_);
#line 621 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 621 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			g_propagate_error (error, _inner_error0_);
#line 621 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			_gconf_value_free0 (val);
#line 621 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			(list == NULL) ? NULL : (list = (_g_slist_free__gconf_value_free0_ (list), NULL));
#line 621 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			_g_free0 (full_key);
#line 621 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			return;
#line 3996 "config-impl-gconf.c"
		}
#line 585 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_gconf_value_free0 (val);
#line 585 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		(list == NULL) ? NULL : (list = (_g_slist_free__gconf_value_free0_ (list), NULL));
#line 4002 "config-impl-gconf.c"
	} else {
		DesktopAgnosticConfigSchemaType* st = NULL;
		GSList* list = NULL;
		GConfClient* _tmp39_;
		const gchar* _tmp40_;
		GSList* _tmp41_;
#line 625 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		st = NULL;
#line 628 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		if (type != G_TYPE_STRING) {
#line 4013 "config-impl-gconf.c"
			DesktopAgnosticConfigSchemaType* _tmp26_;
			DesktopAgnosticConfigSchemaType* _tmp27_;
			DesktopAgnosticConfigSchemaType* _tmp28_;
#line 630 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			_tmp26_ = desktop_agnostic_config_schema_find_type (type);
#line 630 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			_tmp27_ = _g_object_ref0 (_tmp26_);
#line 630 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			_g_object_unref0 (st);
#line 630 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			st = _tmp27_;
#line 631 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			_tmp28_ = st;
#line 631 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			if (_tmp28_ == NULL) {
#line 4029 "config-impl-gconf.c"
				const gchar* _tmp29_;
				GError* _tmp30_;
#line 633 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				_tmp29_ = g_type_name (type);
#line 633 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				_tmp30_ = g_error_new (DESKTOP_AGNOSTIC_CONFIG_ERROR, DESKTOP_AGNOSTIC_CONFIG_ERROR_INVALID_TYPE, "Invalid config value type: %s.", _tmp29_);
#line 633 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				_inner_error0_ = _tmp30_;
#line 633 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				g_propagate_error (error, _inner_error0_);
#line 633 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				(list == NULL) ? NULL : (list = (_g_slist_free__g_free0_ (list), NULL));
#line 633 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				_g_object_unref0 (st);
#line 633 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				_g_free0 (full_key);
#line 633 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				return;
#line 4048 "config-impl-gconf.c"
			}
		}
#line 638 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		(list == NULL) ? NULL : (list = (_g_slist_free__g_free0_ (list), NULL));
#line 638 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		list = NULL;
#line 4055 "config-impl-gconf.c"
		{
			GValueArray* list_val_collection = NULL;
			guint list_val_index = 0U;
#line 640 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			list_val_collection = value;
#line 640 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			for (list_val_index = 0; list_val_index < list_val_collection->n_values; list_val_index = list_val_index + 1) {
#line 4063 "config-impl-gconf.c"
				GValue list_val = {0};
#line 640 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
				list_val = *g_value_array_get_nth (list_val_collection, list_val_index);
#line 4067 "config-impl-gconf.c"
				{
					DesktopAgnosticConfigSchemaType* _tmp31_;
#line 642 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					_tmp31_ = st;
#line 642 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
					if (_tmp31_ == NULL) {
#line 4074 "config-impl-gconf.c"
						GValue _tmp32_;
						gchar* _tmp33_;
#line 644 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						_tmp32_ = list_val;
#line 644 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						_tmp33_ = g_strdup (g_value_get_string (&_tmp32_));
#line 644 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						list = g_slist_append (list, _tmp33_);
#line 4083 "config-impl-gconf.c"
					} else {
						gchar* _tmp34_ = NULL;
						DesktopAgnosticConfigSchemaType* _tmp35_;
						GValue _tmp36_;
						gchar* _tmp37_;
						gchar* _tmp38_;
#line 648 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						_tmp35_ = st;
#line 648 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						_tmp36_ = list_val;
#line 648 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						_tmp37_ = desktop_agnostic_config_schema_type_serialize (_tmp35_, &_tmp36_, &_inner_error0_);
#line 648 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						_tmp34_ = _tmp37_;
#line 648 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 648 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
							g_propagate_error (error, _inner_error0_);
#line 648 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
							(list == NULL) ? NULL : (list = (_g_slist_free__g_free0_ (list), NULL));
#line 648 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
							_g_object_unref0 (st);
#line 648 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
							_g_free0 (full_key);
#line 648 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
							return;
#line 4110 "config-impl-gconf.c"
						}
#line 648 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						_tmp38_ = _tmp34_;
#line 648 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						_tmp34_ = NULL;
#line 648 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						list = g_slist_append (list, _tmp38_);
#line 642 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
						_g_free0 (_tmp34_);
#line 4120 "config-impl-gconf.c"
					}
				}
			}
		}
#line 651 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_tmp39_ = self->priv->client;
#line 651 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_tmp40_ = full_key;
#line 651 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_tmp41_ = list;
#line 651 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		gconf_client_set_list (_tmp39_, _tmp40_, GCONF_VALUE_STRING, _tmp41_, &_inner_error0_);
#line 651 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 651 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			g_propagate_error (error, _inner_error0_);
#line 651 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			(list == NULL) ? NULL : (list = (_g_slist_free__g_free0_ (list), NULL));
#line 651 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			_g_object_unref0 (st);
#line 651 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			_g_free0 (full_key);
#line 651 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
			return;
#line 4145 "config-impl-gconf.c"
		}
#line 585 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		(list == NULL) ? NULL : (list = (_g_slist_free__g_free0_ (list), NULL));
#line 585 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_g_object_unref0 (st);
#line 4151 "config-impl-gconf.c"
	}
#line 576 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_g_free0 (full_key);
#line 4155 "config-impl-gconf.c"
}

DesktopAgnosticConfigGConfBackend*
desktop_agnostic_config_gconf_backend_construct (GType object_type)
{
	DesktopAgnosticConfigGConfBackend * self = NULL;
#line 28 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	self = (DesktopAgnosticConfigGConfBackend*) desktop_agnostic_config_backend_construct (object_type);
#line 28 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	return self;
#line 4166 "config-impl-gconf.c"
}

DesktopAgnosticConfigGConfBackend*
desktop_agnostic_config_gconf_backend_new (void)
{
#line 28 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	return desktop_agnostic_config_gconf_backend_construct (DESKTOP_AGNOSTIC_CONFIG_TYPE_GCONF_BACKEND);
#line 4174 "config-impl-gconf.c"
}

static gchar*
desktop_agnostic_config_gconf_backend_real_get_name (DesktopAgnosticConfigBackend* base)
{
	gchar* result;
	DesktopAgnosticConfigGConfBackend* self;
	gchar* _tmp0_;
#line 38 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	self = (DesktopAgnosticConfigGConfBackend*) base;
#line 40 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp0_ = g_strdup (DESKTOP_AGNOSTIC_CONFIG_BACKEND_NAME);
#line 40 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	result = _tmp0_;
#line 40 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	return result;
#line 4191 "config-impl-gconf.c"
}

static GObject *
desktop_agnostic_config_gconf_backend_constructor (GType type,
                                                   guint n_construct_properties,
                                                   GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	DesktopAgnosticConfigGConfBackend * self;
	GConfClient* _tmp0_;
#line 44 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	parent_class = G_OBJECT_CLASS (desktop_agnostic_config_gconf_backend_parent_class);
#line 44 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 44 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DESKTOP_AGNOSTIC_CONFIG_TYPE_GCONF_BACKEND, DesktopAgnosticConfigGConfBackend);
#line 46 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp0_ = gconf_client_get_default ();
#line 46 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	self->priv->client = _tmp0_;
#line 44 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	return obj;
#line 4215 "config-impl-gconf.c"
}

static void
desktop_agnostic_config_gconf_backend_class_init (DesktopAgnosticConfigGConfBackendClass * klass,
                                                  gpointer klass_data)
{
#line 28 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	desktop_agnostic_config_gconf_backend_parent_class = g_type_class_peek_parent (klass);
#line 28 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	g_type_class_adjust_private_offset (klass, &DesktopAgnosticConfigGConfBackend_private_offset);
#line 28 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	((GObjectClass *) klass)->constructed = (void (*) (GObject*)) desktop_agnostic_config_gconf_backend_real_constructed;
#line 28 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	((DesktopAgnosticConfigBackendClass *) klass)->remove = (void (*) (DesktopAgnosticConfigBackend*, GError**)) desktop_agnostic_config_gconf_backend_real_remove;
#line 28 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	((DesktopAgnosticConfigBackendClass *) klass)->notify_add = (void (*) (DesktopAgnosticConfigBackend*, const gchar*, const gchar*, DesktopAgnosticConfigNotifyFunc, gpointer, GError**)) desktop_agnostic_config_gconf_backend_real_notify_add;
#line 28 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	((DesktopAgnosticConfigBackendClass *) klass)->notify = (void (*) (DesktopAgnosticConfigBackend*, const gchar*, const gchar*, GError**)) desktop_agnostic_config_gconf_backend_real_notify;
#line 28 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	((DesktopAgnosticConfigBackendClass *) klass)->notify_remove = (void (*) (DesktopAgnosticConfigBackend*, const gchar*, const gchar*, DesktopAgnosticConfigNotifyFunc, gpointer, GError**)) desktop_agnostic_config_gconf_backend_real_notify_remove;
#line 28 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	((DesktopAgnosticConfigBackendClass *) klass)->reset = (void (*) (DesktopAgnosticConfigBackend*, GError**)) desktop_agnostic_config_gconf_backend_real_reset;
#line 28 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	((DesktopAgnosticConfigBackendClass *) klass)->get_value = (void (*) (DesktopAgnosticConfigBackend*, const gchar*, const gchar*, GValue*, GError**)) desktop_agnostic_config_gconf_backend_real_get_value;
#line 28 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	((DesktopAgnosticConfigBackendClass *) klass)->get_bool = (gboolean (*) (DesktopAgnosticConfigBackend*, const gchar*, const gchar*, GError**)) desktop_agnostic_config_gconf_backend_real_get_bool;
#line 28 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	((DesktopAgnosticConfigBackendClass *) klass)->set_bool = (void (*) (DesktopAgnosticConfigBackend*, const gchar*, const gchar*, gboolean, GError**)) desktop_agnostic_config_gconf_backend_real_set_bool;
#line 28 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	((DesktopAgnosticConfigBackendClass *) klass)->get_float = (gfloat (*) (DesktopAgnosticConfigBackend*, const gchar*, const gchar*, GError**)) desktop_agnostic_config_gconf_backend_real_get_float;
#line 28 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	((DesktopAgnosticConfigBackendClass *) klass)->set_float = (void (*) (DesktopAgnosticConfigBackend*, const gchar*, const gchar*, gfloat, GError**)) desktop_agnostic_config_gconf_backend_real_set_float;
#line 28 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	((DesktopAgnosticConfigBackendClass *) klass)->get_int = (gint (*) (DesktopAgnosticConfigBackend*, const gchar*, const gchar*, GError**)) desktop_agnostic_config_gconf_backend_real_get_int;
#line 28 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	((DesktopAgnosticConfigBackendClass *) klass)->set_int = (void (*) (DesktopAgnosticConfigBackend*, const gchar*, const gchar*, gint, GError**)) desktop_agnostic_config_gconf_backend_real_set_int;
#line 28 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	((DesktopAgnosticConfigBackendClass *) klass)->get_string = (gchar* (*) (DesktopAgnosticConfigBackend*, const gchar*, const gchar*, GError**)) desktop_agnostic_config_gconf_backend_real_get_string;
#line 28 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	((DesktopAgnosticConfigBackendClass *) klass)->set_string = (void (*) (DesktopAgnosticConfigBackend*, const gchar*, const gchar*, const gchar*, GError**)) desktop_agnostic_config_gconf_backend_real_set_string;
#line 28 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	((DesktopAgnosticConfigBackendClass *) klass)->get_list = (GValueArray* (*) (DesktopAgnosticConfigBackend*, const gchar*, const gchar*, GError**)) desktop_agnostic_config_gconf_backend_real_get_list;
#line 28 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	((DesktopAgnosticConfigBackendClass *) klass)->set_list = (void (*) (DesktopAgnosticConfigBackend*, const gchar*, const gchar*, GValueArray*, GError**)) desktop_agnostic_config_gconf_backend_real_set_list;
#line 28 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	DESKTOP_AGNOSTIC_CONFIG_BACKEND_CLASS (klass)->get_name = (gchar* (*) (DesktopAgnosticConfigBackend*)) desktop_agnostic_config_gconf_backend_real_get_name;
#line 28 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_desktop_agnostic_config_gconf_backend_get_property;
#line 28 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	G_OBJECT_CLASS (klass)->constructor = desktop_agnostic_config_gconf_backend_constructor;
#line 28 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	G_OBJECT_CLASS (klass)->finalize = desktop_agnostic_config_gconf_backend_finalize;
#line 28 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DESKTOP_AGNOSTIC_CONFIG_GCONF_BACKEND_NAME_PROPERTY, desktop_agnostic_config_gconf_backend_properties[DESKTOP_AGNOSTIC_CONFIG_GCONF_BACKEND_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 4270 "config-impl-gconf.c"
}

static void
desktop_agnostic_config_gconf_backend_instance_init (DesktopAgnosticConfigGConfBackend * self,
                                                     gpointer klass)
{
#line 28 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	self->priv = desktop_agnostic_config_gconf_backend_get_instance_private (self);
#line 4279 "config-impl-gconf.c"
}

static void
desktop_agnostic_config_gconf_backend_finalize (GObject * obj)
{
	DesktopAgnosticConfigGConfBackend * self;
	GError* _inner_error0_ = NULL;
#line 28 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DESKTOP_AGNOSTIC_CONFIG_TYPE_GCONF_BACKEND, DesktopAgnosticConfigGConfBackend);
#line 4289 "config-impl-gconf.c"
	{
		GConfClient* _tmp0_;
		GConfClient* _tmp1_;
		const gchar* _tmp2_;
#line 99 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_tmp0_ = self->priv->client;
#line 99 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		gconf_client_notify_remove (_tmp0_, self->priv->connection_id);
#line 100 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_tmp1_ = self->priv->client;
#line 100 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_tmp2_ = self->priv->path;
#line 100 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		gconf_client_remove_dir (_tmp1_, _tmp2_, &_inner_error0_);
#line 100 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4306 "config-impl-gconf.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
#line 97 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		err = _inner_error0_;
#line 97 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_inner_error0_ = NULL;
#line 104 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_tmp3_ = err;
#line 104 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_tmp4_ = _tmp3_->message;
#line 104 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		g_critical ("config-impl-gconf.vala:104: Config (GConf) error: %s", _tmp4_);
#line 97 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		_g_error_free0 (err);
#line 4328 "config-impl-gconf.c"
	}
	__finally0:
#line 97 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 97 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 97 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		g_clear_error (&_inner_error0_);
#line 4337 "config-impl-gconf.c"
	}
#line 30 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_g_free0 (self->priv->schema_path);
#line 31 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_g_free0 (self->priv->path);
#line 28 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	G_OBJECT_CLASS (desktop_agnostic_config_gconf_backend_parent_class)->finalize (obj);
#line 4345 "config-impl-gconf.c"
}

static GType
desktop_agnostic_config_gconf_backend_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DesktopAgnosticConfigGConfBackendClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) desktop_agnostic_config_gconf_backend_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DesktopAgnosticConfigGConfBackend), 0, (GInstanceInitFunc) desktop_agnostic_config_gconf_backend_instance_init, NULL };
	GType desktop_agnostic_config_gconf_backend_type_id;
	desktop_agnostic_config_gconf_backend_type_id = g_type_register_static (DESKTOP_AGNOSTIC_CONFIG_TYPE_BACKEND, "DesktopAgnosticConfigGConfBackend", &g_define_type_info, 0);
	DesktopAgnosticConfigGConfBackend_private_offset = g_type_add_instance_private (desktop_agnostic_config_gconf_backend_type_id, sizeof (DesktopAgnosticConfigGConfBackendPrivate));
	return desktop_agnostic_config_gconf_backend_type_id;
}

GType
desktop_agnostic_config_gconf_backend_get_type (void)
{
	static volatile gsize desktop_agnostic_config_gconf_backend_type_id__once = 0;
	if (g_once_init_enter (&desktop_agnostic_config_gconf_backend_type_id__once)) {
		GType desktop_agnostic_config_gconf_backend_type_id;
		desktop_agnostic_config_gconf_backend_type_id = desktop_agnostic_config_gconf_backend_get_type_once ();
		g_once_init_leave (&desktop_agnostic_config_gconf_backend_type_id__once, desktop_agnostic_config_gconf_backend_type_id);
	}
	return desktop_agnostic_config_gconf_backend_type_id__once;
}

static void
_vala_desktop_agnostic_config_gconf_backend_get_property (GObject * object,
                                                          guint property_id,
                                                          GValue * value,
                                                          GParamSpec * pspec)
{
	DesktopAgnosticConfigGConfBackend * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DESKTOP_AGNOSTIC_CONFIG_TYPE_GCONF_BACKEND, DesktopAgnosticConfigGConfBackend);
#line 28 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	switch (property_id) {
#line 28 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		case DESKTOP_AGNOSTIC_CONFIG_GCONF_BACKEND_NAME_PROPERTY:
#line 28 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		g_value_take_string (value, desktop_agnostic_config_backend_get_name ((DesktopAgnosticConfigBackend*) self));
#line 28 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		break;
#line 4386 "config-impl-gconf.c"
		default:
#line 28 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 28 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
		break;
#line 4392 "config-impl-gconf.c"
	}
}

static GValue*
_g_value_dup (GValue* self)
{
#line 665 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	return g_boxed_copy (G_TYPE_VALUE, self);
#line 4401 "config-impl-gconf.c"
}

static gpointer
__g_value_dup0 (gpointer self)
{
#line 665 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	return self ? _g_value_dup (self) : NULL;
#line 4409 "config-impl-gconf.c"
}

GType
register_plugin (void)
{
	GValue val = {0};
	GHashTable* backend_metadata_keys = NULL;
	GValue _tmp0_ = {0};
	GHashTable* _tmp1_;
	gchar* _tmp2_;
	GValue _tmp3_;
	GValue _tmp4_;
	GValue* _tmp5_;
	GValue _tmp6_ = {0};
	gchar* _tmp7_;
	GValue _tmp8_;
	GValue _tmp9_;
	GValue* _tmp10_;
	GType result;
#line 663 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	g_value_init (&_tmp0_, G_TYPE_STRING);
#line 663 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	g_value_set_string (&_tmp0_, "/apps");
#line 663 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 663 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	val = _tmp0_;
#line 664 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp1_ = desktop_agnostic_config_backend_get_backend_metadata_keys ();
#line 664 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	backend_metadata_keys = _tmp1_;
#line 665 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp2_ = g_strdup_printf ("%s.base_path", DESKTOP_AGNOSTIC_CONFIG_BACKEND_NAME);
#line 665 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp3_ = val;
#line 665 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp4_ = _tmp3_;
#line 665 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp5_ = __g_value_dup0 (&_tmp4_);
#line 665 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	g_hash_table_insert (backend_metadata_keys, _tmp2_, _tmp5_);
#line 666 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	g_value_init (&_tmp6_, G_TYPE_STRING);
#line 666 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	g_value_set_string (&_tmp6_, "${base_path}/instances");
#line 666 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 666 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	val = _tmp6_;
#line 667 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp7_ = g_strdup_printf ("%s.base_instance_path", DESKTOP_AGNOSTIC_CONFIG_BACKEND_NAME);
#line 667 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp8_ = val;
#line 667 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp9_ = _tmp8_;
#line 667 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	_tmp10_ = __g_value_dup0 (&_tmp9_);
#line 667 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	g_hash_table_insert (backend_metadata_keys, _tmp7_, _tmp10_);
#line 669 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	result = DESKTOP_AGNOSTIC_CONFIG_TYPE_GCONF_BACKEND;
#line 669 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 669 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-gconf.vala"
	return result;
#line 4475 "config-impl-gconf.c"
}

