/* config-impl-keyfile.c generated by valac 0.56.17, the Vala compiler
 * generated from config-impl-keyfile.vala, do not modify */

/*
 * A GKeyFile-based implementation of the Config interface.
 *
 * Copyright (C) 2009 Mark Lee <libdesktop-agnostic@lazymalevolence.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 *
 * Author : Mark Lee <libdesktop-agnostic@lazymalevolence.com>
 */

#include "da-cfg-keyfile.h"
#include <glib.h>
#include <desktop-agnostic-vfs.h>
#include <stdlib.h>
#include <string.h>
#include <config-notify-delegate.c>
#include <glib-object.h>
#include <desktop-agnostic-cfg.h>
#include <float.h>
#include <math.h>
#include <gio/gio.h>
#include <glib/gstdio.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	DESKTOP_AGNOSTIC_CONFIG_GKEY_FILE_0_PROPERTY,
	DESKTOP_AGNOSTIC_CONFIG_GKEY_FILE_NAME_PROPERTY,
	DESKTOP_AGNOSTIC_CONFIG_GKEY_FILE_NUM_PROPERTIES
};
static GParamSpec* desktop_agnostic_config_gkey_file_properties[DESKTOP_AGNOSTIC_CONFIG_GKEY_FILE_NUM_PROPERTIES];
#define _g_key_file_unref0(var) ((var == NULL) ? NULL : (var = (g_key_file_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_value_array_free0(var) ((var == NULL) ? NULL : (var = (g_value_array_free (var), NULL)))
#define _desktop_agnostic_config_notify_delegate_free0(var) ((var == NULL) ? NULL : (var = (desktop_agnostic_config_notify_delegate_free (var), NULL)))

struct _DesktopAgnosticConfigGKeyFilePrivate {
	GKeyFile* _data;
	DesktopAgnosticVFSFile* _keyfile;
	DesktopAgnosticVFSFileMonitor* _keyfile_monitor;
	gulong _monitor_changed_id;
	gchar* _checksum;
	gboolean _autosave;
	GData* _notifiers;
};

static gint DesktopAgnosticConfigGKeyFile_private_offset;
static gpointer desktop_agnostic_config_gkey_file_parent_class = NULL;

static void desktop_agnostic_config_gkey_file_save_config (DesktopAgnosticConfigGKeyFile* self,
                                                    gboolean calc_chksum,
                                                    GError** error);
static gchar* desktop_agnostic_config_gkey_file_calculate_checksum_from_data (DesktopAgnosticConfigGKeyFile* self,
                                                                       const gchar* data);
static void desktop_agnostic_config_gkey_file_calculate_checksum (DesktopAgnosticConfigGKeyFile* self);
static void desktop_agnostic_config_gkey_file_update_config (DesktopAgnosticConfigGKeyFile* self,
                                                      const gchar* group,
                                                      const gchar* key,
                                                      GError** error);
static void desktop_agnostic_config_gkey_file_load_data (DesktopAgnosticConfigGKeyFile* self,
                                                  DesktopAgnosticVFSFile* file);
static void desktop_agnostic_config_gkey_file_update_from_keyfile (DesktopAgnosticConfigGKeyFile* self,
                                                            const gchar* data,
                                                            GError** error);
static void desktop_agnostic_config_gkey_file_set_value_from_keyfile (DesktopAgnosticConfigGKeyFile* self,
                                                               GKeyFile* keyfile,
                                                               const gchar* group,
                                                               const gchar* key,
                                                               GError** error);
static GValueArray* desktop_agnostic_config_gkey_file_generate_valuearray_from_keyfile (DesktopAgnosticConfigGKeyFile* self,
                                                                                 GKeyFile* keyfile,
                                                                                 const gchar* group,
                                                                                 const gchar* key,
                                                                                 GError** error);
static gdouble* _vala_array_dup1 (gdouble* self,
                           gssize length);
static void desktop_agnostic_config_gkey_file_on_keyfile_changed (DesktopAgnosticConfigGKeyFile* self,
                                                           DesktopAgnosticVFSFile* file,
                                                           DesktopAgnosticVFSFile* other,
                                                           DesktopAgnosticVFSFileMonitorEvent event,
                                                           DesktopAgnosticVFSFileMonitor* monitor);
static void desktop_agnostic_config_gkey_file_ensure_directory (DesktopAgnosticConfigGKeyFile* self,
                                                         const gchar* path);
static gboolean desktop_agnostic_config_gkey_file_create_file_monitor (DesktopAgnosticConfigGKeyFile* self);
static void desktop_agnostic_config_gkey_file_real_constructed (GObject* base);
static void desktop_agnostic_config_gkey_file_reset_nosave (DesktopAgnosticConfigGKeyFile* self,
                                                     GError** error);
static gboolean _desktop_agnostic_config_gkey_file_create_file_monitor_gsource_func (gpointer self);
static void desktop_agnostic_config_gkey_file_real_reset (DesktopAgnosticConfigBackend* base,
                                                   GError** error);
static void desktop_agnostic_config_gkey_file_real_notify_add (DesktopAgnosticConfigBackend* base,
                                                        const gchar* group,
                                                        const gchar* key,
                                                        DesktopAgnosticConfigNotifyFunc callback,
                                                        gpointer callback_target,
                                                        GError** error);
static void desktop_agnostic_config_gkey_file_real_notify (DesktopAgnosticConfigBackend* base,
                                                    const gchar* group,
                                                    const gchar* key,
                                                    GError** error);
static void desktop_agnostic_config_gkey_file_real_notify_remove (DesktopAgnosticConfigBackend* base,
                                                           const gchar* group,
                                                           const gchar* key,
                                                           DesktopAgnosticConfigNotifyFunc callback,
                                                           gpointer callback_target,
                                                           GError** error);
static void desktop_agnostic_config_gkey_file_real_remove (DesktopAgnosticConfigBackend* base,
                                                    GError** error);
static void desktop_agnostic_config_gkey_file_real_get_value (DesktopAgnosticConfigBackend* base,
                                                       const gchar* group,
                                                       const gchar* key,
                                                       GValue* result,
                                                       GError** error);
static gboolean desktop_agnostic_config_gkey_file_real_get_bool (DesktopAgnosticConfigBackend* base,
                                                          const gchar* group,
                                                          const gchar* key,
                                                          GError** error);
static void desktop_agnostic_config_gkey_file_real_set_bool (DesktopAgnosticConfigBackend* base,
                                                      const gchar* group,
                                                      const gchar* key,
                                                      gboolean value,
                                                      GError** error);
static gfloat desktop_agnostic_config_gkey_file_real_get_float (DesktopAgnosticConfigBackend* base,
                                                         const gchar* group,
                                                         const gchar* key,
                                                         GError** error);
static void desktop_agnostic_config_gkey_file_real_set_float (DesktopAgnosticConfigBackend* base,
                                                       const gchar* group,
                                                       const gchar* key,
                                                       gfloat value,
                                                       GError** error);
static gint desktop_agnostic_config_gkey_file_real_get_int (DesktopAgnosticConfigBackend* base,
                                                     const gchar* group,
                                                     const gchar* key,
                                                     GError** error);
static void desktop_agnostic_config_gkey_file_real_set_int (DesktopAgnosticConfigBackend* base,
                                                     const gchar* group,
                                                     const gchar* key,
                                                     gint value,
                                                     GError** error);
static gchar* desktop_agnostic_config_gkey_file_real_get_string (DesktopAgnosticConfigBackend* base,
                                                          const gchar* group,
                                                          const gchar* key,
                                                          GError** error);
static void desktop_agnostic_config_gkey_file_real_set_string (DesktopAgnosticConfigBackend* base,
                                                        const gchar* group,
                                                        const gchar* key,
                                                        const gchar* value,
                                                        GError** error);
static GValueArray* desktop_agnostic_config_gkey_file_real_get_list (DesktopAgnosticConfigBackend* base,
                                                              const gchar* group,
                                                              const gchar* key,
                                                              GError** error);
static void desktop_agnostic_config_gkey_file_real_set_list (DesktopAgnosticConfigBackend* base,
                                                      const gchar* group,
                                                      const gchar* key,
                                                      GValueArray* value,
                                                      GError** error);
static void _vala_array_add1 (gboolean* * array,
                       gint* length,
                       gint* size,
                       gboolean value);
static void _vala_array_add2 (gint* * array,
                       gint* length,
                       gint* size,
                       gint value);
static void _vala_array_add3 (gdouble* * array,
                       gint* length,
                       gint* size,
                       gdouble value);
static void _vala_array_add4 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add5 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static GObject * desktop_agnostic_config_gkey_file_constructor (GType type,
                                                         guint n_construct_properties,
                                                         GObjectConstructParam * construct_properties);
static void desktop_agnostic_config_gkey_file_finalize (GObject * obj);
static GType desktop_agnostic_config_gkey_file_get_type_once (void);
static void _vala_desktop_agnostic_config_gkey_file_get_property (GObject * object,
                                                           guint property_id,
                                                           GValue * value,
                                                           GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
desktop_agnostic_config_gkey_file_get_instance_private (DesktopAgnosticConfigGKeyFile* self)
{
	return G_STRUCT_MEMBER_P (self, DesktopAgnosticConfigGKeyFile_private_offset);
}

/**
     * Saves the current state of the configuration to the filesystem,
     * suppressing the "changed" signal from the file monitor.
     */
static void
desktop_agnostic_config_gkey_file_save_config (DesktopAgnosticConfigGKeyFile* self,
                                               gboolean calc_chksum,
                                               GError** error)
{
	gchar* data = NULL;
	GKeyFile* _tmp0_;
	gchar* _tmp1_;
	DesktopAgnosticVFSFile* _tmp5_;
	const gchar* _tmp6_;
	GError* _inner_error0_ = NULL;
#line 59 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	g_return_if_fail (self != NULL);
#line 63 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp0_ = self->priv->_data;
#line 63 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp1_ = g_key_file_to_data (_tmp0_, NULL, NULL);
#line 63 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_g_free0 (data);
#line 63 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	data = _tmp1_;
#line 64 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	if (calc_chksum) {
#line 255 "config-impl-keyfile.c"
		const gchar* _tmp2_;
		gchar* _tmp3_;
#line 66 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp2_ = data;
#line 66 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp3_ = desktop_agnostic_config_gkey_file_calculate_checksum_from_data (self, _tmp2_);
#line 66 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_g_free0 (self->priv->_checksum);
#line 66 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		self->priv->_checksum = _tmp3_;
#line 266 "config-impl-keyfile.c"
	}
#line 69 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	if (self->priv->_monitor_changed_id != ((gulong) 0)) {
#line 270 "config-impl-keyfile.c"
		DesktopAgnosticVFSFileMonitor* _tmp4_;
#line 72 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp4_ = self->priv->_keyfile_monitor;
#line 72 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		g_signal_handler_block (_tmp4_, self->priv->_monitor_changed_id);
#line 276 "config-impl-keyfile.c"
	}
#line 75 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp5_ = self->priv->_keyfile;
#line 75 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp6_ = data;
#line 75 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	desktop_agnostic_vfs_file_replace_contents (_tmp5_, _tmp6_, &_inner_error0_);
#line 75 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 75 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		g_propagate_error (error, _inner_error0_);
#line 75 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_g_free0 (data);
#line 75 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		return;
#line 292 "config-impl-keyfile.c"
	}
#line 76 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	if (self->priv->_monitor_changed_id != ((gulong) 0)) {
#line 296 "config-impl-keyfile.c"
		DesktopAgnosticVFSFileMonitor* _tmp7_;
#line 79 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp7_ = self->priv->_keyfile_monitor;
#line 79 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		g_signal_handler_unblock (_tmp7_, self->priv->_monitor_changed_id);
#line 302 "config-impl-keyfile.c"
	}
#line 59 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_g_free0 (data);
#line 306 "config-impl-keyfile.c"
}

static gchar*
desktop_agnostic_config_gkey_file_calculate_checksum_from_data (DesktopAgnosticConfigGKeyFile* self,
                                                                const gchar* data)
{
	gint _tmp0_;
	gint _tmp1_;
	gchar* _tmp2_;
	gchar* result;
#line 83 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 83 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	g_return_val_if_fail (data != NULL, NULL);
#line 86 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp0_ = strlen (data);
#line 86 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp1_ = _tmp0_;
#line 86 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp2_ = g_compute_checksum_for_string (G_CHECKSUM_SHA256, data, (gsize) _tmp1_);
#line 86 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	result = _tmp2_;
#line 86 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	return result;
#line 331 "config-impl-keyfile.c"
}

static void
desktop_agnostic_config_gkey_file_calculate_checksum (DesktopAgnosticConfigGKeyFile* self)
{
	gchar* data = NULL;
	GKeyFile* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 89 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	g_return_if_fail (self != NULL);
#line 93 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp0_ = self->priv->_data;
#line 93 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp1_ = g_key_file_to_data (_tmp0_, NULL, NULL);
#line 93 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_g_free0 (data);
#line 93 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	data = _tmp1_;
#line 94 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp2_ = desktop_agnostic_config_gkey_file_calculate_checksum_from_data (self, data);
#line 94 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_g_free0 (self->priv->_checksum);
#line 94 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	self->priv->_checksum = _tmp2_;
#line 89 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_g_free0 (data);
#line 359 "config-impl-keyfile.c"
}

/**
     * Saves the current configuration state to the filesystem (if autosave is
     * on) and emits the notify signal.
     */
static void
desktop_agnostic_config_gkey_file_update_config (DesktopAgnosticConfigGKeyFile* self,
                                                 const gchar* group,
                                                 const gchar* key,
                                                 GError** error)
{
	GError* _inner_error0_ = NULL;
#line 101 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	g_return_if_fail (self != NULL);
#line 101 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	g_return_if_fail (group != NULL);
#line 101 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	g_return_if_fail (key != NULL);
#line 104 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	if (self->priv->_autosave) {
#line 106 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		desktop_agnostic_config_gkey_file_save_config (self, TRUE, &_inner_error0_);
#line 106 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 106 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			g_propagate_error (error, _inner_error0_);
#line 106 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			return;
#line 389 "config-impl-keyfile.c"
		}
	}
#line 108 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	desktop_agnostic_config_backend_notify ((DesktopAgnosticConfigBackend*) self, group, key, &_inner_error0_);
#line 108 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 108 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		g_propagate_error (error, _inner_error0_);
#line 108 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		return;
#line 400 "config-impl-keyfile.c"
	}
}

static void
desktop_agnostic_config_gkey_file_load_data (DesktopAgnosticConfigGKeyFile* self,
                                             DesktopAgnosticVFSFile* file)
{
	GError* _inner_error0_ = NULL;
#line 111 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	g_return_if_fail (self != NULL);
#line 111 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	g_return_if_fail (file != NULL);
#line 413 "config-impl-keyfile.c"
	{
		gchar* data = NULL;
		gsize length = 0UL;
		gboolean _tmp0_ = FALSE;
		gchar* _tmp1_ = NULL;
		gsize _tmp2_ = 0UL;
		gboolean _tmp3_;
#line 121 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp3_ = desktop_agnostic_vfs_file_load_contents (file, &_tmp1_, &_tmp2_, &_inner_error0_);
#line 121 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_g_free0 (data);
#line 121 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		data = _tmp1_;
#line 121 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		length = _tmp2_;
#line 121 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp0_ = _tmp3_;
#line 121 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 121 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_g_free0 (data);
#line 121 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			if (g_error_matches (_inner_error0_, G_KEY_FILE_ERROR, G_KEY_FILE_ERROR_PARSE)) {
#line 437 "config-impl-keyfile.c"
				goto __catch0_g_key_file_error_parse;
			}
			goto __catch0_g_error;
		}
#line 121 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		if (_tmp0_) {
#line 444 "config-impl-keyfile.c"
			const gchar* _tmp4_;
#line 123 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp4_ = data;
#line 123 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			desktop_agnostic_config_gkey_file_update_from_keyfile (self, _tmp4_, &_inner_error0_);
#line 123 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 123 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				_g_free0 (data);
#line 123 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				if (g_error_matches (_inner_error0_, G_KEY_FILE_ERROR, G_KEY_FILE_ERROR_PARSE)) {
#line 456 "config-impl-keyfile.c"
					goto __catch0_g_key_file_error_parse;
				}
				goto __catch0_g_error;
			}
		} else {
#line 127 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			desktop_agnostic_config_gkey_file_save_config (self, TRUE, &_inner_error0_);
#line 127 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 127 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				_g_free0 (data);
#line 127 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				if (g_error_matches (_inner_error0_, G_KEY_FILE_ERROR, G_KEY_FILE_ERROR_PARSE)) {
#line 470 "config-impl-keyfile.c"
					goto __catch0_g_key_file_error_parse;
				}
				goto __catch0_g_error;
			}
		}
#line 114 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_g_free0 (data);
#line 478 "config-impl-keyfile.c"
	}
	goto __finally0;
	__catch0_g_key_file_error_parse:
	{
		GError* e = NULL;
		GError* _tmp5_;
		const gchar* _tmp6_;
#line 114 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		e = _inner_error0_;
#line 114 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_inner_error0_ = NULL;
#line 134 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp5_ = e;
#line 134 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp6_ = _tmp5_->message;
#line 134 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		g_warning ("config-impl-keyfile.vala:134: File is invalid: %s", _tmp6_);
#line 135 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		desktop_agnostic_config_gkey_file_save_config (self, TRUE, &_inner_error0_);
#line 135 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 135 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_g_error_free0 (e);
#line 502 "config-impl-keyfile.c"
			goto __finally0;
		}
#line 114 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_g_error_free0 (e);
#line 507 "config-impl-keyfile.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
		GError* _tmp9_;
#line 114 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		e = _inner_error0_;
#line 114 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_inner_error0_ = NULL;
#line 139 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp7_ = e;
#line 139 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp8_ = _tmp7_->message;
#line 139 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp9_ = e;
#line 139 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		g_critical ("config-impl-keyfile.vala:139: Failed to load the keyfile: %s Code:%d", _tmp8_, _tmp9_->code);
#line 114 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_g_error_free0 (e);
#line 530 "config-impl-keyfile.c"
	}
	__finally0:
#line 114 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 114 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 114 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		g_clear_error (&_inner_error0_);
#line 114 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		return;
#line 541 "config-impl-keyfile.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 146 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	return self ? g_object_ref (self) : NULL;
#line 550 "config-impl-keyfile.c"
}

static void
desktop_agnostic_config_gkey_file_set_value_from_keyfile (DesktopAgnosticConfigGKeyFile* self,
                                                          GKeyFile* keyfile,
                                                          const gchar* group,
                                                          const gchar* key,
                                                          GError** error)
{
	DesktopAgnosticConfigSchemaOption* option = NULL;
	DesktopAgnosticConfigSchema* _tmp0_;
	DesktopAgnosticConfigSchema* _tmp1_;
	DesktopAgnosticConfigSchemaOption* _tmp2_;
	DesktopAgnosticConfigSchemaOption* _tmp3_;
	GType type = 0UL;
	DesktopAgnosticConfigSchemaOption* _tmp4_;
	GType _tmp5_;
	GType _tmp6_;
	GError* _inner_error0_ = NULL;
#line 143 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	g_return_if_fail (self != NULL);
#line 143 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	g_return_if_fail (keyfile != NULL);
#line 143 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	g_return_if_fail (group != NULL);
#line 143 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	g_return_if_fail (key != NULL);
#line 146 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp0_ = desktop_agnostic_config_backend_get_schema ((DesktopAgnosticConfigBackend*) self);
#line 146 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp1_ = _tmp0_;
#line 146 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp2_ = desktop_agnostic_config_schema_get_option (_tmp1_, group, key);
#line 146 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 146 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	option = _tmp3_;
#line 147 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp4_ = option;
#line 147 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp5_ = desktop_agnostic_config_schema_option_get_option_type (_tmp4_);
#line 147 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp6_ = _tmp5_;
#line 147 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	type = _tmp6_;
#line 148 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	if (type == G_TYPE_BOOLEAN) {
#line 598 "config-impl-keyfile.c"
		gboolean val = FALSE;
		GKeyFile* _tmp8_;
		{
			gboolean _tmp7_ = FALSE;
#line 153 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp7_ = g_key_file_get_boolean (keyfile, group, key, &_inner_error0_);
#line 153 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 153 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 609 "config-impl-keyfile.c"
					goto __catch0_g_key_file_error;
				}
#line 153 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				_g_object_unref0 (option);
#line 153 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 153 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				g_clear_error (&_inner_error0_);
#line 153 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				return;
#line 620 "config-impl-keyfile.c"
			}
#line 153 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			val = _tmp7_;
#line 624 "config-impl-keyfile.c"
		}
		goto __finally0;
		__catch0_g_key_file_error:
		{
#line 151 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			g_clear_error (&_inner_error0_);
#line 157 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_g_object_unref0 (option);
#line 157 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			return;
#line 635 "config-impl-keyfile.c"
		}
		__finally0:
#line 151 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 151 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			g_propagate_error (error, _inner_error0_);
#line 151 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_g_object_unref0 (option);
#line 151 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			return;
#line 646 "config-impl-keyfile.c"
		}
#line 159 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp8_ = self->priv->_data;
#line 159 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		g_key_file_set_boolean (_tmp8_, group, key, val);
#line 160 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		desktop_agnostic_config_gkey_file_update_config (self, group, key, &_inner_error0_);
#line 160 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 160 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			g_propagate_error (error, _inner_error0_);
#line 160 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_g_object_unref0 (option);
#line 160 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			return;
#line 662 "config-impl-keyfile.c"
		}
	} else {
#line 162 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		if (type == G_TYPE_INT) {
#line 667 "config-impl-keyfile.c"
			gint val = 0;
			GKeyFile* _tmp10_;
			{
				gint _tmp9_ = 0;
#line 167 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				_tmp9_ = g_key_file_get_integer (keyfile, group, key, &_inner_error0_);
#line 167 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 167 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 678 "config-impl-keyfile.c"
						goto __catch1_g_key_file_error;
					}
#line 167 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					_g_object_unref0 (option);
#line 167 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 167 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					g_clear_error (&_inner_error0_);
#line 167 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					return;
#line 689 "config-impl-keyfile.c"
				}
#line 167 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				val = _tmp9_;
#line 693 "config-impl-keyfile.c"
			}
			goto __finally1;
			__catch1_g_key_file_error:
			{
#line 165 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				g_clear_error (&_inner_error0_);
#line 171 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				_g_object_unref0 (option);
#line 171 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				return;
#line 704 "config-impl-keyfile.c"
			}
			__finally1:
#line 165 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 165 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				g_propagate_error (error, _inner_error0_);
#line 165 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				_g_object_unref0 (option);
#line 165 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				return;
#line 715 "config-impl-keyfile.c"
			}
#line 173 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp10_ = self->priv->_data;
#line 173 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			g_key_file_set_integer (_tmp10_, group, key, val);
#line 174 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			desktop_agnostic_config_gkey_file_update_config (self, group, key, &_inner_error0_);
#line 174 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 174 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				g_propagate_error (error, _inner_error0_);
#line 174 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				_g_object_unref0 (option);
#line 174 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				return;
#line 731 "config-impl-keyfile.c"
			}
		} else {
#line 176 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			if (type == G_TYPE_FLOAT) {
#line 736 "config-impl-keyfile.c"
				gfloat val = 0.0F;
				GKeyFile* _tmp12_;
				{
					gdouble _tmp11_ = 0.0;
#line 181 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					_tmp11_ = g_key_file_get_double (keyfile, group, key, &_inner_error0_);
#line 181 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 181 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 747 "config-impl-keyfile.c"
							goto __catch2_g_key_file_error;
						}
#line 181 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						_g_object_unref0 (option);
#line 181 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 181 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						g_clear_error (&_inner_error0_);
#line 181 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						return;
#line 758 "config-impl-keyfile.c"
					}
#line 181 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					val = (gfloat) _tmp11_;
#line 762 "config-impl-keyfile.c"
				}
				goto __finally2;
				__catch2_g_key_file_error:
				{
#line 179 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					g_clear_error (&_inner_error0_);
#line 185 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					_g_object_unref0 (option);
#line 185 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					return;
#line 773 "config-impl-keyfile.c"
				}
				__finally2:
#line 179 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 179 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					g_propagate_error (error, _inner_error0_);
#line 179 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					_g_object_unref0 (option);
#line 179 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					return;
#line 784 "config-impl-keyfile.c"
				}
#line 187 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				_tmp12_ = self->priv->_data;
#line 187 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				g_key_file_set_double (_tmp12_, group, key, (gdouble) val);
#line 188 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				desktop_agnostic_config_gkey_file_update_config (self, group, key, &_inner_error0_);
#line 188 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 188 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					g_propagate_error (error, _inner_error0_);
#line 188 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					_g_object_unref0 (option);
#line 188 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					return;
#line 800 "config-impl-keyfile.c"
				}
			} else {
#line 190 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				if (type == G_TYPE_STRING) {
#line 805 "config-impl-keyfile.c"
					gchar* val = NULL;
					GKeyFile* _tmp16_;
					const gchar* _tmp17_;
					{
						gchar* _tmp13_ = NULL;
						gchar* _tmp14_;
						gchar* _tmp15_;
#line 195 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						_tmp14_ = g_key_file_get_string (keyfile, group, key, &_inner_error0_);
#line 195 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						_tmp13_ = _tmp14_;
#line 195 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 195 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 821 "config-impl-keyfile.c"
								goto __catch3_g_key_file_error;
							}
#line 195 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_g_free0 (val);
#line 195 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_g_object_unref0 (option);
#line 195 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 195 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							g_clear_error (&_inner_error0_);
#line 195 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							return;
#line 834 "config-impl-keyfile.c"
						}
#line 195 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						_tmp15_ = _tmp13_;
#line 195 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						_tmp13_ = NULL;
#line 195 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						_g_free0 (val);
#line 195 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						val = _tmp15_;
#line 193 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						_g_free0 (_tmp13_);
#line 846 "config-impl-keyfile.c"
					}
					goto __finally3;
					__catch3_g_key_file_error:
					{
#line 193 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						g_clear_error (&_inner_error0_);
#line 199 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						_g_free0 (val);
#line 199 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						_g_object_unref0 (option);
#line 199 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						return;
#line 859 "config-impl-keyfile.c"
					}
					__finally3:
#line 193 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 193 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						g_propagate_error (error, _inner_error0_);
#line 193 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						_g_free0 (val);
#line 193 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						_g_object_unref0 (option);
#line 193 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						return;
#line 872 "config-impl-keyfile.c"
					}
#line 201 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					_tmp16_ = self->priv->_data;
#line 201 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					_tmp17_ = val;
#line 201 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					g_key_file_set_string (_tmp16_, group, key, _tmp17_);
#line 202 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					desktop_agnostic_config_gkey_file_update_config (self, group, key, &_inner_error0_);
#line 202 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 202 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						g_propagate_error (error, _inner_error0_);
#line 202 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						_g_free0 (val);
#line 202 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						_g_object_unref0 (option);
#line 202 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						return;
#line 892 "config-impl-keyfile.c"
					}
#line 190 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					_g_free0 (val);
#line 896 "config-impl-keyfile.c"
				} else {
#line 204 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					if (type == G_TYPE_VALUE_ARRAY) {
#line 900 "config-impl-keyfile.c"
						GValueArray* arr = NULL;
						GValueArray* _tmp21_;
						{
							GValueArray* _tmp18_ = NULL;
							GValueArray* _tmp19_;
							GValueArray* _tmp20_;
#line 209 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_tmp19_ = desktop_agnostic_config_gkey_file_generate_valuearray_from_keyfile (self, keyfile, group, key, &_inner_error0_);
#line 209 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_tmp18_ = _tmp19_;
#line 209 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 209 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
								if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 915 "config-impl-keyfile.c"
									goto __catch4_g_key_file_error;
								}
								goto __finally4;
							}
#line 209 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_tmp20_ = _tmp18_;
#line 209 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_tmp18_ = NULL;
#line 209 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_g_value_array_free0 (arr);
#line 209 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							arr = _tmp20_;
#line 207 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_g_value_array_free0 (_tmp18_);
#line 930 "config-impl-keyfile.c"
						}
						goto __finally4;
						__catch4_g_key_file_error:
						{
#line 207 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							g_clear_error (&_inner_error0_);
#line 213 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_g_value_array_free0 (arr);
#line 213 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_g_object_unref0 (option);
#line 213 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							return;
#line 943 "config-impl-keyfile.c"
						}
						__finally4:
#line 207 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 207 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							g_propagate_error (error, _inner_error0_);
#line 207 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_g_value_array_free0 (arr);
#line 207 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_g_object_unref0 (option);
#line 207 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							return;
#line 956 "config-impl-keyfile.c"
						}
#line 215 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						_tmp21_ = arr;
#line 215 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						desktop_agnostic_config_backend_set_list ((DesktopAgnosticConfigBackend*) self, group, key, _tmp21_, &_inner_error0_);
#line 215 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 215 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							g_propagate_error (error, _inner_error0_);
#line 215 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_g_value_array_free0 (arr);
#line 215 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_g_object_unref0 (option);
#line 215 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							return;
#line 972 "config-impl-keyfile.c"
						}
#line 204 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						_g_value_array_free0 (arr);
#line 976 "config-impl-keyfile.c"
					} else {
						DesktopAgnosticConfigSchemaType* st = NULL;
						DesktopAgnosticConfigSchemaType* _tmp22_;
						DesktopAgnosticConfigSchemaType* _tmp23_;
						DesktopAgnosticConfigSchemaType* _tmp24_;
						gchar* val = NULL;
						GKeyFile* _tmp30_;
						const gchar* _tmp31_;
#line 219 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						_tmp22_ = desktop_agnostic_config_schema_find_type (type);
#line 219 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						_tmp23_ = _g_object_ref0 (_tmp22_);
#line 219 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						st = _tmp23_;
#line 220 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						_tmp24_ = st;
#line 220 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						if (_tmp24_ == NULL) {
#line 995 "config-impl-keyfile.c"
							const gchar* _tmp25_;
							GError* _tmp26_;
#line 222 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_tmp25_ = g_type_name (type);
#line 222 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_tmp26_ = g_error_new (DESKTOP_AGNOSTIC_CONFIG_ERROR, DESKTOP_AGNOSTIC_CONFIG_ERROR_INVALID_TYPE, "'%s' is an invalid config type.", _tmp25_);
#line 222 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_inner_error0_ = _tmp26_;
#line 222 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							g_propagate_error (error, _inner_error0_);
#line 222 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_g_object_unref0 (st);
#line 222 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_g_object_unref0 (option);
#line 222 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							return;
#line 1012 "config-impl-keyfile.c"
						}
						{
							gchar* _tmp27_ = NULL;
							gchar* _tmp28_;
							gchar* _tmp29_;
#line 229 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_tmp28_ = g_key_file_get_string (keyfile, group, key, &_inner_error0_);
#line 229 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_tmp27_ = _tmp28_;
#line 229 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 229 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
								if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 1026 "config-impl-keyfile.c"
									goto __catch5_g_key_file_error;
								}
#line 229 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
								_g_free0 (val);
#line 229 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
								_g_object_unref0 (st);
#line 229 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
								_g_object_unref0 (option);
#line 229 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
								g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 229 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
								g_clear_error (&_inner_error0_);
#line 229 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
								return;
#line 1041 "config-impl-keyfile.c"
							}
#line 229 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_tmp29_ = _tmp27_;
#line 229 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_tmp27_ = NULL;
#line 229 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_g_free0 (val);
#line 229 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							val = _tmp29_;
#line 227 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_g_free0 (_tmp27_);
#line 1053 "config-impl-keyfile.c"
						}
						goto __finally5;
						__catch5_g_key_file_error:
						{
#line 227 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							g_clear_error (&_inner_error0_);
#line 233 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_g_free0 (val);
#line 233 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_g_object_unref0 (st);
#line 233 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_g_object_unref0 (option);
#line 233 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							return;
#line 1068 "config-impl-keyfile.c"
						}
						__finally5:
#line 227 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 227 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							g_propagate_error (error, _inner_error0_);
#line 227 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_g_free0 (val);
#line 227 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_g_object_unref0 (st);
#line 227 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_g_object_unref0 (option);
#line 227 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							return;
#line 1083 "config-impl-keyfile.c"
						}
#line 235 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						_tmp30_ = self->priv->_data;
#line 235 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						_tmp31_ = val;
#line 235 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						g_key_file_set_string (_tmp30_, group, key, _tmp31_);
#line 236 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						desktop_agnostic_config_gkey_file_update_config (self, group, key, &_inner_error0_);
#line 236 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 236 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							g_propagate_error (error, _inner_error0_);
#line 236 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_g_free0 (val);
#line 236 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_g_object_unref0 (st);
#line 236 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_g_object_unref0 (option);
#line 236 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							return;
#line 1105 "config-impl-keyfile.c"
						}
#line 204 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						_g_free0 (val);
#line 204 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						_g_object_unref0 (st);
#line 1111 "config-impl-keyfile.c"
					}
				}
			}
		}
	}
#line 143 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_g_object_unref0 (option);
#line 1119 "config-impl-keyfile.c"
}

static void
desktop_agnostic_config_gkey_file_update_from_keyfile (DesktopAgnosticConfigGKeyFile* self,
                                                       const gchar* data,
                                                       GError** error)
{
	gchar* checksum = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 240 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	g_return_if_fail (self != NULL);
#line 240 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	g_return_if_fail (data != NULL);
#line 243 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp0_ = desktop_agnostic_config_gkey_file_calculate_checksum_from_data (self, data);
#line 243 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	checksum = _tmp0_;
#line 245 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp1_ = self->priv->_checksum;
#line 245 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp2_ = checksum;
#line 245 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	if (g_strcmp0 (_tmp1_, _tmp2_) != 0) {
#line 1146 "config-impl-keyfile.c"
		DesktopAgnosticConfigSchema* schema = NULL;
		DesktopAgnosticConfigSchema* _tmp3_;
		DesktopAgnosticConfigSchema* _tmp4_;
		DesktopAgnosticConfigSchema* _tmp5_;
		GKeyFile* new_data = NULL;
		GKeyFile* _tmp7_;
		GKeyFile* _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
		DesktopAgnosticConfigSchema* _tmp11_;
		GList* _tmp12_;
		const gchar* _tmp50_;
		const gchar* _tmp51_;
#line 247 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp3_ = desktop_agnostic_config_backend_get_schema ((DesktopAgnosticConfigBackend*) self);
#line 247 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp4_ = _tmp3_;
#line 247 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		schema = _tmp4_;
#line 248 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp5_ = schema;
#line 248 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		if (_tmp5_ == NULL) {
#line 1170 "config-impl-keyfile.c"
			GError* _tmp6_;
#line 250 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp6_ = g_error_new_literal (DESKTOP_AGNOSTIC_CONFIG_ERROR, DESKTOP_AGNOSTIC_CONFIG_ERROR_NO_SCHEMA, "The schema was not loaded.");
#line 250 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_inner_error0_ = _tmp6_;
#line 250 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			g_propagate_error (error, _inner_error0_);
#line 250 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_g_free0 (checksum);
#line 250 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			return;
#line 1182 "config-impl-keyfile.c"
		}
#line 253 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp7_ = g_key_file_new ();
#line 253 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		new_data = _tmp7_;
#line 254 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp8_ = new_data;
#line 254 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp9_ = strlen (data);
#line 254 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp10_ = _tmp9_;
#line 254 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		g_key_file_load_from_data (_tmp8_, data, (gsize) _tmp10_, G_KEY_FILE_NONE, &_inner_error0_);
#line 254 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 254 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			g_propagate_error (error, _inner_error0_);
#line 254 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_g_key_file_unref0 (new_data);
#line 254 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_g_free0 (checksum);
#line 254 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			return;
#line 1206 "config-impl-keyfile.c"
		}
#line 256 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		self->priv->_autosave = FALSE;
#line 257 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp11_ = schema;
#line 257 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp12_ = desktop_agnostic_config_schema_get_groups (_tmp11_);
#line 1214 "config-impl-keyfile.c"
		{
			GList* group_collection = NULL;
			GList* group_it = NULL;
#line 257 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			group_collection = _tmp12_;
#line 257 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			for (group_it = group_collection; group_it != NULL; group_it = group_it->next) {
#line 1222 "config-impl-keyfile.c"
				const gchar* group = NULL;
#line 257 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				group = (const gchar*) group_it->data;
#line 1226 "config-impl-keyfile.c"
				{
					gboolean _tmp13_ = FALSE;
					GKeyFile* _tmp14_;
					const gchar* _tmp15_;
#line 259 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					_tmp14_ = self->priv->_data;
#line 259 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					_tmp15_ = group;
#line 259 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					if (g_key_file_has_group (_tmp14_, _tmp15_)) {
#line 1237 "config-impl-keyfile.c"
						GKeyFile* _tmp16_;
						const gchar* _tmp17_;
#line 259 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						_tmp16_ = new_data;
#line 259 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						_tmp17_ = group;
#line 259 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						_tmp13_ = g_key_file_has_group (_tmp16_, _tmp17_);
#line 1246 "config-impl-keyfile.c"
					} else {
#line 259 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						_tmp13_ = FALSE;
#line 1250 "config-impl-keyfile.c"
					}
#line 259 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					if (_tmp13_) {
#line 1254 "config-impl-keyfile.c"
						DesktopAgnosticConfigSchema* _tmp18_;
						const gchar* _tmp19_;
						GList* _tmp20_;
#line 261 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						_tmp18_ = schema;
#line 261 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						_tmp19_ = group;
#line 261 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						_tmp20_ = desktop_agnostic_config_schema_get_keys (_tmp18_, _tmp19_);
#line 1264 "config-impl-keyfile.c"
						{
							GList* key_collection = NULL;
							GList* key_it = NULL;
#line 261 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							key_collection = _tmp20_;
#line 261 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							for (key_it = key_collection; key_it != NULL; key_it = key_it->next) {
#line 1272 "config-impl-keyfile.c"
								const gchar* key = NULL;
#line 261 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
								key = (const gchar*) key_it->data;
#line 1276 "config-impl-keyfile.c"
								{
									gboolean _tmp21_ = FALSE;
									GKeyFile* _tmp22_;
									const gchar* _tmp23_;
									const gchar* _tmp24_;
#line 264 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
									_tmp22_ = new_data;
#line 264 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
									_tmp23_ = group;
#line 264 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
									_tmp24_ = key;
#line 264 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
									_tmp21_ = g_key_file_has_key (_tmp22_, _tmp23_, _tmp24_, &_inner_error0_);
#line 264 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
									if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 264 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
										g_propagate_error (error, _inner_error0_);
#line 264 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
										(group_collection == NULL) ? NULL : (group_collection = (g_list_free (group_collection), NULL));
#line 264 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
										_g_key_file_unref0 (new_data);
#line 264 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
										_g_free0 (checksum);
#line 264 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
										return;
#line 1302 "config-impl-keyfile.c"
									}
#line 264 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
									if (_tmp21_) {
#line 1306 "config-impl-keyfile.c"
										gboolean _tmp25_ = FALSE;
										DesktopAgnosticConfigSchema* _tmp26_;
										const gchar* _tmp27_;
										const gchar* _tmp28_;
										DesktopAgnosticConfigSchemaOption* _tmp29_;
										GType _tmp30_;
										GType _tmp31_;
#line 267 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
										_tmp26_ = schema;
#line 267 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
										_tmp27_ = group;
#line 267 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
										_tmp28_ = key;
#line 267 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
										_tmp29_ = desktop_agnostic_config_schema_get_option (_tmp26_, _tmp27_, _tmp28_);
#line 267 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
										_tmp30_ = desktop_agnostic_config_schema_option_get_option_type (_tmp29_);
#line 267 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
										_tmp31_ = _tmp30_;
#line 267 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
										if (_tmp31_ == G_TYPE_VALUE_ARRAY) {
#line 267 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
											_tmp25_ = TRUE;
#line 1330 "config-impl-keyfile.c"
										} else {
											gboolean _tmp32_ = FALSE;
											gboolean _tmp33_ = FALSE;
											GKeyFile* _tmp34_;
											const gchar* _tmp35_;
											const gchar* _tmp36_;
#line 268 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
											_tmp34_ = self->priv->_data;
#line 268 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
											_tmp35_ = group;
#line 268 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
											_tmp36_ = key;
#line 268 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
											_tmp33_ = g_key_file_has_key (_tmp34_, _tmp35_, _tmp36_, &_inner_error0_);
#line 268 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
											if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 268 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
												g_propagate_error (error, _inner_error0_);
#line 268 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
												(group_collection == NULL) ? NULL : (group_collection = (g_list_free (group_collection), NULL));
#line 268 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
												_g_key_file_unref0 (new_data);
#line 268 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
												_g_free0 (checksum);
#line 268 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
												return;
#line 1357 "config-impl-keyfile.c"
											}
#line 268 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
											if (_tmp33_) {
#line 1361 "config-impl-keyfile.c"
												gchar* _tmp37_ = NULL;
												GKeyFile* _tmp38_;
												const gchar* _tmp39_;
												const gchar* _tmp40_;
												gchar* _tmp41_;
												gchar* _tmp42_ = NULL;
												GKeyFile* _tmp43_;
												const gchar* _tmp44_;
												const gchar* _tmp45_;
												gchar* _tmp46_;
#line 269 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
												_tmp38_ = self->priv->_data;
#line 269 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
												_tmp39_ = group;
#line 269 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
												_tmp40_ = key;
#line 269 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
												_tmp41_ = g_key_file_get_value (_tmp38_, _tmp39_, _tmp40_, &_inner_error0_);
#line 269 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
												_tmp37_ = _tmp41_;
#line 269 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
												if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 269 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
													g_propagate_error (error, _inner_error0_);
#line 269 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
													(group_collection == NULL) ? NULL : (group_collection = (g_list_free (group_collection), NULL));
#line 269 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
													_g_key_file_unref0 (new_data);
#line 269 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
													_g_free0 (checksum);
#line 269 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
													return;
#line 1394 "config-impl-keyfile.c"
												}
#line 269 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
												_tmp43_ = new_data;
#line 269 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
												_tmp44_ = group;
#line 269 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
												_tmp45_ = key;
#line 269 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
												_tmp46_ = g_key_file_get_value (_tmp43_, _tmp44_, _tmp45_, &_inner_error0_);
#line 269 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
												_tmp42_ = _tmp46_;
#line 269 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
												if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 269 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
													g_propagate_error (error, _inner_error0_);
#line 269 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
													_g_free0 (_tmp37_);
#line 269 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
													(group_collection == NULL) ? NULL : (group_collection = (g_list_free (group_collection), NULL));
#line 269 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
													_g_key_file_unref0 (new_data);
#line 269 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
													_g_free0 (checksum);
#line 269 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
													return;
#line 1420 "config-impl-keyfile.c"
												}
#line 269 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
												_tmp32_ = g_strcmp0 (_tmp37_, _tmp42_) != 0;
#line 268 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
												_g_free0 (_tmp42_);
#line 268 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
												_g_free0 (_tmp37_);
#line 1428 "config-impl-keyfile.c"
											} else {
#line 268 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
												_tmp32_ = FALSE;
#line 1432 "config-impl-keyfile.c"
											}
#line 268 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
											_tmp25_ = _tmp32_;
#line 1436 "config-impl-keyfile.c"
										}
#line 267 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
										if (_tmp25_) {
#line 1440 "config-impl-keyfile.c"
											GKeyFile* _tmp47_;
											const gchar* _tmp48_;
											const gchar* _tmp49_;
#line 271 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
											_tmp47_ = new_data;
#line 271 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
											_tmp48_ = group;
#line 271 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
											_tmp49_ = key;
#line 271 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
											desktop_agnostic_config_gkey_file_set_value_from_keyfile (self, _tmp47_, _tmp48_, _tmp49_, &_inner_error0_);
#line 271 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
											if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 271 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
												g_propagate_error (error, _inner_error0_);
#line 271 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
												(group_collection == NULL) ? NULL : (group_collection = (g_list_free (group_collection), NULL));
#line 271 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
												_g_key_file_unref0 (new_data);
#line 271 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
												_g_free0 (checksum);
#line 271 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
												return;
#line 1464 "config-impl-keyfile.c"
											}
										}
									}
								}
							}
						}
					}
				}
			}
#line 257 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			(group_collection == NULL) ? NULL : (group_collection = (g_list_free (group_collection), NULL));
#line 1476 "config-impl-keyfile.c"
		}
#line 277 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		self->priv->_autosave = TRUE;
#line 279 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		desktop_agnostic_config_gkey_file_calculate_checksum (self);
#line 280 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp50_ = self->priv->_checksum;
#line 280 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp51_ = checksum;
#line 280 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		if (g_strcmp0 (_tmp50_, _tmp51_) != 0) {
#line 283 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			desktop_agnostic_config_gkey_file_save_config (self, FALSE, &_inner_error0_);
#line 283 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 283 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				g_propagate_error (error, _inner_error0_);
#line 283 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				_g_key_file_unref0 (new_data);
#line 283 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				_g_free0 (checksum);
#line 283 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				return;
#line 1500 "config-impl-keyfile.c"
			}
		}
#line 245 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_g_key_file_unref0 (new_data);
#line 1505 "config-impl-keyfile.c"
	}
#line 240 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_g_free0 (checksum);
#line 1509 "config-impl-keyfile.c"
}

static gdouble*
_vala_array_dup1 (gdouble* self,
                  gssize length)
{
#line 338 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	if (length > 0) {
#line 338 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		return _vala_memdup2 (self, length * sizeof (gdouble));
#line 1520 "config-impl-keyfile.c"
	}
#line 338 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	return NULL;
#line 1524 "config-impl-keyfile.c"
}

static GValueArray*
desktop_agnostic_config_gkey_file_generate_valuearray_from_keyfile (DesktopAgnosticConfigGKeyFile* self,
                                                                    GKeyFile* keyfile,
                                                                    const gchar* group,
                                                                    const gchar* key,
                                                                    GError** error)
{
	DesktopAgnosticConfigSchemaOption* option = NULL;
	GType list_type = 0UL;
	GValueArray* arr = NULL;
	DesktopAgnosticConfigSchema* _tmp0_;
	DesktopAgnosticConfigSchema* _tmp1_;
	DesktopAgnosticConfigSchemaOption* _tmp2_;
	DesktopAgnosticConfigSchemaOption* _tmp3_;
	DesktopAgnosticConfigSchemaOption* _tmp4_;
	DesktopAgnosticConfigSchemaOption* _tmp8_;
	GType _tmp9_;
	GType _tmp10_;
	GError* _inner_error0_ = NULL;
	GValueArray* result;
#line 288 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 288 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	g_return_val_if_fail (keyfile != NULL, NULL);
#line 288 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	g_return_val_if_fail (group != NULL, NULL);
#line 288 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	g_return_val_if_fail (key != NULL, NULL);
#line 296 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp0_ = desktop_agnostic_config_backend_get_schema ((DesktopAgnosticConfigBackend*) self);
#line 296 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp1_ = _tmp0_;
#line 296 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp2_ = desktop_agnostic_config_schema_get_option (_tmp1_, group, key);
#line 296 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 296 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_g_object_unref0 (option);
#line 296 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	option = _tmp3_;
#line 297 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp4_ = option;
#line 297 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	if (_tmp4_ == NULL) {
#line 1571 "config-impl-keyfile.c"
		GError* _tmp5_;
#line 299 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp5_ = g_error_new (DESKTOP_AGNOSTIC_CONFIG_ERROR, DESKTOP_AGNOSTIC_CONFIG_ERROR_KEY_NOT_FOUND, "The key %s/%s is invalid.", group, key);
#line 299 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_inner_error0_ = _tmp5_;
#line 299 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		g_propagate_error (error, _inner_error0_);
#line 299 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_g_value_array_free0 (arr);
#line 299 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_g_object_unref0 (option);
#line 299 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		return NULL;
#line 1585 "config-impl-keyfile.c"
	} else {
		gboolean _tmp6_ = FALSE;
#line 302 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp6_ = g_key_file_has_key (keyfile, group, key, &_inner_error0_);
#line 302 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 302 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			g_propagate_error (error, _inner_error0_);
#line 302 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_g_value_array_free0 (arr);
#line 302 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_g_object_unref0 (option);
#line 302 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			return NULL;
#line 1600 "config-impl-keyfile.c"
		}
#line 302 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		if (!_tmp6_) {
#line 1604 "config-impl-keyfile.c"
			GValueArray* _tmp7_;
#line 304 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp7_ = g_value_array_new ((guint) 0);
#line 304 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			result = _tmp7_;
#line 304 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_g_value_array_free0 (arr);
#line 304 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_g_object_unref0 (option);
#line 304 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			return result;
#line 1616 "config-impl-keyfile.c"
		}
	}
#line 306 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp8_ = option;
#line 306 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp9_ = desktop_agnostic_config_schema_option_get_list_type (_tmp8_);
#line 306 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp10_ = _tmp9_;
#line 306 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	list_type = _tmp10_;
#line 307 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	if (list_type == G_TYPE_BOOLEAN) {
#line 1629 "config-impl-keyfile.c"
		gboolean* list_data = NULL;
		gint list_data_length1 = 0;
		gint _list_data_size_ = 0;
		GValue val = {0};
		gboolean* _tmp11_ = NULL;
		gsize _tmp12_ = 0;
		gboolean* _tmp13_;
		gint _tmp11__length1;
		gint __tmp11__size_;
		gboolean* _tmp14_;
		gint _tmp14__length1;
		gboolean* _tmp15_;
		gint _tmp15__length1;
		GValueArray* _tmp16_;
		gboolean* _tmp17_;
		gint _tmp17__length1;
#line 312 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp13_ = g_key_file_get_boolean_list (keyfile, group, key, &_tmp12_, &_inner_error0_);
#line 312 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp11_ = _tmp13_;
#line 312 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp11__length1 = _tmp12_;
#line 312 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		__tmp11__size_ = _tmp11__length1;
#line 312 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 312 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			g_propagate_error (error, _inner_error0_);
#line 312 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 312 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			list_data = (g_free (list_data), NULL);
#line 312 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_g_value_array_free0 (arr);
#line 312 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_g_object_unref0 (option);
#line 312 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			return NULL;
#line 1668 "config-impl-keyfile.c"
		}
#line 312 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp14_ = _tmp11_;
#line 312 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp14__length1 = _tmp11__length1;
#line 312 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp11_ = NULL;
#line 312 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp11__length1 = 0;
#line 312 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		list_data = (g_free (list_data), NULL);
#line 312 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		list_data = _tmp14_;
#line 312 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		list_data_length1 = _tmp14__length1;
#line 312 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_list_data_size_ = list_data_length1;
#line 313 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp15_ = list_data;
#line 313 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp15__length1 = list_data_length1;
#line 313 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp16_ = g_value_array_new ((guint) _tmp15__length1);
#line 313 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_g_value_array_free0 (arr);
#line 313 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		arr = _tmp16_;
#line 314 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp17_ = list_data;
#line 314 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp17__length1 = list_data_length1;
#line 1700 "config-impl-keyfile.c"
		{
			gboolean* item_collection = NULL;
			gint item_collection_length1 = 0;
			gint _item_collection_size_ = 0;
			gint item_it = 0;
#line 314 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			item_collection = _tmp17_;
#line 314 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			item_collection_length1 = _tmp17__length1;
#line 314 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			for (item_it = 0; item_it < item_collection_length1; item_it = item_it + 1) {
#line 1712 "config-impl-keyfile.c"
				gboolean item = FALSE;
#line 314 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				item = item_collection[item_it];
#line 1716 "config-impl-keyfile.c"
				{
					GValue _tmp18_ = {0};
					GValueArray* _tmp19_;
					GValue _tmp20_;
#line 316 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					g_value_init (&_tmp18_, G_TYPE_BOOLEAN);
#line 316 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					g_value_set_boolean (&_tmp18_, item);
#line 316 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 316 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					val = _tmp18_;
#line 317 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					_tmp19_ = arr;
#line 317 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					_tmp20_ = val;
#line 317 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					g_value_array_append (_tmp19_, &_tmp20_);
#line 1735 "config-impl-keyfile.c"
				}
			}
		}
#line 307 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp11_ = (g_free (_tmp11_), NULL);
#line 307 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 307 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		list_data = (g_free (list_data), NULL);
#line 1745 "config-impl-keyfile.c"
	} else {
#line 320 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		if (list_type == G_TYPE_INT) {
#line 1749 "config-impl-keyfile.c"
			gint* list_data = NULL;
			gint list_data_length1 = 0;
			gint _list_data_size_ = 0;
			GValue val = {0};
			gint* _tmp21_ = NULL;
			gsize _tmp22_ = 0;
			gint* _tmp23_;
			gint _tmp21__length1;
			gint __tmp21__size_;
			gint* _tmp24_;
			gint _tmp24__length1;
			gint* _tmp25_;
			gint _tmp25__length1;
			GValueArray* _tmp26_;
			gint* _tmp27_;
			gint _tmp27__length1;
#line 325 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp23_ = g_key_file_get_integer_list (keyfile, group, key, &_tmp22_, &_inner_error0_);
#line 325 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp21_ = _tmp23_;
#line 325 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp21__length1 = _tmp22_;
#line 325 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			__tmp21__size_ = _tmp21__length1;
#line 325 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 325 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				g_propagate_error (error, _inner_error0_);
#line 325 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 325 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				list_data = (g_free (list_data), NULL);
#line 325 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				_g_value_array_free0 (arr);
#line 325 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				_g_object_unref0 (option);
#line 325 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				return NULL;
#line 1788 "config-impl-keyfile.c"
			}
#line 325 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp24_ = _tmp21_;
#line 325 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp24__length1 = _tmp21__length1;
#line 325 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp21_ = NULL;
#line 325 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp21__length1 = 0;
#line 325 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			list_data = (g_free (list_data), NULL);
#line 325 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			list_data = _tmp24_;
#line 325 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			list_data_length1 = _tmp24__length1;
#line 325 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_list_data_size_ = list_data_length1;
#line 326 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp25_ = list_data;
#line 326 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp25__length1 = list_data_length1;
#line 326 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp26_ = g_value_array_new ((guint) _tmp25__length1);
#line 326 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_g_value_array_free0 (arr);
#line 326 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			arr = _tmp26_;
#line 327 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp27_ = list_data;
#line 327 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp27__length1 = list_data_length1;
#line 1820 "config-impl-keyfile.c"
			{
				gint* item_collection = NULL;
				gint item_collection_length1 = 0;
				gint _item_collection_size_ = 0;
				gint item_it = 0;
#line 327 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				item_collection = _tmp27_;
#line 327 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				item_collection_length1 = _tmp27__length1;
#line 327 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				for (item_it = 0; item_it < item_collection_length1; item_it = item_it + 1) {
#line 1832 "config-impl-keyfile.c"
					gint item = 0;
#line 327 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					item = item_collection[item_it];
#line 1836 "config-impl-keyfile.c"
					{
						GValue _tmp28_ = {0};
						GValueArray* _tmp29_;
						GValue _tmp30_;
#line 329 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						g_value_init (&_tmp28_, G_TYPE_INT);
#line 329 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						g_value_set_int (&_tmp28_, item);
#line 329 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 329 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						val = _tmp28_;
#line 330 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						_tmp29_ = arr;
#line 330 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						_tmp30_ = val;
#line 330 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						g_value_array_append (_tmp29_, &_tmp30_);
#line 1855 "config-impl-keyfile.c"
					}
				}
			}
#line 320 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp21_ = (g_free (_tmp21_), NULL);
#line 320 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 320 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			list_data = (g_free (list_data), NULL);
#line 1865 "config-impl-keyfile.c"
		} else {
#line 333 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			if (list_type == G_TYPE_FLOAT) {
#line 1869 "config-impl-keyfile.c"
				gdouble* list_data = NULL;
				gint list_data_length1 = 0;
				gint _list_data_size_ = 0;
				GValue val = {0};
				gdouble* _tmp31_ = NULL;
				gsize _tmp32_ = 0;
				gdouble* _tmp33_;
				gint _tmp31__length1;
				gint __tmp31__size_;
				gdouble* _tmp34_;
				gint _tmp34__length1;
				gdouble* _tmp35_;
				gint _tmp35__length1;
				GValueArray* _tmp36_;
				gdouble* _tmp37_;
				gint _tmp37__length1;
#line 338 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				_tmp33_ = g_key_file_get_double_list (keyfile, group, key, &_tmp32_, &_inner_error0_);
#line 338 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				_tmp31_ = _tmp33_;
#line 338 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				_tmp31__length1 = _tmp32_;
#line 338 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				__tmp31__size_ = _tmp31__length1;
#line 338 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 338 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					g_propagate_error (error, _inner_error0_);
#line 338 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 338 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					list_data = (g_free (list_data), NULL);
#line 338 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					_g_value_array_free0 (arr);
#line 338 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					_g_object_unref0 (option);
#line 338 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					return NULL;
#line 1908 "config-impl-keyfile.c"
				}
#line 338 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				_tmp34_ = (((gdouble*) _tmp31_) != NULL) ? _vala_array_dup1 ((gdouble*) _tmp31_, (_tmp31__length1 * sizeof (gdouble)) / sizeof (gdouble)) : ((gdouble*) _tmp31_);
#line 338 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				_tmp34__length1 = (_tmp31__length1 * sizeof (gdouble)) / sizeof (gdouble);
#line 338 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				list_data = (g_free (list_data), NULL);
#line 338 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				list_data = _tmp34_;
#line 338 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				list_data_length1 = _tmp34__length1;
#line 338 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				_list_data_size_ = list_data_length1;
#line 339 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				_tmp35_ = list_data;
#line 339 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				_tmp35__length1 = list_data_length1;
#line 339 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				_tmp36_ = g_value_array_new ((guint) _tmp35__length1);
#line 339 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				_g_value_array_free0 (arr);
#line 339 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				arr = _tmp36_;
#line 340 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				_tmp37_ = list_data;
#line 340 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				_tmp37__length1 = list_data_length1;
#line 1936 "config-impl-keyfile.c"
				{
					gdouble* item_collection = NULL;
					gint item_collection_length1 = 0;
					gint _item_collection_size_ = 0;
					gint item_it = 0;
#line 340 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					item_collection = _tmp37_;
#line 340 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					item_collection_length1 = _tmp37__length1;
#line 340 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					for (item_it = 0; item_it < item_collection_length1; item_it = item_it + 1) {
#line 1948 "config-impl-keyfile.c"
						gdouble item = 0.0;
#line 340 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						item = item_collection[item_it];
#line 1952 "config-impl-keyfile.c"
						{
							GValue _tmp38_ = {0};
							GValueArray* _tmp39_;
							GValue _tmp40_;
#line 342 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							g_value_init (&_tmp38_, G_TYPE_FLOAT);
#line 342 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							g_value_set_float (&_tmp38_, (gfloat) item);
#line 342 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 342 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							val = _tmp38_;
#line 343 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_tmp39_ = arr;
#line 343 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_tmp40_ = val;
#line 343 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							g_value_array_append (_tmp39_, &_tmp40_);
#line 1971 "config-impl-keyfile.c"
						}
					}
				}
#line 333 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				_tmp31_ = (g_free (_tmp31_), NULL);
#line 333 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 333 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				list_data = (g_free (list_data), NULL);
#line 1981 "config-impl-keyfile.c"
			} else {
#line 346 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				if (list_type == G_TYPE_STRING) {
#line 1985 "config-impl-keyfile.c"
					gchar** list_data = NULL;
					gint list_data_length1 = 0;
					gint _list_data_size_ = 0;
					GValue val = {0};
					gchar** _tmp41_ = NULL;
					gsize _tmp42_ = 0;
					gchar** _tmp43_;
					gint _tmp41__length1;
					gint __tmp41__size_;
					gchar** _tmp44_;
					gint _tmp44__length1;
					gchar** _tmp45_;
					gint _tmp45__length1;
					GValueArray* _tmp46_;
					gchar** _tmp47_;
					gint _tmp47__length1;
#line 351 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					_tmp43_ = g_key_file_get_string_list (keyfile, group, key, &_tmp42_, &_inner_error0_);
#line 351 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					_tmp41_ = _tmp43_;
#line 351 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					_tmp41__length1 = _tmp42_;
#line 351 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					__tmp41__size_ = _tmp41__length1;
#line 351 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 351 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						g_propagate_error (error, _inner_error0_);
#line 351 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 351 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						list_data = (_vala_array_free (list_data, list_data_length1, (GDestroyNotify) g_free), NULL);
#line 351 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						_g_value_array_free0 (arr);
#line 351 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						_g_object_unref0 (option);
#line 351 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						return NULL;
#line 2024 "config-impl-keyfile.c"
					}
#line 351 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					_tmp44_ = _tmp41_;
#line 351 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					_tmp44__length1 = _tmp41__length1;
#line 351 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					_tmp41_ = NULL;
#line 351 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					_tmp41__length1 = 0;
#line 351 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					list_data = (_vala_array_free (list_data, list_data_length1, (GDestroyNotify) g_free), NULL);
#line 351 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					list_data = _tmp44_;
#line 351 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					list_data_length1 = _tmp44__length1;
#line 351 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					_list_data_size_ = list_data_length1;
#line 352 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					_tmp45_ = list_data;
#line 352 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					_tmp45__length1 = list_data_length1;
#line 352 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					_tmp46_ = g_value_array_new ((guint) _tmp45__length1);
#line 352 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					_g_value_array_free0 (arr);
#line 352 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					arr = _tmp46_;
#line 353 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					_tmp47_ = list_data;
#line 353 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					_tmp47__length1 = list_data_length1;
#line 2056 "config-impl-keyfile.c"
					{
						gchar** item_collection = NULL;
						gint item_collection_length1 = 0;
						gint _item_collection_size_ = 0;
						gint item_it = 0;
#line 353 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						item_collection = _tmp47_;
#line 353 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						item_collection_length1 = _tmp47__length1;
#line 353 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						for (item_it = 0; item_it < item_collection_length1; item_it = item_it + 1) {
#line 2068 "config-impl-keyfile.c"
							gchar* _tmp48_;
							gchar* item = NULL;
#line 353 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_tmp48_ = g_strdup (item_collection[item_it]);
#line 353 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							item = _tmp48_;
#line 2075 "config-impl-keyfile.c"
							{
								const gchar* _tmp49_;
								GValue _tmp50_ = {0};
								GValueArray* _tmp51_;
								GValue _tmp52_;
#line 355 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
								_tmp49_ = item;
#line 355 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
								g_value_init (&_tmp50_, G_TYPE_STRING);
#line 355 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
								g_value_set_string (&_tmp50_, _tmp49_);
#line 355 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
								G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 355 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
								val = _tmp50_;
#line 356 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
								_tmp51_ = arr;
#line 356 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
								_tmp52_ = val;
#line 356 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
								g_value_array_append (_tmp51_, &_tmp52_);
#line 353 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
								_g_free0 (item);
#line 2099 "config-impl-keyfile.c"
							}
						}
					}
#line 346 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					_tmp41_ = (_vala_array_free (_tmp41_, _tmp41__length1, (GDestroyNotify) g_free), NULL);
#line 346 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 346 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					list_data = (_vala_array_free (list_data, list_data_length1, (GDestroyNotify) g_free), NULL);
#line 2109 "config-impl-keyfile.c"
				} else {
					DesktopAgnosticConfigSchemaType* st = NULL;
					DesktopAgnosticConfigSchemaType* _tmp53_;
					DesktopAgnosticConfigSchemaType* _tmp54_;
					DesktopAgnosticConfigSchemaType* _tmp55_;
					gchar** list_data = NULL;
					gint list_data_length1 = 0;
					gint _list_data_size_ = 0;
					gchar** _tmp58_ = NULL;
					gsize _tmp59_ = 0;
					gchar** _tmp60_;
					gint _tmp58__length1;
					gint __tmp58__size_;
					gchar** _tmp61_;
					gint _tmp61__length1;
					gchar** _tmp62_;
					gint _tmp62__length1;
					GValueArray* _tmp63_;
					gchar** _tmp64_;
					gint _tmp64__length1;
#line 361 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					_tmp53_ = desktop_agnostic_config_schema_find_type (list_type);
#line 361 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					_tmp54_ = _g_object_ref0 (_tmp53_);
#line 361 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					st = _tmp54_;
#line 362 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					_tmp55_ = st;
#line 362 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					if (_tmp55_ == NULL) {
#line 2140 "config-impl-keyfile.c"
						const gchar* _tmp56_;
						GError* _tmp57_;
#line 364 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						_tmp56_ = g_type_name (list_type);
#line 364 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						_tmp57_ = g_error_new (DESKTOP_AGNOSTIC_CONFIG_ERROR, DESKTOP_AGNOSTIC_CONFIG_ERROR_INVALID_TYPE, "'%s' is an invalid config type.", _tmp56_);
#line 364 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						_inner_error0_ = _tmp57_;
#line 364 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						g_propagate_error (error, _inner_error0_);
#line 364 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						_g_object_unref0 (st);
#line 364 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						_g_value_array_free0 (arr);
#line 364 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						_g_object_unref0 (option);
#line 364 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						return NULL;
#line 2159 "config-impl-keyfile.c"
					}
#line 370 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					_tmp60_ = g_key_file_get_string_list (keyfile, group, key, &_tmp59_, &_inner_error0_);
#line 370 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					_tmp58_ = _tmp60_;
#line 370 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					_tmp58__length1 = _tmp59_;
#line 370 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					__tmp58__size_ = _tmp58__length1;
#line 370 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 370 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						g_propagate_error (error, _inner_error0_);
#line 370 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						list_data = (_vala_array_free (list_data, list_data_length1, (GDestroyNotify) g_free), NULL);
#line 370 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						_g_object_unref0 (st);
#line 370 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						_g_value_array_free0 (arr);
#line 370 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						_g_object_unref0 (option);
#line 370 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						return NULL;
#line 2183 "config-impl-keyfile.c"
					}
#line 370 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					_tmp61_ = _tmp58_;
#line 370 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					_tmp61__length1 = _tmp58__length1;
#line 370 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					_tmp58_ = NULL;
#line 370 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					_tmp58__length1 = 0;
#line 370 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					list_data = (_vala_array_free (list_data, list_data_length1, (GDestroyNotify) g_free), NULL);
#line 370 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					list_data = _tmp61_;
#line 370 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					list_data_length1 = _tmp61__length1;
#line 370 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					_list_data_size_ = list_data_length1;
#line 371 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					_tmp62_ = list_data;
#line 371 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					_tmp62__length1 = list_data_length1;
#line 371 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					_tmp63_ = g_value_array_new ((guint) _tmp62__length1);
#line 371 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					_g_value_array_free0 (arr);
#line 371 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					arr = _tmp63_;
#line 372 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					_tmp64_ = list_data;
#line 372 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					_tmp64__length1 = list_data_length1;
#line 2215 "config-impl-keyfile.c"
					{
						gchar** item_collection = NULL;
						gint item_collection_length1 = 0;
						gint _item_collection_size_ = 0;
						gint item_it = 0;
#line 372 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						item_collection = _tmp64_;
#line 372 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						item_collection_length1 = _tmp64__length1;
#line 372 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						for (item_it = 0; item_it < item_collection_length1; item_it = item_it + 1) {
#line 2227 "config-impl-keyfile.c"
							gchar* _tmp65_;
							gchar* item = NULL;
#line 372 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_tmp65_ = g_strdup (item_collection[item_it]);
#line 372 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							item = _tmp65_;
#line 2234 "config-impl-keyfile.c"
							{
								GValue _tmp66_ = {0};
								DesktopAgnosticConfigSchemaType* _tmp67_;
								const gchar* _tmp68_;
								GValue _tmp69_ = {0};
								GValueArray* _tmp70_;
#line 374 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
								_tmp67_ = st;
#line 374 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
								_tmp68_ = item;
#line 374 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
								desktop_agnostic_config_schema_type_deserialize (_tmp67_, _tmp68_, &_tmp69_, &_inner_error0_);
#line 374 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
								_tmp66_ = _tmp69_;
#line 374 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
								if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 374 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
									g_propagate_error (error, _inner_error0_);
#line 374 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
									_g_free0 (item);
#line 374 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
									_tmp58_ = (_vala_array_free (_tmp58_, _tmp58__length1, (GDestroyNotify) g_free), NULL);
#line 374 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
									list_data = (_vala_array_free (list_data, list_data_length1, (GDestroyNotify) g_free), NULL);
#line 374 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
									_g_object_unref0 (st);
#line 374 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
									_g_value_array_free0 (arr);
#line 374 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
									_g_object_unref0 (option);
#line 374 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
									return NULL;
#line 2267 "config-impl-keyfile.c"
								}
#line 374 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
								_tmp70_ = arr;
#line 374 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
								g_value_array_append (_tmp70_, &_tmp66_);
#line 372 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
								G_IS_VALUE (&_tmp66_) ? (g_value_unset (&_tmp66_), NULL) : NULL;
#line 372 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
								_g_free0 (item);
#line 2277 "config-impl-keyfile.c"
							}
						}
					}
#line 346 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					_tmp58_ = (_vala_array_free (_tmp58_, _tmp58__length1, (GDestroyNotify) g_free), NULL);
#line 346 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					list_data = (_vala_array_free (list_data, list_data_length1, (GDestroyNotify) g_free), NULL);
#line 346 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					_g_object_unref0 (st);
#line 2287 "config-impl-keyfile.c"
				}
			}
		}
	}
#line 378 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	result = arr;
#line 378 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_g_object_unref0 (option);
#line 378 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	return result;
#line 2298 "config-impl-keyfile.c"
}

static void
desktop_agnostic_config_gkey_file_on_keyfile_changed (DesktopAgnosticConfigGKeyFile* self,
                                                      DesktopAgnosticVFSFile* file,
                                                      DesktopAgnosticVFSFile* other,
                                                      DesktopAgnosticVFSFileMonitorEvent event,
                                                      DesktopAgnosticVFSFileMonitor* monitor)
{
	GError* _inner_error0_ = NULL;
#line 381 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	g_return_if_fail (self != NULL);
#line 381 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	g_return_if_fail (file != NULL);
#line 381 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	g_return_if_fail (monitor != NULL);
#line 385 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	switch (event) {
#line 385 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		case DESKTOP_AGNOSTIC_VFS_FILE_MONITOR_EVENT_CHANGED:
#line 2319 "config-impl-keyfile.c"
		{
#line 399 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			desktop_agnostic_config_gkey_file_load_data (self, file);
#line 400 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			break;
#line 2325 "config-impl-keyfile.c"
		}
#line 385 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		case DESKTOP_AGNOSTIC_VFS_FILE_MONITOR_EVENT_DELETED:
#line 2329 "config-impl-keyfile.c"
		{
			DesktopAgnosticVFSFile* _tmp0_;
#line 402 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp0_ = self->priv->_keyfile;
#line 402 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			if (!desktop_agnostic_vfs_file_exists (_tmp0_)) {
#line 2336 "config-impl-keyfile.c"
				GFile* impl = NULL;
				DesktopAgnosticVFSFile* _tmp1_;
				void* _tmp2_;
				void* _tmp3_;
				GFile* _tmp4_;
				GFile* _tmp5_;
				gchar* _tmp6_;
				gchar* _tmp7_;
				gchar* _tmp8_;
				gchar* _tmp9_;
#line 404 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				_tmp1_ = self->priv->_keyfile;
#line 404 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				_tmp2_ = desktop_agnostic_vfs_file_get_implementation (_tmp1_);
#line 404 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				_tmp3_ = _tmp2_;
#line 404 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				_tmp4_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, g_file_get_type (), GFile));
#line 404 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				impl = _tmp4_;
#line 405 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				_tmp5_ = impl;
#line 405 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				_tmp6_ = g_file_get_path (_tmp5_);
#line 405 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				_tmp7_ = _tmp6_;
#line 405 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				_tmp8_ = g_path_get_dirname (_tmp7_);
#line 405 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				_tmp9_ = _tmp8_;
#line 405 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				desktop_agnostic_config_gkey_file_ensure_directory (self, _tmp9_);
#line 405 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				_g_free0 (_tmp9_);
#line 405 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				_g_free0 (_tmp7_);
#line 2373 "config-impl-keyfile.c"
				{
#line 408 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					desktop_agnostic_config_backend_reset ((DesktopAgnosticConfigBackend*) self, &_inner_error0_);
#line 408 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2379 "config-impl-keyfile.c"
						goto __catch0_g_error;
					}
				}
				goto __finally0;
				__catch0_g_error:
				{
					GError* e = NULL;
					GError* _tmp10_;
					const gchar* _tmp11_;
					GError* _tmp12_;
#line 406 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					e = _inner_error0_;
#line 406 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					_inner_error0_ = NULL;
#line 412 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					_tmp10_ = e;
#line 412 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					_tmp11_ = _tmp10_->message;
#line 412 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					_tmp12_ = e;
#line 412 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					g_critical ("config-impl-keyfile.vala:412: Failed to regenerate the default configu" \
"ration: %s Code:%d", _tmp11_, _tmp12_->code);
#line 406 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					_g_error_free0 (e);
#line 2404 "config-impl-keyfile.c"
				}
				__finally0:
#line 406 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 406 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					_g_object_unref0 (impl);
#line 406 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 406 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					g_clear_error (&_inner_error0_);
#line 406 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					return;
#line 2417 "config-impl-keyfile.c"
				}
#line 402 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				_g_object_unref0 (impl);
#line 2421 "config-impl-keyfile.c"
			}
#line 416 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			break;
#line 2425 "config-impl-keyfile.c"
		}
		default:
		{
#line 419 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			break;
#line 2431 "config-impl-keyfile.c"
		}
	}
}

static void
desktop_agnostic_config_gkey_file_ensure_directory (DesktopAgnosticConfigGKeyFile* self,
                                                    const gchar* path)
{
#line 423 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	g_return_if_fail (self != NULL);
#line 423 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	g_return_if_fail (path != NULL);
#line 426 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	if (!g_file_test (path, G_FILE_TEST_EXISTS)) {
#line 2446 "config-impl-keyfile.c"
		gint d_errno = 0;
#line 428 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		d_errno = g_mkdir_with_parents (path, 0755);
#line 429 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		if (d_errno != 0) {
#line 2452 "config-impl-keyfile.c"
			const gchar* _tmp0_;
#line 431 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp0_ = g_strerror (d_errno);
#line 431 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			g_critical ("config-impl-keyfile.vala:431: Config file error: %s", _tmp0_);
#line 2458 "config-impl-keyfile.c"
		}
	}
}

static gboolean
desktop_agnostic_config_gkey_file_create_file_monitor (DesktopAgnosticConfigGKeyFile* self)
{
	DesktopAgnosticVFSFile* _tmp0_;
	DesktopAgnosticVFSFileMonitor* _tmp1_;
	DesktopAgnosticVFSFileMonitor* _tmp2_;
	gboolean result;
#line 436 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 439 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp0_ = self->priv->_keyfile;
#line 439 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp1_ = desktop_agnostic_vfs_file_monitor (_tmp0_);
#line 439 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_g_object_unref0 (self->priv->_keyfile_monitor);
#line 439 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	self->priv->_keyfile_monitor = _tmp1_;
#line 440 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp2_ = self->priv->_keyfile_monitor;
#line 440 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	self->priv->_monitor_changed_id = g_signal_connect_swapped (_tmp2_, "changed", (GCallback) desktop_agnostic_config_gkey_file_on_keyfile_changed, self);
#line 444 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	result = FALSE;
#line 444 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	return result;
#line 2488 "config-impl-keyfile.c"
}

/**
     * Determines the path to the config file and creates/loads it.
     */
static gboolean
_desktop_agnostic_config_gkey_file_create_file_monitor_gsource_func (gpointer self)
{
	gboolean result;
	result = desktop_agnostic_config_gkey_file_create_file_monitor ((DesktopAgnosticConfigGKeyFile*) self);
#line 496 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	return result;
#line 2501 "config-impl-keyfile.c"
}

static void
desktop_agnostic_config_gkey_file_real_constructed (GObject* base)
{
	DesktopAgnosticConfigGKeyFile * self;
	gchar* base_path = NULL;
	gchar* path = NULL;
	DesktopAgnosticConfigSchema* schema = NULL;
	DesktopAgnosticConfigSchema* _tmp0_;
	DesktopAgnosticConfigSchema* _tmp1_;
	DesktopAgnosticConfigSchema* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	GError* _inner_error0_ = NULL;
#line 450 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	self = (DesktopAgnosticConfigGKeyFile*) base;
#line 455 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp0_ = desktop_agnostic_config_backend_get_schema ((DesktopAgnosticConfigBackend*) self);
#line 455 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp1_ = _tmp0_;
#line 455 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 455 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	schema = _tmp2_;
#line 457 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp3_ = g_get_user_config_dir ();
#line 457 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp4_ = g_build_filename (_tmp3_, "desktop-agnostic", NULL);
#line 457 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_g_free0 (base_path);
#line 457 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	base_path = _tmp4_;
#line 459 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp5_ = desktop_agnostic_config_backend_get_instance_id ((DesktopAgnosticConfigBackend*) self);
#line 459 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp6_ = _tmp5_;
#line 459 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	if (_tmp6_ == NULL) {
#line 2543 "config-impl-keyfile.c"
		const gchar* _tmp7_;
		DesktopAgnosticConfigSchema* _tmp8_;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
#line 461 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp7_ = base_path;
#line 461 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp8_ = schema;
#line 461 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp9_ = desktop_agnostic_config_schema_get_app_name (_tmp8_);
#line 461 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp10_ = _tmp9_;
#line 461 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp11_ = g_strdup_printf ("%s.ini", _tmp10_);
#line 461 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp12_ = _tmp11_;
#line 461 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp13_ = g_build_filename (_tmp7_, _tmp12_, NULL);
#line 461 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_g_free0 (path);
#line 461 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		path = _tmp13_;
#line 461 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_g_free0 (_tmp12_);
#line 2571 "config-impl-keyfile.c"
	} else {
		const gchar* _tmp14_;
		DesktopAgnosticConfigSchema* _tmp15_;
		const gchar* _tmp16_;
		const gchar* _tmp17_;
		const gchar* _tmp18_;
		const gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
#line 466 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp14_ = base_path;
#line 466 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp15_ = schema;
#line 466 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp16_ = desktop_agnostic_config_schema_get_app_name (_tmp15_);
#line 466 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp17_ = _tmp16_;
#line 466 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp18_ = desktop_agnostic_config_backend_get_instance_id ((DesktopAgnosticConfigBackend*) self);
#line 466 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp19_ = _tmp18_;
#line 466 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp20_ = g_strdup_printf ("%s-%s.ini", _tmp17_, _tmp19_);
#line 466 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp21_ = _tmp20_;
#line 466 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp22_ = g_build_filename (_tmp14_, "instances", _tmp21_, NULL);
#line 466 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_g_free0 (path);
#line 466 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		path = _tmp22_;
#line 466 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_g_free0 (_tmp21_);
#line 2606 "config-impl-keyfile.c"
	}
	{
		DesktopAgnosticVFSFile* _tmp23_ = NULL;
		const gchar* _tmp24_;
		DesktopAgnosticVFSFile* _tmp25_;
		DesktopAgnosticVFSFile* _tmp26_;
		DesktopAgnosticVFSFile* _tmp27_;
#line 473 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp24_ = path;
#line 473 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp25_ = desktop_agnostic_vfs_file_new_for_path (_tmp24_, &_inner_error0_);
#line 473 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp23_ = _tmp25_;
#line 473 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2622 "config-impl-keyfile.c"
			goto __catch0_g_error;
		}
#line 473 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp26_ = _tmp23_;
#line 473 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp23_ = NULL;
#line 473 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_g_object_unref0 (self->priv->_keyfile);
#line 473 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		self->priv->_keyfile = _tmp26_;
#line 474 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp27_ = self->priv->_keyfile;
#line 474 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		if (desktop_agnostic_vfs_file_exists (_tmp27_)) {
#line 2637 "config-impl-keyfile.c"
			DesktopAgnosticVFSFile* _tmp28_;
#line 476 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			desktop_agnostic_config_gkey_file_reset_nosave (self, &_inner_error0_);
#line 476 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 476 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				_g_object_unref0 (_tmp23_);
#line 2645 "config-impl-keyfile.c"
				goto __catch0_g_error;
			}
#line 477 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			desktop_agnostic_config_gkey_file_calculate_checksum (self);
#line 478 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp28_ = self->priv->_keyfile;
#line 478 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			desktop_agnostic_config_gkey_file_load_data (self, _tmp28_);
#line 2654 "config-impl-keyfile.c"
		} else {
			const gchar* _tmp29_;
			gchar* _tmp30_;
			gchar* _tmp31_;
#line 482 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp29_ = path;
#line 482 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp30_ = g_path_get_dirname (_tmp29_);
#line 482 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp31_ = _tmp30_;
#line 482 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			desktop_agnostic_config_gkey_file_ensure_directory (self, _tmp31_);
#line 482 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_g_free0 (_tmp31_);
#line 483 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			desktop_agnostic_config_backend_reset ((DesktopAgnosticConfigBackend*) self, &_inner_error0_);
#line 483 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 483 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				_g_object_unref0 (_tmp23_);
#line 2675 "config-impl-keyfile.c"
				goto __catch0_g_error;
			}
		}
#line 471 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_g_object_unref0 (_tmp23_);
#line 2681 "config-impl-keyfile.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp32_;
		const gchar* _tmp33_;
		GError* _tmp34_;
#line 471 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		e = _inner_error0_;
#line 471 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_inner_error0_ = NULL;
#line 488 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp32_ = e;
#line 488 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp33_ = _tmp32_->message;
#line 488 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp34_ = e;
#line 488 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		g_critical ("config-impl-keyfile.vala:488: Configuration error: %s Code:%d", _tmp33_, _tmp34_->code);
#line 471 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_g_error_free0 (e);
#line 2704 "config-impl-keyfile.c"
	}
	__finally0:
#line 471 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 471 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_g_object_unref0 (schema);
#line 471 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_g_free0 (path);
#line 471 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_g_free0 (base_path);
#line 471 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 471 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		g_clear_error (&_inner_error0_);
#line 471 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		return;
#line 2721 "config-impl-keyfile.c"
	}
#line 496 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, _desktop_agnostic_config_gkey_file_create_file_monitor_gsource_func, g_object_ref (self), g_object_unref);
#line 450 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_g_object_unref0 (schema);
#line 450 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_g_free0 (path);
#line 450 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_g_free0 (base_path);
#line 2731 "config-impl-keyfile.c"
}

static void
desktop_agnostic_config_gkey_file_reset_nosave (DesktopAgnosticConfigGKeyFile* self,
                                                GError** error)
{
	DesktopAgnosticConfigSchema* schema = NULL;
	DesktopAgnosticConfigSchema* _tmp0_;
	DesktopAgnosticConfigSchema* _tmp1_;
	GList* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 506 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	g_return_if_fail (self != NULL);
#line 509 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp0_ = desktop_agnostic_config_backend_get_schema ((DesktopAgnosticConfigBackend*) self);
#line 509 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp1_ = _tmp0_;
#line 509 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	schema = _tmp1_;
#line 510 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	if (schema == NULL) {
#line 2753 "config-impl-keyfile.c"
		GError* _tmp2_;
#line 512 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp2_ = g_error_new_literal (DESKTOP_AGNOSTIC_CONFIG_ERROR, DESKTOP_AGNOSTIC_CONFIG_ERROR_NO_SCHEMA, "The schema was not loaded.");
#line 512 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_inner_error0_ = _tmp2_;
#line 512 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		g_propagate_error (error, _inner_error0_);
#line 512 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		return;
#line 2763 "config-impl-keyfile.c"
	}
#line 515 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	self->priv->_autosave = FALSE;
#line 516 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp3_ = desktop_agnostic_config_schema_get_groups (schema);
#line 2769 "config-impl-keyfile.c"
	{
		GList* group_collection = NULL;
		GList* group_it = NULL;
#line 516 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		group_collection = _tmp3_;
#line 516 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		for (group_it = group_collection; group_it != NULL; group_it = group_it->next) {
#line 2777 "config-impl-keyfile.c"
			const gchar* group = NULL;
#line 516 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			group = (const gchar*) group_it->data;
#line 2781 "config-impl-keyfile.c"
			{
				const gchar* _tmp4_;
				GList* _tmp5_;
#line 518 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				_tmp4_ = group;
#line 518 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				_tmp5_ = desktop_agnostic_config_schema_get_keys (schema, _tmp4_);
#line 2789 "config-impl-keyfile.c"
				{
					GList* key_collection = NULL;
					GList* key_it = NULL;
#line 518 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					key_collection = _tmp5_;
#line 518 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					for (key_it = key_collection; key_it != NULL; key_it = key_it->next) {
#line 2797 "config-impl-keyfile.c"
						const gchar* key = NULL;
#line 518 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						key = (const gchar*) key_it->data;
#line 2801 "config-impl-keyfile.c"
						{
							DesktopAgnosticConfigSchemaOption* option = NULL;
							const gchar* _tmp6_;
							const gchar* _tmp7_;
							DesktopAgnosticConfigSchemaOption* _tmp8_;
							DesktopAgnosticConfigSchemaOption* _tmp9_;
							gboolean _tmp10_ = FALSE;
							const gchar* _tmp11_;
							const gchar* _tmp12_;
#line 520 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_tmp6_ = group;
#line 520 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_tmp7_ = key;
#line 520 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_tmp8_ = desktop_agnostic_config_schema_get_option (schema, _tmp6_, _tmp7_);
#line 520 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_tmp9_ = _g_object_ref0 (_tmp8_);
#line 520 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							option = _tmp9_;
#line 521 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_tmp11_ = desktop_agnostic_config_backend_get_instance_id ((DesktopAgnosticConfigBackend*) self);
#line 521 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_tmp12_ = _tmp11_;
#line 521 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							if (_tmp12_ == NULL) {
#line 521 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
								_tmp10_ = TRUE;
#line 2829 "config-impl-keyfile.c"
							} else {
								DesktopAgnosticConfigSchemaOption* _tmp13_;
								gboolean _tmp14_;
								gboolean _tmp15_;
#line 521 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
								_tmp13_ = option;
#line 521 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
								_tmp14_ = desktop_agnostic_config_schema_option_get_per_instance (_tmp13_);
#line 521 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
								_tmp15_ = _tmp14_;
#line 521 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
								_tmp10_ = _tmp15_;
#line 2842 "config-impl-keyfile.c"
							}
#line 521 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							if (_tmp10_) {
#line 2846 "config-impl-keyfile.c"
								const gchar* _tmp16_;
								const gchar* _tmp17_;
								DesktopAgnosticConfigSchemaOption* _tmp18_;
								GValue _tmp19_ = {0};
								GValue _tmp20_;
#line 523 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
								_tmp16_ = group;
#line 523 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
								_tmp17_ = key;
#line 523 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
								_tmp18_ = option;
#line 523 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
								desktop_agnostic_config_schema_option_get_default_value (_tmp18_, &_tmp19_);
#line 523 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
								_tmp20_ = _tmp19_;
#line 523 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
								desktop_agnostic_config_backend_set_value ((DesktopAgnosticConfigBackend*) self, _tmp16_, _tmp17_, &_tmp20_, &_inner_error0_);
#line 523 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
								if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 523 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
									g_propagate_error (error, _inner_error0_);
#line 523 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
									_g_object_unref0 (option);
#line 523 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
									(group_collection == NULL) ? NULL : (group_collection = (g_list_free (group_collection), NULL));
#line 523 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
									return;
#line 2874 "config-impl-keyfile.c"
								}
							}
#line 518 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_g_object_unref0 (option);
#line 2879 "config-impl-keyfile.c"
						}
					}
				}
			}
		}
#line 516 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		(group_collection == NULL) ? NULL : (group_collection = (g_list_free (group_collection), NULL));
#line 2887 "config-impl-keyfile.c"
	}
#line 527 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	self->priv->_autosave = TRUE;
#line 2891 "config-impl-keyfile.c"
}

static void
desktop_agnostic_config_gkey_file_real_reset (DesktopAgnosticConfigBackend* base,
                                              GError** error)
{
	DesktopAgnosticConfigGKeyFile * self;
	GError* _inner_error0_ = NULL;
#line 530 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	self = (DesktopAgnosticConfigGKeyFile*) base;
#line 533 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	desktop_agnostic_config_gkey_file_reset_nosave (self, &_inner_error0_);
#line 533 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 533 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		g_propagate_error (error, _inner_error0_);
#line 533 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		return;
#line 2910 "config-impl-keyfile.c"
	}
#line 534 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	desktop_agnostic_config_gkey_file_save_config (self, TRUE, &_inner_error0_);
#line 534 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 534 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		g_propagate_error (error, _inner_error0_);
#line 534 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		return;
#line 2920 "config-impl-keyfile.c"
	}
}

static void
desktop_agnostic_config_gkey_file_real_notify_add (DesktopAgnosticConfigBackend* base,
                                                   const gchar* group,
                                                   const gchar* key,
                                                   DesktopAgnosticConfigNotifyFunc callback,
                                                   gpointer callback_target,
                                                   GError** error)
{
	DesktopAgnosticConfigGKeyFile * self;
	gchar* full_key = NULL;
	gchar* _tmp0_;
	GSList* funcs = NULL;
	gconstpointer _tmp1_;
	DesktopAgnosticConfigNotifyDelegate* data = NULL;
	DesktopAgnosticConfigNotifyDelegate* _tmp2_;
	DesktopAgnosticConfigNotifyDelegate* _tmp3_;
#line 537 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	self = (DesktopAgnosticConfigGKeyFile*) base;
#line 537 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	g_return_if_fail (group != NULL);
#line 537 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	g_return_if_fail (key != NULL);
#line 540 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp0_ = g_strdup_printf ("%s/%s", group, key);
#line 540 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	full_key = _tmp0_;
#line 541 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp1_ = g_datalist_get_data (&self->priv->_notifiers, full_key);
#line 541 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	funcs = (GSList*) _tmp1_;
#line 542 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp2_ = desktop_agnostic_config_notify_delegate_new (callback, callback_target);
#line 542 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	data = _tmp2_;
#line 543 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp3_ = data;
#line 543 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	data = NULL;
#line 543 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	funcs = g_slist_append (funcs, _tmp3_);
#line 544 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	g_datalist_set_data (&self->priv->_notifiers, full_key, funcs);
#line 537 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_desktop_agnostic_config_notify_delegate_free0 (data);
#line 537 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_g_free0 (full_key);
#line 2970 "config-impl-keyfile.c"
}

static void
desktop_agnostic_config_gkey_file_real_notify (DesktopAgnosticConfigBackend* base,
                                               const gchar* group,
                                               const gchar* key,
                                               GError** error)
{
	DesktopAgnosticConfigGKeyFile * self;
	gchar* full_key = NULL;
	gchar* _tmp0_;
	GValue value = {0};
	GValue _tmp1_ = {0};
	GSList* funcs = NULL;
	gconstpointer _tmp2_;
	GSList* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 547 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	self = (DesktopAgnosticConfigGKeyFile*) base;
#line 547 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	g_return_if_fail (group != NULL);
#line 547 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	g_return_if_fail (key != NULL);
#line 550 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp0_ = g_strdup_printf ("%s/%s", group, key);
#line 550 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	full_key = _tmp0_;
#line 551 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	desktop_agnostic_config_backend_get_value ((DesktopAgnosticConfigBackend*) self, group, key, &_tmp1_, &_inner_error0_);
#line 551 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	value = _tmp1_;
#line 551 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 551 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		g_propagate_error (error, _inner_error0_);
#line 551 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_g_free0 (full_key);
#line 551 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		return;
#line 3010 "config-impl-keyfile.c"
	}
#line 552 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp2_ = g_datalist_get_data (&self->priv->_notifiers, full_key);
#line 552 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	funcs = (GSList*) _tmp2_;
#line 553 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp3_ = funcs;
#line 3018 "config-impl-keyfile.c"
	{
		GSList* data_collection = NULL;
		GSList* data_it = NULL;
#line 553 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		data_collection = _tmp3_;
#line 553 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		for (data_it = data_collection; data_it != NULL; data_it = data_it->next) {
#line 3026 "config-impl-keyfile.c"
			DesktopAgnosticConfigNotifyDelegate* data = NULL;
#line 553 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			data = (DesktopAgnosticConfigNotifyDelegate*) data_it->data;
#line 3030 "config-impl-keyfile.c"
			{
				DesktopAgnosticConfigNotifyDelegate* _tmp4_;
				GValue _tmp5_;
#line 556 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				_tmp4_ = data;
#line 556 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				_tmp5_ = value;
#line 556 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				desktop_agnostic_config_notify_delegate_execute (_tmp4_, group, key, &_tmp5_);
#line 3040 "config-impl-keyfile.c"
			}
		}
	}
#line 547 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	G_IS_VALUE (&value) ? (g_value_unset (&value), NULL) : NULL;
#line 547 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_g_free0 (full_key);
#line 3048 "config-impl-keyfile.c"
}

static void
desktop_agnostic_config_gkey_file_real_notify_remove (DesktopAgnosticConfigBackend* base,
                                                      const gchar* group,
                                                      const gchar* key,
                                                      DesktopAgnosticConfigNotifyFunc callback,
                                                      gpointer callback_target,
                                                      GError** error)
{
	DesktopAgnosticConfigGKeyFile * self;
	gchar* full_key = NULL;
	gchar* _tmp0_;
	GSList* funcs = NULL;
	const gchar* _tmp1_;
	gconstpointer _tmp2_;
	DesktopAgnosticConfigNotifyDelegate* ndata = NULL;
	DesktopAgnosticConfigNotifyDelegate* _tmp3_;
	GSList* node = NULL;
	GSList* _tmp4_;
	DesktopAgnosticConfigNotifyDelegate* _tmp5_;
	GSList* _tmp6_;
	GSList* _tmp7_;
#line 560 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	self = (DesktopAgnosticConfigGKeyFile*) base;
#line 560 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	g_return_if_fail (group != NULL);
#line 560 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	g_return_if_fail (key != NULL);
#line 563 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp0_ = g_strdup_printf ("%s/%s", group, key);
#line 563 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	full_key = _tmp0_;
#line 564 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp1_ = full_key;
#line 564 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp2_ = g_datalist_get_data (&self->priv->_notifiers, _tmp1_);
#line 564 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	funcs = (GSList*) _tmp2_;
#line 565 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp3_ = desktop_agnostic_config_notify_delegate_new (callback, callback_target);
#line 565 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	ndata = _tmp3_;
#line 568 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp4_ = funcs;
#line 568 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp5_ = ndata;
#line 568 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp6_ = g_slist_find_custom (_tmp4_, _tmp5_, (GCompareFunc) desktop_agnostic_config_notify_delegate_compare);
#line 568 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	node = _tmp6_;
#line 569 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp7_ = node;
#line 569 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	if (_tmp7_ != NULL) {
#line 3104 "config-impl-keyfile.c"
		GSList* _tmp8_;
		GSList* _tmp9_;
		const gchar* _tmp10_;
		GSList* _tmp11_;
#line 571 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp8_ = node;
#line 571 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_desktop_agnostic_config_notify_delegate_free0 (_tmp8_->data);
#line 571 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp8_->data = NULL;
#line 572 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp9_ = node;
#line 572 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		funcs = g_slist_delete_link (funcs, _tmp9_);
#line 573 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp10_ = full_key;
#line 573 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp11_ = funcs;
#line 573 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		g_datalist_set_data (&self->priv->_notifiers, _tmp10_, _tmp11_);
#line 3125 "config-impl-keyfile.c"
	}
#line 560 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_desktop_agnostic_config_notify_delegate_free0 (ndata);
#line 560 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_g_free0 (full_key);
#line 3131 "config-impl-keyfile.c"
}

/**
     * Removes the config file from the file system.
     */
static void
desktop_agnostic_config_gkey_file_real_remove (DesktopAgnosticConfigBackend* base,
                                               GError** error)
{
	DesktopAgnosticConfigGKeyFile * self;
	DesktopAgnosticVFSFile* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 580 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	self = (DesktopAgnosticConfigGKeyFile*) base;
#line 584 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp0_ = self->priv->_keyfile;
#line 584 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	desktop_agnostic_vfs_file_remove (_tmp0_, &_inner_error0_);
#line 584 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 584 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		g_propagate_error (error, _inner_error0_);
#line 584 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		return;
#line 3156 "config-impl-keyfile.c"
	}
}

static void
desktop_agnostic_config_gkey_file_real_get_value (DesktopAgnosticConfigBackend* base,
                                                  const gchar* group,
                                                  const gchar* key,
                                                  GValue* result,
                                                  GError** error)
{
	DesktopAgnosticConfigGKeyFile * self;
	DesktopAgnosticConfigSchema* schema = NULL;
	DesktopAgnosticConfigSchema* _tmp0_;
	DesktopAgnosticConfigSchema* _tmp1_;
	DesktopAgnosticConfigSchema* _tmp2_;
	DesktopAgnosticConfigSchemaOption* option = NULL;
	DesktopAgnosticConfigSchema* _tmp3_;
	DesktopAgnosticConfigSchemaOption* _tmp4_;
	DesktopAgnosticConfigSchemaOption* _tmp5_;
	GType option_type = 0UL;
	GValue _result_ = {0};
	DesktopAgnosticConfigSchemaOption* _tmp6_;
	DesktopAgnosticConfigSchemaOption* _tmp8_;
	GType _tmp9_;
	GType _tmp10_;
	GError* _inner_error0_ = NULL;
#line 587 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	self = (DesktopAgnosticConfigGKeyFile*) base;
#line 587 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	g_return_if_fail (group != NULL);
#line 587 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	g_return_if_fail (key != NULL);
#line 590 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp0_ = desktop_agnostic_config_backend_get_schema ((DesktopAgnosticConfigBackend*) self);
#line 590 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp1_ = _tmp0_;
#line 590 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 590 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	schema = _tmp2_;
#line 591 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp3_ = schema;
#line 591 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp4_ = desktop_agnostic_config_schema_get_option (_tmp3_, group, key);
#line 591 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 591 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	option = _tmp5_;
#line 595 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp6_ = option;
#line 595 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	if (_tmp6_ == NULL) {
#line 3209 "config-impl-keyfile.c"
		GError* _tmp7_;
#line 597 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp7_ = g_error_new_literal (DESKTOP_AGNOSTIC_CONFIG_ERROR, DESKTOP_AGNOSTIC_CONFIG_ERROR_KEY_NOT_FOUND, "Could not find group and/or key in schema.");
#line 597 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_inner_error0_ = _tmp7_;
#line 597 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		g_propagate_error (error, _inner_error0_);
#line 597 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		G_IS_VALUE (&_result_) ? (g_value_unset (&_result_), NULL) : NULL;
#line 597 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_g_object_unref0 (option);
#line 597 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_g_object_unref0 (schema);
#line 597 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		return;
#line 3225 "config-impl-keyfile.c"
	}
#line 600 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp8_ = option;
#line 600 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp9_ = desktop_agnostic_config_schema_option_get_option_type (_tmp8_);
#line 600 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp10_ = _tmp9_;
#line 600 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	option_type = _tmp10_;
#line 602 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	if (option_type == G_TYPE_BOOLEAN) {
#line 3237 "config-impl-keyfile.c"
		gboolean _tmp11_ = FALSE;
		GValue _tmp12_ = {0};
#line 604 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp11_ = desktop_agnostic_config_backend_get_bool ((DesktopAgnosticConfigBackend*) self, group, key, &_inner_error0_);
#line 604 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 604 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			g_propagate_error (error, _inner_error0_);
#line 604 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			G_IS_VALUE (&_result_) ? (g_value_unset (&_result_), NULL) : NULL;
#line 604 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_g_object_unref0 (option);
#line 604 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_g_object_unref0 (schema);
#line 604 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			return;
#line 3254 "config-impl-keyfile.c"
		}
#line 604 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		g_value_init (&_tmp12_, G_TYPE_BOOLEAN);
#line 604 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		g_value_set_boolean (&_tmp12_, _tmp11_);
#line 604 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		G_IS_VALUE (&_result_) ? (g_value_unset (&_result_), NULL) : NULL;
#line 604 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_result_ = _tmp12_;
#line 3264 "config-impl-keyfile.c"
	} else {
#line 606 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		if (option_type == G_TYPE_FLOAT) {
#line 3268 "config-impl-keyfile.c"
			gfloat _tmp13_ = 0.0F;
			GValue _tmp14_ = {0};
#line 608 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp13_ = desktop_agnostic_config_backend_get_float ((DesktopAgnosticConfigBackend*) self, group, key, &_inner_error0_);
#line 608 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 608 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				g_propagate_error (error, _inner_error0_);
#line 608 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				G_IS_VALUE (&_result_) ? (g_value_unset (&_result_), NULL) : NULL;
#line 608 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				_g_object_unref0 (option);
#line 608 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				_g_object_unref0 (schema);
#line 608 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				return;
#line 3285 "config-impl-keyfile.c"
			}
#line 608 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			g_value_init (&_tmp14_, G_TYPE_FLOAT);
#line 608 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			g_value_set_float (&_tmp14_, _tmp13_);
#line 608 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			G_IS_VALUE (&_result_) ? (g_value_unset (&_result_), NULL) : NULL;
#line 608 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_result_ = _tmp14_;
#line 3295 "config-impl-keyfile.c"
		} else {
#line 610 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			if (option_type == G_TYPE_INT) {
#line 3299 "config-impl-keyfile.c"
				gint _tmp15_ = 0;
				GValue _tmp16_ = {0};
#line 612 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				_tmp15_ = desktop_agnostic_config_backend_get_int ((DesktopAgnosticConfigBackend*) self, group, key, &_inner_error0_);
#line 612 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 612 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					g_propagate_error (error, _inner_error0_);
#line 612 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					G_IS_VALUE (&_result_) ? (g_value_unset (&_result_), NULL) : NULL;
#line 612 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					_g_object_unref0 (option);
#line 612 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					_g_object_unref0 (schema);
#line 612 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					return;
#line 3316 "config-impl-keyfile.c"
				}
#line 612 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				g_value_init (&_tmp16_, G_TYPE_INT);
#line 612 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				g_value_set_int (&_tmp16_, _tmp15_);
#line 612 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				G_IS_VALUE (&_result_) ? (g_value_unset (&_result_), NULL) : NULL;
#line 612 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				_result_ = _tmp16_;
#line 3326 "config-impl-keyfile.c"
			} else {
#line 614 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				if (option_type == G_TYPE_STRING) {
#line 3330 "config-impl-keyfile.c"
					gchar* _tmp17_ = NULL;
					gchar* _tmp18_;
					gchar* _tmp19_;
					GValue _tmp20_ = {0};
#line 616 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					_tmp18_ = desktop_agnostic_config_backend_get_string ((DesktopAgnosticConfigBackend*) self, group, key, &_inner_error0_);
#line 616 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					_tmp17_ = _tmp18_;
#line 616 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 616 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						g_propagate_error (error, _inner_error0_);
#line 616 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						G_IS_VALUE (&_result_) ? (g_value_unset (&_result_), NULL) : NULL;
#line 616 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						_g_object_unref0 (option);
#line 616 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						_g_object_unref0 (schema);
#line 616 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						return;
#line 3351 "config-impl-keyfile.c"
					}
#line 616 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					_tmp19_ = _tmp17_;
#line 616 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					_tmp17_ = NULL;
#line 616 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					g_value_init (&_tmp20_, G_TYPE_STRING);
#line 616 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					g_value_take_string (&_tmp20_, _tmp19_);
#line 616 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					G_IS_VALUE (&_result_) ? (g_value_unset (&_result_), NULL) : NULL;
#line 616 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					_result_ = _tmp20_;
#line 614 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					_g_free0 (_tmp17_);
#line 3367 "config-impl-keyfile.c"
				} else {
#line 618 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					if (option_type == G_TYPE_VALUE_ARRAY) {
#line 3371 "config-impl-keyfile.c"
						GValueArray* _tmp21_ = NULL;
						GValueArray* _tmp22_;
						GValueArray* _tmp23_;
						GValue _tmp24_ = {0};
#line 620 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						_tmp22_ = desktop_agnostic_config_backend_get_list ((DesktopAgnosticConfigBackend*) self, group, key, &_inner_error0_);
#line 620 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						_tmp21_ = _tmp22_;
#line 620 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 620 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							g_propagate_error (error, _inner_error0_);
#line 620 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							G_IS_VALUE (&_result_) ? (g_value_unset (&_result_), NULL) : NULL;
#line 620 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_g_object_unref0 (option);
#line 620 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_g_object_unref0 (schema);
#line 620 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							return;
#line 3392 "config-impl-keyfile.c"
						}
#line 620 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						_tmp23_ = _tmp21_;
#line 620 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						_tmp21_ = NULL;
#line 620 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						g_value_init (&_tmp24_, G_TYPE_VALUE_ARRAY);
#line 620 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						g_value_take_boxed (&_tmp24_, _tmp23_);
#line 620 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						G_IS_VALUE (&_result_) ? (g_value_unset (&_result_), NULL) : NULL;
#line 620 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						_result_ = _tmp24_;
#line 618 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						_g_value_array_free0 (_tmp21_);
#line 3408 "config-impl-keyfile.c"
					} else {
						DesktopAgnosticConfigSchemaType* st = NULL;
						DesktopAgnosticConfigSchemaType* _tmp25_;
						DesktopAgnosticConfigSchemaType* _tmp26_;
						DesktopAgnosticConfigSchemaType* _tmp27_;
#line 624 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						_tmp25_ = desktop_agnostic_config_schema_find_type (option_type);
#line 624 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						_tmp26_ = _g_object_ref0 (_tmp25_);
#line 624 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						st = _tmp26_;
#line 625 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						_tmp27_ = st;
#line 625 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						if (_tmp27_ == NULL) {
#line 3424 "config-impl-keyfile.c"
							const gchar* _tmp28_;
							GError* _tmp29_;
#line 627 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_tmp28_ = g_type_name (option_type);
#line 627 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_tmp29_ = g_error_new (DESKTOP_AGNOSTIC_CONFIG_ERROR, DESKTOP_AGNOSTIC_CONFIG_ERROR_INVALID_TYPE, "'%s' is an invalid config type.", _tmp28_);
#line 627 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_inner_error0_ = _tmp29_;
#line 627 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							g_propagate_error (error, _inner_error0_);
#line 627 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_g_object_unref0 (st);
#line 627 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							G_IS_VALUE (&_result_) ? (g_value_unset (&_result_), NULL) : NULL;
#line 627 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_g_object_unref0 (option);
#line 627 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_g_object_unref0 (schema);
#line 627 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							return;
#line 3445 "config-impl-keyfile.c"
						} else {
							gchar* _tmp30_ = NULL;
							gchar* _tmp31_;
							GValue _tmp32_ = {0};
							DesktopAgnosticConfigSchemaType* _tmp33_;
							GValue _tmp34_ = {0};
							GValue _tmp35_;
#line 632 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_tmp31_ = desktop_agnostic_config_backend_get_string ((DesktopAgnosticConfigBackend*) self, group, key, &_inner_error0_);
#line 632 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_tmp30_ = _tmp31_;
#line 632 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 632 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
								g_propagate_error (error, _inner_error0_);
#line 632 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
								_g_object_unref0 (st);
#line 632 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
								G_IS_VALUE (&_result_) ? (g_value_unset (&_result_), NULL) : NULL;
#line 632 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
								_g_object_unref0 (option);
#line 632 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
								_g_object_unref0 (schema);
#line 632 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
								return;
#line 3471 "config-impl-keyfile.c"
							}
#line 632 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_tmp33_ = st;
#line 632 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							desktop_agnostic_config_schema_type_deserialize (_tmp33_, _tmp30_, &_tmp34_, &_inner_error0_);
#line 632 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_tmp32_ = _tmp34_;
#line 632 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 632 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
								g_propagate_error (error, _inner_error0_);
#line 632 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
								_g_free0 (_tmp30_);
#line 632 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
								_g_object_unref0 (st);
#line 632 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
								G_IS_VALUE (&_result_) ? (g_value_unset (&_result_), NULL) : NULL;
#line 632 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
								_g_object_unref0 (option);
#line 632 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
								_g_object_unref0 (schema);
#line 632 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
								return;
#line 3495 "config-impl-keyfile.c"
							}
#line 632 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_tmp35_ = _tmp32_;
#line 632 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							memset (&_tmp32_, 0, sizeof (GValue));
#line 632 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							G_IS_VALUE (&_result_) ? (g_value_unset (&_result_), NULL) : NULL;
#line 632 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_result_ = _tmp35_;
#line 625 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							G_IS_VALUE (&_tmp32_) ? (g_value_unset (&_tmp32_), NULL) : NULL;
#line 625 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_g_free0 (_tmp30_);
#line 3509 "config-impl-keyfile.c"
						}
#line 618 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						_g_object_unref0 (st);
#line 3513 "config-impl-keyfile.c"
					}
				}
			}
		}
	}
#line 635 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	*result = _result_;
#line 635 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_g_object_unref0 (option);
#line 635 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_g_object_unref0 (schema);
#line 635 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	return;
#line 3527 "config-impl-keyfile.c"
}

static gpointer
_g_error_copy0 (gpointer self)
{
#line 654 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	return self ? g_error_copy (self) : NULL;
#line 3535 "config-impl-keyfile.c"
}

static gboolean
desktop_agnostic_config_gkey_file_real_get_bool (DesktopAgnosticConfigBackend* base,
                                                 const gchar* group,
                                                 const gchar* key,
                                                 GError** error)
{
	DesktopAgnosticConfigGKeyFile * self;
	gboolean _tmp11_ = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 638 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	self = (DesktopAgnosticConfigGKeyFile*) base;
#line 638 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	g_return_val_if_fail (group != NULL, FALSE);
#line 638 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	g_return_val_if_fail (key != NULL, FALSE);
#line 3554 "config-impl-keyfile.c"
	{
		gboolean _tmp0_ = FALSE;
		GKeyFile* _tmp1_;
#line 643 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp1_ = self->priv->_data;
#line 643 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp0_ = g_key_file_get_boolean (_tmp1_, group, key, &_inner_error0_);
#line 643 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3564 "config-impl-keyfile.c"
			gboolean _tmp2_ = FALSE;
#line 643 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 3568 "config-impl-keyfile.c"
				goto __catch0_g_key_file_error;
			}
#line 643 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 643 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			g_clear_error (&_inner_error0_);
#line 643 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			return _tmp2_;
#line 3577 "config-impl-keyfile.c"
		}
#line 643 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		result = _tmp0_;
#line 643 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		return result;
#line 3583 "config-impl-keyfile.c"
	}
	goto __finally0;
	__catch0_g_key_file_error:
	{
		GError* err = NULL;
		gboolean _tmp3_ = FALSE;
		GError* _tmp4_;
#line 641 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		err = _inner_error0_;
#line 641 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_inner_error0_ = NULL;
#line 647 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp4_ = err;
#line 647 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		if (g_error_matches (_tmp4_, G_KEY_FILE_ERROR, G_KEY_FILE_ERROR_GROUP_NOT_FOUND)) {
#line 647 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp3_ = TRUE;
#line 3601 "config-impl-keyfile.c"
		} else {
			GError* _tmp5_;
#line 648 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp5_ = err;
#line 648 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp3_ = g_error_matches (_tmp5_, G_KEY_FILE_ERROR, G_KEY_FILE_ERROR_KEY_NOT_FOUND);
#line 3608 "config-impl-keyfile.c"
		}
#line 647 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		if (_tmp3_) {
#line 3612 "config-impl-keyfile.c"
			GError* _tmp6_;
			const gchar* _tmp7_;
			GError* _tmp8_;
#line 650 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp6_ = err;
#line 650 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp7_ = _tmp6_->message;
#line 650 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp8_ = g_error_new_literal (DESKTOP_AGNOSTIC_CONFIG_ERROR, DESKTOP_AGNOSTIC_CONFIG_ERROR_KEY_NOT_FOUND, _tmp7_);
#line 650 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_inner_error0_ = _tmp8_;
#line 650 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_g_error_free0 (err);
#line 3626 "config-impl-keyfile.c"
			goto __finally0;
		} else {
			GError* _tmp9_;
			GError* _tmp10_;
#line 654 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp9_ = err;
#line 654 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp10_ = _g_error_copy0 (_tmp9_);
#line 654 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_inner_error0_ = _tmp10_;
#line 654 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_g_error_free0 (err);
#line 3639 "config-impl-keyfile.c"
			goto __finally0;
		}
#line 641 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_g_error_free0 (err);
#line 3644 "config-impl-keyfile.c"
	}
	__finally0:
#line 641 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	g_propagate_error (error, _inner_error0_);
#line 641 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	return _tmp11_;
#line 3651 "config-impl-keyfile.c"
}

static void
desktop_agnostic_config_gkey_file_real_set_bool (DesktopAgnosticConfigBackend* base,
                                                 const gchar* group,
                                                 const gchar* key,
                                                 gboolean value,
                                                 GError** error)
{
	DesktopAgnosticConfigGKeyFile * self;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GKeyFile* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 659 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	self = (DesktopAgnosticConfigGKeyFile*) base;
#line 659 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	g_return_if_fail (group != NULL);
#line 659 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	g_return_if_fail (key != NULL);
#line 662 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp2_ = self->priv->_data;
#line 662 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	if (!g_key_file_has_group (_tmp2_, group)) {
#line 662 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp1_ = TRUE;
#line 3678 "config-impl-keyfile.c"
	} else {
		gboolean _tmp3_ = FALSE;
		GKeyFile* _tmp4_;
#line 662 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp4_ = self->priv->_data;
#line 662 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp3_ = g_key_file_has_key (_tmp4_, group, key, &_inner_error0_);
#line 662 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 662 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			g_propagate_error (error, _inner_error0_);
#line 662 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			return;
#line 3692 "config-impl-keyfile.c"
		}
#line 662 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp1_ = !_tmp3_;
#line 3696 "config-impl-keyfile.c"
	}
#line 662 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	if (_tmp1_) {
#line 662 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp0_ = TRUE;
#line 3702 "config-impl-keyfile.c"
	} else {
		gboolean _tmp5_ = FALSE;
#line 663 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp5_ = desktop_agnostic_config_backend_get_bool ((DesktopAgnosticConfigBackend*) self, group, key, &_inner_error0_);
#line 663 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 663 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			g_propagate_error (error, _inner_error0_);
#line 663 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			return;
#line 3713 "config-impl-keyfile.c"
		}
#line 663 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp0_ = _tmp5_ != value;
#line 3717 "config-impl-keyfile.c"
	}
#line 662 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	if (_tmp0_) {
#line 3721 "config-impl-keyfile.c"
		GKeyFile* _tmp6_;
#line 665 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp6_ = self->priv->_data;
#line 665 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		g_key_file_set_boolean (_tmp6_, group, key, value);
#line 666 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		desktop_agnostic_config_gkey_file_update_config (self, group, key, &_inner_error0_);
#line 666 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 666 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			g_propagate_error (error, _inner_error0_);
#line 666 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			return;
#line 3735 "config-impl-keyfile.c"
		}
	}
}

static gfloat
desktop_agnostic_config_gkey_file_real_get_float (DesktopAgnosticConfigBackend* base,
                                                  const gchar* group,
                                                  const gchar* key,
                                                  GError** error)
{
	DesktopAgnosticConfigGKeyFile * self;
	gfloat _tmp11_ = -1.0F;
	GError* _inner_error0_ = NULL;
	gfloat result;
#line 670 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	self = (DesktopAgnosticConfigGKeyFile*) base;
#line 670 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	g_return_val_if_fail (group != NULL, 0.0F);
#line 670 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	g_return_val_if_fail (key != NULL, 0.0F);
#line 3756 "config-impl-keyfile.c"
	{
		gdouble _tmp0_ = 0.0;
		GKeyFile* _tmp1_;
#line 675 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp1_ = self->priv->_data;
#line 675 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp0_ = g_key_file_get_double (_tmp1_, group, key, &_inner_error0_);
#line 675 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3766 "config-impl-keyfile.c"
			gfloat _tmp2_ = -1.0F;
#line 675 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 3770 "config-impl-keyfile.c"
				goto __catch0_g_key_file_error;
			}
#line 675 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 675 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			g_clear_error (&_inner_error0_);
#line 675 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			return _tmp2_;
#line 3779 "config-impl-keyfile.c"
		}
#line 675 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		result = (gfloat) _tmp0_;
#line 675 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		return result;
#line 3785 "config-impl-keyfile.c"
	}
	goto __finally0;
	__catch0_g_key_file_error:
	{
		GError* err = NULL;
		gboolean _tmp3_ = FALSE;
		GError* _tmp4_;
#line 673 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		err = _inner_error0_;
#line 673 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_inner_error0_ = NULL;
#line 679 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp4_ = err;
#line 679 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		if (g_error_matches (_tmp4_, G_KEY_FILE_ERROR, G_KEY_FILE_ERROR_GROUP_NOT_FOUND)) {
#line 679 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp3_ = TRUE;
#line 3803 "config-impl-keyfile.c"
		} else {
			GError* _tmp5_;
#line 680 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp5_ = err;
#line 680 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp3_ = g_error_matches (_tmp5_, G_KEY_FILE_ERROR, G_KEY_FILE_ERROR_KEY_NOT_FOUND);
#line 3810 "config-impl-keyfile.c"
		}
#line 679 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		if (_tmp3_) {
#line 3814 "config-impl-keyfile.c"
			GError* _tmp6_;
			const gchar* _tmp7_;
			GError* _tmp8_;
#line 682 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp6_ = err;
#line 682 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp7_ = _tmp6_->message;
#line 682 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp8_ = g_error_new_literal (DESKTOP_AGNOSTIC_CONFIG_ERROR, DESKTOP_AGNOSTIC_CONFIG_ERROR_KEY_NOT_FOUND, _tmp7_);
#line 682 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_inner_error0_ = _tmp8_;
#line 682 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_g_error_free0 (err);
#line 3828 "config-impl-keyfile.c"
			goto __finally0;
		} else {
			GError* _tmp9_;
			GError* _tmp10_;
#line 686 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp9_ = err;
#line 686 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp10_ = _g_error_copy0 (_tmp9_);
#line 686 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_inner_error0_ = _tmp10_;
#line 686 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_g_error_free0 (err);
#line 3841 "config-impl-keyfile.c"
			goto __finally0;
		}
#line 673 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_g_error_free0 (err);
#line 3846 "config-impl-keyfile.c"
	}
	__finally0:
#line 673 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	g_propagate_error (error, _inner_error0_);
#line 673 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	return _tmp11_;
#line 3853 "config-impl-keyfile.c"
}

static void
desktop_agnostic_config_gkey_file_real_set_float (DesktopAgnosticConfigBackend* base,
                                                  const gchar* group,
                                                  const gchar* key,
                                                  gfloat value,
                                                  GError** error)
{
	DesktopAgnosticConfigGKeyFile * self;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GKeyFile* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 691 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	self = (DesktopAgnosticConfigGKeyFile*) base;
#line 691 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	g_return_if_fail (group != NULL);
#line 691 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	g_return_if_fail (key != NULL);
#line 694 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp2_ = self->priv->_data;
#line 694 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	if (!g_key_file_has_group (_tmp2_, group)) {
#line 694 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp1_ = TRUE;
#line 3880 "config-impl-keyfile.c"
	} else {
		gboolean _tmp3_ = FALSE;
		GKeyFile* _tmp4_;
#line 694 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp4_ = self->priv->_data;
#line 694 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp3_ = g_key_file_has_key (_tmp4_, group, key, &_inner_error0_);
#line 694 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 694 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			g_propagate_error (error, _inner_error0_);
#line 694 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			return;
#line 3894 "config-impl-keyfile.c"
		}
#line 694 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp1_ = !_tmp3_;
#line 3898 "config-impl-keyfile.c"
	}
#line 694 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	if (_tmp1_) {
#line 694 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp0_ = TRUE;
#line 3904 "config-impl-keyfile.c"
	} else {
		gfloat _tmp5_ = 0.0F;
#line 695 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp5_ = desktop_agnostic_config_backend_get_float ((DesktopAgnosticConfigBackend*) self, group, key, &_inner_error0_);
#line 695 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 695 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			g_propagate_error (error, _inner_error0_);
#line 695 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			return;
#line 3915 "config-impl-keyfile.c"
		}
#line 695 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp0_ = _tmp5_ != value;
#line 3919 "config-impl-keyfile.c"
	}
#line 694 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	if (_tmp0_) {
#line 3923 "config-impl-keyfile.c"
		GKeyFile* _tmp6_;
#line 697 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp6_ = self->priv->_data;
#line 697 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		g_key_file_set_double (_tmp6_, group, key, (gdouble) value);
#line 698 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		desktop_agnostic_config_gkey_file_update_config (self, group, key, &_inner_error0_);
#line 698 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 698 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			g_propagate_error (error, _inner_error0_);
#line 698 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			return;
#line 3937 "config-impl-keyfile.c"
		}
	}
}

static gint
desktop_agnostic_config_gkey_file_real_get_int (DesktopAgnosticConfigBackend* base,
                                                const gchar* group,
                                                const gchar* key,
                                                GError** error)
{
	DesktopAgnosticConfigGKeyFile * self;
	gint _tmp11_ = -1;
	GError* _inner_error0_ = NULL;
	gint result;
#line 702 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	self = (DesktopAgnosticConfigGKeyFile*) base;
#line 702 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	g_return_val_if_fail (group != NULL, 0);
#line 702 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	g_return_val_if_fail (key != NULL, 0);
#line 3958 "config-impl-keyfile.c"
	{
		gint _tmp0_ = 0;
		GKeyFile* _tmp1_;
#line 707 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp1_ = self->priv->_data;
#line 707 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp0_ = g_key_file_get_integer (_tmp1_, group, key, &_inner_error0_);
#line 707 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3968 "config-impl-keyfile.c"
			gint _tmp2_ = -1;
#line 707 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 3972 "config-impl-keyfile.c"
				goto __catch0_g_key_file_error;
			}
#line 707 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 707 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			g_clear_error (&_inner_error0_);
#line 707 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			return _tmp2_;
#line 3981 "config-impl-keyfile.c"
		}
#line 707 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		result = _tmp0_;
#line 707 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		return result;
#line 3987 "config-impl-keyfile.c"
	}
	goto __finally0;
	__catch0_g_key_file_error:
	{
		GError* err = NULL;
		gboolean _tmp3_ = FALSE;
		GError* _tmp4_;
#line 705 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		err = _inner_error0_;
#line 705 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_inner_error0_ = NULL;
#line 711 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp4_ = err;
#line 711 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		if (g_error_matches (_tmp4_, G_KEY_FILE_ERROR, G_KEY_FILE_ERROR_GROUP_NOT_FOUND)) {
#line 711 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp3_ = TRUE;
#line 4005 "config-impl-keyfile.c"
		} else {
			GError* _tmp5_;
#line 712 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp5_ = err;
#line 712 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp3_ = g_error_matches (_tmp5_, G_KEY_FILE_ERROR, G_KEY_FILE_ERROR_KEY_NOT_FOUND);
#line 4012 "config-impl-keyfile.c"
		}
#line 711 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		if (_tmp3_) {
#line 4016 "config-impl-keyfile.c"
			GError* _tmp6_;
			const gchar* _tmp7_;
			GError* _tmp8_;
#line 714 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp6_ = err;
#line 714 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp7_ = _tmp6_->message;
#line 714 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp8_ = g_error_new_literal (DESKTOP_AGNOSTIC_CONFIG_ERROR, DESKTOP_AGNOSTIC_CONFIG_ERROR_KEY_NOT_FOUND, _tmp7_);
#line 714 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_inner_error0_ = _tmp8_;
#line 714 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_g_error_free0 (err);
#line 4030 "config-impl-keyfile.c"
			goto __finally0;
		} else {
			GError* _tmp9_;
			GError* _tmp10_;
#line 718 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp9_ = err;
#line 718 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp10_ = _g_error_copy0 (_tmp9_);
#line 718 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_inner_error0_ = _tmp10_;
#line 718 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_g_error_free0 (err);
#line 4043 "config-impl-keyfile.c"
			goto __finally0;
		}
#line 705 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_g_error_free0 (err);
#line 4048 "config-impl-keyfile.c"
	}
	__finally0:
#line 705 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	g_propagate_error (error, _inner_error0_);
#line 705 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	return _tmp11_;
#line 4055 "config-impl-keyfile.c"
}

static void
desktop_agnostic_config_gkey_file_real_set_int (DesktopAgnosticConfigBackend* base,
                                                const gchar* group,
                                                const gchar* key,
                                                gint value,
                                                GError** error)
{
	DesktopAgnosticConfigGKeyFile * self;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GKeyFile* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 723 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	self = (DesktopAgnosticConfigGKeyFile*) base;
#line 723 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	g_return_if_fail (group != NULL);
#line 723 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	g_return_if_fail (key != NULL);
#line 726 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp2_ = self->priv->_data;
#line 726 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	if (!g_key_file_has_group (_tmp2_, group)) {
#line 726 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp1_ = TRUE;
#line 4082 "config-impl-keyfile.c"
	} else {
		gboolean _tmp3_ = FALSE;
		GKeyFile* _tmp4_;
#line 726 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp4_ = self->priv->_data;
#line 726 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp3_ = g_key_file_has_key (_tmp4_, group, key, &_inner_error0_);
#line 726 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 726 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			g_propagate_error (error, _inner_error0_);
#line 726 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			return;
#line 4096 "config-impl-keyfile.c"
		}
#line 726 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp1_ = !_tmp3_;
#line 4100 "config-impl-keyfile.c"
	}
#line 726 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	if (_tmp1_) {
#line 726 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp0_ = TRUE;
#line 4106 "config-impl-keyfile.c"
	} else {
		gint _tmp5_ = 0;
#line 727 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp5_ = desktop_agnostic_config_backend_get_int ((DesktopAgnosticConfigBackend*) self, group, key, &_inner_error0_);
#line 727 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 727 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			g_propagate_error (error, _inner_error0_);
#line 727 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			return;
#line 4117 "config-impl-keyfile.c"
		}
#line 727 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp0_ = _tmp5_ != value;
#line 4121 "config-impl-keyfile.c"
	}
#line 726 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	if (_tmp0_) {
#line 4125 "config-impl-keyfile.c"
		GKeyFile* _tmp6_;
#line 729 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp6_ = self->priv->_data;
#line 729 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		g_key_file_set_integer (_tmp6_, group, key, value);
#line 730 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		desktop_agnostic_config_gkey_file_update_config (self, group, key, &_inner_error0_);
#line 730 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 730 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			g_propagate_error (error, _inner_error0_);
#line 730 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			return;
#line 4139 "config-impl-keyfile.c"
		}
	}
}

static gchar*
desktop_agnostic_config_gkey_file_real_get_string (DesktopAgnosticConfigBackend* base,
                                                   const gchar* group,
                                                   const gchar* key,
                                                   GError** error)
{
	DesktopAgnosticConfigGKeyFile * self;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 734 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	self = (DesktopAgnosticConfigGKeyFile*) base;
#line 734 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	g_return_val_if_fail (group != NULL, NULL);
#line 734 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	g_return_val_if_fail (key != NULL, NULL);
#line 4159 "config-impl-keyfile.c"
	{
		gchar* _tmp0_ = NULL;
		GKeyFile* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
#line 739 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp1_ = self->priv->_data;
#line 739 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp2_ = g_key_file_get_string (_tmp1_, group, key, &_inner_error0_);
#line 739 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp0_ = _tmp2_;
#line 739 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 739 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 4175 "config-impl-keyfile.c"
				goto __catch0_g_key_file_error;
			}
#line 739 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 739 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			g_clear_error (&_inner_error0_);
#line 739 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			return NULL;
#line 4184 "config-impl-keyfile.c"
		}
#line 739 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp3_ = _tmp0_;
#line 739 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp0_ = NULL;
#line 739 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		result = _tmp3_;
#line 739 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_g_free0 (_tmp0_);
#line 739 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		return result;
#line 4196 "config-impl-keyfile.c"
	}
	goto __finally0;
	__catch0_g_key_file_error:
	{
		GError* err = NULL;
		gboolean _tmp4_ = FALSE;
		GError* _tmp5_;
#line 737 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		err = _inner_error0_;
#line 737 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_inner_error0_ = NULL;
#line 743 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp5_ = err;
#line 743 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		if (g_error_matches (_tmp5_, G_KEY_FILE_ERROR, G_KEY_FILE_ERROR_GROUP_NOT_FOUND)) {
#line 743 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp4_ = TRUE;
#line 4214 "config-impl-keyfile.c"
		} else {
			GError* _tmp6_;
#line 744 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp6_ = err;
#line 744 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp4_ = g_error_matches (_tmp6_, G_KEY_FILE_ERROR, G_KEY_FILE_ERROR_KEY_NOT_FOUND);
#line 4221 "config-impl-keyfile.c"
		}
#line 743 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		if (_tmp4_) {
#line 4225 "config-impl-keyfile.c"
			GError* _tmp7_;
			const gchar* _tmp8_;
			GError* _tmp9_;
#line 746 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp7_ = err;
#line 746 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp8_ = _tmp7_->message;
#line 746 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp9_ = g_error_new_literal (DESKTOP_AGNOSTIC_CONFIG_ERROR, DESKTOP_AGNOSTIC_CONFIG_ERROR_KEY_NOT_FOUND, _tmp8_);
#line 746 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_inner_error0_ = _tmp9_;
#line 746 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_g_error_free0 (err);
#line 4239 "config-impl-keyfile.c"
			goto __finally0;
		} else {
			GError* _tmp10_;
			GError* _tmp11_;
#line 750 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp10_ = err;
#line 750 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp11_ = _g_error_copy0 (_tmp10_);
#line 750 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_inner_error0_ = _tmp11_;
#line 750 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_g_error_free0 (err);
#line 4252 "config-impl-keyfile.c"
			goto __finally0;
		}
#line 737 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_g_error_free0 (err);
#line 4257 "config-impl-keyfile.c"
	}
	__finally0:
#line 737 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	g_propagate_error (error, _inner_error0_);
#line 737 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	return NULL;
#line 4264 "config-impl-keyfile.c"
}

static void
desktop_agnostic_config_gkey_file_real_set_string (DesktopAgnosticConfigBackend* base,
                                                   const gchar* group,
                                                   const gchar* key,
                                                   const gchar* value,
                                                   GError** error)
{
	DesktopAgnosticConfigGKeyFile * self;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GKeyFile* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 755 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	self = (DesktopAgnosticConfigGKeyFile*) base;
#line 755 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	g_return_if_fail (group != NULL);
#line 755 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	g_return_if_fail (key != NULL);
#line 755 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	g_return_if_fail (value != NULL);
#line 758 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp2_ = self->priv->_data;
#line 758 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	if (!g_key_file_has_group (_tmp2_, group)) {
#line 758 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp1_ = TRUE;
#line 4293 "config-impl-keyfile.c"
	} else {
		gboolean _tmp3_ = FALSE;
		GKeyFile* _tmp4_;
#line 758 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp4_ = self->priv->_data;
#line 758 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp3_ = g_key_file_has_key (_tmp4_, group, key, &_inner_error0_);
#line 758 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 758 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			g_propagate_error (error, _inner_error0_);
#line 758 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			return;
#line 4307 "config-impl-keyfile.c"
		}
#line 758 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp1_ = !_tmp3_;
#line 4311 "config-impl-keyfile.c"
	}
#line 758 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	if (_tmp1_) {
#line 758 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp0_ = TRUE;
#line 4317 "config-impl-keyfile.c"
	} else {
		gchar* _tmp5_ = NULL;
		gchar* _tmp6_;
#line 759 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp6_ = desktop_agnostic_config_backend_get_string ((DesktopAgnosticConfigBackend*) self, group, key, &_inner_error0_);
#line 759 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp5_ = _tmp6_;
#line 759 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 759 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			g_propagate_error (error, _inner_error0_);
#line 759 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			return;
#line 4331 "config-impl-keyfile.c"
		}
#line 759 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp0_ = g_strcmp0 (_tmp5_, value) != 0;
#line 758 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_g_free0 (_tmp5_);
#line 4337 "config-impl-keyfile.c"
	}
#line 758 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	if (_tmp0_) {
#line 4341 "config-impl-keyfile.c"
		GKeyFile* _tmp7_;
#line 761 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp7_ = self->priv->_data;
#line 761 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		g_key_file_set_string (_tmp7_, group, key, value);
#line 762 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		desktop_agnostic_config_gkey_file_update_config (self, group, key, &_inner_error0_);
#line 762 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 762 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			g_propagate_error (error, _inner_error0_);
#line 762 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			return;
#line 4355 "config-impl-keyfile.c"
		}
	}
}

static GValueArray*
desktop_agnostic_config_gkey_file_real_get_list (DesktopAgnosticConfigBackend* base,
                                                 const gchar* group,
                                                 const gchar* key,
                                                 GError** error)
{
	DesktopAgnosticConfigGKeyFile * self;
	GError* _inner_error0_ = NULL;
	GValueArray* result;
#line 766 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	self = (DesktopAgnosticConfigGKeyFile*) base;
#line 766 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	g_return_val_if_fail (group != NULL, NULL);
#line 766 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	g_return_val_if_fail (key != NULL, NULL);
#line 4375 "config-impl-keyfile.c"
	{
		GValueArray* _tmp0_ = NULL;
		GKeyFile* _tmp1_;
		GValueArray* _tmp2_;
		GValueArray* _tmp3_;
#line 771 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp1_ = self->priv->_data;
#line 771 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp2_ = desktop_agnostic_config_gkey_file_generate_valuearray_from_keyfile (self, _tmp1_, group, key, &_inner_error0_);
#line 771 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp0_ = _tmp2_;
#line 771 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 771 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 4391 "config-impl-keyfile.c"
				goto __catch0_g_key_file_error;
			}
			goto __finally0;
		}
#line 771 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp3_ = _tmp0_;
#line 771 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp0_ = NULL;
#line 771 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		result = _tmp3_;
#line 771 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_g_value_array_free0 (_tmp0_);
#line 771 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		return result;
#line 4406 "config-impl-keyfile.c"
	}
	goto __finally0;
	__catch0_g_key_file_error:
	{
		GError* err = NULL;
		gboolean _tmp4_ = FALSE;
		GError* _tmp5_;
#line 769 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		err = _inner_error0_;
#line 769 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_inner_error0_ = NULL;
#line 775 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp5_ = err;
#line 775 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		if (g_error_matches (_tmp5_, G_KEY_FILE_ERROR, G_KEY_FILE_ERROR_GROUP_NOT_FOUND)) {
#line 775 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp4_ = TRUE;
#line 4424 "config-impl-keyfile.c"
		} else {
			GError* _tmp6_;
#line 776 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp6_ = err;
#line 776 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp4_ = g_error_matches (_tmp6_, G_KEY_FILE_ERROR, G_KEY_FILE_ERROR_KEY_NOT_FOUND);
#line 4431 "config-impl-keyfile.c"
		}
#line 775 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		if (_tmp4_) {
#line 4435 "config-impl-keyfile.c"
			GError* _tmp7_;
			const gchar* _tmp8_;
			GError* _tmp9_;
#line 778 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp7_ = err;
#line 778 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp8_ = _tmp7_->message;
#line 778 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp9_ = g_error_new_literal (DESKTOP_AGNOSTIC_CONFIG_ERROR, DESKTOP_AGNOSTIC_CONFIG_ERROR_KEY_NOT_FOUND, _tmp8_);
#line 778 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_inner_error0_ = _tmp9_;
#line 778 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_g_error_free0 (err);
#line 4449 "config-impl-keyfile.c"
			goto __finally0;
		} else {
			GError* _tmp10_;
			GError* _tmp11_;
#line 782 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp10_ = err;
#line 782 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp11_ = _g_error_copy0 (_tmp10_);
#line 782 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_inner_error0_ = _tmp11_;
#line 782 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_g_error_free0 (err);
#line 4462 "config-impl-keyfile.c"
			goto __finally0;
		}
#line 769 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_g_error_free0 (err);
#line 4467 "config-impl-keyfile.c"
	}
	__finally0:
#line 769 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	g_propagate_error (error, _inner_error0_);
#line 769 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	return NULL;
#line 4474 "config-impl-keyfile.c"
}

static void
_vala_array_add1 (gboolean* * array,
                  gint* length,
                  gint* size,
                  gboolean value)
{
#line 848 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	if ((*length) == (*size)) {
#line 848 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 848 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		*array = g_renew (gboolean, *array, *size);
#line 4489 "config-impl-keyfile.c"
	}
#line 848 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	(*array)[(*length)++] = value;
#line 4493 "config-impl-keyfile.c"
}

static void
_vala_array_add2 (gint* * array,
                  gint* length,
                  gint* size,
                  gint value)
{
#line 858 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	if ((*length) == (*size)) {
#line 858 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 858 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		*array = g_renew (gint, *array, *size);
#line 4508 "config-impl-keyfile.c"
	}
#line 858 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	(*array)[(*length)++] = value;
#line 4512 "config-impl-keyfile.c"
}

static void
_vala_array_add3 (gdouble* * array,
                  gint* length,
                  gint* size,
                  gdouble value)
{
#line 868 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	if ((*length) == (*size)) {
#line 868 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 868 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		*array = g_renew (gdouble, *array, *size);
#line 4527 "config-impl-keyfile.c"
	}
#line 868 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	(*array)[(*length)++] = value;
#line 4531 "config-impl-keyfile.c"
}

static void
_vala_array_add4 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 878 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	if ((*length) == (*size)) {
#line 878 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 878 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 4546 "config-impl-keyfile.c"
	}
#line 878 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	(*array)[(*length)++] = value;
#line 878 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	(*array)[*length] = NULL;
#line 4552 "config-impl-keyfile.c"
}

static void
_vala_array_add5 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 895 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	if ((*length) == (*size)) {
#line 895 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 895 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 4567 "config-impl-keyfile.c"
	}
#line 895 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	(*array)[(*length)++] = value;
#line 895 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	(*array)[*length] = NULL;
#line 4573 "config-impl-keyfile.c"
}

static void
desktop_agnostic_config_gkey_file_real_set_list (DesktopAgnosticConfigBackend* base,
                                                 const gchar* group,
                                                 const gchar* key,
                                                 GValueArray* value,
                                                 GError** error)
{
	DesktopAgnosticConfigGKeyFile * self;
	DesktopAgnosticConfigSchemaOption* option = NULL;
	DesktopAgnosticConfigSchema* _tmp0_;
	DesktopAgnosticConfigSchema* _tmp1_;
	DesktopAgnosticConfigSchemaOption* _tmp2_;
	DesktopAgnosticConfigSchemaOption* _tmp3_;
	GType list_type = 0UL;
	DesktopAgnosticConfigSchemaOption* _tmp4_;
	GType _tmp5_;
	GType _tmp6_;
	gboolean _tmp7_ = FALSE;
	GKeyFile* _tmp8_;
	gboolean _tmp23_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 787 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	self = (DesktopAgnosticConfigGKeyFile*) base;
#line 787 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	g_return_if_fail (group != NULL);
#line 787 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	g_return_if_fail (key != NULL);
#line 787 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	g_return_if_fail (value != NULL);
#line 790 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp0_ = desktop_agnostic_config_backend_get_schema ((DesktopAgnosticConfigBackend*) self);
#line 790 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp1_ = _tmp0_;
#line 790 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp2_ = desktop_agnostic_config_schema_get_option (_tmp1_, group, key);
#line 790 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 790 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	option = _tmp3_;
#line 791 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp4_ = option;
#line 791 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp5_ = desktop_agnostic_config_schema_option_get_list_type (_tmp4_);
#line 791 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp6_ = _tmp5_;
#line 791 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	list_type = _tmp6_;
#line 793 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp8_ = self->priv->_data;
#line 793 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	if (g_key_file_has_group (_tmp8_, group)) {
#line 4627 "config-impl-keyfile.c"
		gboolean _tmp9_ = FALSE;
		GKeyFile* _tmp10_;
#line 793 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp10_ = self->priv->_data;
#line 793 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp9_ = g_key_file_has_key (_tmp10_, group, key, &_inner_error0_);
#line 793 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 793 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			g_propagate_error (error, _inner_error0_);
#line 793 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_g_object_unref0 (option);
#line 793 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			return;
#line 4642 "config-impl-keyfile.c"
		}
#line 793 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp7_ = _tmp9_;
#line 4646 "config-impl-keyfile.c"
	} else {
#line 793 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp7_ = FALSE;
#line 4650 "config-impl-keyfile.c"
	}
#line 793 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	if (_tmp7_) {
#line 4654 "config-impl-keyfile.c"
		GValueArray* old_value = NULL;
		GValueArray* _tmp11_ = NULL;
		GValueArray* _tmp12_;
		GValueArray* _tmp13_;
		GValueArray* _tmp14_;
#line 797 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp12_ = desktop_agnostic_config_backend_get_list ((DesktopAgnosticConfigBackend*) self, group, key, &_inner_error0_);
#line 797 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp11_ = _tmp12_;
#line 797 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 797 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			g_propagate_error (error, _inner_error0_);
#line 797 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_g_value_array_free0 (old_value);
#line 797 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_g_object_unref0 (option);
#line 797 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			return;
#line 4674 "config-impl-keyfile.c"
		}
#line 797 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp13_ = _tmp11_;
#line 797 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp11_ = NULL;
#line 797 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_g_value_array_free0 (old_value);
#line 797 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		old_value = _tmp13_;
#line 798 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp14_ = old_value;
#line 798 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		if (_tmp14_->n_values == value->n_values) {
#line 4688 "config-impl-keyfile.c"
			gboolean is_equal = FALSE;
#line 800 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			is_equal = TRUE;
#line 4692 "config-impl-keyfile.c"
			{
				guint i = 0U;
#line 801 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				i = (guint) 0;
#line 4697 "config-impl-keyfile.c"
				{
					gboolean _tmp15_ = FALSE;
#line 801 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					_tmp15_ = TRUE;
#line 801 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					while (TRUE) {
#line 4704 "config-impl-keyfile.c"
						GValue old_val = {0};
						GValue new_val = {0};
						GValueArray* _tmp17_;
						gboolean _tmp18_ = FALSE;
#line 801 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						if (!_tmp15_) {
#line 4711 "config-impl-keyfile.c"
							guint _tmp16_;
#line 801 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_tmp16_ = i;
#line 801 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							i = _tmp16_ + 1;
#line 4717 "config-impl-keyfile.c"
						}
#line 801 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						_tmp15_ = FALSE;
#line 801 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						if (!(i < value->n_values)) {
#line 801 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							break;
#line 4725 "config-impl-keyfile.c"
						}
#line 807 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						_tmp17_ = old_value;
#line 807 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						old_val = *g_value_array_get_nth (_tmp17_, i);
#line 808 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						new_val = *g_value_array_get_nth (value, i);
#line 810 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						if (G_VALUE_TYPE (&old_val) != G_VALUE_TYPE (&new_val)) {
#line 810 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_tmp18_ = TRUE;
#line 4737 "config-impl-keyfile.c"
						} else {
							gchar* _tmp19_;
							gchar* _tmp20_;
							gchar* _tmp21_;
							gchar* _tmp22_;
#line 811 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_tmp19_ = g_strdup_value_contents (&old_val);
#line 811 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_tmp20_ = _tmp19_;
#line 811 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_tmp21_ = g_strdup_value_contents (&new_val);
#line 811 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_tmp22_ = _tmp21_;
#line 811 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_tmp18_ = g_strcmp0 (_tmp20_, _tmp22_) != 0;
#line 811 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_g_free0 (_tmp22_);
#line 811 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_g_free0 (_tmp20_);
#line 4757 "config-impl-keyfile.c"
						}
#line 810 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						if (_tmp18_) {
#line 813 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							is_equal = FALSE;
#line 814 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							break;
#line 4765 "config-impl-keyfile.c"
						}
					}
				}
			}
#line 817 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			if (is_equal) {
#line 819 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				_g_value_array_free0 (_tmp11_);
#line 819 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				_g_value_array_free0 (old_value);
#line 819 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				_g_object_unref0 (option);
#line 819 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				return;
#line 4780 "config-impl-keyfile.c"
			}
		}
#line 793 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_g_value_array_free0 (_tmp11_);
#line 793 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_g_value_array_free0 (old_value);
#line 4787 "config-impl-keyfile.c"
	}
#line 824 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	if (value->n_values == ((guint) 0)) {
#line 4791 "config-impl-keyfile.c"
		gboolean _tmp24_ = FALSE;
		gboolean _tmp25_ = FALSE;
#line 825 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		if (list_type == G_TYPE_BOOLEAN) {
#line 825 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp25_ = TRUE;
#line 4798 "config-impl-keyfile.c"
		} else {
#line 825 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp25_ = list_type == G_TYPE_INT;
#line 4802 "config-impl-keyfile.c"
		}
#line 825 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		if (_tmp25_) {
#line 825 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp24_ = TRUE;
#line 4808 "config-impl-keyfile.c"
		} else {
#line 825 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp24_ = list_type == G_TYPE_FLOAT;
#line 4812 "config-impl-keyfile.c"
		}
#line 825 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp23_ = _tmp24_;
#line 4816 "config-impl-keyfile.c"
	} else {
#line 824 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp23_ = FALSE;
#line 4820 "config-impl-keyfile.c"
	}
#line 824 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	if (_tmp23_) {
#line 4824 "config-impl-keyfile.c"
		GKeyFile* _tmp26_;
#line 827 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		g_warning ("config-impl-keyfile.vala:827: Discarding empty key: %s", key);
#line 828 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp26_ = self->priv->_data;
#line 828 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		if (!g_key_file_has_group (_tmp26_, group)) {
#line 4832 "config-impl-keyfile.c"
			GKeyFile* _tmp27_;
			GKeyFile* _tmp28_;
#line 832 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp27_ = self->priv->_data;
#line 832 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			g_key_file_set_boolean (_tmp27_, group, key, TRUE);
#line 833 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp28_ = self->priv->_data;
#line 833 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			g_key_file_remove_key (_tmp28_, group, key, &_inner_error0_);
#line 833 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 833 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				g_propagate_error (error, _inner_error0_);
#line 833 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				_g_object_unref0 (option);
#line 833 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				return;
#line 4851 "config-impl-keyfile.c"
			}
		} else {
#line 840 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_g_object_unref0 (option);
#line 840 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			return;
#line 4858 "config-impl-keyfile.c"
		}
	} else {
#line 843 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		if (list_type == G_TYPE_BOOLEAN) {
#line 4863 "config-impl-keyfile.c"
			gboolean* list = NULL;
			gboolean* _tmp29_;
			gint list_length1;
			gint _list_size_;
			GKeyFile* _tmp31_;
			gboolean* _tmp32_;
			gint _tmp32__length1;
#line 845 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp29_ = g_new0 (gboolean, 0);
#line 845 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			list = _tmp29_;
#line 845 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			list_length1 = 0;
#line 845 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_list_size_ = list_length1;
#line 4879 "config-impl-keyfile.c"
			{
				GValueArray* val_collection = NULL;
				guint val_index = 0U;
#line 846 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				val_collection = value;
#line 846 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				for (val_index = 0; val_index < val_collection->n_values; val_index = val_index + 1) {
#line 4887 "config-impl-keyfile.c"
					GValue val = {0};
#line 846 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					val = *g_value_array_get_nth (val_collection, val_index);
#line 4891 "config-impl-keyfile.c"
					{
						GValue _tmp30_;
#line 848 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						_tmp30_ = val;
#line 848 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						_vala_array_add1 (&list, &list_length1, &_list_size_, g_value_get_boolean (&_tmp30_));
#line 4898 "config-impl-keyfile.c"
					}
				}
			}
#line 851 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp31_ = self->priv->_data;
#line 851 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp32_ = list;
#line 851 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			_tmp32__length1 = list_length1;
#line 851 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			g_key_file_set_boolean_list (_tmp31_, group, key, _tmp32_, (gint) _tmp32__length1);
#line 843 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			list = (g_free (list), NULL);
#line 4912 "config-impl-keyfile.c"
		} else {
#line 853 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
			if (list_type == G_TYPE_INT) {
#line 4916 "config-impl-keyfile.c"
				gint* list = NULL;
				gint* _tmp33_;
				gint list_length1;
				gint _list_size_;
				GKeyFile* _tmp36_;
				gint* _tmp37_;
				gint _tmp37__length1;
#line 855 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				_tmp33_ = g_new0 (gint, 0);
#line 855 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				list = _tmp33_;
#line 855 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				list_length1 = 0;
#line 855 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				_list_size_ = list_length1;
#line 4932 "config-impl-keyfile.c"
				{
					GValueArray* val_collection = NULL;
					guint val_index = 0U;
#line 856 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					val_collection = value;
#line 856 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					for (val_index = 0; val_index < val_collection->n_values; val_index = val_index + 1) {
#line 4940 "config-impl-keyfile.c"
						GValue val = {0};
#line 856 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						val = *g_value_array_get_nth (val_collection, val_index);
#line 4944 "config-impl-keyfile.c"
						{
							gint _tmp34_ = 0;
							GValue _tmp35_;
#line 858 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_tmp35_ = val;
#line 858 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_tmp34_ = desktop_agnostic_config_backend_get_int_from_value (&_tmp35_, &_inner_error0_);
#line 858 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 858 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
								g_propagate_error (error, _inner_error0_);
#line 858 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
								list = (g_free (list), NULL);
#line 858 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
								_g_object_unref0 (option);
#line 858 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
								return;
#line 4962 "config-impl-keyfile.c"
							}
#line 858 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_vala_array_add2 (&list, &list_length1, &_list_size_, _tmp34_);
#line 4966 "config-impl-keyfile.c"
						}
					}
				}
#line 861 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				_tmp36_ = self->priv->_data;
#line 861 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				_tmp37_ = list;
#line 861 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				_tmp37__length1 = list_length1;
#line 861 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				g_key_file_set_integer_list (_tmp36_, group, key, _tmp37_, (gint) _tmp37__length1);
#line 853 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				list = (g_free (list), NULL);
#line 4980 "config-impl-keyfile.c"
			} else {
#line 863 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
				if (list_type == G_TYPE_FLOAT) {
#line 4984 "config-impl-keyfile.c"
					gdouble* list = NULL;
					gdouble* _tmp38_;
					gint list_length1;
					gint _list_size_;
					GKeyFile* _tmp41_;
					gdouble* _tmp42_;
					gint _tmp42__length1;
#line 865 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					_tmp38_ = g_new0 (gdouble, 0);
#line 865 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					list = _tmp38_;
#line 865 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					list_length1 = 0;
#line 865 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					_list_size_ = list_length1;
#line 5000 "config-impl-keyfile.c"
					{
						GValueArray* val_collection = NULL;
						guint val_index = 0U;
#line 866 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						val_collection = value;
#line 866 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						for (val_index = 0; val_index < val_collection->n_values; val_index = val_index + 1) {
#line 5008 "config-impl-keyfile.c"
							GValue val = {0};
#line 866 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							val = *g_value_array_get_nth (val_collection, val_index);
#line 5012 "config-impl-keyfile.c"
							{
								gfloat _tmp39_ = 0.0F;
								GValue _tmp40_;
#line 868 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
								_tmp40_ = val;
#line 868 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
								_tmp39_ = desktop_agnostic_config_backend_get_float_from_value (&_tmp40_, &_inner_error0_);
#line 868 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
								if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 868 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
									g_propagate_error (error, _inner_error0_);
#line 868 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
									list = (g_free (list), NULL);
#line 868 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
									_g_object_unref0 (option);
#line 868 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
									return;
#line 5030 "config-impl-keyfile.c"
								}
#line 868 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
								_vala_array_add3 (&list, &list_length1, &_list_size_, (gdouble) _tmp39_);
#line 5034 "config-impl-keyfile.c"
							}
						}
					}
#line 871 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					_tmp41_ = self->priv->_data;
#line 871 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					_tmp42_ = list;
#line 871 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					_tmp42__length1 = list_length1;
#line 871 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					g_key_file_set_double_list (_tmp41_, group, key, _tmp42_, (gint) _tmp42__length1);
#line 863 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					list = (g_free (list), NULL);
#line 5048 "config-impl-keyfile.c"
				} else {
#line 873 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
					if (list_type == G_TYPE_STRING) {
#line 5052 "config-impl-keyfile.c"
						gchar** list = NULL;
						gchar** _tmp43_;
						gint list_length1;
						gint _list_size_;
						GKeyFile* _tmp46_;
						gchar** _tmp47_;
						gint _tmp47__length1;
#line 875 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						_tmp43_ = g_new0 (gchar*, 0 + 1);
#line 875 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						list = _tmp43_;
#line 875 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						list_length1 = 0;
#line 875 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						_list_size_ = list_length1;
#line 5068 "config-impl-keyfile.c"
						{
							GValueArray* val_collection = NULL;
							guint val_index = 0U;
#line 876 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							val_collection = value;
#line 876 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							for (val_index = 0; val_index < val_collection->n_values; val_index = val_index + 1) {
#line 5076 "config-impl-keyfile.c"
								GValue val = {0};
#line 876 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
								val = *g_value_array_get_nth (val_collection, val_index);
#line 5080 "config-impl-keyfile.c"
								{
									GValue _tmp44_;
									gchar* _tmp45_;
#line 878 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
									_tmp44_ = val;
#line 878 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
									_tmp45_ = g_strdup (g_value_get_string (&_tmp44_));
#line 878 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
									_vala_array_add4 (&list, &list_length1, &_list_size_, _tmp45_);
#line 5090 "config-impl-keyfile.c"
								}
							}
						}
#line 881 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						_tmp46_ = self->priv->_data;
#line 881 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						_tmp47_ = list;
#line 881 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						_tmp47__length1 = list_length1;
#line 881 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						g_key_file_set_string_list (_tmp46_, group, key, (const gchar* const*) _tmp47_, (gint) _tmp47__length1);
#line 873 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						list = (_vala_array_free (list, list_length1, (GDestroyNotify) g_free), NULL);
#line 5104 "config-impl-keyfile.c"
					} else {
						DesktopAgnosticConfigSchemaType* st = NULL;
						DesktopAgnosticConfigSchemaType* _tmp48_;
						DesktopAgnosticConfigSchemaType* _tmp49_;
						DesktopAgnosticConfigSchemaType* _tmp50_;
						gchar** list = NULL;
						gchar** _tmp53_;
						gint list_length1;
						gint _list_size_;
						GKeyFile* _tmp59_;
						gchar** _tmp60_;
						gint _tmp60__length1;
#line 885 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						_tmp48_ = desktop_agnostic_config_schema_find_type (list_type);
#line 885 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						_tmp49_ = _g_object_ref0 (_tmp48_);
#line 885 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						st = _tmp49_;
#line 886 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						_tmp50_ = st;
#line 886 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						if (_tmp50_ == NULL) {
#line 5127 "config-impl-keyfile.c"
							const gchar* _tmp51_;
							GError* _tmp52_;
#line 888 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_tmp51_ = g_type_name (list_type);
#line 888 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_tmp52_ = g_error_new (DESKTOP_AGNOSTIC_CONFIG_ERROR, DESKTOP_AGNOSTIC_CONFIG_ERROR_INVALID_TYPE, "'%s' is an invalid config type.", _tmp51_);
#line 888 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_inner_error0_ = _tmp52_;
#line 888 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							g_propagate_error (error, _inner_error0_);
#line 888 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_g_object_unref0 (st);
#line 888 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							_g_object_unref0 (option);
#line 888 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							return;
#line 5144 "config-impl-keyfile.c"
						}
#line 892 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						_tmp53_ = g_new0 (gchar*, 0 + 1);
#line 892 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						list = _tmp53_;
#line 892 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						list_length1 = 0;
#line 892 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						_list_size_ = list_length1;
#line 5154 "config-impl-keyfile.c"
						{
							GValueArray* val_collection = NULL;
							guint val_index = 0U;
#line 893 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							val_collection = value;
#line 893 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
							for (val_index = 0; val_index < val_collection->n_values; val_index = val_index + 1) {
#line 5162 "config-impl-keyfile.c"
								GValue val = {0};
#line 893 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
								val = *g_value_array_get_nth (val_collection, val_index);
#line 5166 "config-impl-keyfile.c"
								{
									gchar* _tmp54_ = NULL;
									DesktopAgnosticConfigSchemaType* _tmp55_;
									GValue _tmp56_;
									gchar* _tmp57_;
									gchar* _tmp58_;
#line 895 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
									_tmp55_ = st;
#line 895 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
									_tmp56_ = val;
#line 895 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
									_tmp57_ = desktop_agnostic_config_schema_type_serialize (_tmp55_, &_tmp56_, &_inner_error0_);
#line 895 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
									_tmp54_ = _tmp57_;
#line 895 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
									if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 895 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
										g_propagate_error (error, _inner_error0_);
#line 895 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
										list = (_vala_array_free (list, list_length1, (GDestroyNotify) g_free), NULL);
#line 895 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
										_g_object_unref0 (st);
#line 895 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
										_g_object_unref0 (option);
#line 895 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
										return;
#line 5193 "config-impl-keyfile.c"
									}
#line 895 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
									_tmp58_ = _tmp54_;
#line 895 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
									_tmp54_ = NULL;
#line 895 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
									_vala_array_add5 (&list, &list_length1, &_list_size_, _tmp58_);
#line 893 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
									_g_free0 (_tmp54_);
#line 5203 "config-impl-keyfile.c"
								}
							}
						}
#line 898 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						_tmp59_ = self->priv->_data;
#line 898 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						_tmp60_ = list;
#line 898 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						_tmp60__length1 = list_length1;
#line 898 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						g_key_file_set_string_list (_tmp59_, group, key, (const gchar* const*) _tmp60_, (gint) _tmp60__length1);
#line 873 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						list = (_vala_array_free (list, list_length1, (GDestroyNotify) g_free), NULL);
#line 873 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
						_g_object_unref0 (st);
#line 5219 "config-impl-keyfile.c"
					}
				}
			}
		}
	}
#line 900 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	desktop_agnostic_config_gkey_file_update_config (self, group, key, &_inner_error0_);
#line 900 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 900 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		g_propagate_error (error, _inner_error0_);
#line 900 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_g_object_unref0 (option);
#line 900 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		return;
#line 5235 "config-impl-keyfile.c"
	}
#line 787 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_g_object_unref0 (option);
#line 5239 "config-impl-keyfile.c"
}

DesktopAgnosticConfigGKeyFile*
desktop_agnostic_config_gkey_file_construct (GType object_type)
{
	DesktopAgnosticConfigGKeyFile * self = NULL;
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	self = (DesktopAgnosticConfigGKeyFile*) desktop_agnostic_config_backend_construct (object_type);
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	return self;
#line 5250 "config-impl-keyfile.c"
}

DesktopAgnosticConfigGKeyFile*
desktop_agnostic_config_gkey_file_new (void)
{
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	return desktop_agnostic_config_gkey_file_construct (DESKTOP_AGNOSTIC_CONFIG_TYPE_GKEY_FILE);
#line 5258 "config-impl-keyfile.c"
}

static gchar*
desktop_agnostic_config_gkey_file_real_get_name (DesktopAgnosticConfigBackend* base)
{
	gchar* result;
	DesktopAgnosticConfigGKeyFile* self;
	gchar* _tmp0_;
#line 38 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	self = (DesktopAgnosticConfigGKeyFile*) base;
#line 40 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp0_ = g_strdup ("GKeyFile");
#line 40 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	result = _tmp0_;
#line 40 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	return result;
#line 5275 "config-impl-keyfile.c"
}

static GObject *
desktop_agnostic_config_gkey_file_constructor (GType type,
                                               guint n_construct_properties,
                                               GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	DesktopAgnosticConfigGKeyFile * self;
	DesktopAgnosticConfigSchema* _tmp0_;
	DesktopAgnosticConfigSchema* _tmp1_;
#line 44 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	parent_class = G_OBJECT_CLASS (desktop_agnostic_config_gkey_file_parent_class);
#line 44 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 44 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DESKTOP_AGNOSTIC_CONFIG_TYPE_GKEY_FILE, DesktopAgnosticConfigGKeyFile);
#line 46 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	self->priv->_autosave = TRUE;
#line 47 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	self->priv->_monitor_changed_id = (gulong) 0;
#line 48 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp0_ = desktop_agnostic_config_backend_get_schema ((DesktopAgnosticConfigBackend*) self);
#line 48 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp1_ = _tmp0_;
#line 48 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	if (_tmp1_ != NULL) {
#line 5304 "config-impl-keyfile.c"
		GKeyFile* _tmp2_;
#line 50 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_tmp2_ = g_key_file_new ();
#line 50 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		_g_key_file_unref0 (self->priv->_data);
#line 50 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		self->priv->_data = _tmp2_;
#line 51 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		g_datalist_init (&self->priv->_notifiers);
#line 5314 "config-impl-keyfile.c"
	}
#line 44 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	return obj;
#line 5318 "config-impl-keyfile.c"
}

static void
desktop_agnostic_config_gkey_file_class_init (DesktopAgnosticConfigGKeyFileClass * klass,
                                              gpointer klass_data)
{
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	desktop_agnostic_config_gkey_file_parent_class = g_type_class_peek_parent (klass);
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	g_type_class_adjust_private_offset (klass, &DesktopAgnosticConfigGKeyFile_private_offset);
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	((GObjectClass *) klass)->constructed = (void (*) (GObject*)) desktop_agnostic_config_gkey_file_real_constructed;
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	((DesktopAgnosticConfigBackendClass *) klass)->reset = (void (*) (DesktopAgnosticConfigBackend*, GError**)) desktop_agnostic_config_gkey_file_real_reset;
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	((DesktopAgnosticConfigBackendClass *) klass)->notify_add = (void (*) (DesktopAgnosticConfigBackend*, const gchar*, const gchar*, DesktopAgnosticConfigNotifyFunc, gpointer, GError**)) desktop_agnostic_config_gkey_file_real_notify_add;
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	((DesktopAgnosticConfigBackendClass *) klass)->notify = (void (*) (DesktopAgnosticConfigBackend*, const gchar*, const gchar*, GError**)) desktop_agnostic_config_gkey_file_real_notify;
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	((DesktopAgnosticConfigBackendClass *) klass)->notify_remove = (void (*) (DesktopAgnosticConfigBackend*, const gchar*, const gchar*, DesktopAgnosticConfigNotifyFunc, gpointer, GError**)) desktop_agnostic_config_gkey_file_real_notify_remove;
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	((DesktopAgnosticConfigBackendClass *) klass)->remove = (void (*) (DesktopAgnosticConfigBackend*, GError**)) desktop_agnostic_config_gkey_file_real_remove;
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	((DesktopAgnosticConfigBackendClass *) klass)->get_value = (void (*) (DesktopAgnosticConfigBackend*, const gchar*, const gchar*, GValue*, GError**)) desktop_agnostic_config_gkey_file_real_get_value;
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	((DesktopAgnosticConfigBackendClass *) klass)->get_bool = (gboolean (*) (DesktopAgnosticConfigBackend*, const gchar*, const gchar*, GError**)) desktop_agnostic_config_gkey_file_real_get_bool;
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	((DesktopAgnosticConfigBackendClass *) klass)->set_bool = (void (*) (DesktopAgnosticConfigBackend*, const gchar*, const gchar*, gboolean, GError**)) desktop_agnostic_config_gkey_file_real_set_bool;
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	((DesktopAgnosticConfigBackendClass *) klass)->get_float = (gfloat (*) (DesktopAgnosticConfigBackend*, const gchar*, const gchar*, GError**)) desktop_agnostic_config_gkey_file_real_get_float;
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	((DesktopAgnosticConfigBackendClass *) klass)->set_float = (void (*) (DesktopAgnosticConfigBackend*, const gchar*, const gchar*, gfloat, GError**)) desktop_agnostic_config_gkey_file_real_set_float;
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	((DesktopAgnosticConfigBackendClass *) klass)->get_int = (gint (*) (DesktopAgnosticConfigBackend*, const gchar*, const gchar*, GError**)) desktop_agnostic_config_gkey_file_real_get_int;
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	((DesktopAgnosticConfigBackendClass *) klass)->set_int = (void (*) (DesktopAgnosticConfigBackend*, const gchar*, const gchar*, gint, GError**)) desktop_agnostic_config_gkey_file_real_set_int;
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	((DesktopAgnosticConfigBackendClass *) klass)->get_string = (gchar* (*) (DesktopAgnosticConfigBackend*, const gchar*, const gchar*, GError**)) desktop_agnostic_config_gkey_file_real_get_string;
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	((DesktopAgnosticConfigBackendClass *) klass)->set_string = (void (*) (DesktopAgnosticConfigBackend*, const gchar*, const gchar*, const gchar*, GError**)) desktop_agnostic_config_gkey_file_real_set_string;
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	((DesktopAgnosticConfigBackendClass *) klass)->get_list = (GValueArray* (*) (DesktopAgnosticConfigBackend*, const gchar*, const gchar*, GError**)) desktop_agnostic_config_gkey_file_real_get_list;
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	((DesktopAgnosticConfigBackendClass *) klass)->set_list = (void (*) (DesktopAgnosticConfigBackend*, const gchar*, const gchar*, GValueArray*, GError**)) desktop_agnostic_config_gkey_file_real_set_list;
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	DESKTOP_AGNOSTIC_CONFIG_BACKEND_CLASS (klass)->get_name = (gchar* (*) (DesktopAgnosticConfigBackend*)) desktop_agnostic_config_gkey_file_real_get_name;
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_desktop_agnostic_config_gkey_file_get_property;
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	G_OBJECT_CLASS (klass)->constructor = desktop_agnostic_config_gkey_file_constructor;
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	G_OBJECT_CLASS (klass)->finalize = desktop_agnostic_config_gkey_file_finalize;
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DESKTOP_AGNOSTIC_CONFIG_GKEY_FILE_NAME_PROPERTY, desktop_agnostic_config_gkey_file_properties[DESKTOP_AGNOSTIC_CONFIG_GKEY_FILE_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 5373 "config-impl-keyfile.c"
}

static void
desktop_agnostic_config_gkey_file_instance_init (DesktopAgnosticConfigGKeyFile * self,
                                                 gpointer klass)
{
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	self->priv = desktop_agnostic_config_gkey_file_get_instance_private (self);
#line 5382 "config-impl-keyfile.c"
}

static void
desktop_agnostic_config_gkey_file_finalize (GObject * obj)
{
	DesktopAgnosticConfigGKeyFile * self;
	DesktopAgnosticVFSFileMonitor* _tmp0_;
	DesktopAgnosticVFSFileMonitor* _tmp1_;
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DESKTOP_AGNOSTIC_CONFIG_TYPE_GKEY_FILE, DesktopAgnosticConfigGKeyFile);
#line 501 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp0_ = self->priv->_keyfile_monitor;
#line 501 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	desktop_agnostic_vfs_file_monitor_cancel (_tmp0_);
#line 502 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_tmp1_ = self->priv->_keyfile_monitor;
#line 502 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	g_signal_handler_disconnect (_tmp1_, self->priv->_monitor_changed_id);
#line 29 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_g_key_file_unref0 (self->priv->_data);
#line 30 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_g_object_unref0 (self->priv->_keyfile);
#line 31 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_g_object_unref0 (self->priv->_keyfile_monitor);
#line 33 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	_g_free0 (self->priv->_checksum);
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	G_OBJECT_CLASS (desktop_agnostic_config_gkey_file_parent_class)->finalize (obj);
#line 5411 "config-impl-keyfile.c"
}

static GType
desktop_agnostic_config_gkey_file_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DesktopAgnosticConfigGKeyFileClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) desktop_agnostic_config_gkey_file_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DesktopAgnosticConfigGKeyFile), 0, (GInstanceInitFunc) desktop_agnostic_config_gkey_file_instance_init, NULL };
	GType desktop_agnostic_config_gkey_file_type_id;
	desktop_agnostic_config_gkey_file_type_id = g_type_register_static (DESKTOP_AGNOSTIC_CONFIG_TYPE_BACKEND, "DesktopAgnosticConfigGKeyFile", &g_define_type_info, 0);
	DesktopAgnosticConfigGKeyFile_private_offset = g_type_add_instance_private (desktop_agnostic_config_gkey_file_type_id, sizeof (DesktopAgnosticConfigGKeyFilePrivate));
	return desktop_agnostic_config_gkey_file_type_id;
}

GType
desktop_agnostic_config_gkey_file_get_type (void)
{
	static volatile gsize desktop_agnostic_config_gkey_file_type_id__once = 0;
	if (g_once_init_enter (&desktop_agnostic_config_gkey_file_type_id__once)) {
		GType desktop_agnostic_config_gkey_file_type_id;
		desktop_agnostic_config_gkey_file_type_id = desktop_agnostic_config_gkey_file_get_type_once ();
		g_once_init_leave (&desktop_agnostic_config_gkey_file_type_id__once, desktop_agnostic_config_gkey_file_type_id);
	}
	return desktop_agnostic_config_gkey_file_type_id__once;
}

static void
_vala_desktop_agnostic_config_gkey_file_get_property (GObject * object,
                                                      guint property_id,
                                                      GValue * value,
                                                      GParamSpec * pspec)
{
	DesktopAgnosticConfigGKeyFile * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DESKTOP_AGNOSTIC_CONFIG_TYPE_GKEY_FILE, DesktopAgnosticConfigGKeyFile);
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	switch (property_id) {
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		case DESKTOP_AGNOSTIC_CONFIG_GKEY_FILE_NAME_PROPERTY:
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		g_value_take_string (value, desktop_agnostic_config_backend_get_name ((DesktopAgnosticConfigBackend*) self));
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		break;
#line 5452 "config-impl-keyfile.c"
		default:
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 27 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
		break;
#line 5458 "config-impl-keyfile.c"
	}
}

GType
register_plugin (void)
{
	GType result;
#line 907 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	result = DESKTOP_AGNOSTIC_CONFIG_TYPE_GKEY_FILE;
#line 907 "/tmp/B.ufz0esdn/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-impl-keyfile.vala"
	return result;
#line 5470 "config-impl-keyfile.c"
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

